<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Compilation Stock Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .text-wrap {
        white-space: -moz-pre-wrap !important;
        /* Mozilla, since 1999 */
        white-space: -pre-wrap;
        /* Opera 4-6 */
        white-space: -o-pre-wrap;
        /* Opera 7 */
        white-space: pre-wrap;
        /* css-3 */
        word-wrap: break-word;
        /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap;
        /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }

    .select2-container .select2-selection--single {
        height: 42px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    .add_product .select2-selection__rendered {
        width: 220px !important;
    }

    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }

    .YourCustomTableClass table thead {
        background-color: none;
    }
</style>
<?php if (Yii::$app->session->hasFlash('success')) { ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success'); ?></strong>
    </div>
<?php } ?>
<?php if (Yii::$app->session->hasFlash('error')) : ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left col-md-8">
                                            <div class="widget-numbers dj-text-success">Compilation Stock Report</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <!-- <div class="djsec-text-right dj-print-sec"> -->

                                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&print=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i> Print</button></a>
                                            <?php } else { ?>
                                                <a href="<?= Url::base() . '/reports/compilation-stock-report/export-pdf?prod_id=' . $product_id; ?>" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i> Print</button></a>
                                            <?php } ?>
                                            <!-- </div> -->
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="widget-numbers dj-text-success"><a class="search_field_buttons" href="<?= Url::base() . '/reports/compilation-stock-report/index' ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-arrow-left fa-fw" aria-hidden="true"></i>Back</a></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a class="search_field_buttons" href="<?= Url::base() . '/reports/compilation-stock-report/monthly-summary?prod_id=' . $product_id; ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                    <div class="form-row">

                        <div class="col-md-2">
                            <div class="position-relative form-group">
                                <label for="notes">From</label>
                                <?= $form->field($model, 'from_date')->textInput(['type' => 'date', 'maxlength' => true, 'class' => "form-control "])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-2">
                            <div class="position-relative form-group">
                                <label for="notes">To</label>
                                <?= $form->field($model, 'to_date')->textInput(['type' => 'date', 'maxlength' => true, 'class' => "form-control "])->label(false) ?>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-12 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search', 'style' => "padding: 9px 21px"]) ?>
                    </div>

                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row">

                <div class="col-md-12">
                    <h4 style="text-align: center">Monthly Summary</h4>
                    <?php if ($model->from_date != '' & $model->to_date != '') { ?>
                        <p style="text-align: center">For period <?= Yii::$app->formatter->asDate($model->from_date, 'long'); ?> to <?= Yii::$app->formatter->asDate($model->to_date, 'long'); ?></p>
                    <?php } ?>
                </div>
                <div class="col-md-6">
                    <h5 style="text-align: center">Purchase</h5>

                    <p><b>Name:</b><?= $product; ?> </p>

                    <?= GridView::widget([
                        'dataProvider' => $dataProvider_1,
                        // 'showFooter' => true,
                        'footerRowOptions' => ['style' => 'font-weight:bold;'],
                        'options' => [
                            'class' => 'YourCustomTableClass',
                        ],
                        "id" => "grid",
                        'columns' => [
                            [
                                'label' => 'Date',
                                'attribute' => 'Date',
                                'value' => function ($data) {
                                    return $data->Date;
                                }
                            ],
                            [
                                'label' => 'Qty',
                                'attribute' => 'Qty',
                                'value' => function ($data) {
                                    return $data->Qty;
                                }
                            ],
                            [
                                'label' => 'Vch No',
                                'attribute' => 'VChNo',
                                'value' => function ($data) {
                                    return $data->VChNo;
                                }
                            ],
                            [
                                'label' => 'Vendor/Branch Name',
                                'attribute' => 'VendorName',
                                'value' => function ($data) {
                                    return $data->VendorName;
                                }
                            ]

                        ],
                    ]); ?>
                </div>
                <div class="col-md-6">
                    <h5 style="text-align: center">Sale</h5>

                    <?= GridView::widget([
                        'dataProvider' => $dataProvider_2,
                        //  'showFooter' => true,
                        'footerRowOptions' => ['style' => 'font-weight:bold;'],
                        'options' => [
                            'class' => 'YourCustomTableClass',
                        ],
                        "id" => "grid",
                        'columns' => [
                            [
                                'label' => 'Date',
                                'attribute' => 'Date',
                                'value' => function ($data) {
                                    return $data->Date;
                                }
                            ],
                            [
                                'label' => 'Qty',
                                'attribute' => 'Qty',
                                'value' => function ($data) {
                                    return $data->Qty;
                                }
                            ],
                            [
                                'label' => 'Vch No',
                                'attribute' => 'VChNo',
                                'value' => function ($data) {
                                    return $data->VChNo;
                                }
                            ],
                            [
                                'label' => 'Customer Name',
                                'attribute' => 'Particulars',
                                'value' => function ($data) {
                                    return $data->Particulars;
                                }
                            ],


                        ],
                    ]); ?>


                </div>
            </div>
        </div>
    </div>
</div>


<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function() {
            $('#search-report').toggle();
        });
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>