<?php

namespace backend\modules\master\controllers;

use Yii;
use backend\modules\master\models\Customer;
use backend\modules\master\models\CustomerSearch;
use backend\modules\master\models\CustomerContact;
use backend\modules\master\models\CustomerDocument;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\IndianCities;
use yii\helpers\ArrayHelper;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\data\ActiveDataProvider;
use Mpdf\Mpdf;
use yii\web\UploadedFile;
use yii2tech\spreadsheet\Spreadsheet;
use yii\helpers\Json;

/**
 * CustomerController implements the CRUD actions for Customer model.
 */
class CustomerController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $country=["India"=>"India",
    "Others"=>"Others",
   ]
    ;
    public static $state=["Odisha"=>"Odisha",
    "Others"=>"Others",
    ]
    ;
    public static $gst_type = ["Unregistered"=>"Unregistered",
     "Registred"=>"Registred","Compounded" =>"Compounded",
     "Branch" =>"Branch"]
     ;
    Public static $removal =["Regular" =>"Regular",
    "Import"=>"Import","Compounded" =>"Compounded"
    ]
    ; 
    Public static $credit_t =["Due upon receipt" =>"Due upon receipt",
    "Due within 7 days"=>"Due within 7 days","Due within 10 days" =>"Due within 10 days"
    ,"Due within 15 days" =>"Due within 15 days", "Due within 30 days" =>"Due within 30 days"
    ,"Due within 45 days" =>"Due within 45 days","Due within 60 days" =>"Due within 60 days"
    ,"Due within 75 days" =>"Due within 75 days","Due within 90 days" =>"Due within 90 days"
    ,"Due within 120 days" =>"Due within 120 days",
    ]
    ; 

    /**
     * Lists all Customer models.
     * @return mixed
     */
    public function actionIndex()
    {Yii::$app->view->params['active']=20;
        $model=new Customer;
        $searchModel = new CustomerSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        if($model->load(Yii::$app->request->post())){

            if($model->findid!=''){
                $from_date=$model->from_date;
                $to_date=$model->to_date;
                $id=$model->findid;
                return $this->redirect(['statement-pdf','from_date'=>$from_date,'to_date'=>$to_date,'id'=>$id]);
            }
        }

        return $this->render('index', [
            'searchModel' => $searchModel,
            'model'=>$model,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Customer model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id,$page_id=null)
    {Yii::$app->view->params['active']=20;
      $contact=CustomerContact::find()->where(['customer_id'=>$id])->all();
        return $this->render('view', [
            'model' => $this->findModel($id),
            'contact' => $contact,
        ]);
    }
    public function actionDelattachment($id)
    {
        $file=CustomerDocument::find()->where(['id'=>$id])->one();
         $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
//     public function actionDeleteAttachment()
//     {
//         Yii::$app->view->params['active']=20;
//         $id=Yii::$app->request->post('remove_id');
//         $customer_doc = CustomerDocument::find()->where(['id'=>$id])->one();
//         $customer_doc->delete();

//       echo  "success";
//  }
//  Public function actionDownloadAttachment($id)
//  {
//     Yii::$app->view->params['active']=20;
//  $data=CustomerDocument::find()->where(['customer_id'=>$id])->all();
//  if(!$data){
//  Yii::$app->getSession()->setFlash('success', 'No Attachment Found');
//  return $this->redirect(['index']);
//  }
//  $file = Yii::$app->basePath.'/web/setting/customer_documents/customerdoc_'.$id.'.zip';
//  $zip = new \ZipArchive();
//  $zip->open($file, \ZipArchive::CREATE | \ZipArchive::OVERWRITE) ;
//  foreach($data as $value){
//     $files[]=Yii::$app->basePath . '/web/setting/customer_documents/'.$value->document_name;
//  }
//  foreach($files as $val){
//      $zip->addFromString(basename($val), file_get_contents($val));
//  }
//  $zip->close();
//  return Yii::$app->response->sendFile($file);
//  }

 public function actionValidationCreate($name)
 { 
     
   $count=Customer::find()->where(['business_name'=>$name])->count();
   if($count>=1)
   return 0;
   else
   return 1;
 }
 public function actionNameValidation($name,$id=null,$page=null,$update=null)
 {  
 if($update=='update'){
        //  if($page==1){
         $count1=Customer::find()->where(['business_name'=>$name,'id'=>$id])->count();
         $count2=Customer::find()->where(['business_name'=>$name])->count();

         if(($count1==1 && $count2==1) || ($count1==0 && $count2==0))
            {
                return 1;
            }
            else
            {
                return 0; 
            }
         }

 }
    /**
     * Creates a new Customer model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($page_id=null)
    {Yii::$app->view->params['active']=20;
        $model = new Customer();
        $customerdocument = new CustomerDocument();
        $count = Customer::find()->count();      
        if ($model->load(Yii::$app->request->post())) {
            $data=Yii::$app->request->post();
            if($data['page_id']==1)
            {
                $model->page_id	=$data['page_id'];
                $model->save(false);               
                $ledger = new AccountingLedger();
                $ledger->taxable_ledger ='TAXABLE';
                $ledger->ledger_id = $model->business_name;
                $ledger->name = $model->business_name;
                $ledger->group_name_id =28;
                $ledger->account_type_id = 4;
                $ledger->alias_name =$model->business_name;
                $ledger->opening_balance = $model->opening_as_on;
                $ledger->save(false);
                return $this->redirect(['update','id'=>$model->id,'page_id'=>$model->page_id+1]);
            
                // else{
                //     print_r($model->getErrors());
                //     die();
                // }
                
            }
            // return $this->redirect(['index']);
        }

        return $this->render('create', [
            'model' => $model,
            'customerdocument' => $customerdocument,
            'country'=> CustomerController::$country,
            'state'=> CustomerController::$state,
            'gst_type'=> CustomerController::$gst_type,
            'removal'=> CustomerController::$removal,
            'credit_t'=>CustomerController::$credit_t,
            'count' =>$count,
            'page_id'=>$page_id,
        ]);
    }
    /**
     * Updates an existing Customer model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id,$page_id)
    {Yii::$app->view->params['active']=20;
        $model = $this->findModel($id);
         $contact = new CustomerContact();
         $customerdocument = new CustomerDocument();
         $con = CustomerContact::find()->where(['customer_id'=>$id])->all();
        if ($model->load(Yii::$app->request->post()) ) {

            $data=Yii::$app->request->post();
            //echo "<pre>";print_r($files);die();
            $previous_val = Customer::find()->where(['id'=>$id])->one(); 
             $ledger = AccountingLedger::find()->where(['ledger_id'=>$previous_val->business_name])->andWhere(['account_type_id'=> 4])->one();
            // $ledger = new AccountingLedger();
            if(isset($ledger)){
                $ledger->taxable_ledger ='TAXABLE';
                $ledger->ledger_id = $model->business_name;
                $ledger->name = $model->business_name;
               // $ledger->group_name_id =28;
               // $ledger->account_type_id = 4;
                $ledger->alias_name =$model->business_name;
                $ledger->opening_balance = $model->opening_as_on;
                $ledger->save(false);
            }
            if($model->page_id !=6){
                $model->page_id=$data['page_id'];
            }
            $model->save(false);
            if($customerdocument->validate())
            {  
               $names=UploadedFile::getInstances($customerdocument,'document_name');
               foreach ($names as $name) {
                   // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                   $path='setting/customer_documents/'.$name->baseName.'.'.$name->extension;
                   if($name->saveAs($path))
                   {
                       $filename = $name->baseName.'.'.$name->extension;
                       $filepath = $path;
                       yii::$app->db->createCommand()->insert('customer_document',['document_name'=>$filename,'customer_id'=>$model->id])->execute();
                   }
                   
               }

            }else{
                print_r($customerdocument->getErrors());die();
            }
            if($data['page_id']==5)
            {
                $contacts =CustomerContact::deleteAll(['customer_id'=>$id]);
                if(isset($data['contactdynupdate']))
                {
                    
                    foreach ($data['contactdynupdate'] as $value) {
                    if($value['contact_name']!='')
                    {
                        $contact = new CustomerContact();
                        $contact->contact_name = $value['contact_name'];
                        $contact->designation = $value['designation'];
                        $contact->contact_email_id = $value['contact_email_id'];
                        $contact->contact_mobile_no = $value['contact_mobile_no'];
                        $contact->is_primary = $value['is_primary'];
                        $contact->is_private = $value['is_private'];
                        $contact->customer_id = $id;
                        $contact->created_at=date('Y-m-d H:i:s');
                        $contact->updated_at=date('Y-m-d H:i:s');
                        $contact->save(false);
                    }
                    }
                }
                
                foreach ($data['contactdyn'] as $value) {
                if($value['contact_name']!='')
                {
                    // print_r($value['is_primary']);
                    // exit();
                    $contact = new CustomerContact();
                    $contact->contact_name = $value['contact_name'];
                    $contact->designation = $value['designation'];
                    $contact->contact_email_id = $value['contact_email_id'];
                    $contact->contact_mobile_no = $value['contact_mobile_no'];
                    $contact->is_primary = $value['is_primary'];
                    $contact->is_private = $value['is_private'];
                    $contact->customer_id = $id;
                    
                    $contact->created_at=date('Y-m-d H:i:s');
                    $contact->updated_at=date('Y-m-d H:i:s');
                    $contact->save(false);
                }

            }
            
        }
        
            if($page_id==6)
            {
                Yii::$app->getSession()->setFlash('success', 'Successfully Updated Customer details');
                return $this->redirect(['customer/index']);
            }
            else
            {
                return $this->redirect(['update','id'=>$model->id,'page_id'=>$page_id+1]);
            }
            
            
        }
        return $this->render('update', [
            'model' => $model,
            'con' => $con,
            'contact' => $contact,
            'page_id'=>$page_id,
            'customerdocument' => $customerdocument,
            'country'=> CustomerController::$country,
            'state'=> CustomerController::$state,
            'gst_type'=> CustomerController::$gst_type,
            'removal'=> CustomerController::$removal,
            'credit_t'=>CustomerController::$credit_t,
        ]);
    }
    public function actionFindattachments($id)
    {
        $find=CustomerDocument::find()->select(['document_name','id'])->where(['customer_id'=>$id])->asArray ()->all();
        echo Json::encode($find);
        // return $exporter->send($find);
        // return $find;
    }
    public function actionDownload($id) 
    {
        $model=CustomerDocument::find()->where(['id'=>$id])->one();
        if($model->document_name!=null)
        {

            $local=yii::getAlias('@webroot/setting/customer_documents/');

            $name=$model->document_name;

            $find=$local.$name;
            if(file_exists($find))
            {  ob_clean();
                ob_start();
               return yii::$app->response->sendFile($find);
               ob_flush();
               exit();

            }
        }
    }
    public function actionExportPdf()
    {Yii::$app->view->params['active']=20;
        $dataProvider = new ActiveDataProvider([
            'query' => Customer::find()->orderBy(['id' => SORT_DESC]),
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/customer/export-pdf', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('customer_details.pdf', 'I');
    }
    public function actionCitydetails($searchTerm=null)
    {   
        // print_r('jj');
        // die();
        if(!$searchTerm)
        $city=IndianCities::find()->limit(10)->all();
        else
        $city=IndianCities::find()->where(["like","city",$searchTerm])->limit(10)->all();

        $citylist=ArrayHelper::map($city, 'city', 'city');
        return json_encode($citylist);
    }
    public function actionStatementPdf($from_date,$to_date,$id)
    {Yii::$app->view->params['active']=20;
        // $dataProvider = new ActiveDataProvider([
        //     'query' => Customer::find(),
        // ]);

        // print_r($to_date);die();
        $model=$this->findModel($id);
        // $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/customer/statement-pdf', [
            'id' => $id,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'model'=>$model
        ]));
        $mpdf->Output('statement.pdf', 'I');
    }

    public function actionExcelExport($detail=null)
    {Yii::$app->view->params['active']=20;
        $dataProvider = new ActiveDataProvider([
            'query' =>Customer::find()->orderBy(['id' => SORT_DESC]),
        ]);
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'business_name',
            'customer_code',
            'customer_type',
            'mobile',
            'account_id',
            'customer_code',
            'dob',
            'email',
            'email2',
            'fax',
            'website',
            'phone',
            'phone2',
            'adderss_line_1',
            'adderss_line_2',
            'adderss_line_3',
            'city',
            'state',
            'pin_code',
            'country',
            [
            'label' => 'Shipping To',
            'attribute' => 'sipping_to_name',
            'value' => function ($data) {
                return $data->sipping_to_name;
            },
            ],
            'shipping_address_1',
            'shipping_address_2',
            'shipping_address_3',
            'area',
            'shipping_city',
            'shipping_state',
            'shipping_postcode',
            'shipping_country',
            'opening_as_on:date',
            'customer_gst_type',
            'gstin_no',
            'ho_state_code',
            'pan_number',
            'aadhar_number',
            'type_of_removal',
            'cst_no',
            'ecc_no',
            'cex_no',
            'ledger',
            'credit_limit',
            'credit_limit2',
            'credit_days',
            'credit_terms',
            'customers_code',
            'customer_brn',
            'ic_type',
            'tin',
        ],
    ]);
        }else{
            // print_r("xxxxx");
            // exit();
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'header'=> 'Name',
                        'value'=>'business_name',
                    ],
                    [
                        'header'=> 'Customer Type',
                        'value'=>'customer_type',
                    ],
                    [
                        'header'=> 'Email',
                        'value'=>'email',
                    ],
                    [
                        'header'=> 'Mobile (HP)',
                        'value'=>'mobile',
                    ],
                    [
                        'header' => 'State',
                        'value' =>'state',
                    ]
                   
                ],
            ]);
        }
    return $exporter->send('customer_details.xlsx');
    }

    /**
     * Deletes an existing Customer model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        Yii::$app->view->params['active']=20;
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $customer=$this->findModel($id);       
            $customer->delete();
            }
            Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
            return $this->redirect(['index']);
        }
        else
        {
            $this->findModel($id)->delete();
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
            return $this->redirect(['index']);
        }
    }


    /**
     * Finds the Customer model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Customer the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {Yii::$app->view->params['active']=20;
        if (($model = Customer::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
