<?php

namespace backend\modules\master\controllers;

use Yii;
use yii\helpers\Html;
use yii\helpers\Url;
use common\models\User;
use backend\models\UserClient;
use backend\modules\master\models\LeadExecutive;
use backend\modules\master\models\LeadExecutiveSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;
use yii\data\ActiveDataProvider;
use Mpdf\Mpdf;
use yii2tech\spreadsheet\Spreadsheet;
use backend\models\AuthItem;
use backend\models\AuthAssignment;
use yii\helpers\ArrayHelper;
/**
 * LeadExecutiveController implements the CRUD actions for LeadExecutive model.
 */
class LeadExecutiveController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all LeadExecutive models.
     * @return mixed
     */
    public function actionClientCheck($name)
    {
        $item=AuthItem::find()->where(['name'=>$name])->one();
        return $item->client_specific;
    }
    public function actionIndex()
    {
        Yii::$app->view->params['active']=2;
        $searchModel = new LeadExecutiveSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('/leads/lead-executive/index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single LeadExecutive model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        Yii::$app->view->params['active']=234;
        return $this->render('/leads/lead-executive/view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new LeadExecutive model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        Yii::$app->view->params['active']=234;
        $model = new LeadExecutive(['scenario' => 'create']);
        $userind = new User();
        if ($model->load(Yii::$app->request->post()) ) {



            $model->photo = UploadedFile::getInstance($model, 'photo');
            if($model->photo){
            $nameimage=(new \DateTime())->format('u');
            $model->photo->saveAs('setting/leadexecutive_photos/' .$nameimage.'.'.$model->photo->extension);
            $model->photo=$nameimage. '.' . $model->photo->extension;
            }
            if($model->save()){
            $data = Yii::$app->request->post('LeadExecutive');
            $userind->username = $data['name'];
            $userind->email = $data['email'];
            $userind->role = $data['type'];
            $userind->setPassword($data['password']);
            $userind->generateAuthKey();
            $userind->generateEmailVerificationToken();
            if($model->status==1)
               $userind->status =10;
            else
               $userind->status =0;  
            if($userind->save()){
                if($model->customers){
                    foreach($model->customers as $value){
                        $custind=new UserClient();
                        $custind->user_id=$userind->id;
                        $custind->client_id=$value;
                        $custind->client_type='Customer';
                        $custind->save(false);
                    }
                }
                if($model->vendors){
                    foreach($model->vendors as $value){
                        $custind=new UserClient();
                        $custind->user_id=$userind->id;
                        $custind->client_id=$value;
                        $custind->client_type='Vendor';
                        $custind->save(false);
                    }
                }
            // $role->item_name=$userind->role;
            // $role->user_id=$userind->id;
            // $role->created_at=$userind->created_at;
            // $role->save(false);
            $model->user_id=$userind->id;
            $model->save(false);
            }
            if($model->type!='')
            {
                $assignment = new AuthAssignment;
                $assignment->item_name = $model->type;
                $assignment->user_id =$userind->id ;
                $assignment->save(false); 
            }
            Yii::$app->getSession()->setFlash('success', 'Created Successfully');
            return $this->redirect(['/admin/user/index']);
        }
        }

        return $this->render('/leads/lead-executive/create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing LeadExecutive model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=234;
        $model = $this->findModel($id);

        // if ($model->load(Yii::$app->request->post()) && $model->save()) {
            $oldemail=$model->email;
            $oldimage=$model->photo;
            if ($model->load(Yii::$app->request->post()) ) {
                $useremail=User::find()->where(['email'=>$model->email])->count();
                $model->photo = UploadedFile::getInstance($model, 'photo');
                if($model->photo){
                $nameimage=(new \DateTime())->format('u');
                $model->photo->saveAs('setting/leadexecutive_photos/' .$nameimage.'.'.$model->photo->extension);
                $model->photo=$nameimage. '.' . $model->photo->extension;
                }else{
                    $model->photo=$oldimage;   
                }
            // if($useremail==0 && $oldemail!=$model->email ){
            //     $model->save(false);}
            //     elseif($useremail==1 && $oldemail==$model->email ){
            //         $model->save(false);
            //     } else{
            //     Yii::$app->getSession()->setFlash('success', 'Email already exist');
            //     return $this->redirect(['update','id'=>$model->id]);
            // }
            if($model->save()){                
                $data = Yii::$app->request->post('LeadExecutive');
                $user=User::find()->where(['id'=>$model->user_id])->one();
                $user->username=$data['name'];
                $user->email=$data['email'];
                $user->role = $data['type'];
                if($data['password']){
                $user->setPassword($data['password']);
                $user->generateAuthKey();
                $user->generateEmailVerificationToken();
                }
                // $role=AuthAssignment::find()->where(['user_id'=>$model->user_id])->one();
                // $role->item_name=$user->role;
                // $role->save(false);
                 if($model->status==1)
                   $user->status =10;
                else
                   $user->status =0;  
                $user->save();
                 if($model->type!='')
                { 
                    $assign = AuthAssignment::find()->where(['user_id'=>$user->id])->one();
                    if($assign!='')
                    {
                         $assign->delete();
                    }
                    $assignment = new AuthAssignment;
                    $assignment->item_name = $model->type;
                    $assignment->user_id =$user->id ;
                    $assignment->save(false); 
                }
                UserClient::deleteAll(['user_id'=>$user->id,'client_type'=>'Customer']);
                if($model->customers){
                    
                    foreach($model->customers as $value){
                        $custind=new UserClient();
                        $custind->user_id=$user->id;
                        $custind->client_id=$value;
                        $custind->client_type='Customer';
                        $custind->save(false);
                    }
                }
                UserClient::deleteAll(['user_id'=>$user->id,'client_type'=>'Vendor']);
                if($model->vendors){
                    
                    foreach($model->vendors as $value){
                        $custind=new UserClient();
                        $custind->user_id=$user->id;
                        $custind->client_id=$value;
                        $custind->client_type='Vendor';
                        $custind->save(false);
                    }
                }
                Yii::$app->getSession()->setFlash('success', ' Updated Successfully');
                return $this->redirect(['/admin/user/index']);
            }
            }
        // }

        return $this->render('/leads/lead-executive/update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing LeadExecutive model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        Yii::$app->view->params['active']=234;
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $lead=$this->findModel($id);
            $user=User::find()->where(['id'=>$lead->user_id])->one();
            if($user)
            {
                $user->delete();
            }
            $lead->delete();
            }
            Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
            return $this->redirect(['index']);
        }
        else
        {
            $lead = $this->findModel($id);
            $user=User::find()->where(['id'=>$lead->user_id])->one();
            if($user)
            {
                $user->delete();
            }
            $lead->delete();
            Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
            return $this->redirect(['index']);
        }
        
    }
    public function actionExcelExport($detail=null)
    {
        Yii::$app->view->params['active']=2;
        $dataProvider = new ActiveDataProvider([
            'query' => LeadExecutive::find()->orderBy(['id' => SORT_DESC]),
        ]);
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'name',
            'type',
            'products',
              [
                // 'format' => 'email',
                'attribute'=>'email',
              ],
              [
                'attribute'=>'photo',
                'label'=>'Photo',
                'format' => 'raw',
                'value' => function ($model, $key, $index, $widget) {
                    if($model->photo)
                    return "=HYPERLINK(\"" . Url::base(true) .'/setting/leadexecutive_photos/'.$model->photo. "\", \"" . Yii::t('app', $model->photo) . "\")";
                    return '';
                }
            ],
            'phone',
            'executive_ic',
            'ic_type',
            'address_line1',
            'address_line2',
            'city',
            'state',
            'zip_code',
            'target',
            'target_based_on',
            // 'status',
            'created_at:date',
            'updated_at:date',
        ],
    ]);
        }else{
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
            'name',
            'email',
            'phone',
            'type',
           
            // 'created_at:date'
                ],
            ]);
        }
    return $exporter->send('lead_executive.xlsx');
    }
    public function actionExportPdf()
    {
        Yii::$app->view->params['active']=2;
        $dataProvider = new ActiveDataProvider([
            'query' => LeadExecutive::find()->orderBy(['id' => SORT_DESC]),
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        // $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/leads/lead-executive/exportpdf', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('lead_executive.pdf', 'I');
    }

    public function actionEditProfile($id)
    {
         Yii::$app->view->params['active']=234;
         // $access = Yii::$app->user->identity->id;
         if (Yii::$app->user->isGuest) {

            return $this->goHome();
        }
         $model = LeadExecutive::find()->where(['user_id'=>$id])->one();
            $oldimage=$model->photo;
            if ($model->load(Yii::$app->request->post()) ) {
                $useremail=User::find()->where(['id'=>$model->user_id])->count();
                $model->photo = UploadedFile::getInstance($model, 'photo');
                if($model->photo){
                $nameimage=(new \DateTime())->format('u');
                $model->photo->saveAs('setting/leadexecutive_photos/' .$nameimage.'.'.$model->photo->extension);
                $model->photo=$nameimage. '.' . $model->photo->extension;
                }else{
                    $model->photo=$oldimage;   
                }
            if($model->save()){                
                $data = Yii::$app->request->post('LeadExecutive');
                $user=User::find()->where(['id'=>$model->user_id])->one();
                $user->username=$data['name'];
                if($data['password']){
                $user->setPassword($data['password']);
                $user->generateAuthKey();
                $user->generateEmailVerificationToken();
                }
                $user->save();
                Yii::$app->getSession()->setFlash('success', ' Updated Successfully');
                return $this->redirect(['/site/index']);
            }
            }

        return $this->render('/leads/lead-executive/editprofile', [
            'model' => $model,
        ]);
    }
    /**
     * Finds the LeadExecutive model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return LeadExecutive the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        Yii::$app->view->params['active']=2;
        if (($model = LeadExecutive::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    
}
