<?php

namespace backend\modules\master\controllers;

use Yii;
use backend\modules\master\models\PurchaseOrder;
use backend\modules\master\models\PurchaseOrderSearch;
use backend\modules\master\models\PurchaseOrderProduct;
use backend\modules\master\models\PurchaseOrderIndentProduct;
use backend\modules\master\models\PurchaseOrderIndent;
use backend\modules\master\models\Product;
use backend\modules\master\models\PurchaseDocument;
use backend\modules\master\models\PurchaseAgainstGr;
use backend\modules\master\models\AccountingTax;
use backend\models\UserClient;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Vendor;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use backend\models\AuthAssignment;
use Mpdf\Mpdf;
use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\GenericTemplate;

/**
 * PurchaseOrderController implements the CRUD actions for PurchaseOrder model.
 */
class PurchaseOrderController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $settings_type=["Exp Payment"=>"Exp Payment"
    ]
    ;
    public static $banks_name=["Punjab National Bank"=>"Punjab National Bank",
    "Bank of India"=>"Bank of India",
    "State Bank of India"=>"State Bank of India"        
    ]
    ;
    /**
     * Lists all PurchaseOrder models.
     * @return mixed
     */
    public function actionIndex($details=null)
    {       
        Yii::$app->view->params['active']=23;
        $model= new PurchaseOrder();
        $searchModel = new PurchaseOrderSearch();
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        }
        else
        {
            $accessed[] = Yii::$app->user->identity->id;
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams,$accessed);
        }
        
        if($model->load(Yii::$app->request->get())){
        // if($model->from_date!="" && $model->to_date!=""){
            //echo "<pre>";print_r($model);die();
             if($model->product!=""){
                $exist_product = PurchaseOrderProduct::find()->where(['product_id'=>$model->product])->all();
                $purchase_ids=array();
                foreach ($exist_product as $key => $row){
                    $purchase_ids[$key] = $row['purchase_order_id'];
                  }
                  if($user_type->item_name == 'Admin')
                    {
                       $query=PurchaseOrder::find()->orderBy([
                        'id' => SORT_DESC,
                      ])->WHERE(['in', 'id',$purchase_ids])->andwhere(['is_deleted' =>0]);
                    }
                    else
                    {
                        $accessed = Yii::$app->user->identity->id;
                        $v_ids= [];
                        $j = 0;
                        foreach($purchase_ids as $val)
                        {
                            $purchase_order_assessed = PurchaseOrder::find()->where(['id'=>$val])->one();
                            if($purchase_order_assessed != '')
                            {
                                $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->andWhere(['client_id'=>$purchase_order_assessed->vendor_name])->one();
                                if($vendors)
                                {
                                    $v_ids[$j] = $vendors->client_id;
                                    $j++;
                                }
                            }
                        }
                        $query=PurchaseOrder::find()->orderBy(['id' => SORT_DESC])->WHERE(['in', 'vendor_name',$v_ids])->andwhere(['is_deleted' =>0]);
                    }
           // echo "<pre>";print_r($purchase_ids);die();
            }
            else{
                if($user_type->item_name == 'Admin')
                {
                   $query=PurchaseOrder::find()->orderBy([
                    'id' => SORT_DESC,
                  ])->where(['is_deleted' =>0]);
                }
                else
                {
                    $accessed = Yii::$app->user->identity->id;
                    // print_r($accessed);
                    // die();
                    $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->all();
                    $vendor_ids= [];
                    $i = 0;
                    foreach($vendors as $data)
                    {
                        $vendor_ids[$i] = $data->client_id;
                        $i++;
                    } 
                   //  print_r($vendor_ids);
                   // die();
                    $query = PurchaseOrder::find()->orderBy(['id' => SORT_DESC])->where(['in', 'vendor_name', $vendor_ids])->andWhere(['is_deleted' =>0]);
                }
             $query->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
              ->andFilterWhere(['like', 'setting_type', $model->setting_type])
             ->andFilterWhere(['like', 'po_last', $model->po_last])
             ->andFilterWhere(['like', 'total_amount', $model->total_amount])
             ->andFilterWhere(['like', 'vendor_name', $model->vendor]);
            }
         // }
         $dataProvider = new ActiveDataProvider(['query' => $query]);
         
         
         // foreach ($dataProvider->models as $model) {
         //        if($)
         //    }

        }

        if($details==true)
        {
            $detail = true;
            $data = $dataProvider;
            $this->actionExcelExport($detail,$data);
        }

        return $this->render('/purchase/purchase-order/index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,
        ]);
    }

    /**
     * Displays a single PurchaseOrder model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id,$from=null)
    {
        Yii::$app->view->params['active']=23;

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_purchase = PurchaseOrder::find()->where(['id'=>$id])->one();
            $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
            if($check_vendor == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['purchase-order/index']);
            }
        }



        $products=PurchaseOrderProduct::find()->where(['purchase_order_id'=>$id])->all();
    
        return $this->render('/purchase/purchase-order/view', [
            'model' => $this->findModel($id),
            'products'=>$products,
            'from'=>$from,
        ]);
    }



    public function actionPrintall($id=null,$from=null)
    {

         $products=PurchaseOrderProduct::find()->where(['purchase_order_id'=>$id])->all();
    
        return $this->renderPartial('/purchase/purchase-order/printall', [
            'model' => $this->findModel($id),
            'products'=>$products,
            'from'=>$from,
        ]);
        
    }

    /**
     * Creates a new PurchaseOrder model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($id=null,$from=null)
    {
        Yii::$app->view->params['active']=23;

        $data=Yii::$app->request->post();
        $model = new PurchaseOrder();
        $purchaseorderproduct = new PurchaseOrderProduct();
        $last_purchase=PurchaseOrder::find()->orderby(['id' => SORT_DESC])->one();

        $selected_date=date('Y-m-d');
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        $dynamic_date_last = ($year - 1) . '-' . '03' . '-' . '31';

        // print_r($dynamic_date);
        echo '<script>';
echo 'console.log("Dynamic Date:", ' . json_encode($dynamic_date) . ');';
echo '</script>';
            if( strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=PurchaseOrder::find()->where(['<=', 'date', $dynamic_date])->andWhere(['>=', 'date', $dynamic_date_last])->count();
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=PurchaseOrder::find()->where(['>=', 'date', $dynamic_date])->count();
            }
            else{
                $last_entry=0;
            }

            echo '<script>';
            echo 'console.log("Dynamic Date:", ' . json_encode($last_entry) . ');';
            echo '</script>';



        if($from=='purchase-order')
          {
            $data = $this->findModel($id)->attributes;
            $model->setAttributes($data);
            $purchaseorderproduct = PurchaseOrderProduct::find()->where(['purchase_order_id'=>$id])->all();
          }
          if($from == "purchase-indent")
          {
            $indent = PurchaseOrderIndent::find()->where(['id'=>$id])->one();
            $purchaseorderproduct = PurchaseOrderIndentProduct::find()->where(['purchase_order_indent_id'=>$id])->all();
          }
        
        if ($model->load(Yii::$app->request->post())) {



            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$model->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
                if($check_vendor == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['purchase-order/index']);
                }
            }

            $model->updated_by=Yii::$app->user->identity->id;
            $data=Yii::$app->request->post();
            $model->po_no_final=$data['PurchaseOrder']['prefix']."-". $data['PurchaseOrder']['po_last'];
            $check_duplixy=PurchaseOrder::find()->where(['po_no_final'=>$model->po_no_final])->one();
           //echo "<pre>";print_r($data);die();
            
          if(!isset($check_duplixy)){
            if($data['PurchaseOrder']['advance_payment']==1){
                $model->advance_payment='Yes';
                $model->advance_settingtype=$data['PurchaseOrder']['advance_settingtype'];
                $model->advance_amount=$data['PurchaseOrder']['advance_amount'];
                $model->bank=$data['PurchaseOrder']['bank'];
                $model->cheque_no=$data['PurchaseOrder']['cheque_no'];
                $model->cheque_date=$data['PurchaseOrder']['cheque_date'];
                $model->advance_note=$data['PurchaseOrder']['advance_note'];
           }
            else{
                $model->advance_payment='No';
                $model->advance_settingtype="";
                $model->advance_amount="";
                $model->bank="";
                $model->cheque_no="";
                $model->cheque_date="";
                $model->advance_note="";
            }
            if(Yii::$app->request->post('reminder')){
                $model->reminder='Yes';
                $model->reminder_through=1;
                $model->reminder_for=$data['PurchaseOrder']['reminder_for'];
                $model->reminder_emails=$data['PurchaseOrder']['reminder_emails'];
                $model->reminder_repeat_on=$data['PurchaseOrder']['reminder_repeat_on'];
                $model->reminder_from_date=$data['PurchaseOrder']['reminder_from_date'];
                $model->reminder_to_date=$data['PurchaseOrder']['reminder_to_date'];
                $model->reminder_content=$data['PurchaseOrder']['reminder_content'];
            }
            else{
                $model->reminder='No';
                $model->reminder_for="";
                $model->reminder_through="";
                $model->reminder_emails="";
                $model->reminder_repeat_on="";
                $model->reminder_from_date="";
                $model->reminder_to_date="";
                $model->reminder_content="";

            }
                $model->status = "Pending";

                $model->pending_amount = $model->total_amount;
                $model->billed=0;
                $model->gr_status=0;
                $model->save(false);
            if($from == 'purchase-indent')
            {
                $fromindent = PurchaseOrderIndent::find()->where(['id'=>$indent->id])->one();
                $fromindent->converted_to= "Purchase Order";
                $fromindent->convert_purchase_id = $model->id;
                $fromindent->save(false);
            }
                $files = UploadedFile::getInstances($model, 'files');
               foreach($files as $file){
                $purchase_doc = PurchaseDocument::find()->where(['purchase_id'=>$model->id])->all();
                $tmp = explode('.', $file);
                $document = new PurchaseDocument();
                $ext = end($tmp);
               // $ext = end((explode(".", $file)));
                $filename = Yii::$app->security->generateRandomString().".{$ext}";
                $serialize[] = $filename;
                $count=count($purchase_doc)+1;
                $name=(new \DateTime())->format('u').$count.".{$ext}";
                $file->saveAs(Yii::$app->basePath . '/web/setting/purchase_documents/' . $name);
                $document->document_name=$name; 
                $document->purchase_id=$model->id;
                $document->save();
              }
            if(isset($data['productdyn'])){
            foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                    $product = new PurchaseOrderProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    if($product->discount=='')
                    {
                        $product->discount = 0;
                    }
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->purchase_order_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);

                    $avilableproduct = Product::find()->where(['id'=>$product->product_id])->one();
                    $avilableproduct->stock_unit = $avilableproduct->stock_unit + $product->quantity;
                    $avilableproduct->save(false);
                } 
                
            }
           }
            if(isset($data['productdynupdate'])){
                foreach ($data['productdynupdate'] as $value) {
                    if($value['price']!='')
                    {
                        $product = new PurchaseOrderProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    if($product->discount=='')
                    {
                        $product->discount = 0;
                    }
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->purchase_order_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);

                    $avilableproduct = Product::find()->where(['id'=>$product->product_id])->one();
                    $avilableproduct->stock_unit = $avilableproduct->stock_unit + $product->quantity;
                    $avilableproduct->save(false);
                    }
                    
                  }
                }
            $data=Yii::$app->request->post();
           if (Yii::$app->request->post('save')==0) {
                         Yii::$app->getSession()->setFlash('success', 'Successfully created Purchase Order');
                         return $this->redirect(['purchase-order/index']);
                  }

                if (Yii::$app->request->post('save') == 1) {
                       Yii::$app->getSession()->setFlash('success', 'Successfully created Purchase Order');
                       return $this->redirect(['purchase-order/create']);
                  }
          } 
          else{
            Yii::$app->getSession()->setFlash('success', 'Successfully created Purchase Order');
            return $this->redirect(['purchase-order/index']);
        }    
              
        }

        return $this->render('/purchase/purchase-order/create', [
            'model' => $model,
            'last_purchase' => $last_purchase,
            'purchaseorderproduct' => $purchaseorderproduct,
            'settings_type'=> PurchaseOrderController::$settings_type,
            'banks_name'=> PurchaseOrderController::$banks_name,
            'from' => $from,
            'last_entry'=>$last_entry+1,
        ]);
    }
    
    public function actionExportPdf($print=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        Yii::$app->view->params['active']=23;


        if($user_type->item_name == 'Admin')
                {
                   $query=PurchaseOrder::find()->orderBy([
                    'id' => SORT_DESC,
                  ])->where(['is_deleted' =>0]);
                }
                else
                {
                    $accessed = Yii::$app->user->identity->id;
                    // print_r($accessed);
                    // die();
                    $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->all();
                    $vendor_ids= [];
                    $i = 0;
                    foreach($vendors as $data)
                    {
                        $vendor_ids[$i] = $data->client_id;
                        $i++;
                    } 
                   //  print_r($vendor_ids);
                   // die();
                    $query = PurchaseOrder::find()->orderBy(['id' => SORT_DESC])->where(['in', 'vendor_name', $vendor_ids])->andWhere(['is_deleted' =>0]);
                }



        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/purchase/purchase-order/export-pdf', [
            'dataProvider' => $dataProvider,

        ]));
        if($print=='print')
        {
            $mpdf->Output('Purcahse_details.pdf', 'I');
        }
        else
        {
            $mpdf->Output('Purcahse_details.pdf', 'D');
        }
        
    }

    public function actionExcelExport($detail=null,$data=null)
    {
     Yii::$app->view->params['active']=23;
     $check_id = Yii::$app->user->identity->id;
     $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
   if($user_type->item_name == 'Admin')
    {
       $query=PurchaseOrder::find()->orderBy([
        'id' => SORT_DESC,
      ])->where(['is_deleted' =>0]);
    }
    else
    {
        $accessed = Yii::$app->user->identity->id;
        // print_r($accessed);
        // die();
        $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->all();
        $vendor_ids= [];
        $i = 0;
        foreach($vendors as $data)
        {
            $vendor_ids[$i] = $data->client_id;
            $i++;
        } 
       //  print_r($vendor_ids);
       // die();
        $query = PurchaseOrder::find()->orderBy(['id' => SORT_DESC])->where(['in', 'vendor_name', $vendor_ids])->andWhere(['is_deleted' =>0]);
    }
    if($data!='')
    {
        $dataProvider = $data;
    }
    else{
        $dataProvider = new ActiveDataProvider([
            'query' =>$query,
        ]);
    }
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'setting_type',
            [
                'header'=> 'Vendor Name / Financial Category',
                'attribute' => 'vendor_name',
                'value'=> function($data){
                    $vendor=Vendor::find()->where(['id'=>$data->vendor_name])->one();
                   return $vendor?$vendor->business_name:'';
                } 
            ],
            'sendor_gstin',
            'bill_type',
            'notes:ntext',
            'delivery_address:ntext',
            'supply_type',
            'supply_attracts',
            'currancy',
            'point_of_supply',
            'eligibity_of_itc',
            'prefix',
            'po_last',
            [
                'header'=> 'date',
                'attribute' => 'date',
                'value'=> function($data){
                    $last_date = date('d-m-y', strtotime($data->date));
                   return $last_date;
                } 
            ],
            [
                'header'=> 'Due Date',
                'attribute' => 'due_date',
                'value'=> function($data){
                    if(isset($data->due_date)){
                    $last_date = date('d-m-y', strtotime($data->due_date));
                   return $last_date;
                    }
                } 
            ],
            'terms_of_payment',
            'total_amount',
            'terms_and_condition:ntext',
            'advance_payment',
            'advance_settingtype',
            'advance_amount',
            'bank',
            'cheque_no',
            'cheque_date',
            'advance_note',
            'supplier_ref',
            'other_ref',
            'dispatch_through',
            'destination',
            'mode_of_payment',
            'delivery_date',
            'reminder',
            'reminder_for',
            'reminder_emails',
            'reminder_content',
            'reminder_repeat_on',
            [
                'header'=> 'Reminder From Date',
                'attribute' => 'reminder_from_date',
                'value'=> function($data){
                    if(isset($data->reminder_from_date)){
                    $last_date = date('d-m-y', strtotime($data->reminder_from_date));
                   return $last_date;
                    }
                } 
            ],
            [
                'header'=> 'Reminder To Date',
                'attribute' => 'reminder_to_date',
                'value'=> function($data){
                    if(isset($data->reminder_to_date)){
                    $last_date = date('d-m-y', strtotime($data->reminder_to_date));
                   return $last_date;
                    }
                } 
            ],
            'terms_of_delivery',
        ],
    ]);
        }else{
            
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'header'=> 'PO #',
                        'value'=> function($data){
                            return $data->prefix."-". $data->po_last;
                        } 
                    ],
                    [
                        'header'=> 'Vendor Name / Financial Category',
                        'attribute' => 'vendor_name',
                        'value'=> function($data){
                            $vendor=Vendor::find()->where(['id'=>$data->vendor_name])->one();
                           return $vendor?$vendor->business_name:'';
                        } 
                    ],
                    [
                        'header'=> 'Date',
                        'value'=> function($data){
                            return date(("\ F jS  Y"), strtotime($data->date));
                        } 
                    ],
                    [
                        'header'=> 'Amount',
                        'value'=>'total_amount',
                    ],
                    [
                        'header'=> 'Paid',
                        'value'=>'advance_amount',
                    ],
                    [
                        'header'=> 'Pending',
                        'value'=> function($data){
                            return ($data->total_amount-$data->advance_amount);
                        } 
                    ],
                    [
                        'header'=> 'Status',
                        'value'=> function($data){
                            if(isset($data->advance_amount)){
                                return "Paid";
                            }
                            else{
                                return "Draft";
                            }
                        } 
                    ],
                    [
                        'header'=> 'Stock Status',
                        'value'=> function($data){
                            return "";
                        } 
                    ],
                ],
            ]);
        }
    return $exporter->send('PurchaseOrder_details.xlsx');
    }

    public function actionFindproduct($productid)
    {
        Yii::$app->view->params['active']=23;
        $productdetails= Product::find()->where(['id' =>$productid])->one();
        echo Json::encode($productdetails);
    }
   public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
    public function actionVendordetails($searchTerm=null)
    {   
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();

        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Vendor::find()->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }   
        else
        {
            $vendor_ids = [];
            $i =0;

            $vendors = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Vendor'])->all();
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Vendor::find()->where(['in','id',$vendor_ids])->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$vendor_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }
        
    }

    /**
     * Updates an existing PurchaseOrder model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=23;

        $selected_date="2022-03-21";
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if( strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=PurchaseOrder::find()->where(['<=', 'date', $dynamic_date])->count();
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=PurchaseOrder::find()->where(['>=', 'date', $dynamic_date])->count();
            }
            else{
                $last_entry=0;
            }


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_purchase = PurchaseOrder::find()->where(['id'=>$id])->one();
            $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
            if($check_vendor == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['purchase-order/index']);
            }
        }
        
        $model = $this->findModel($id);
        if( $model->is_deleted==0){
        $data=Yii::$app->request->post();
        $purchaseorderproduct =PurchaseOrderProduct::find()->where(['purchase_order_id'=>$id])->all();
        if ($model->load(Yii::$app->request->post())) {
            $model->updated_by=Yii::$app->user->identity->id;
            $model->pending_amount = $model->total_amount;
            $data=Yii::$app->request->post();
             if($data['PurchaseOrder']['advance_payment']==1){
                 $model->advance_payment='Yes';
                 $model->advance_settingtype=$data['PurchaseOrder']['advance_settingtype'];
                 $model->advance_amount=$data['PurchaseOrder']['advance_amount'];
                 $model->bank=$data['PurchaseOrder']['bank'];
                 $model->cheque_no=$data['PurchaseOrder']['cheque_no'];
                 $model->cheque_date=$data['PurchaseOrder']['cheque_date'];
                 $model->advance_note=$data['PurchaseOrder']['advance_note'];
            }
             else{
                 $model->advance_payment='No';
                 $model->advance_settingtype="";
                 $model->advance_amount="";
                 $model->bank="";
                 $model->cheque_no="";
                 $model->cheque_date="";
                 $model->advance_note="";
             }
             if(Yii::$app->request->post('reminder')){
                $model->reminder='Yes';
                $model->reminder_through=1;
                $model->reminder_for=$data['PurchaseOrder']['reminder_for'];
                $model->reminder_emails=$data['PurchaseOrder']['reminder_emails'];
                $model->reminder_repeat_on=$data['PurchaseOrder']['reminder_repeat_on'];
                $model->reminder_from_date=$data['PurchaseOrder']['reminder_from_date'];
                $model->reminder_to_date=$data['PurchaseOrder']['reminder_to_date'];
                $model->reminder_content=$data['PurchaseOrder']['reminder_content'];
            }
            else{
                $model->reminder='No';
                $model->reminder_for="";
                $model->reminder_through="";
                $model->reminder_emails="";
                $model->reminder_repeat_on="";
                $model->reminder_from_date="";
                $model->reminder_to_date="";
                $model->reminder_content="";

            }
                    $model->save(false);
                    $files = UploadedFile::getInstances($model, 'files');
                    foreach($files as $file){
                        $purchase_doc = PurchaseDocument::find()->where(['purchase_id'=>$model->id])->all();
                        $tmp = explode('.', $file);
                        $document = new PurchaseDocument();
                        $ext = end($tmp);
                       // $ext = end((explode(".", $file)));
                        $filename = Yii::$app->security->generateRandomString().".{$ext}";
                        $serialize[] = $filename;
                        $count=count($purchase_doc)+1;
                        $name=(new \DateTime())->format('u').$count.".{$ext}";
                        $file->saveAs(Yii::$app->basePath . '/web/setting/purchase_documents/' . $name);
                        $document->document_name=$name; 
                        $document->purchase_id=$model->id;
                        $document->save();
                      }
            $purchase_order_product_delete=PurchaseOrderProduct::deleteAll(['purchase_order_id'=>$id]);
            if(isset($data['productdyn'])){
              //  echo "<pre>";print_r($data['productdyn']);die();

          foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                    $product = new PurchaseOrderProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    if($product->discount=='')
                    {
                        $product->discount = 0;
                    }
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->purchase_order_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);

                    $avilableproduct = Product::find()->where(['id'=>$product->product_id])->one();
                    $avilableproduct->stock_unit = $avilableproduct->stock_unit + $product->quantity;
                    $avilableproduct->save(false);
                } 
            }
         }
            if(isset($data['productdynupdate'])){
            foreach ($data['productdynupdate'] as $value) {
                    if($value['price']!='')
                    {
                    $porder = new PurchaseOrderProduct();
                    $porder->product_id = $value['product'];
                    $porder->description = $value['desc'];
                    $porder->quantity = $value['quantity'];
                    $porder->units = $value['units'];
                    $porder->price = $value['price'];
                    $porder->unit_price = $value['unitprice'];
                    $porder->discount = $value['discount'];
                    if($porder->discount=='')
                    {
                        $porder->discount = 0;
                    }
                    $porder->tax=$value['tax'];
                    $porder->discount_type=$value['discounttype'];
                    $porder->tax_included = $value['tax_included'];
                    $porder->amount = $value['amount'];
                    $porder->purchase_order_id = $model->id;
                    $porder->created_at=date('Y-m-d H:i:s');
                    $porder->updated_at=date('Y-m-d H:i:s');
                    $porder->save(false);

                    $avilableproduct = Product::find()->where(['id'=>$porder->product_id])->one();
                    $avilableproduct->stock_unit = $avilableproduct->stock_unit + $porder->quantity;
                    $avilableproduct->save(false);
                }
                }
        }
        if (Yii::$app->request->post('save') == 0) {
            Yii::$app->getSession()->setFlash('success', 'Updated Successfully');
            return $this->redirect(['purchase-order/index']);
     }

   if (Yii::$app->request->post('save') == 1) {
          Yii::$app->getSession()->setFlash('success', 'Updated Successfully');
          return $this->redirect(['purchase-order/create']);
     }
    }
    $purchase_doc = PurchaseDocument::find()->where(['purchase_id'=>$model->id])->all();

        return $this->render('/purchase/purchase-order/update', [
            'model' => $model,
            'purchaseorderproduct' => $purchaseorderproduct,
            'purchase_doc' => $purchase_doc,
            'last_entry'=>$last_entry+1,
            'settings_type'=> PurchaseOrderController::$settings_type,
            'banks_name'=> PurchaseOrderController::$banks_name,
        ]);
    } 
    else{
        print_r("this is a deleted record");
    }
    
    }

    /**
     * Deletes an existing PurchaseOrder model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        Yii::$app->view->params['active']=23;
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $purchase=$this->findModel($id);  
            $purchase->is_deleted = 1;   
            $purchase->save(false);
            }
            Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
            return $this->redirect(['index']);
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_purchase = PurchaseOrder::find()->where(['id'=>$id])->one();
                $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
                if($check_vendor == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['purchase-order/index']);
                }
            }
            $purchase=$this->findModel($id);  
            $purchase->is_deleted =1;   
            $purchase->save(false);
            Yii::$app->getSession()->setFlash('success', 'Successfully Deleted');
            return $this->redirect(['index']);
        } 
    }
    public function actionDeleteAttachment()
    {
        Yii::$app->view->params['active']=23;
      
        $id=Yii::$app->request->post('remove_id');
        $customer_doc = PurchaseDocument::find()->where(['id'=>$id])->one();
        $customer_doc->delete();

      echo  "success";
 }
 public function actionPurchaseOrderTemplate($id,$print=null)
    {
        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_purchase = PurchaseOrder::find()->where(['id'=>$id])->one();
            $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
            if($check_vendor == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['purchase-order/index']);
            }
        }
        
      $model = $this->findModel($id);
      $mpdf = new mPDF;
      $mpdf->WriteHTML('Page {PAGENO} of {nb}');
      $mpdf->showImageErrors = true;
      $mpdf->WriteHTML($this->renderPartial('/purchase/purchase-order/purchase-order-template', [
            'model' => $model,
        ]));
        if($print=='print')
        {
         $mpdf->Output('purchase-order.pdf', 'I');
        }
        else
        {
            $mpdf->Output('purchase-order.pdf', 'D');
        }


    }
    public function actionPurchaseOrderTemplatePrint($id)
    {
        
      $model = $this->findModel($id);
      $mpdf = new mPDF;
      $mpdf->WriteHTML('Page {PAGENO} of {nb}');
      $mpdf->showImageErrors = true;
      $mpdf->WriteHTML($this->renderPartial('/purchase/purchase-order/purchase-order-template', [
            'model' => $model,
        ]));

         $mpdf->Output('purchase-order.pdf', 'I');


    } 

 Public function actionDownloadAttachment($id)
 {
    Yii::$app->view->params['active']=23;
 $data=PurchaseDocument::find()->where(['purchase_id'=>$id])->all();
 if(!$data){
 Yii::$app->getSession()->setFlash('success', 'No Attachment Found');
 return $this->redirect(['index']);
 }
 $file = Yii::$app->basePath.'/web/setting/purchase_documents/purchasedoc_'.$id.'zip';
 $zip = new \ZipArchive();
 $zip->open($file, \ZipArchive::CREATE | \ZipArchive::OVERWRITE) ;
 foreach($data as $value){
    $files[]=Yii::$app->basePath . '/web/setting/purchase_documents/'.$value->document_name;
 }
 foreach($files as $val){
     $zip->addFromString(basename($val), file_get_contents($val));
 }
 $zip->close();
 return Yii::$app->response->sendFile($file);
 }

 public function actionPurchasePending()
 {
    Yii::$app->view->params['active']=130;
    $model = new PurchaseAgainstGr();
    $check_id = Yii::$app->user->identity->id;
    $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
    if($user_type->item_name == 'Admin')
    {
      $query = PurchaseAgainstGr::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Bill'],['convert_to'=>'Payment']])->orderBy(['id' => SORT_DESC]);
    }
    else
    {
        $accessed = Yii::$app->user->identity->id;
        $v_ids= [];
        $j = 0;
        $purchase_ids = PurchaseOrder::find()->all();
        foreach($purchase_ids as $val)
        {
            $purchase_order_assessed = PurchaseOrder::find()->where(['id'=>$val->id])->one();
            if($purchase_order_assessed != '')
            {
                $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->andWhere(['client_id'=>$purchase_order_assessed->vendor_name])->one();
                if($vendors)
                {
                    $v_ids[$j] = $vendors->client_id;
                    $j++;
                }
            }
        }
        $assigned_purchaseorders=PurchaseOrder::find()->WHERE(['in', 'vendor_name',$v_ids])->andwhere(['is_deleted' =>0])->all();
        $pur_ids= [];
        $i = 0;
        foreach($assigned_purchaseorders as $val)
        {
           $pur_ids[$i] = $val->id;
           $i++;
        }

        $query = PurchaseAgainstGr::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Bill'],['convert_to'=>'Payment']])->andWhere(['in','purchase_id',$pur_ids])->orderBy(['id' => SORT_DESC]);

    }

    
        if($model->load(Yii::$app->request->get()))
        {
            // print_r('dd');
            // die();
            $query->andFilterWhere(['between', 'purchase_date', $model->from_date,$model->to_date]);
        }   
        $dataProvider = new ActiveDataProvider(['query' => $query]);

    return $this->render('/purchase/purchase-order/purchase-pending', [
            'model' => $model,
            'dataProvider'=>$dataProvider,
           
            // 'sales_types'=> SaleOrderController::$sales_types,
        ]);
 }

    public function actionCheckPurchaseorder()
    {                     
        $ids=Yii::$app->request->post('data');
        // $ids = [3,2];
        $p_id = PurchaseAgainstGr::find()->select('purchase_id')->where(['id'=>$ids[0]])->one();
        // print_r($s_id);
        // die();
        $count =0;
        for($i=0; $i<count($ids); $i++)
        {
        
          $purchase= PurchaseAgainstGr::find()->where(['id'=>$ids[$i]])->one();
          $purchase_id= PurchaseAgainstGr::find()->select('purchase_id')->where(['id'=>$ids[$i]])->one();
          if($p_id!=$purchase_id)
          {
             $count = $count + 1;
          }
          else
          {
            if($purchase->bill_no!=null)
            {
                 $count = $count + 1;
            }
          }
        }                             
        if($count == 0 ){
            echo 'true';
        }
        else{
            echo 'false';
        }
       
    }

    public function actionFromPurchaseorder()
    {       
                    // $ids = [2,3];
        $ids=Yii::$app->request->post('data');
        $p_id = PurchaseAgainstGr::find()->where(['id'=>$ids[0]])->one();
       
        return Yii::$app->getResponse()->redirect(['users/purchase-bill/create','po'=>$p_id->purchase_id,'from' => 'against_gr','gr'=>$ids]);
    }

    /**
     * Finds the PurchaseOrder model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return PurchaseOrder the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = PurchaseOrder::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionFinddetails()
    { 
        $taxdetails= Accountingtax::find()->select(['tax_name','accounting_tax_id'])->where(['is_deleted'=>0])
              ->andWhere(['tax_sub_type'=>'Output'])
              ->andWhere(['status'=>1])
              ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])->all();      
        $taxlist=ArrayHelper::map($taxdetails, 'accounting_tax_id','tax_name');
        return Json::encode($taxlist);
    }
    public function actionTaxdetails($item)
    {
       $taxdetails= AccountingTax::find()->where(['accounting_tax_id' =>$item])->one();
        echo Json::encode($taxdetails);
    }
     public function actionFindvendordetails($customerid)
    {
       $vendordetails= Vendor::find()->where(['id' =>$customerid])->one();
        echo Json::encode($vendordetails);
    }

    public function actionFieldpurchaseordersettingtype($setting=null,$template=null)
    {   
        //print_r(1);die();
        $find = GenericTemplate::find()->where(['template_for'=>'Purchase Order'])->andWhere(['gt_id'=>$setting])->count();
        echo Json::encode($find);
    }

    public function actionSelectdate($selected_date=null)
    {  
        $selected_date=$_GET['selected_date']; 
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        $dynamic_date_last = ($year - 1) . '-' . '03' . '-' . '31';
        $count_before_year=PurchaseOrder::find()->where(['<=', 'date', $dynamic_date])->andWhere(['>=', 'date', $dynamic_date_last])->count();
        $count_after_year=PurchaseOrder::find()->where(['>=', 'date', $dynamic_date])->count();

        if(strtotime($selected_date) <= strtotime($dynamic_date)) { 
            $last_entry=$count_before_year+1;
        }
        else if(strtotime($selected_date) > strtotime($dynamic_date)){
            $last_entry=$count_after_year+1;
        } 
        else{
            $last_entry=0;
        }
        echo $last_entry;
    }



}
