<?php

namespace backend\modules\master\controllers;

use Yii;
use backend\modules\master\models\PurchaseOrderIndent;
use backend\modules\master\models\PurchaseOrderIndentSearch;
use backend\modules\master\models\PurchaseOrderIndentProduct;
use backend\modules\master\models\PurchaseOrderProduct;
use backend\modules\master\models\PurchaseOrder;
use backend\modules\master\models\Product;
use backend\modules\master\models\PurchaseDocument;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\Controller;
use yii\helpers\ArrayHelper;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use Mpdf\Mpdf;

/**
 * PurchaseOrderIndentController implements the CRUD actions for PurchaseOrderIndent model.
 */
class PurchaseOrderIndentController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    public static $settings_type=["Invoice Receipt"=>"Invoice Receipt"
    ]
    ;
    public static $banks_name=["Punjab National Bank"=>"Punjab National Bank",
    "Bank of India"=>"Bank of India",
    "State Bank of India"=>"State Bank of India"        
];
    /**
     * Lists all PurchaseOrderIndent models.
     * @return mixed
     */
    public function actionIndex()
    {
        Yii::$app->view->params['active']=22;
        $model = new PurchaseOrderIndent();
        $searchModel = new PurchaseOrderIndentSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        if($model->load(Yii::$app->request->get())){
            $query=PurchaseOrderIndent::find()->where(['is_deleted' =>0]);
            $dataProvider = new ActiveDataProvider([
                'query' => $query,
            ]);
            //echo "<pre>";print_r($model);die();
            if($model->search!=""){
                $query
                ->andFilterWhere(['like', 'converted_to', $model->search])
                ->orFilterWhere(['like', 'subject', $model->search]);

            }
           else if($model->from_date!="" && $model->to_date!=""){
                //echo "<pre>";print_r($model);die();
                 if($model->product!=""){
                    $exist_product = PurchaseOrderIndentProduct::find()->where(['product_id'=>$model->product])->all();
                    $purchase_ids=array();
                    foreach ($exist_product as $key => $row){
                        $purchase_ids[$key] = $row['purchase_order_indent_id'];
                      }
                $query=PurchaseOrderIndent::find()->orderBy([
                    'id' => SORT_DESC,
                  ])->WHERE(['in', 'id',$purchase_ids])->andwhere(['is_deleted' =>0]);
               // echo "<pre>";print_r($purchase_ids);die();
                }
                else{
                    $query=PurchaseOrderIndent::find()->orderBy([
                        'id' => SORT_DESC,
                      ])->where(['is_deleted' =>0]);
                 $query->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                  ->andFilterWhere(['like', 'subject', $model->subject])
                 ->andFilterWhere(['like', 'converted_to', $model->converted_to]);
                }
             }
             else{
                $dataProvider = new ActiveDataProvider(['query' => $query]);

             }
             $dataProvider = new ActiveDataProvider(['query' => $query]);
    
            }

        return $this->render('/purchase/purchase-order-indent/index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,

        ]);
    }

    /**
     * Displays a single PurchaseOrderIndent model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        Yii::$app->view->params['active']=22;
        $products=PurchaseOrderIndentProduct::find()->where(['purchase_order_indent_id'=>$id])->all();
        return $this->render('/purchase/purchase-order-indent/view', [
            'model' => $this->findModel($id),
            'products'=>$products,
        ]);
    }

    /**
     * Creates a new PurchaseOrderIndent model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        Yii::$app->view->params['active']=22;
        $model = new PurchaseOrderIndent();
        $purchaseindentproduct = new PurchaseOrderIndentProduct();
        $data=Yii::$app->request->post();
        $tmp = array();
        $last_purchase_indent=PurchaseOrderIndent::find()->orderby(['id' => SORT_DESC])->one();
        if (Yii::$app->request->post()) {
            $check_duplixy=PurchaseOrderIndent::find()->where(['id'=>$data['last_purchase_indent']+1])->one();
            
          if(!isset($check_duplixy)){
            if(isset($data['productdyn'])){
                $model->total_amount=$data['PurchaseOrderIndent']['total_amount'];
                $model->sub_total_amount=$data['PurchaseOrderIndent']['sub_total_amount'];
                $model->date=date('Y-m-d H:i:s');
                $model->source="Manual";
               foreach ($data['productdyn'] as $key => $row){
                if(isset($row['product_name']) && $row['price']!=0){
                    $productdetails= Product::find()->where(['id' =>$row['product_name']])->one();
                   $tmp[$key] = $productdetails->product_name."(".$productdetails->description.")";
                }
              }
              $model->subject=implode(' , ', $tmp);
              $model->save(false);
              foreach ($data['productdyn'] as $key => $value){
                //   print_r($value);die();
               // echo "<pre>";print_r($data['productdyn']);die();
                if($value['price']!=0){
                $purchase_order_product = new PurchaseOrderIndentProduct();
                $purchase_order_product->product_id = $value['product_name'];
                $purchase_order_product->description = $value['desc'];
                $purchase_order_product->quantity = $value['quantity'];
                $purchase_order_product->units = $value['units'];
                $purchase_order_product->unit_price = $value['unitprice'];
                $purchase_order_product->price = $value['price'];
                $purchase_order_product->amount = $value['amount'];
                $purchase_order_product->tax = $value['tax'];
                $purchase_order_product->purchase_order_indent_id = $model->id;
               $purchase_order_product->save(false);

                }
              }
              //die();
              Yii::$app->getSession()->setFlash('success', 'Successfully created the Purchase Indent');
              return $this->redirect(['purchase-order-indent/index']);
           }
         }
         else{
            Yii::$app->getSession()->setFlash('success', 'Successfully created the Purchase Indent');
            return $this->redirect(['purchase-order-indent/index']);
         }
        }

        return $this->render('/purchase/purchase-order-indent/create', [
            'model' => $model,
            'purchaseindentproduct' =>  $purchaseindentproduct,
            'last_purchase_indent' => $last_purchase_indent
        ]);
    }
    public function actionFindproduct($productid)
    {
        Yii::$app->view->params['active']=22;
        // print_r('xx');
        // exit();
        // $productdetails= Product::findOne($productid);
        $productdetails= Product::find()->where(['id' =>$productid])->one();
        echo Json::encode($productdetails);
    }
    

    /**
     * Updates an existing PurchaseOrderIndent model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=22;
        $model = $this->findModel($id);
        $data=Yii::$app->request->post();
        $tmp = array();
        $tmp_update = array();
        $purchaseindentproduct =PurchaseOrderIndentProduct::find()->where(['purchase_order_indent_id'=>$id])->all();
       // echo "<pre>";print_r($purchaseindentproduct);die();
       if( $model->is_deleted==0){
        if (Yii::$app->request->post()) {
             if(isset($data['productdynupdate'])){
                foreach ($data['productdynupdate'] as $key => $row){
                    if(isset($row['product_name']) && $row['price']!=0){
                        $productdetails= Product::find()->where(['id' =>$row['product_name']])->one();
                    $tmp[$key] = $productdetails->product_name."(".$productdetails->description.")";
                 }
               }
            }
            if(isset($data['productdyn'])){
                foreach ($data['productdyn'] as $key => $row){
                    if(isset($row['product_name']) && $row['price']!=0){
                        $productdetails= Product::find()->where(['id' =>$row['product_name']])->one();
                     $tmp_update[$key] = $productdetails->product_name."(".$productdetails->description.")";
                 }
               }
            }               
               $model->total_amount=$data['PurchaseOrderIndent']['total_amount'];
               $model->sub_total_amount=$data['PurchaseOrderIndent']['sub_total_amount'];
               $model->date=date('Y-m-d H:i:s');
               $model->source="Sales Order";
               $model->subject=implode(' , ', $tmp).' , '.implode(' , ', $tmp_update);
               $model->save(false);
               $purchase_order_product_delete=PurchaseOrderIndentProduct::deleteAll(['purchase_order_indent_id'=>$id]);
               if(isset($data['productdyn'])){
               foreach ($data['productdyn'] as $key => $value){
                if($value['price']!=0){
                $purchase_order_product = new PurchaseOrderIndentProduct();
                $purchase_order_product->product_id = $value['product_name'];
                $purchase_order_product->description = $value['desc'];
                $purchase_order_product->quantity = $value['quantity'];
                $purchase_order_product->tax = $value['tax'];
                $purchase_order_product->units = $value['units'];
                $purchase_order_product->unit_price = $value['unitprice'];
                $purchase_order_product->price = $value['price'];
                $purchase_order_product->amount = $value['amount'];
                $purchase_order_product->purchase_order_indent_id = $model->id;
                $purchase_order_product->save(false);

                }
              }
            }
            if(isset($data['productdynupdate'])){
               foreach ($data['productdynupdate'] as $key => $value){
                if($value['price']!=0){
                $purchase_order_product = new PurchaseOrderIndentProduct();
                $purchase_order_product->product_id = $value['product_name'];
                $purchase_order_product->description = $value['desc'];
                $purchase_order_product->quantity = $value['quantity'];
                $purchase_order_product->units = $value['units'];
                $purchase_order_product->unit_price = $value['unitprice'];
                $purchase_order_product->price = $value['price'];
                $purchase_order_product->tax = $value['tax'];
                $purchase_order_product->amount = $value['amount'];
                $purchase_order_product->purchase_order_indent_id = $model->id;
                $purchase_order_product->save(false);

                }
              }
            }
               Yii::$app->getSession()->setFlash('success', 'Successfully updated the Purchase Indent');
               return $this->redirect(['purchase-order-indent/index']);
            
         }
        return $this->render('/purchase/purchase-order-indent/update', [
            'model' => $model,
            'purchaseindentproduct' => $purchaseindentproduct,
        ]);
       }
       else{
        print_r("this is a deleted record");
       }
    }
    //  public function  actionConvertPurchase($id)
    // {
    //     Yii::$app->view->params['active']=22;
    //     $model = new PurchaseOrder();
    //     if( $model->is_deleted==0){
    //     $data=Yii::$app->request->post();
    //     $purchaseindentproduct =PurchaseOrderIndentProduct::find()->where(['purchase_order_indent_id'=>$id])->all();
    //     $exist_purchaseindent =PurchaseOrderIndent::find()->where(['id'=>$id])->one();


    //     if ($model->load(Yii::$app->request->post())) {
    //         $data=Yii::$app->request->post();
    //         $model->total_amount=$data['PurchaseOrderIndent']['total_amount'];
    //         $model->sub_total_amount=$data['PurchaseOrderIndent']['sub_total_amount'];
    //      // echo "<pre>";print_r($data);die();
    //          if($data['PurchaseOrder']['advance_payment']==1){
    //              $model->advance_payment='Yes';
    //              $model->advance_settingtype=$data['PurchaseOrder']['advance_settingtype'];
    //              $model->advance_amount=$data['PurchaseOrder']['advance_amount'];
    //              $model->bank=$data['PurchaseOrder']['bank'];
    //              $model->cheque_no=$data['PurchaseOrder']['cheque_no'];
    //              $model->cheque_date=$data['PurchaseOrder']['cheque_date'];
    //              $model->advance_note=$data['PurchaseOrder']['advance_note'];
    //         }
    //          else{
    //              $model->advance_payment='No';
    //              $model->advance_settingtype="";
    //              $model->advance_amount="";
    //              $model->bank="";
    //              $model->cheque_no="";
    //              $model->cheque_date="";
    //              $model->advance_note="";
    //          }
    //          if(isset($model->reminder_for)){
    //             $model->reminder='Yes';
    //          }
    //          else{
    //             $model->reminder='No';
    //          }
    //          if($model->reminder_through==1){
    //              $model->reminder_through=1;
    //              $model->reminder_emails=$data['PurchaseOrder']['reminder_emails'];
    //              $model->reminder_repeat_on=$data['PurchaseOrder']['reminder_repeat_on'];
    //              $model->reminder_from_date=$data['PurchaseOrder']['reminder_from_date'];
    //              $model->reminder_to_date=$data['PurchaseOrder']['reminder_to_date'];
    //              $model->reminder_content=$data['PurchaseOrder']['reminder_content'];
    //          }
    //          else{
    //              $model->reminder_through="";
    //              $model->reminder_emails="";
    //              $model->reminder_repeat_on="";
    //              $model->reminder_from_date="";
    //              $model->reminder_to_date="";
    //              $model->reminder_content="";
 
    //          }
    //                 $model->save(false);
    //                 $exist_purchaseindent->converted_to= "Purchase Order";
    //                 $exist_purchaseindent->convert_purchase_id	=$model->id;
    //                 $exist_purchaseindent->save(false);
    //                 $files = UploadedFile::getInstances($model, 'files');
    //                 foreach($files as $file){
    //                     $purchase_doc = PurchaseDocument::find()->where(['purchase_id'=>$model->id])->all();
    //                     $tmp = explode('.', $file);
    //                     $document = new PurchaseDocument();
    //                     $ext = end($tmp);
    //                    // $ext = end((explode(".", $file)));
    //                     $filename = Yii::$app->security->generateRandomString().".{$ext}";
    //                     $serialize[] = $filename;
    //                     $count=count($purchase_doc)+1;
    //                     $name=(new \DateTime())->format('u').$count.".{$ext}";
    //                     $file->saveAs(Yii::$app->basePath . '/web/setting/purchase_documents/' . $name);
    //                     $document->document_name=$name; 
    //                     $document->purchase_id=$model->id;
    //                     $document->save();
    //                   }
    //         $purchase_order_product_delete=PurchaseOrderProduct::deleteAll(['purchase_order_id'=>$id]);
    //         if(isset($data['productdyn'])){
    //           //  echo "<pre>";print_r($data['productdyn']);die();

    //         foreach ($data['productdyn'] as $value) {
    //             $purchase_order_product = new PurchaseOrderProduct();
    //             $purchase_order_product->product_id = $value['product_name'];
    //             $purchase_order_product->description = $value['desc'];
    //             $purchase_order_product->quantity = $value['quantity'];
    //             $purchase_order_product->unit_price = $value['unitprice'];
    //             $purchase_order_product->units = $value['units'];
    //             $purchase_order_product->price = $value['price'];
    //             $purchase_order_product->discount = $value['discount'];
    //             $purchase_order_product->tax = $value['tax'];
    //             if(isset($value['discounttype'])){
    //             $purchase_order_product->discount_type=$value['discounttype'];
    //             }
    //             if(isset($value['tax_included'])){
    //                 $purchase_order_product->tax_included = 1;

    //             }
    //             else{
    //                 $purchase_order_product->tax_included = 0;
    //             }
    //             $purchase_order_product->amount = $value['amount'];
    //             $purchase_order_product->purchase_order_id = $model->id;
    //             $purchase_order_product->created_at=date('Y-m-d H:i:s');
    //             $purchase_order_product->updated_at=date('Y-m-d H:i:s');
    //             $purchase_order_product->save(false);
    //         }
    //      }
    //         if(isset($data['productdynupdate'])){
    //         foreach ($data['productdynupdate'] as $value) {
    //             $purchase_order_product = new PurchaseOrderProduct();
    //             $purchase_order_product->product_id = $value['product_name'];
    //             $purchase_order_product->description = $value['desc'];
    //             $purchase_order_product->quantity = $value['quantity'];
    //             $purchase_order_product->units = $value['units'];
    //             $purchase_order_product->price = $value['price'];
    //             $purchase_order_product->unit_price = $value['unitprice'];
    //             $purchase_order_product->discount = $value['discount'];
    //             $purchase_order_product->tax = $value['tax'];
    //             $purchase_order_product->discount_type=$value['discounttype'];
    //             $purchase_order_product->tax_included = $value['tax_included'];
    //             $purchase_order_product->amount = $value['amount'];
    //             $purchase_order_product->purchase_order_id = $model->id;
    //             $purchase_order_product->created_at=date('Y-m-d H:i:s');
    //             $purchase_order_product->updated_at=date('Y-m-d H:i:s');
    //             $purchase_order_product->save(false);
    //         }
    //     }
    //     Yii::$app->getSession()->setFlash('success', 'Converted to Purchase Order Successfully');
    //     return $this->redirect(['purchase-order/index']);
    // }
    // $purchase_doc = PurchaseDocument::find()->where(['purchase_id'=>$model->id])->all();

    //     return $this->render('/purchase/purchase-order-indent/convertpurchase', [
    //         'model' => $model,
    //         'purchaseorderproduct' => $purchaseindentproduct,
    //         'purchase_doc' => $purchase_doc,
    //         'exist_purchaseindent' => $exist_purchaseindent,
    //         'settings_type'=> PurchaseOrderIndentController::$settings_type,
    //         'banks_name'=> PurchaseOrderIndentController::$banks_name,
    //     ]);
    // } 
    // else{
    //     print_r("this is a deleted record");
    // }
    
    // }

    /**
     * Deletes an existing PurchaseOrderIndent model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    
    public function actionExportPdf()
    {
        Yii::$app->view->params['active']=22;
        $dataProvider = new ActiveDataProvider([
            'query' => PurchaseOrderIndent::find()->orderBy([
                'id' => SORT_DESC,
              ])->where(['is_deleted' =>0]),
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/purchase/purchase-order-indent/export-pdf', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('PurchaseIndent_details.pdf', 'D');
    }

    public function actionExcelExport($detail=null)
    {Yii::$app->view->params['active']=22;
        $dataProvider = new ActiveDataProvider([
            'query' =>PurchaseOrderIndent::find()->orderBy([
                'id' => SORT_DESC,
              ])->where(['is_deleted' =>0]),
        ]);
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'subject',
            [
                'header'=> 'Date',
                'value'=> function($data){
                    if(isset($data->date)){
                    $last_date = date('d-m-y', strtotime($data->date));
                   return $last_date;
                    }
                } 
            ],
            'converted_to',
            'total_amount'

        ],
    ]);
        }else{
            // print_r("xxxxx");
            // exit();
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    'subject',
                    [
                        'header'=> 'Date',
                        'value'=> function($data){
                            if(isset($data->date)){
                            $last_date = date('d-m-y', strtotime($data->date));
                           return $last_date;
                            }
                        } 
                    ],
                 'converted_to',
                 'total_amount'
                ],
            ]);
        }
    return $exporter->send('PurchaseIndent_details.xlsx');
    }
    public function actionDelete($id=null)
    {
        Yii::$app->view->params['active']=22;
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $purchase=$this->findModel($id);  
            $purchase->is_deleted = 1;   
            $purchase->save(false);
            }
            Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
            return $this->redirect(['index']);
        }
        else
        {
            $purchase=$this->findModel($id);  
            $purchase->is_deleted =1;   
            $purchase->save(false);
            Yii::$app->getSession()->setFlash('success', 'Successfully Deleted');
            return $this->redirect(['index']);
        }
        
        
    }
    /**
     * Finds the PurchaseOrderIndent model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return PurchaseOrderIndent the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = PurchaseOrderIndent::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }

}
