<?php

namespace backend\modules\master\controllers;

use Yii;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\VendorcontactDetails;
use backend\modules\master\models\VendorSearch;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\IndianCities;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;
use yii\data\ActiveDataProvider;
use yii\helpers\ArrayHelper;
use Mpdf\Mpdf;
use yii2tech\spreadsheet\Spreadsheet;

/**
 * VendorController implements the CRUD actions for Vendor model.
 */
class VendorController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    // 'delete' => ['POST'],
                ],
            ],
        ];
    }

    public static $country=["India"=>"India",
    "Others"=>"Others",
   ]
    ;
    public static $state=["Others"=>"Others",
    ]
    ;
    public static $gst_type = ["Unregistered"=>"Unregistered",
     "Registred"=>"Registred","Compounded" =>"Compounded",
     "Branch" =>"Branch"]
     ;
    Public static $removal =["Regular" =>"Regular",
    "Import"=>"Import","Compounded" =>"Compounded"
    ]
    ; 

    /**
     * Lists all Vendor models.
     * @return mixed
     */
    public function actionIndex()
    {
        Yii::$app->view->params['active']=13;
        $model=new Vendor();
        $searchModel = new VendorSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $query = Vendor::find();
        if($model->load(Yii::$app->request->get())){
            $query->andFilterWhere(['like', 'business_name', $model->findname])
            ->andFilterWhere(['like', 'mobile_no', $model->mobile]);

            
                $dataProvider = new ActiveDataProvider(['query' => $query]);   
        }

        return $this->render('index', [
            'model' => $model,
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Vendor model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        Yii::$app->view->params['active']=13;
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Vendor model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($page=null)
    {
        Yii::$app->view->params['active']=13;
        $model = new Vendor();
        $contact = new VendorcontactDetails();
        $count = Vendor::find()->count();
        if ($model->load(Yii::$app->request->post()) ) {
            // && $contact->load(Yii::$app->request->post())
            $model->created_at=date('Y-m-d H:i:s');
             $model->updated_at=date('Y-m-d H:i:s');
            $model->alternative_phone_no = $_POST['Vendor']['alternative_phone_no'];
            $model->page=$_POST['Vendor']['page'];
            $page = $model->page;
            $model->save(false);

            $ledger = new AccountingLedger();
            $ledger->taxable_ledger ='TAXABLE';
            $ledger->ledger_id = $model->business_name;
            $ledger->name = $model->business_name;
            $ledger->group_name_id =29;
            $ledger->account_type_id = 3;
            $ledger->alias_name =$model->business_name;
            $ledger->opening_balance = $model->opening_as_on;
            $ledger->save(false);
           
            return $this->redirect(['update','id'=>$model->id,'page'=>2]);
        }

        return $this->render('create', [
            'model' => $model,
            'contact' => $contact,
            'country'=> VendorController::$country,
            'state'=> VendorController::$state,
            'gst_type'=> VendorController::$gst_type,
            'removal'=> VendorController::$removal,
            'count' => $count,
            'page'=>$page,
        ]);
    }

    /**
     * Updates an existing Vendor model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id,$page)
    {
        Yii::$app->view->params['active']=13;
        if($page>7)
            {
               return $this->redirect(['vendor/index']); 
            }
        $model = $this->findModel($id);
       
         $contact = new VendorcontactDetails();
          $con = VendorcontactDetails::find()->where(['vendor_id'=>$id])->all();
        if ($model->load(Yii::$app->request->post()) ) {
            // && $con->load(Yii::$app->request->post())
            $model->updated_at=date('Y-m-d H:i:s');
            
            // $model->save(false);
            $data=Yii::$app->request->post();
            $previous_data = Vendor::find()->where(['id'=>$id])->one();
            $ledger = AccountingLedger::find()->where(['ledger_id'=>$previous_data->business_name])->one();
            $ledger->taxable_ledger ='TAXABLE';
            $ledger->ledger_id = $model->business_name;
            $ledger->name = $model->business_name;
            $ledger->group_name_id =29;
            $ledger->account_type_id = 3;
            $ledger->alias_name =$model->business_name;
            $ledger->opening_balance = $model->opening_as_on;
            $ledger->save(false);
            if($model->page !=7){
                $model->page=$_POST['Vendor']['page'];
            }
            $model->save(false);
            if($page==5)
            {
                $contacts =VendorcontactDetails::deleteAll(['vendor_id'=>$id]);
                if(isset($data['contactdynupdate']))
                {
                    
                    foreach ($data['contactdynupdate'] as $value) {
                    if($value['contact_name']!='')
                    {
                        $contact = new VendorcontactDetails();
                        $contact->contact_name = $value['contact_name'];
                        $contact->designation = $value['designation'];
                        $contact->contact_email_id = $value['contact_email_id'];
                        $contact->contact_mobile_no = $value['contact_mobile_no'];
                        $contact->contact_person_type = $value['contact_person_type'];
                        $contact->contact_type = $value['contact_type'];
                        $contact->vendor_id = $id;
                        $contact->created_at=date('Y-m-d H:i:s');
                        $contact->updated_at=date('Y-m-d H:i:s');
                        $contact->save(false);
                    }
                    }
                }

                foreach ($data['contactdyn'] as $value) {
                if($value['contact_name']!='')
                {
                    $contact = new VendorcontactDetails();
                    $contact->contact_name = $value['contact_name'];
                    $contact->designation = $value['designation'];
                    $contact->contact_email_id = $value['contact_email_id'];
                    $contact->contact_mobile_no = $value['contact_mobile_no'];
                    $contact->contact_person_type = $value['contact_person_type'];
                    $contact->contact_type = $value['contact_type'];
                    $contact->vendor_id = $id;
                    $contact->created_at=date('Y-m-d H:i:s');
                    $contact->updated_at=date('Y-m-d H:i:s');
                    $contact->save(false);
                }

            }
            }

            if($page==7)
            {
                Yii::$app->getSession()->setFlash('success', 'Successfully Created Vendor');
                return $this->redirect(['vendor/index']);
            }
            
            else
            {
                return $this->redirect(['update','id'=>$model->id,'page'=>$page+1]);
            }
            
        }
        return $this->render('update', [
            'model' => $model,
            'contact' => $contact,
            'con' => $con,
            'page'=>$page,
            'country'=> VendorController::$country,
            'state'=> VendorController::$state,
            'gst_type'=> VendorController::$gst_type,
            'removal'=> VendorController::$removal,
        ]);
    }
    /**
     * Deletes an existing Vendor model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $this->findModel($id)->delete();
            $contactdetails = VendorcontactDetails::find()->where(['vendor_id'=>$id])->all();
            foreach ($contactdetails as $contactdetails) {
                # code...
                 $contactdetails->delete();
            }
            }
            Yii::$app->getSession()->setFlash('success', 'Successfully  Deleted selected Vendors'); 
            return $this->redirect(['index']);
        }
        else
        {
            $this->findModel($id)->delete();
            $contactdetails = VendorcontactDetails::find()->where(['vendor_id'=>$id])->all();
            foreach ($contactdetails as $contactdetails) {
                # code...
                 $contactdetails->delete();
            }
            Yii::$app->getSession()->setFlash('success', 'Vendor Deleted Successfully'); 
            return $this->redirect(['index']);
        }
        
    }

    public function actionExportPdf()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Vendor::find()->orderBy(['id' => SORT_DESC]),
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/vendor/export-pdf', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('vendors_details.pdf', 'I');
    }

    public function actionExcelExport($detail=null)
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Vendor::find()->orderBy(['id' => SORT_DESC]),
        ]);
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'business_name',
            'mobile_no',
            'account_id',
            'pricelist',
            'email',
            'vendor_type',
            'fax',
            'website',
            'phone_no',
            'alternative_phone_no',
            [
            'label' => 'Address',
            'attribute' => 'adderss_line_1',
            'value' => function ($data) {
                return $data->adderss_line_1.','.$data->adderss_line_2.','.$data->adderss_line_3.','.$data->city.','.$data->state.'('.$data->pin_code.'),'.$data->country;
            },
            ],
            [
            'label' => 'Shipping To',
            'attribute' => 'sipping_to_name',
            'value' => function ($data) {
                return $data->sipping_to_name;
            },
            ],
            [
            'label' => 'Shipping Address',
            'attribute' => 'adderss_line_1',
            'value' => function ($data) {
                return $data->shipping_address_1.','.$data->shipping_address_2.','.$data->shipping_address_3.','.$data->shipping_city.','.$data->shipping_state.'('.$data->shipping_postcode.'),'.$data->shipping_country;
            },
            ],
            'opening_as_on',
            'customer_gst_type',
            'gstin_no',
            'ho_state_code',
            'pan_number',
            'aadhar_number',
            'service_task_no',
            'cst_no',
            'ledger',
            'credit_terms',
            'vendor_ic',
            'vendor_brn',
            'ic_type',
            'tin',
            'beneficiary_name',
            'beneficiary_account_no',
            'bank_name',
            'bank_branch',
            'ifse_code',
            'swift',
            'micr_code',
            'account_type',
            'bsr',    
        ],
    ]);
        }else{
            // print_r("xxxxx");
            // exit();
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                  'business_name',
                    'email',
                    'vendor_type',
                    'country',
                ],
            ]);
        }
    return $exporter->send('vendor_details.xlsx');
    }


    public function actionValidationCreate($name)
    { 
        
      $count=Vendor::find()->where(['business_name'=>$name])->count();
      if($count>=1)
      return 0;
      else
      return 1;
    }
    public function actionNameValidation($name,$id=null,$page=null,$update=null)
    {  
    if($update=='update'){
            if($page==1){
            $count1=Vendor::find()->where(['business_name'=>$name,'id'=>$id])->count();
            $count2=Vendor::find()->where(['business_name'=>$name])->count();
            
             }
            else{
            $count1=Vendor::find()->where(['business_name'=>$name,'id'=>$id])->count();
            $count2=Vendor::find()->where(['business_name'=>$name])->count();
            
            }
            if(($count1==1 && $count2==1) || ($count1==0 && $count2==0))
            {
                return 1;
            }
            else
            {
                return 0; 
            }
            }

    }

    public function actionCitydetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $city=IndianCities::find()->limit(10)->all();
        else
        $city=IndianCities::find()->where(["like","city",$searchTerm])->limit(10)->all();

        $citylist=ArrayHelper::map($city, 'city', 'city');
        return json_encode($citylist);
    }
    /**
     * Finds the Vendor model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Vendor the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Vendor::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
