<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "account_group".
 *
 * @property int $account_group_id
 * @property string $group_name
 * @property int|null $parent_id
 * @property int $type_id
 * @property int $status
 * @property string $created_at
 * @property string $updated_at
 *
 * @property Types $type
 */
class AccountGroup extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'account_group';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['group_name'], 'unique'],
            [['group_name', 'type_id'], 'required'],
            [['parent_id', 'type_id', 'status'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['group_name'], 'string', 'max' => 50],
            [['type_id'], 'exist', 'skipOnError' => true, 'targetClass' => Types::className(), 'targetAttribute' => ['type_id' => 'type_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'account_group_id' => 'Account Group ID',
            'group_name' => 'Group Name',
            'parent_id' => 'Parent ID',
            'type_id' => 'Type ID',
            'status' => 'Status',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[Type]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getType()
    {
        return $this->hasOne(Types::className(), ['type_id' => 'type_id']);
    }
}
