<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\AccountingLedger;

/**
 * AccountingLedgerSearch represents the model behind the search form of `backend\modules\master\models\AccountingLedger`.
 */
class AccountingLedgerSearch extends AccountingLedger
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['accounting_ledger_id', 'group_name_id', 'msic_code'], 'integer'],
            [['taxable_ledger','account_type_id', 'ledger_id', 'name', 'alias_name', 'created_at', 'updated_at'], 'safe'],
            [['opening_balance'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = AccountingLedger::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort'=> ['defaultOrder' => ['accounting_ledger_id' => SORT_DESC]]

        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'accounting_ledger_id' => $this->accounting_ledger_id,
            'group_name_id' => $this->group_name_id,
            'account_type_id' => $this->account_type_id,
            'opening_balance' => $this->opening_balance,
            'msic_code' => $this->msic_code,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'taxable_ledger', $this->taxable_ledger])
            ->andFilterWhere(['like', 'ledger_id', $this->ledger_id])
            ->andFilterWhere(['like', 'account_type_id', $this->account_type_id])
            ->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'alias_name', $this->alias_name]);

        return $dataProvider;
    }
}
