<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "business_type".
 *
 * @property int $id
 * @property string $business_type_name
 * @property string $created_at
 * @property string $updated_at
 */
class BusinessType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'business_type';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['business_type_name'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['business_type_name'], 'string', 'max' => 254],
            ['business_type_name', 'unique','message' => 'This Business Type Name has already been taken.'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'business_type_name' => 'Business Type Name',
            'created_at' => 'Created Date',
            'updated_at' => 'Updated Date',
        ];
    }
}
