<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\CompanyProfile;

/**
 * CompanyProfileSearch represents the model behind the search form of `backend\modules\master\models\CompanyProfile`.
 */
class CompanyProfileSearch extends CompanyProfile
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'gstin_no', 'pan_no', 'mobile_no', 'org_contact_no'], 'integer'],
            [['company_name', 'email_id', 'f_year_start', 'f_year_end', 'f_year', 'address', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = CompanyProfile::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'f_year_start' => $this->f_year_start,
            'f_year_end' => $this->f_year_end,
            'gstin_no' => $this->gstin_no,
            'pan_no' => $this->pan_no,
            'mobile_no' => $this->mobile_no,
            'org_contact_no' => $this->org_contact_no,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'company_name', $this->company_name])
            ->andFilterWhere(['like', 'email_id', $this->email_id])
            ->andFilterWhere(['like', 'f_year', $this->f_year])
            ->andFilterWhere(['like', 'address', $this->address]);

        return $dataProvider;
    }
}
