<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "customer_contact".
 *
 * @property int $id
 * @property string $contact_name
 * @property int $customer_id
 * @property string $designation
 * @property string $contact_email_id
 * @property string $contact_mobile_no
 * @property string|null $is_primary
 * @property string|null $is_private
 * @property string $created_at
 * @property string $updated_at
 *
 * @property Customer $customer
 */
class CustomerContact extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'customer_contact';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['created_at', 'updated_at'], 'safe'],
            [['contact_name', 'vendor_id', 'designation', 'contact_email_id', 'contact_mobile_no', 'contact_type', 'contact_person_type'], 'string', 'max' => 254],
             [['contact_mobile_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Contact Person No can Contain only numeric characters.'],
             [['contact_mobile_no'], 'string','min'=>10, 'max' => 10],
              [['contact_email_id'], 'email'],
        ];
    }  

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'contact_name' => 'Contact Name',
            'customer_id' => 'Customer ID',
            'designation' => 'Designation',
            'contact_email_id' => 'Contact Email ID',
            'contact_mobile_no' => 'Contact Mobile No',
            'is_primary' => 'Is Primary',
            'is_private' => 'Is Private',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[Customer]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCustomer()
    {
        return $this->hasOne(Customer::className(), ['id' => 'customer_id']);
    }
}
