<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "discount_customer".
 *
 * @property int $id
 * @property int $discount_id
 * @property string|null $category
 * @property string $created_at
 * @property string $updated_at
 *
 * @property ProductDiscount $discount
 */
class DiscountCustomer extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'discount_customer';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['discount_id'], 'required'],
            [['discount_id'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['category'], 'string', 'max' => 128],
            [['discount_id'], 'exist', 'skipOnError' => true, 'targetClass' => ProductDiscount::className(), 'targetAttribute' => ['discount_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'discount_id' => 'Discount ID',
            'category' => 'Category',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[Discount]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDiscount()
    {
        return $this->hasOne(ProductDiscount::className(), ['id' => 'discount_id']);
    }
}
