<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "leads_enquiry".
 *
 * @property int $id
 * @property string|null $from_date
 * @property string|null $to_date
 * @property string $name
 * @property string $email
 * @property string $mobile
 * @property string|null $city
 * @property string|null $address
 * @property string|null $business_type
 * @property string|null $call_status
 * @property string|null $messages
 * @property string|null $mode_of_enquiry
 * @property string $created_at
 * @property string $updated_at
 */
class LeadsEnquiry extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'leads_enquiry';
    }

    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public function rules()
    {
        return [
            [['name', 'email', 'mobile','date'], 'required'],
            [['messages'], 'string'],
            [['created_at', 'updated_at','from_date','to_date'], 'safe'],
            [['date'], 'string', 'max' => 32],
            [['name', 'email', 'city', 'business_type', 'call_status', 'mode_of_enquiry'], 'string', 'max' => 128],
            [['converted_to'], 'string', 'max' => 254],
            [['mobile'], 'match' ,'pattern'=>'/^\d{10}$/', 'message'=> 'Phone No should contain 10 digit and only numeric'], 
            [['address'], 'string', 'max' => 1024],
            ['email', 'unique', 'message' => 'This email address has already been taken.'],
            [['email'], 'email'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'from_date' => 'From Date',
            'to_date' => 'To Date',
            'date' => 'Date',
            'name' => 'Name',
            'email' => 'Email',
            'mobile' => 'Mobile',
            'city' => 'City',
            'address' => 'Address',
            'business_type' => 'Business Type',
            'call_status' => 'Call Status',
            'messages' => 'Messages',
            'mode_of_enquiry' => 'Mode Of Enquiry',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
