<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\LeadsQuotes;

/**
 * LeadsQuotesSearch represents the model behind the search form of `backend\modules\master\models\LeadsQuotes`.
 */
class LeadsQuotesSearch extends LeadsQuotes
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'Is_tax'], 'integer'],
            [['supply_attracts', 'customer', 'executive', 'notes', 'receiver_gstn', 'sales_type', 'supply_attracts_rcharge', 'pointof_supply', 'terms', 'Date'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = LeadsQuotes::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'Is_tax' => $this->Is_tax,
            'Date' => $this->Date,
        ]);

        $query->andFilterWhere(['like', 'supply_attracts', $this->supply_attracts])
            ->andFilterWhere(['like', 'customer', $this->customer])
            ->andFilterWhere(['like', 'executive', $this->executive])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'receiver_gstn', $this->receiver_gstn])
            ->andFilterWhere(['like', 'sales_type', $this->sales_type])
            ->andFilterWhere(['like', 'supply_attracts_rcharge', $this->supply_attracts_rcharge])
            ->andFilterWhere(['like', 'pointof_supply', $this->pointof_supply])
            ->andFilterWhere(['like', 'terms', $this->terms]);

        return $dataProvider;
    }
}
