<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\Leads;

/**
 * LeadsSearch represents the model behind the search form of `backend\modules\master\models\Leads`.
 */
class LeadsSearch extends Leads
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'mobile'], 'integer'],
            [['enquiry_no', 'appoint_date', 'set_reminder', 'name','lead_date', 'email', 'city', 'address', 'business_type', 'product_model', 'mode_enquiry', 'remark', 'created_at', 'updated_at','status','postponed_date'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        //$query = Leads::find();
        $query=Leads::find()->where(['is_disqualify' =>1])->orderBy([
                'id' => SORT_DESC,
              ]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'appoint_date' => $this->appoint_date,
            'mobile' => $this->mobile,
            'status' => $this->status,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
            'status' => $this->status,
        ]);

        $query->andFilterWhere(['like', 'enquiry_no', $this->enquiry_no])
            ->andFilterWhere(['like', 'set_reminder', $this->set_reminder])
            ->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'lead_date', $this->lead_date])
            ->andFilterWhere(['like', 'postponed_date', $this->postponed_date])
            ->andFilterWhere(['like', 'email', $this->email])
            ->andFilterWhere(['like', 'city', $this->city])
            ->andFilterWhere(['like', 'address', $this->address])
            ->andFilterWhere(['like', 'business_type', $this->business_type])
            ->andFilterWhere(['like', 'product_model', $this->product_model])
            ->andFilterWhere(['like', 'status', $this->status])
            ->andFilterWhere(['like', 'mode_enquiry', $this->mode_enquiry])
            ->andFilterWhere(['like', 'remark', $this->remark]);

        return $dataProvider;
    }
}
