<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\ProductDiscount;

/**
 * ProductDiscountSearch represents the model behind the search form of `backend\modules\master\models\ProductDiscount`.
 */
class ProductDiscountSearch extends ProductDiscount
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'status'], 'integer'],
            [['dis_type', 'dis_name', 'id_code', 'start_date', 'till_date', 'access', 'category_include_exclude', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = ProductDiscount::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'status' => $this->status,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'dis_type', $this->dis_type])
            ->andFilterWhere(['like', 'dis_name', $this->dis_name])
            ->andFilterWhere(['like', 'id_code', $this->id_code])
            ->andFilterWhere(['like', 'start_date', $this->start_date])
            ->andFilterWhere(['like', 'till_date', $this->till_date])
            ->andFilterWhere(['like', 'access', $this->access])
            ->andFilterWhere(['like', 'category_include_exclude', $this->category_include_exclude]);
        return $dataProvider;
    }
}
