<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_order_indent".
 *
 * @property int $id
 * @property string|null $subject
 * @property float|null $total_amount
 * @property float|null $sub_total_amount
 * @property string|null $date
 * @property string|null $converted_to
 * @property int $is_deleted
 */
class PurchaseOrderIndent extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_order_indent';
    }

    /**
     * {@inheritdoc}
     */
    public $search,$from_date,$to_date,$product,$last_purchase_indent,$convert,$findsource;
    public function rules()
    {
        return [
            [['subject'], 'string'],
            [['from_date','to_date'], 'required'],
            [['total_amount', 'sub_total_amount','convert_purchase_id'], 'number'],
            ['total_amount', 'compare', 'compareValue' => 0, 'operator' => '>'],
            [['date','search','product','last_purchase_indent','convert','source'], 'safe'],
            [['is_deleted','convert_purchase_id'], 'integer'],
            [['converted_to'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'subject' => 'Subject',
            'total_amount' => 'Total Amount',
            'sub_total_amount' => 'Sub Total Amount',
            'date' => 'Date',
            'converted_to' => 'Converted To',
            'convert_purchase_id' => 'Convert Purchase Id',
            'is_deleted' => 'Is Deleted',
        ];
    }
}
