<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_order_indent_product".
 *
 * @property int $id
 * @property int|null $purchase_order_indent_id
 * @property int|null $product_id
 * @property string|null $description
 * @property string|null $quantity
 * @property string|null $units
 * @property float|null $unit_price
 * @property float|null $price
 * @property string|null $discount
 * @property string|null $tax
 * @property string|null $discount_type
 * @property string|null $tax_included
 * @property float|null $amount
 * @property string|null $created_at
 * @property string|null $updated_at
 */
class PurchaseOrderIndentProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_order_indent_product';
    }
    public $discount,$discount_type,$tax_included;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['purchase_order_indent_id', 'product_id'], 'integer'],
            ['product_id', 'required', 'message' => 'Product cannot be blank'],
            [['unit_price', 'price', 'amount',], 'number'],
            [['created_at', 'updated_at','tax'], 'safe'],
            [['description', 'units','tax'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'purchase_order_indent_id' => 'Purchase Order Indent ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'unit_price' => 'Unit Price',
            'tax' => 'Tax',
            'price' => 'Price',
            'amount' => 'Amount',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
