<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\PurchaseOrderIndent;

/**
 * PurchaseOrderIndentSearch represents the model behind the search form of `backend\modules\master\models\PurchaseOrderIndent`.
 */
class PurchaseOrderIndentSearch extends PurchaseOrderIndent
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'is_deleted'], 'integer'],
            [['subject', 'date', 'converted_to'], 'safe'],
            [['total_amount','sub_total_amount'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query =PurchaseOrderIndent::find()->orderBy([
            'id' => SORT_DESC,
          ])->where(['is_deleted' =>0]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'total_amount' => $this->total_amount,
            'date' => $this->date,
            'is_deleted' => $this->is_deleted,
        ]);

        $query->andFilterWhere(['like', 'subject', $this->subject])
            ->andFilterWhere(['like', 'converted_to', $this->converted_to]);

        return $dataProvider;
    }
}
