<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_order_product".
 *
 * @property int $id
 * @property int|null $purchase_order_id
 * @property int $product_id
 * @property string $description
 * @property string $quantity
 * @property string $units
 * @property float|null $unit_price
 * @property float $price
 * @property string $discount
 * @property string $discount_type
 * @property string $tax_included
 * @property float $amount
 * @property string $created_at
 * @property string $updated_at
 */
class PurchaseOrderProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $qty;
    public $unit;
   // public $price;
    public $incl_tax;
    public static function tableName()
    {
        return 'purchase_order_product';
    }

    /**
     * {@inheritdoc}
     */
    
    public function rules()
    {
        return [
           
            [['created_at', 'updated_at','tax','qty','unit','incl_tax'], 'safe'],
            [['purchase_order_id', 'product_id', 'description', 'units',  'discount', 'tax_included','discount_type'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
            [['price', 'amount','unit_price'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'purchase_order_id' => 'Purchase Order ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'unit_price' => 'Unit Price',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'discount_type' => 'Discount Type',
            'tax_included' => 'Tax Included',
            'amount' => 'Amount',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
    
}
