<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_receipt_details".
 *
 * @property int $id
 * @property string $setting_type
 * @property string $payment_type
 * @property string $receipt_no
 * @property string $prefix
 * @property string $receipt_id
 * @property string $suffix
 * @property string $invoice_no
 * @property string $purchase_order_no
 * @property string $receipt_date
 * @property string $cheque_no
 * @property string|null $cheque_date
 * @property string $payment_mode
 * @property string $bank_name
 * @property float $amount
 * @property float $tds_amount
 * @property float $total_amount
 * @property string $customer_name
 * @property string $customer_type
 * @property string|null $receipt_documents
 * @property string $notes
 * @property string $created_at
 * @property string $updated_at
 */
class PurchaseReceiptDetails extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_receipt_details';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_type', 'payment_type', 'receipt_no', 'prefix', 'receipt_id', 'suffix', 'invoice_no', 'purchase_order_no', 'receipt_date', 'cheque_no', 'payment_mode', 'bank_name', 'amount', 'tds_amount', 'total_amount', 'customer_name', 'customer_type', 'notes', 'created_at', 'updated_at'], 'required'],
            [['receipt_date', 'cheque_date', 'created_at', 'updated_at'], 'safe'],
            [['amount', 'tds_amount', 'total_amount'], 'number'],
            [['notes'], 'string'],
            [['setting_type', 'payment_type', 'prefix', 'receipt_id', 'suffix', 'invoice_no', 'purchase_order_no', 'cheque_no', 'payment_mode', 'bank_name', 'customer_name', 'customer_type', 'receipt_documents'], 'string', 'max' => 254],
            [['receipt_no'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_type' => 'Setting Type',
            'payment_type' => 'Payment Type',
            'receipt_no' => 'Receipt No',
            'prefix' => 'Prefix',
            'receipt_id' => 'Receipt ID',
            'suffix' => 'Suffix',
            'invoice_no' => 'Invoice No',
            'purchase_order_no' => 'Purchase Order No',
            'receipt_date' => 'Receipt Date',
            'cheque_no' => 'Cheque No',
            'cheque_date' => 'Cheque Date',
            'payment_mode' => 'Payment Mode',
            'bank_name' => 'Bank Name',
            'amount' => 'Amount',
            'tds_amount' => 'Tds Amount',
            'total_amount' => 'Total Amount',
            'customer_name' => 'Customer Name',
            'customer_type' => 'Customer Type',
            'receipt_documents' => 'Receipt Documents',
            'notes' => 'Notes',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
