<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "tax_class".
 *
 * @property int $id
 * @property string $tax_class_name
 * @property string $tax_class_code
 * @property string $remarks
 * @property string $created_at
 * @property string $updated_at
 */
class TaxClass extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tax_class';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['tax_class_name', 'tax_class_code'], 'required'],
            [['remarks'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
            [['tax_class_name'], 'string', 'max' => 254],
            [['tax_class_code'], 'string', 'max' => 30],
            ['tax_class_code', 'unique', 'message' => 'This Code has already been taken.'],
            ['tax_class_name', 'unique', 'message' => 'This Tax class name has already been taken.'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'tax_class_name' => 'Tax Class Name',
            'tax_class_code' => 'Tax Class Code',
            'remarks' => 'Remarks',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
