<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "vendor".
 *
 * @property int $id
 * @property string $business_name
 * @property int $mobile_no
 * @property string $customer_code
 * @property string $account_id
 * @property int $pricelist
 * @property string $dob
 * @property string $email
 * @property string $alternative_email
 * @property string $fax
 * @property string $website
 * @property int $phone_no
 * @property int $alternative_phone_no
 * @property string $executive
 * @property string $adderss_line_1
 * @property string $adderss_line_2
 * @property string $adderss_line_3
 * @property string $area
 * @property string $city
 * @property string $country
 * @property string $state
 * @property int $pin_code
 * @property string $sipping_to_name
 * @property string $shipping_address_1
 * @property string $shipping_address_2
 * @property string $shipping_address_3
 * @property string $shipping_city
 * @property int $shipping_postcode
 * @property string $shipping_state
 * @property string $shipping_country
 * @property string $opening_as_on
 * @property string $customer_gst_type
 * @property string $gstin_no
 * @property string $ho_state_code
 * @property string $type_of_removal
 * @property string $iec
 * @property string $pan_number
 * @property string $aadhar_number
 * @property string $service_task_no
 * @property string $cst_no
 * @property string $ecc_no
 * @property string $cex_regn_no
 * @property string $ledger
 * @property int $credit_limit
 * @property int $additional_credit_limit
 * @property int $credit_days
 * @property string $credit_terms
 * @property string $file
 * @property string $customer_ic
 * @property string $customer_brn
 * @property string $ic_type
 * @property string $tin
 */
class Vendor extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'vendor';
    }

    /**
     * {@inheritdoc}
     */
    public $mobile;
    public $findname;
    public function rules()
    {
        return [
            [['business_name','customer_gst_type'], 'required'],
            [[ 'pricelist'], 'integer'],
            [['business_name','vendor_type','email', 'account_id', 'fax', 'website','adderss_line_1', 'adderss_line_2', 'adderss_line_3','sipping_to_name', 'shipping_address_1', 'shipping_address_2', 'shipping_address_3',  'customer_gst_type', 'gstin_no', 'ho_state_code', 'type_of_removal','pan_number',  'cst_no',  'ledger', 'credit_terms','vendor_ic', 'vendor_brn',  'ic_type', 'tin','beneficiary_name','beneficiary_account_no','bank_name','bank_branch','ifse_code','account_type','swift','micr_code','bsr','is_shipping_address_same_as_address','opening_as_on'], 'string', 'max' => 254],
            [['swift','micr_code','bsr'],'string','max'=>20],
            [['business_name'],'unique','message'=> 'Business Name has already been taken.'],
            [['pin_code',], 'string','min'=>6, 'max' =>6],
             [['pin_code'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Pin Code Can Contain only numeric characters.'],
             [['shipping_postcode',], 'string','min'=>6, 'max' =>6],
             [['shipping_postcode'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Shipping PostCode Can Contain only numeric characters.'],
             [['email'], 'email'],
             [['country', 'state', 'city','shipping_city', 'shipping_state', 'shipping_country'], 'string', 'max' => 56],

             [['phone_no'], 'string','min'=>10, 'max' => 10],
             [['phone_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Contact No can Contain only numeric characters.'],

             [['alternative_phone_no'], 'string','min'=>10, 'max' => 10],
             [['alternative_phone_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'It can Contain only numeric characters.'],

             [['mobile_no'], 'string','min'=>10, 'max' => 10],
             [['mobile_no'], 'string','min'=>10, 'max' => 10],
             [['mobile_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Mobile No can Contain only numeric characters.'],

             [[ 'service_task_no'], 'string','min'=>15, 'max' => 15],
             [['service_task_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Service Task Number Can Contain only numeric characters.'],

             [['aadhar_number',], 'string','min'=>12, 'max' => 12],
             [['aadhar_number'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Aadhar Format should be like numeric.'],

             [['pan_number',], 'string','min'=>10, 'max' => 10],
             [['pan_number'], 'match' ,'pattern'=>'/^([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}?$/', 'message'=> 'PAN Format should be like  ABCDE1234Z.'],

             [['gstin_no'], 'string','min'=>15, 'max' => 15],
             [['gstin_no'], 'match' ,'pattern'=>'/^([0-9]){2}([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}?$/', 'message'=> 'GSTIN Format should be like  12ABCDE1234Z1Z1.'],

             [['tin',], 'string','min'=>10, 'max' => 10],
             [['tin'], 'match' ,'pattern'=>'/^([A-Z]){5}([0-9]){4}([A-Z]){1}?$/', 'message'=> 'TIN Format should be like  ABCDE1234Z.'],

             ['email','unique', 'targetClass' => '\common\models\User', 'message' => 'This email address has already been taken.'],
            ['phone_no','unique', 'message' => 'This Phone no has already been taken.'],
            ['mobile_no','unique', 'message' => 'This Phone no has already been taken.'],
            ['alternative_phone_no','unique', 'message' => 'This Phone no has already been taken.'],
            [['mobile','findname'],'safe'],
            [['opening_as_on'], 'number','numberPattern'=>'/^\d+(.\d{1,2})?$/', 'message'=> 'Integer or decimal value upto 2 digit is required'],
            ['gstin_no', 'required', 'when' => function($model) {
                return $model->customer_gst_type == 'Registred';
            },'whenClient' => "function (attribute, value) {
                return $('#vendor-customer_gst_type').val() == 'Registred';
            }"],
            
        ];
    }
    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'business_name' => 'Business Name',
            'mobile_no' => 'Mobile No',
            'account_id' => 'Account ID',
            'pricelist' => 'Pricelist',
            'dob' => 'Dob',
            'email' => 'Email',
            'alternative_email' => 'Alternative Email',
            'fax' => 'Fax',
            'website' => 'Website',
            'alternative_phone_no' => 'Alternative Phone No',
            'adderss_line_1' => 'Adderss Line 1',
            'adderss_line_2' => 'Adderss Line 2',
            'adderss_line_3' => 'Adderss Line 3',
            'area' => 'Area',
            'city' => 'City',
            'country' => 'Country',
            'state' => 'State',
            'pin_code' => 'Pin Code',
            'sipping_to_name' => 'Sipping To Name',
            'shipping_address_1' => 'Shipping Address 1',
            'shipping_address_2' => 'Shipping Address 2',
            'shipping_address_3' => 'Shipping Address 3',
            'shipping_city' => 'Shipping City',
            'shipping_postcode' => 'Shipping Postcode',
            'shipping_state' => 'Shipping State',
            'shipping_country' => 'Shipping Country',
            'opening_as_on' => 'Opening As On',
            'customer_gst_type' => 'Customer Gst Type',
            'gstin_no' => 'Gstin No',
            'ho_state_code' => 'Ho State Code',
            'type_of_removal' => 'Type Of Removal',
            'iec' => 'Iec',
            'pan_number' => 'Pan Number',
            'aadhar_number' => 'Aadhar Number',
            'service_task_no' => 'Service Task No',
            'cst_no' => 'Cst No',
            'ecc_no' => 'Ecc No',
            'cex_regn_no' => 'Cex Regn No',
            'ledger' => 'Ledger',
            'credit_limit' => 'Credit Limit',
            'additional_credit_limit' => 'Additional Credit Limit',
            'credit_days' => 'Credit Days',
            'credit_terms' => 'Credit Terms',
            'vendor_ic' => 'Vendor Ic',
            'vendor_brn' => 'Vendor Brn',
            'ic_type' => 'Ic Type',
            'tin' => 'Tin',
        ];
    }
}
