<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "vendorcontact_details".
 *
 * @property int $id
 * @property string $contact_name
 * @property string $vendor_id
 * @property string $designation
 * @property string $email_id
 * @property string $mobile_no
 * @property string $contact_type
 * @property string $contact_person_type
 * @property string $created_at
 * @property string $updated_at
 */
class VendorcontactDetails extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'vendorcontact_details';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['created_at', 'updated_at'], 'safe'],
            [['contact_name', 'vendor_id', 'designation', 'contact_email_id', 'contact_mobile_no', 'contact_type', 'contact_person_type'], 'string', 'max' => 254],
             [['contact_mobile_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Contact Person No can Contain only numeric characters.'],
             [['contact_mobile_no'], 'string','min'=>10, 'max' => 10],
              [['contact_email_id'], 'email'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'contact_name' => 'Contact Name',
            'vendor_id' => 'Vendor ID',
            'designation' => 'Designation',
            'email_id' => 'Email ID',
            'mobile_no' => 'Mobile No',
            'contact_type' => 'Contact Type',
            'contact_person_type' => 'Contact Person Type',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
