<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\ParentGroup;
use backend\modules\master\models\Types;
use backend\modules\master\models\AccountGroup;
use backend\modules\master\models\AccountGroupSearch;
use yii\widgets\ActiveForm;




/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\AccountGroupSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Account Groups';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}

</style>
<!-- <div class="account-group-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Account Group', ['create'], ['class' => 'btn btn-success']) ?>
    </p> -->

    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>
    <?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Account Groups</div>
                                                            </div>
															<div class="widget-content-right">
															<a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Group</a>
                                                                <a href="<?=Url::base()?>/master/account-group/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Group</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        
                        <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">
                        <button id='delete' href="<?=Url::base()?>/master/account-group/delete-account-group" class='mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn'><i class="fa fa-trash"></i> Delete</button>

							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">
                        <a href="<?=Url::base();?>/master/account-group/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                            <a href="<?=Url::base();?>/master/account-group/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                            <a href="<?=Url::base();?>/master/account-group/excel-export" data-method="post">	<button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
							
											
                                     </div>
							 </div>
							 </div>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
           

            //'account_group_id',
            'group_name',
           // 'parent_id',
            // 'type_id',
            //'status',
            
            [
                'label'=>'Parent Name',
               'attribute' => 'parent_id',
               'filter' => Html::activeDropDownList($searchModel, 'parent_id', ArrayHelper::map(ParentGroup::find()->asArray()->all(), 'parent_id', 'parent_name'),['class'=>'form-control','prompt' => '-Parent Name-']),

               'value' => function ($data) {
                $value=ParentGroup::find()->where(['parent_id'=>$data->parent_id])->one();
            
                return $value?$value->parent_name:'';
               }
            ],
            [
                'label'=>'Type Name',
               'attribute' => 'type_id',
               'filter' => Html::activeDropDownList($searchModel, 'type_id', ArrayHelper::map(Types::find()->asArray()->all(), 'type_id', 'type_name'),['class'=>'form-control','prompt' => '-Type Name-']),
               'value' => function ($data) {
                $value=Types::find()->where(['type_id'=>$data->type_id])->one();
                
                return $value?$value->type_name:'';
               }
            ],
            [
                'label' => 'Action',
                // 'attribute' => 'username',
                'format'=>'raw',
                'contentOptions'=>[ 'style'=>'width: 35px'],
                'value' => function ($data) {
                    return '<div class="d-inline-block dropdown">
            <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
            <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                <ul class="nav flex-column">
                <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/account-group/view?id='.$data->account_group_id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/account-group/update?id='.$data->account_group_id.' data-method=post>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/master/account-group/delete?id='.$data->account_group_id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>
                    
                </ul>
            </div>
        </div>';
                },
            ],
            // ['class' => 'yii\grid\ActionColumn'],
            
        ],
    ]); ?>


</div>
<?php ob_start();?>
 <script type="text/javascript">
$(function() {
    // console.log(navigator.userAgent);

$('#delete').click(function(){
var ids = $('#w0').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete-account-group',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
