<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\AccountingTax */

$this->title = $model->accounting_tax_id;
$this->params['breadcrumbs'][] = ['label' => 'Accounting Taxes', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="accounting-tax-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->accounting_tax_id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->accounting_tax_id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'accounting_tax_id',
            'tax_name',
            'tax_class',
            'abbreviation',
            'tax_type',
            'tax_sub_type',
            'supply_type',
            'ledger_name',
            'tax_rate',
            'status',
            'is_deleted',
            'created_at',
            'updated_at',
        ],
    ]) ?>

</div>
