<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\CustomerTypeSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Customer Types';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>

    <?php if (Yii::$app->session->hasFlash('success')){ ?>

            <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
                <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                  <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success');?></strong>
            </div>
        <?php } ?>
        <?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('error') ?></strong>
    </div>
<?php endif; ?>

                <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Customer Type</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                              <!-- <a href="#" class="dj-import-btn"><i class="fa fa-download"></i> Import Customer Type</a> -->
                                                                <a href="#" class="dj-danger-btn" data-toggle="modal" data-target="#customer-type" id="btn-show-modal"><i class="fa fa-plus-circle" aria-hidden="true" onExit="reload"></i>  Add Customer Type</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">
                        
                        <div class="col-sm-6">

                        <div class="djsec-text-left dj-print-sec">
                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/delete'])->one()!=''){?>
                               <button id='delete' class='mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn'><i class="fa fa-trash"></i> Delete</button> 
                               <?php }else {?>

                               <?php } ?>
                                       
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="djsec-text-right dj-print-sec">
                                <!-- <button class="mb-2 mr-2 btn-icon btn btn-primary dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button> -->
                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/excel-export'])->one()!=''){?>
                                <a href="<?=Url::base();?>/master/customer-type/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                                 <a href="<?=Url::base();?>/master/customer-type/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                               <?php }else {?>

                               <?php } ?>

                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/export-pdf'])->one()!=''){?>
                               <a href="<?=Url::base();?>/master/customer-type/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                               <?php }else {?>

                               <?php } ?>

                               
                                <!-- <button class="mb-2 mr-2 btn-icon btn btn-primary dj-ap-btn"><i class="fa fa-print"></i> Print</button> -->
                                
                               

                               
                        </div>
                    </div>
                        </div>
                            
                        <?= GridView::widget([
                            'dataProvider' => $dataProvider,
                            'filterModel' => $searchModel,
                            'columns' => [
                                 ['class' => 'yii\grid\CheckboxColumn',
                                    'contentOptions'=>[ 'style'=>'width: 50px'],],
                                  ['class' => 'yii\grid\SerialColumn',
                                    'header'=>'SL No.',
                                     'contentOptions'=>[ 'style'=>'width: 15px'],],

                                'customer_type',

                                [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 150px'],
                                        'value' => function ($data) use ($assign) {

                                            $topstring = '<div class="d-inline-block dropdown">
                                                                <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                                <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                                    <ul class="nav flex-column">';
                                            $downstring =  '</ul></div></div>';  

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/view'])->one()!='')
                                            {
                                                $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/customer-type/view?id='.$data->id.' data-method=post>
                                                   <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $viewstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/update'])->one()!='')
                                            {
                                                $editstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/customer-type/update?id='.$data->id.'>
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $editstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer-type/delete'])->one()!='')
                                            {
                                                $deletestring = '<li class="nav-item">
                                                <a class="nav-link deletecustomertype" href='.Url::base().'/master/customer-type/delete?id='.$data->id.'  data-method=post>
                                                   <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">  Delete</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $deletestring = '';
                                            }

                                            return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$downstring;
                                        },
                                    ],

                                // ['class' => 'yii\grid\ActionColumn',
                                //   'header'=>'Action',
                                //  'contentOptions'=>[ 'style'=>'width: 150px'],],
                            ],
                        ]); ?> 
                        </div>
                    </div>
                </div>
        <div class="modal fade" id="customer-type" >
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Add Customer Type</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <div class="col-md-12">
                      <div class="position-relative form-group ">
                         <label for="customer" class="">Customer Type <span class="dj-red">*</span></label> 
                            <?= $form->field($model, 'customer_type')->textInput(['maxlength' => true,])->label(false) ?>
                       </div>
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <button class="btn dj-danger-btn submit-btn"><i class="fa fa-check-square-o" aria-hidden="true"></i> Save</button>
                    <a href="" class="btn dj-red-btn" data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true" ></i> Close</a>
                    <!-- <button class="btn dj-red-btn" data-dismiss="modal" aria-label="Close"><i class="fa fa-check-square-o" aria-hidden="true"></i> Save</button> -->
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?> 
    </div>
</div>   
<?php ob_start();?>
 <script type="text/javascript">
$(function() {

$('#delete').click(function(){
    var ids = $('#w0').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected Customer Types?");
        if(x)
        {
            var ids = $('#w0').yiiGridView('getSelectedRows');
            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
              });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some Customer Type to delete!");
    }   
})
$('.deletecustomertype').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected Customer type?");
if (confirm == true)
return true;
else
return false;
})

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>