<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\CustomerType;
use backend\modules\master\models\State;
use yii\widgets\ActiveForm;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\CustomerSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Customers';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
    <?php if (Yii::$app->session->hasFlash('success')){ ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success');?></strong>
    </div>
 <?php } ?>

 <div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                <div class="card">
                    <div class="no-gutters row">
                        <div class="col-md-12 col-lg-12">
                            <ul class="list-group list-group-flush">
                                <li class="bg-transparent list-group-item">
                                    <div class="widget-content p-0">
                                        <div class="widget-content-outer">
                                            <div class="widget-content-wrapper">
                                                <div class="widget-content-left">
                                                    <div class="widget-numbers dj-text-success">Customer</div>
                                                </div>
                                                <div class="widget-content-right">
                                                  <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Customer</a>
                                                   <a href="#" class="dj-danger-btn"><i class="fa fa-commenting-o"></i> Send SMS</a>
                                                  <a href="#" class="dj-danger-btn"><i class="fa fa-envelope"></i> Send Email</a>

                                                  <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/create'])->one()!=''){?>
                                                    <a href="<?=Url::base()?>/master/customer/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Customer</a>
                                                   <?php }else {?>

                                                   <?php } ?>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                              
                            </ul>
                        </div>
                       
                        
                    </div>
                </div>
            </div>
            
              <div class="main-card mb-3 card">
            <div class="card-body">
            <div class="row">
            <div class="col-md-6">
              <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/delete'])->one()!=''){?>
                  <button id='delete' class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
               <?php }else {?>

               <?php } ?>  
        
            </div>
            
            
            <div class="col-sm-6">
             <div class="djsec-text-right dj-print-sec">


                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/excel-export'])->one()!=''){?>
                 <a href="<?=Url::base();?>/master/customer/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>

                 <a href="<?=Url::base();?>/master/customer/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
               <?php }else {?>

               <?php } ?>

               <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/export-pdf'])->one()!=''){?>
                 <a href="<?=Url::base();?>/master/customer/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
               <?php }else {?>

               <?php } ?>      
                                
                         </div>
            </div>
            </div>
                
            <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'columns' => [
                ['class' => 'yii\grid\SerialColumn'],
                ['class' => 'yii\grid\CheckboxColumn'],
            

                // 'id',
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'contentOptions' => ['style' => 'font-weight:bolder'],
                    'header'=> 'Name',
                    'attribute' => 'business_name',
                    'value'=>'business_name',
                ],
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'header'=> 'Customer Type',
                    'value'=>'customer_type',
                    'filter' => Html::activeDropDownList($searchModel, 'customer_type', ArrayHelper::map(CustomerType::find()->asArray()->all(), 'customer_type', 'customer_type'),['class'=>'form-control select_class','prompt' => '--Select--']),
                ],
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'header'=> 'State',
                    'attribute'=>'state',
                    'value'=>'state',
                ],
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'header'=> 'Email',
                    'attribute' => 'email',
                    'value'=>'email',
                ],
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'header'=> 'Mobile (HP)',
                    'attribute' => 'mobile',

                    'value'=>'mobile',
                ],
               
                [
                    'headerOptions' => ['style' => 'color:#3f6ad8'],
                    'label' => 'Action',
                    // 'attribute' => 'username',
                    'format'=>'raw',
                    'value' => function ($data) use ($assign) {

                        $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                        $downstring =  '</ul></div></div>';  



                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/master/customer/view?id='.$data->id.'&page_id='.$data->page_id.' data-method=post>
                            <i class="fa fa-eye"></i>
                                <span class="dj-icon-gap">  View</span>
                            </a>
                        </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/update'])->one()!='')
                        {
                            $editstring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/master/customer/update?id='.$data->id.'&page_id=1>
                                <i class="fa fa-pencil-square"></i>
                                <span class="dj-icon-gap"> Edit</span>
                            </a>
                        </li>';
                        }
                        else
                        {
                            $editstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/findattachments'])->one()!='')
                        {
                            $statementstring = '<li class="nav-item">
                            <a class="nav-link statement_of_account" href=# data-toggle="modal" data-target="#statement" value='.$data->id.'>
                                <i class="fa fa-file"></i>
                                <span class="dj-icon-gap">Statement Of Account</span>
                            </a>
                        </li>';
                        }
                        else
                        {
                            $statementstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/findattachments'])->one()!='')
                        {
                            $attachemntstring = '<li class="nav-item">
                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                <i class="fa fa-file"></i>
                                    <span class="dj-icon-gap"> Download Attachment</span>
                                </a>
                            </li>';
                        }
                        else
                        {
                            $attachemntstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/customer/delete'])->one()!='')
                        {
                            $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/master/customer/delete?id='.$data->id.' data-method=post>
                            <i class="fa fa-trash"></i>
                                <span class="dj-icon-gap">  Delete</span>
                            </a>
                        </li>';
                        }
                        else
                        {
                            $deletestring = '';
                        }

                        return $topstring.''.$viewstring.''.$editstring.''.$statementstring.''.$attachemntstring.''.$deletestring.''.$downstring;
                    },
            ],
                // ['class' => 'yii\grid\ActionColumn'],

            
            ],
        ]); ?>
            </div>
        </div>
    </div>
    <div class="modal fade" id="document" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Customer Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
               
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="statement">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Customer Statement</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <div class="col-md-12">
                      <div class="position-relative form-group">
                      <label for="from"> From <span class='dj-red'>*</span> </label>
                           <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'type'=>'date','class' => "form-control from"])->label(false) ?> 
                       </div>
                       <div class="position-relative form-group">
                       <label for="from">To<span class='dj-red'>*</span> </label>
                       <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'type'=>'date','class' => "form-control to"])->label(false) ?> 
                       </div>
                       <div class="position-relative form-group">

                       <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control statement_id"])->label(false) ?> 
                       </div>
              
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::submitButton('<i class="fa fa-check-square-o"  aria-hidden="true"></i> Preview & Print', ['class' => 'btn dj-blue-btn submit-btn','formtarget'=>"_blank"]) ?>
                    <a href="" class="btn dj-red-btn" data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>
    <?php ob_start();?>
 <script type="text/javascript">
$(function() {

$('.statement_of_account').click(function(){
var id = $(this).attr('value');
// console.log(id);
$('.from').val('');
$('.to').val('');
$('.statement_id').val(id);
});
    $('.select_class').select2();
    $('#delete').click(function(){
var ids = $('#w0').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are u sure you want to delete the selected items?");
else
alert('Please select some item to delete!')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are u sure you want to delete the Customer?");
if (confirm == true)
return true;
else
return false;
})
var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/master/customer/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");               

                  }
         isLoading = false;        

     });
})
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
    