<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\SettingTypes;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id' => $id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\ProductSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Generic Templates';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
</style>
<?php if (Yii::$app->session->hasFlash('success')) : ?>
    <div class="alert alert-success alert-dismissable">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('success') ?>
    </div>
<?php endif; ?>
<?php if (Yii::$app->session->hasFlash('error')) : ?>
    <div class="alert alert-danger alert-dismissable">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Generic Templates</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <!--  <a href="#" class="dj-danger-btn"><i class="fa fa-upload" aria-hidden="true"></i> Export Product</a>
                                                            <a href="#" class="dj-danger-btn"><i clas s="fa fa-download"></i> Import Product</a>-->
                                            <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/generic-template/create'])->one() != '') { ?>
                                                <a href="<?= Url::base() ?>/master/generic-template/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Templates</a>
                                            <?php } else { ?>
                
                                            <?php } ?>

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>

    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row">
                <!-- <div class="col-md-6">
                    <button id='delete' class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>

                </div> -->
                <div class="col-md-6">

                </div>
            </div>
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                // 'filterModel' => $searchModel,
                'columns' => [
                    // ['class' => 'yii\grid\SerialColumn'],
                    // ['class' => 'yii\grid\CheckboxColumn'],
                    // 'gt_id',
                    'template_name',
                    'template_for',
                    'company_name',
                    'address',
                    //'city',
                    //'state',
                    //'pin',
                    //'country',
                    //'mobile',
                    //'phone_no',
                    //'gst_no',
                    //'fax_no',
                    //'trade_licence',
                    //'email:email',
                    //'terms_and_condition',
                    //'bank_name',
                    //'account_holder',
                    //'acc_no',
                    //'ifsc_code',
                    //'company_seal',
                    //'company_signature',

                    // ['class' => 'yii\grid\ActionColumn'],
                    [
                        'label' => 'Action',
                        'format' => 'raw',
                        'headerOptions' => ['style' => 'width:100px'],
                        'value' => function ($data) use ($assign) {

                            $topstring = '<div class="d-inline-block dropdown">
                                                <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                    <ul class="nav flex-column">';
                            $downstring =  '</ul></div></div>';


                            if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/generic-template/update'])->one() != '') {
                                $editstring = '<li class="nav-item">
                                <a class="nav-link" href=' . Url::base() . '/master/generic-template/update?id=' . $data->gt_id . '>
                                    <i class="fa fa-pencil-square"></i>
                                    <span class="dj-icon-gap"> Edit</span>
                                </a>
                            </li>';
                            } else {
                                $editstring = '';
                            }

                            if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/generic-template/delete'])->one() != '') {


                                    if ($data->status =='0') {

                                $deletestring = '<li class="nav-item deleteid" value=' . $data->gt_id . '>
                                <a class="nav-link" href=' . Url::base() . '/master/generic-template/delete?id=' . $data->gt_id . ' data-method=post>
                                   <i class="fa fa-trash"></i>
                                    <span class="dj-icon-gap">  Delete</span>
                                </a>
                            </li>';
                        }
                        else
                        {
                            $deletestring = '';
                        }
                            } else {
                                $deletestring = '';
                            }


                            return $topstring . '' . $editstring . '' . $deletestring . '' . $downstring;
                        },
                    ],
                ],

            ]); ?>