<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\GenericTemplate */

$this->title = $model->gt_id;
$this->params['breadcrumbs'][] = ['label' => 'Generic Templates', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="generic-template-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->gt_id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->gt_id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'gt_id',
            'template_name',
            'template_for',
            'company_name',
            'address',
            'city',
            'state',
            'pin',
            'country',
            'mobile',
            'phone_no',
            'gst_no',
            'fax_no',
            'trade_licence',
            'email:email',
            'terms_and_condition',
            'bank_name',
            'account_holder',
            'acc_no',
            'ifsc_code',
            'company_seal',
            'company_signature',
        ],
    ]) ?>

</div>
