<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use  backend\models\UserClient;
use backend\models\AuthItem;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;

/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\LeadExecutive */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'User', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);


 $customers=UserClient::find()->select(['client_id','customer.business_name'])->where(['user_id'=>$model->user_id,'client_type'=>'Customer'])->leftJoin('customer', 'customer.id = user_client.client_id')->asArray()->all();

 $vendors=UserClient::find()->select(['client_id','vendor.business_name'])->where(['user_id'=>$model->user_id,'client_type'=>'Vendor'])->leftJoin('vendor', 'vendor.id = user_client.client_id')->asArray()->all();

 $count_customer = 1;
 $count_vendor = 1;
?>



<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">View User</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/admin/user/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
<!-- 
    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p> -->
    <div class="main-card mb-3 card">
                           <div class="card-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            // 'id',
            'name',
            'type',
            'products',
            [
                'attribute'=>'photo',
                'label'=>'Photo',
                'format' => 'raw',
                'value' => function($data){
                    if($data->photo)
               return Html::img("../../setting/leadexecutive_photos/".$data->photo,
              ['width' => '200px',
               'height' => '100px','class'=>'imag','title'=>$data->photo]);
               else return '';
              
                }
              ],
            'email:email',
            'phone',
            'executive_ic',
            'ic_type',
            'address_line1',
            'address_line2',
            'city',
            'state',
            'zip_code',
            'target',
            'target_based_on',
            [
                'attribute'=>'status',
                'label'=>'Active',
                // 'format' => 'raw',
                'value' => function($data){
               return $data->status?'Yes':'No';
              
                }
              ],
            'created_at:date',
            'updated_at:date',
        ],
    ]) ?>


<div class="main-card mb-2 card">
<table id="w0" class="table table-striped table-bordered ">
    <thead>
    <tr>
        <th width="50%">Customers</th>
        <th width="50%">Vendors</th>
       
    </tr>
</thead>
<tbody>
    <tr>
        <td>
    <?php foreach($customers as $value){ ?>
        <?= $count_customer ?>.   <?=$value['business_name']?><br> 
         <?php $count_customer = $count_customer +1 ?>   
    <?php  }?> 
    </td>
    <td>
    <?php foreach($vendors as $value){ ?>
           <?= $count_vendor ?>. <?=$value['business_name']?> <br> 
           <?php $count_vendor = $count_vendor +1 ?>        
    <?php  }?> 
    </td>
</tr> 
</tbody>    
</table>


</div>
</div>
</div>


