<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\ProductDiscountSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Product Discounts';
$this->params['breadcrumbs'][] = $this->title;
?>



<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>


<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Discounts</div>
                                                            </div>
															<div class="widget-content-right">
															  <a href="#" class="dj-import-btn"><i class="fa fa-download"></i> Import Discount</a>
                                                                <a href="<?=Url::base()?>/master/product-discount/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Discount</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        
						  <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">
                        <div class="col-md-6">
                        <button id='delete' class='mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn'><i class="fa fa-trash"></i> Delete</button>
                    </div>
                    <div class="col-md-6">
							<div class="djsec-text-right dj-print-sec">

                            <a href="<?=Url::base();?>/master/product-discount/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-primary dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                            <a href="<?=Url::base();?>/master/product-discount/export-pdf" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-primary dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                            <a href="<?=Url::base();?>/master/product-discount/excel-export" data-method="post">	<button class="mb-2 mr-2 btn-icon btn btn-primary dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
											
                    </div>
                    </div>			
                                     </div>

                                     <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\CheckboxColumn'],
            ['class' => 'yii\grid\SerialColumn'],

   
            'dis_type',
            'dis_name',
            'start_date',
            'till_date',
            [
                'label' => 'Status',
                'attribute' => 'status',
                'value' => function ($data) {
                    return $data->status?'Active':'Inactive';
                }
            ],
            [
                'label' => 'Action',
                // 'attribute' => 'username',
                'format'=>'raw',
                'value' => function ($data) {
                    return '<div class="d-inline-block dropdown">
            <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
            <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                <ul class="nav flex-column">
                <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/product-discount/view?id='.$data->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/product-discount/update?id='.$data->id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>
                    <li class="nav-item deleteind">
                        <a class="nav-link" href='.Url::base().'/master/product-discount/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>
                    
                </ul>
            </div>
        </div>';
                },
            ],

            // ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
                            
                        </div>
                    </div>
                </div>

                <?php ob_start();?>
 <script type="text/javascript">
 $(function() {
$('#delete').click(function(){
var ids = $('#w0').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are u sure you want to delete the selected discount?");
else
alert('Please select some discount to delete!')
if (confirm == true) {
$.post( 'delete-discount',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected discount?");
if (confirm == true)
return true;
else
return false;
})
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>