<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use backend\modules\master\models\Product;

/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\PurchaseOrderIndent */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Purchase Order Indents', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="app-main__inner">

<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
    <div class="card">
        <div class="no-gutters row">
            <div class="col-md-12 col-lg-12">
                <ul class="list-group list-group-flush">
                    <li class="bg-transparent list-group-item">
                        <div class="widget-content p-0">
                            <div class="widget-content-outer">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left">
                                        <div class="widget-numbers dj-text-success">View Purchase Indent</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <a href="<?=Url::base();?>/master/purchase-order-indent/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </li>
                    
                </ul>
            </div>
            
            
        </div>
    </div>
</div>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'subject',
            'total_amount',
            [
                'header'=> 'Date',
                'attribute' => 'date',
                'value'=> function($data){
                    if(isset($data->date)){
                    $last_date = date('d-m-y', strtotime($data->date));
                   return $last_date;
                    }
                } 
            ],
            'converted_to',
        ],
    ]) ?>
     <h4>Products</h4>
<table id="w0" class="table table-striped table-bordered detail-view">
    <thead>
    <tr>
        <th>Product</th>
        <th>Description</th>
        <th>Quantity</th>
        <th>Units</th>
        <th>Unit Price</th>
        <th>Amount</th>
    </tr>
</thead>
<tbody>
    <?php foreach($products as $value)
    { 
        if($value->product_id!=""){
        ?>
        <tr>
           <td><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td> 
           <td><?=$value->description?></td>
           <td><?=$value->quantity?></td>
           <td><?=$value->units?></td>
           <td><?=$value->unit_price?></td>
           <td><?=$value->amount?></td>
        </tr>
    <?php } }?>    
</tbody>    
</table>

</div>
