<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Product;
use backend\modules\master\models\AccountingTax;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\GenericTemplate;

if(date("m")>=4)
{
    $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
}
else
{
    $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
}


$purchase = GenericTemplate::find()->where(['template_for' => 'Purchase Order'])->all();
$purchaseorder = ArrayHelper::map($purchase, 'gt_id', 'template_name');

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id' => $id])->one();


$customer = Vendor::find()->select('business_name')->where(['id' => $model->vendor_name])->one();
//$year = "MOHASYN" . date("Y");
$year = "MOHASYN" .$dt;
$tcs_rate = AccountingTax::findOne(35)->tax_rate;
/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\PurchaseOrder */
/* @var $form yii\widgets\ActiveForm */
?>
<style>
    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .rendered .select2-selection__rendered {
        width: 144.406px !important;
    }

    input#purchaseorder-tcs {
        float: right;
        width: 141px;
        margin-bottom: 25px;
    }
</style>
<?php if (Yii::$app->session->hasFlash('success')) { ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success'); ?></strong>
    </div>
<?php } ?>


<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <?php if ($update == 'add') { ?>
                                                <div class="widget-numbers dj-text-success">Add Purchase Order</div>
                                            <?php } else { ?>
                                                <div class="widget-numbers dj-text-success">Update Purchase Order</div>
                                            <?php } ?>
                                        </div>
                                        <div class="widget-content-right">
                                            <a href="<?= Url::base() ?>/master/purchase-order/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?php $form = ActiveForm::begin(); ?>
            <div class="form-row">
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="customer">Settings Type<span class="dj-red">*</span></label>
                        <?php if($model->setting_type=='') { ?>
                        <?= $form->field($model, 'setting_type')->dropdownList(
                            $purchaseorder,
                            ['class' => 'setting_default select_setting form-control', 'prompt' => '--Select--']
                        )->label(false) ?>
                        <div class="error-help">This template is already deleted.</div>
                    <?php } else { ?>

                        <?= $form->field($model, 'setting_type')->dropdownList(
                            $purchaseorder,
                            ['class' => 'select_setting form-control', 'prompt' => '--Select--']
                        )->label(false) ?>
                        <div class="error-help">This template is already deleted.</div>

                    <?php } ?>    
                    </div>

                </div>
                <div class="col-md-6" style="margin:auto;">
                    <div class="text-right">

                        <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/vendor/create'])->one() != '') { ?>
                            <a href="<?= Url::base() ?>/master/vendor/create" class="dj-danger-btn" target="_blank"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Vendor</a>
                        <?php } else { ?>

                        <?php } ?>

                    </div>
                </div>
            </div>
            <hr class="dj-hr">
            <form class="dj-sale-form">
                <div class="form-row">
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="customer">Vendor Name <span class="dj-red">*</span></label>

                            <?php if ($update == 'update' || ($update == 'add' && $from == 'purchase-order')) { ?>
                                <?= $form->field($model, 'vendor_name')->dropDownList([$model->vendor_name => $customer->business_name], ['options' => [$model->vendor_name => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "findvendor vendor_details form-control"])->label(false) ?>
                            <?php } else { ?>
                                <?= $form->field($model, 'vendor_name')->dropDownList([], ['prompt' => '--Select--', 'class' => 'findvendor vendor_details form-control'])->label(false) ?>
                            <?php } ?>

                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="gstn">Sender GSTN/ UID<span class="dj-red">*</span></label>
                            <?= $form->field($model, 'sendor_gstin')->textInput(['maxlength' => true, 'class' => "form-control sendor_gstn"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="salestype">Bill Type</label>
                            <?= $form->field($model, 'bill_type')->dropdownList(
                                [
                                    'B2B' => 'B2B', 'B2C' => 'B2C', 'B2B' => 'B2B', 'EXPORT' => 'EXPORT', 'ADV PAYMENT' => 'ADV PAYMENT'
                                ],
                                ['prompt' => '--Select--', 'class' => 'select_class form-control']
                            )->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="notes">Notes</label>
                            <?= $form->field($model, 'notes')->textInput(['maxlength' => true, 'class' => "form-control"])->textarea(['rows' => '3'])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="notes">Delivery Address</label>
                            <?= $form->field($model, 'delivery_address')->textInput(['maxlength' => true, 'class' => "form-control"])->textarea(['rows' => '3'])->label(false) ?>
                        </div>
                    </div>
                </div>
                <hr class="dj-hr">
                <div class="form-row">
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="customer" class="">Supply Type</label>
                            <?= $form->field($model, 'supply_type')->dropdownList(
                                [
                                    'Inter-State' => 'Inter-State', 'Intra-State' => 'Intra-State', 'Export' => 'Export', 'Exempted' => 'Exempted'
                                ],
                                ['prompt' => '--Select--', 'class' => ' form-control supply_type']
                            )->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="customer" class="">Supply Attracts Reverse Charge</label>
                            <?= $form->field($model, 'supply_attracts')->dropdownList(
                                [
                                    'Yes' => 'Yes', 'No' => 'No'
                                ],
                                ['prompt' => '--Select--', 'class' => 'select_class form-control']
                            )->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="customer" class="">Currency</label>
                            <?= $form->field($model, 'currancy')->dropdownList(
                                [
                                    'Indian Rupees(INR)' => 'Indian Rupees(INR)'
                                ],
                                ['prompt' => '--Select--', 'class' => 'select_class form-control']
                            )->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="customer" class="">Point of Supply (Only if different from location of recipient)</label>
                            <?= $form->field($model, 'point_of_supply')->textInput(['maxlength' => true, 'class' => "form-control point_of_supply"])->label(false) ?>
                        </div>

                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="customer" class="">Eligibility of ITC as inputs/capital goods/input services/none</label>
                            <?= $form->field($model, 'eligibity_of_itc')->dropdownList(
                                [
                                    'Yes' => 'Yes', 'No' => 'No'
                                ],
                                ['prompt' => '--Select--', 'class' => 'select_class form-control']
                            )->label(false) ?>
                        </div>
                    </div>
                </div>
                <hr class="dj-hr">
                <h5 class="card-title">PO #</h5>
                <div class="form-row">
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="prefix" class="">Prefix Ex:RA</label>
                            <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true, 'value' => $year])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <?php
                            if ((isset($last_purchase)) && ($update == "add")) { ?>
                                <label for="salesorder" class="po" id="po_label">PO# Last# <?= $last_entry-1?> </label>
                                <?= $form->field($model, 'po_last')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true, 'value' =>  $last_entry])->label(false) ?>
                            <?php } else  if ((!isset($last_lead)) && ($update == "add")) { ?>
                                <?= $form->field($model, 'po_last')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true, 'value' =>  1])->label(false) ?>
                            <?php } else { ?>
                                <label for="salesorder" class="po" id="po_label">PO# Last# <?= $last_entry-1 ?></label>
                                <?= $form->field($model, 'po_last')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true,'value' =>  $last_entry])->label(false) ?>
                            <?php } ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Suffix EX: RT</label>
                            <?= $form->field($model, 'suffix_last')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true])->label(false) ?>

                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="date" class="">Date <span class="dj-red">*</span></label>
                            <?= $form->field($model, 'date')->textInput(['maxlength' => true, 'class' => "form-control b_date", 'type' => 'date',])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="date" class="">Due Date</label>
                            <?= $form->field($model, 'due_date')->textInput(['maxlength' => true, 'class' => "form-control due_date", 'type' => 'date',])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="date" class="">Terms of Payment</label>
                            <?= $form->field($model, 'terms_of_payment')->dropdownList(
                                [
                                    'Due Open Receipt' => 'Due Open Receipt', 'Due within 7 days' => 'Due within 7 days',
                                    'Due within 10 days' => 'Due within 10 days',
                                    'Due within 15 days' => 'Due within 15 days',
                                    'Due within 30 days' => 'Due within 30 days',
                                    'Due within 45 days' => 'Due within 45 days',
                                    'Due within 60 days' => 'Due within 60 days',
                                    'Due within 75 days' => 'Due within 75 days',
                                    'Due within 90 days' => 'Due within 90 days',
                                    'Due within 120 days' => 'Due within 120 days',
                                ],
                                ['prompt' => '--Select--', 'class' => 'select_class form-control terms_of_payment']
                            )->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="position-relative form-group">
                            <label for="notes">Terms & Condition</label>
                            <?= $form->field($model, 'terms_and_condition')->textInput(['maxlength' => true, 'class' => "form-control"])->textarea(['rows' => '2'])->label(false) ?>
                        </div>
                    </div>
                </div>
                <hr class="dj-hr">

                <div class="form-row">
                    <table class="mb-0 table table-bordered dj-table-form" id="dynamic_field">
                        <thead>
                            <tr>
                                <th colspan="2" width="20%">Product *</th>
                                <th width="10%">Desc</th>
                                <th width="10%">Qty</th>
                                <th width="10%">Units</th>
                                <th width="10%">Price</th>
                                <th width="10%">Discount</th>
                                <th>Discount Type</th>
                                <th width="20%">Tax</th>
                                <th>Incl Tax</th>
                                <th width="10%">Amount</th>
                            </tr>
                        </thead>
                        <tbody id="dj-table-body">
                            <?php if ($update == 'add' && $from == '') { ?>
                                <tr>
                                    <!-- <td class="text-center"><input type="checkbox"></td> -->
                                    <td></td>
                                    <td style="width: 200px" class="rendered"><?= $form->field($purchaseorderproduct, 'product_id')->dropDownList([], ['prompt' => 'Select Product', 'class' => "product_details form-control", 'id' => 'product', 'name' => 'productdyn[0][product]'])->label(false) ?>
                                    </td>

                                    <td>
                                        <?= $form->field($purchaseorderproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => 'productdyn[0][desc]'])->label(false) ?>
                                    </td>

                                    <td>
                                        <?= $form->field($purchaseorderproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => 'productdyn[0][quantity]', 'min' => 1])->label(false) ?>
                                        <div class="error-help">Quantity cant be negative or zero.</div>
                                    </td>
                                    <td>
                                        <?= $form->field($purchaseorderproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control ", 'name' => "productdyn[0][units]"])->label(false) ?>
                                    </td>
                                    <td>

                                        <?= $form->field($purchaseorderproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => 'productdyn[0][unitprice]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                        <?= $form->field($purchaseorderproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => 'productdyn[0][price]', 'type' => 'hidden'])->label(false) ?>

                                        <div class="error-help">Enter valid price.</div>
                                    </td>
                                    <td>
                                        <?= $form->field($purchaseorderproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => 'productdyn[0][discount]', 'type' => 'number', 'min' => 1])->label(false) ?>

                                        <div class="error-help help-type">Discount must be less than 99 & greater than 0</div>
                                    </td>
                                    <td style="width: 150px">
                                        <?= $form->field($purchaseorderproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control ', 'id' => 'discounttype', 'name' => 'productdyn[0][discounttype]'])->label(false) ?>
                                        <div class="error-help">Discount Type cannot be blank.</div>

                                    </td>
                                    <td>

                                        <?= $form->field($purchaseorderproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name', 'accounting_tax_id'])->asArray()
                                            ->where(['is_deleted' => 0])
                                            ->andWhere(['tax_sub_type' => 'Input'])
                                            ->andWhere(['status' => 1])
                                            ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                            ->all(), 'accounting_tax_id', 'tax_name'), ['prompt' => '--Select Tax--', 'class' => "product_tax form-control ", 'style' => 'width:50px', 'name' => 'productdyn[0][tax]', 'id' => 'tax'])->label(false) ?>
                                    </td>

                                    <td class="text-center">
                                        <?= $form->field($purchaseorderproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => 'productdyn[0][tax_included]']) ?>
                                    </td>
                                    <td>
                                        <?= $form->field($purchaseorderproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => 'productdyn[0][amount]'])->label(false) ?>
                                        <div class="error-help">Total amount cannot be negative.</div>
                                    </td>
                                </tr>



                            <?php } else { ?>


                                <?php foreach ($purchaseorderproduct as $key => $purchaseorderproduct) : ?>
                                    <?php $product = Product::find()->select('product_name')->where(['id' => $purchaseorderproduct->product_id])->one(); ?>
                                    <tr>

                                        <?php if ($key == 0) { ?>
                                            <td></td>
                                        <?php } else { ?>
                                            <td class="text-center"><i class="fa fa-close removeproduct" aria-hidden="true" style="color: blue;"></i></td>
                                        <?php } ?>
                                        <td style="width: 200px" class="rendered">

                                            <?= $form->field($purchaseorderproduct, 'product_id')->dropDownList([$purchaseorderproduct->product_id => $product->product_name], ['options' => [$purchaseorderproduct->product_id => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => "productdynupdate[$key][product]"])->label(false) ?>
                                        </td>

                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => "productdynupdate[$key][desc]"])->label(false) ?>
                                        </td>

                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => "productdynupdate[$key][quantity]", 'min' => 1])->label(false) ?>
                                            <div class="error-help">Quantity cant be negative or zero.</div>
                                        </td>
                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control ", 'name' => "productdynupdate[$key][units]"])->label(false) ?>
                                        </td>
                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => "productdynupdate[$key][unitprice]", 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                            <?= $form->field($purchaseorderproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => "productdynupdate[$key][price]", 'type' => 'hidden'])->label(false) ?>

                                            <div class="error-help">Enter valid price.</div>
                                        </td>
                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => "productdynupdate[$key][discount]", 'type' => 'number', 'min' => 1])->label(false) ?>
                                            <!-- <div class="error-help ">Discount  cannot be negative.</div>  -->
                                            <div class="error-help help-type">Discount Type cannot be blank.</div>
                                        </td>
                                        <td style="width: 150px">
                                            <?= $form->field($purchaseorderproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type  form-control', 'id' => 'discounttype', 'name' => "productdynupdate[$key][discounttype]"])->label(false) ?>
                                            <div class="error-help">Discount Type cannot be blank.</div>
                                        </td>
                                        <td>


                                            <?php foreach (explode(',', $purchaseorderproduct->tax) as $taxind) {
                                                $sel_groups_array[$taxind] = array("selected" => true);
                                            } ?>


                                            <?= $form->field($purchaseorderproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name', 'accounting_tax_id'])->asArray()
                                                ->where(['is_deleted' => 0])
                                                ->andWhere(['tax_sub_type' => 'Input'])
                                                ->andWhere(['status' => 1])
                                                ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                ->all(), 'accounting_tax_id', 'tax_name'), ['options' => $sel_groups_array, 'class' => "product_tax form-control", 'style' => 'width:50px', 'name' => "productdynupdate[$key][tax]", 'id' => 'tax'])->label(false) ?>



                                            <?php $sel_groups_array = [] ?>
                                        </td>

                                        <td class="text-center">
                                            <?= $form->field($purchaseorderproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => "productdynupdate[$key][tax_included]"]) ?>
                                        </td>
                                        <td>
                                            <?= $form->field($purchaseorderproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => "productdynupdate[$key][amount]"])->label(false) ?>
                                            <div class="error-help">Total amount cannot be negative.</div>
                                        </td>
                                    </tr>

                                <?php endforeach; ?>
                            <?php } ?>
                        </tbody>
                    </table>
                </div>
                <div class="form-row">
                    <table class="mb-0 table table-bordered">
                        <tr>
                            <td width="25%" rowspan="7"><?= Html::Button(' <i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Line', ['class' => 'dj-danger-btn', 'id' => "add_new"]) ?></td>
                            <td width="25%" rowspan="7" class="text-right">

                                <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/product/create'])->one() != '') { ?>
                                    <a href="<?= Url::base(); ?>/master/product/create" target='Blank' class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Product</a>
                                <?php } else { ?>

                                <?php } ?>



                            </td>
                            <td width="25%"><label class="dj-sub-total-amt">Subtotal:</label></td>
                            <td width="25%" class="text-right"><label class="subtotalamt dj-sub-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sub_total_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control subtotal"])->label(false) ?></td>
                        </tr>
                        <?php if ($update == 'add') { ?>
                            <tr>

                                <td class="sale_order_intrastate"><label class="dj-total-amt">CGST:</label></td>
                                <td width="25%" class="text-right sale_order_intrastate">
                                    <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'cgst')->hiddenInput(['maxlength' => true, 'class' => "form-control cgst"])->label(false) ?>

                                </td>
                            </tr>
                            <tr>
                                <td class="sale_order_intrastate"><label class="dj-total-amt">SGST:</label></td>
                                <td width="25%" class="text-right sale_order_intrastate">
                                    <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sgst')->hiddenInput(['maxlength' => true, 'class' => "form-control sgst"])->label(false) ?>

                                </td>
                            </tr>
                        <?php } else { ?>

                            <tr>
                                <td class="gst_on_update"><label class="dj-total-amt">CGST:</label></td>
                                <td width="25%" class="text-right gst_on_update">
                                    <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'cgst')->hiddenInput(['maxlength' => true, 'class' => "form-control cgst"])->label(false) ?>

                                </td>
                            </tr>
                            <tr>
                                <td class="gst_on_update"><label class="dj-total-amt">SGST:</label></td>
                                <td width="25%" class="text-right gst_on_update">
                                    <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sgst')->hiddenInput(['maxlength' => true, 'class' => "form-control sgst"])->label(false) ?>

                                </td>
                            </tr>

                        <?php } ?>
                        <tr>
                            <?php if ($update == 'add') { ?>
                                <td class="sale_order_interstate"><label class="dj-total-amt">IGST:</label></td>
                                <td width="25%" class="text-right sale_order_interstate"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                    <?= $form->field($model, 'igst')->hiddenInput(['maxlength' => true, 'class' => "form-control total_igst"])->label(false) ?>
                                </td>
                            <?php } else { ?>

                                <td class="igst_on_update"><label class="dj-total-amt ">IGST:</label></td>
                                <td width="25%" class="text-right igst_on_update"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                    <?= $form->field($model, 'igst')->hiddenInput(['maxlength' => true, 'class' => "form-control total_igst"])->label(false) ?>
                                </td>
                            <?php } ?>
                        </tr>

                        <tr>
                            <td width="25%"><label class="dj-sub-total-amt"><?= $form->field($model, 'is_tcs')->checkBox(['label' => '', 'class' => 'tcs_tax'])->label(false) ?></label>&nbsp;&nbsp;<label class="dj-sub-total-amt">TCS:</label></td>
                            <td width="25%" class="text-right"><label class="dj-sub-total-amt tcsam" style="padding-top: 10px"></label><?= $form->field($model, 'tcs')->textInput(['maxlength' => true, 'class' => "form-control tcsamount"])->label(false) ?>
                            </td>
                        </tr>


                        <tr>
                            <td><input type="checkbox" id="round" type="text" class="">&nbsp;&nbsp;<label class="dj-total-amt">Round Off: Amount:</label></td>
                            <td class="text-right"><label class="roundoffamt dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'round_off_amount')->hiddenInput(['maxlength' => true, 'readonly' => true, 'class' => "form-control round_off_amount",'id'=>'roundoffval'])->label(false) ?>
                                <!-- <div class="error-help">Total cannot be negative.</div> -->
                            </td>
                        </tr>
                        <tr>
                            <td><label class="dj-total-amt">Total(INR):</label></td>
                            <td width="25%" class="text-right"><label class="totalamt dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'total_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control total"])->label(false) ?></td>

                        </tr>

                        <tr>
                            <td colspan="4">
                                <div class="form-group">
                                    <div class="form-check form-check-inline">
                                        <?php if (($update == "update") && ($model->advance_payment == "Yes")) { ?>
                                            <?= $form->field($model, 'advance_payment')->checkBox(['label' => 'Allow Advance payment for Purchase Order', 'class' => 'paymentcheck', 'checked' => true]) ?>
                                        <?php } else { ?>
                                            <?= $form->field($model, 'advance_payment')->checkBox(['label' => 'Allow Advance payment for Purchase Order', 'class' => 'paymentcheck', 'checked' => false]) ?>
                                        <?php } ?>


                                    </div>


                                </div>
                            </td>
                        </tr>
                    </table>

                </div>
                <div class="advancenew" style="display:none">
                    <hr class="dj-hr line">
                    <div class="form-row advance">
                        <div class="col-md-12 heading">
                            <div class="dj-other-heading">Advance Payment Datails</div>
                        </div>
                        <div class="col-md-6 setting">
                            <div class="position-relative form-group ">
                                <label for="settings type">Settings Type </label>
                                <?= $form->field($model, 'advance_settingtype')->dropDownList($settings_type, ['class' => "select_setting form-control", 'maxlength' => true])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-6 receipt_amt">
                            <div class="position-relative form-group">
                                <label>Amount(Rs.) </label>
                                <?= $form->field($model, 'advance_amount')->textInput(['maxlength' => true])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-6 receipt_bank">
                            <div class="position-relative form-group">
                                <label>Bank </label>
                                <?= $form->field($model, 'bank')->dropDownList($banks_name, ['prompt' => '--Select--', 'class' => "select_setting form-control", 'maxlength' => true])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-6 cheque">
                            <div class="position-relative form-group">
                                <label for="cheque no">Cheque No. </label>
                                <?= $form->field($model, 'cheque_no')->textInput(['maxlength' => true])->label(false) ?>
                            </div>

                        </div>
                        <div class="col-md-6 cheque_date">
                            <div class="position-relative form-group">
                                <label for="Cheque date">Cheque Date</label>
                                <?= $form->field($model, 'cheque_date')->textInput(['type' => "date", 'class' => "form-control"])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-6 receipt_nt">
                            <div class="position-relative form-group">
                                <label>Advance Note </label>
                                <?= $form->field($model, 'advance_note')->textarea(['maxlength' => true, 'rows' => 1])->label(false) ?>
                            </div>
                        </div>
                    </div>
                    <hr class="dj-hr line">
                </div>


                <div class="form-row">
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Supplier's Ref</label>
                            <?= $form->field($model, 'supplier_ref')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Other Reference</label>
                            <?= $form->field($model, 'other_ref')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Dispatch Through</label>
                            <?= $form->field($model, 'dispatch_through')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Destination </label>
                            <?= $form->field($model, 'destination')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Mode/Terms of Payment</label>
                            <?= $form->field($model, 'mode_of_payment')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="suffix" class="">Deliver date</label>
                            <?= $form->field($model, 'delivery_date')->textInput(['maxlength' => true, 'class' => "form-control", 'type' => 'date',])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-12">
                        <div class="form-check form-check-inline dj-check-switch-sec">
                            <?php if ($update == 'add') { ?>
                                <div class="position-relative form-group">
                                    <input type="checkbox" data-toggle="toggle" data-class="reminder" data-on="Yes" data-off="No" data-style="reminder" data-onstyle="success" data-offstyle="danger" name="reminder" id="reminder">
                                    <label for="inlineCheckbox1" class="form-check-label dj-check-switch">Set Reminder</label>
                                </div>
                            <?php } else { ?>
                                <?php if ($model->reminder == 'Yes') { ?>
                                    <div class="position-relative form-group">
                                        <input type="checkbox" checked data-toggle="toggle" data-class="reminder" data-on="Yes" data-off="No" data-style="reminder" data-onstyle="success" data-offstyle="danger" name="reminder" id="reminder">
                                        <label for="inlineCheckbox1" class="form-check-label dj-check-switch">Set Reminder</label>
                                    </div>
                                <?php } else { ?>

                                    <div class="position-relative form-group">
                                        <input type="checkbox" data-toggle="toggle" data-class="reminder" data-on="Yes" data-off="No" data-style="reminder" data-onstyle="success" data-offstyle="danger" name="reminder" id="reminder">
                                        <label for="inlineCheckbox1" class="form-check-label dj-check-switch">Set Reminder</label>
                                    </div>
                                <?php } ?>
                            <?php } ?>
                        </div>
                    </div>
                    <?php if ($update == 'add') { ?>

                        <hr class="dj-hr reminder_column" style="display:none;">
                        <div class="col-md-12 form-row reminder_details" style="display:none;">
                            <div class="col-md-4 position-relative form-group">
                                <label for="exampleFile" class="">For</label>
                                <?= $form->field($model, 'reminder_for')->textInput(['maxlength' => true, 'class' => "form-control for", 'id' => 'reminder_for'])->label(false) ?>
                            </div>
                            <div class="col-md-4  position-relative form-group">
                                <label for="exampleFile" class="">Reminder Through</label>
                                <?= $form->field($model, 'reminder_through')->checkBox(['label' => 'Email', 'class' => 'email_reminder dynamail', 'style' => 'margin-left:30px; margin-top:10px', 'id' => 'reminder_through']) ?>

                            </div>
                        </div>

                    <?php } else { ?>

                        <?php if ($model->reminder == 'Yes') { ?>
                            <hr class="dj-hr reminder_column">
                            <div class="col-md-12 form-row reminder_details">
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">For</label>
                                    <?= $form->field($model, 'reminder_for')->textInput(['maxlength' => true, 'class' => "form-control for", 'id' => 'reminder_for'])->label(false) ?>
                                </div>
                                <div class="col-md-4  position-relative form-group">
                                    <label for="exampleFile" class="">Reminder Through</label>
                                    <?= $form->field($model, 'reminder_through')->checkBox(['label' => 'Email', 'class' => 'email_reminder_update dynamail', 'style' => 'margin-left:30px; margin-top:10px', 'id' => 'reminder_through']) ?>

                                </div>
                            </div>
                        <?php } else { ?>
                            <div class="col-md-12 form-row reminder_details" style="display:none;">
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">For</label>
                                    <?= $form->field($model, 'reminder_for')->textInput(['maxlength' => true, 'class' => "form-control for", 'id' => 'reminder_for'])->label(false) ?>
                                </div>
                                <div class="col-md-4  position-relative form-group">
                                    <label for="exampleFile" class="">Reminder Through</label>
                                    <?= $form->field($model, 'reminder_through')->checkBox(['label' => 'Email', 'class' => 'email_reminder dynamail', 'style' => 'margin-left:30px; margin-top:10px', 'id' => 'reminder_through']) ?>

                                </div>
                            </div>

                        <?php } ?>
                    <?php } ?>
                    <?php if ($update == 'add') { ?>
                        <div class="form-row email_details" style="display:none;">
                            <div class="col-md-6 position-relative form-group">
                                <label for="exampleFile" class="">Reminder Email</label>

                                <?= $form->field($model, 'reminder_emails')->textarea(['rows' => 1, 'id' => 'reminder_emails'])->label(false) ?>
                            </div>
                            <div class="col-md-6 position-relative form-group">
                                <label for="exampleFile" class="">Repeat</label>

                                <?= $form->field($model, 'reminder_repeat_on')
                                    ->dropDownList([
                                        'One-time' => 'One-time',
                                        'Daily' => 'Daily',
                                        'Weekly' => 'Weekly',
                                        'Monthly' => 'Monthly',
                                        'Quarterly' => 'Quarterly',
                                        'half-yearly' => 'Half-yearly',
                                        'Yearly' => 'Yearly',
                                    ], ['prompt' => '--Select--', 'class' => 'form-control', 'id' => 'reminder_repeat_on'])->label(false) ?>
                            </div>
                            <div class="col-md-4 position-relative form-group">
                                <label for="exampleFile" class="">Reminder From</label>
                                <?= $form->field($model, 'reminder_from_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_from_date'])->label(false) ?>
                            </div>
                            <div class="col-md-4 position-relative form-group">
                                <label for="exampleFile" class="">Reminder To</label>
                                <?= $form->field($model, 'reminder_to_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_to_date'])->label(false) ?>
                            </div>
                            <div class="col-md-4 position-relative form-group">
                                <label for="exampleFile" class="">Content</label>
                                <?= $form->field($model, 'reminder_content')->textarea(['rows' => 1, 'id' => 'reminder_content'])->label(false) ?>
                            </div>
                        </div>
                    <?php } else { ?>
                        <?php if ($model->reminder_through == 1) { ?>
                            <div class="form-row email_details_update">
                                <div class="col-md-6 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder Email</label>

                                    <?= $form->field($model, 'reminder_emails')->textarea(['rows' => 1, 'id' => 'reminder_emails'])->label(false) ?>
                                </div>
                                <div class="col-md-6 position-relative form-group">
                                    <label for="exampleFile" class="">Repeat</label>

                                    <?= $form->field($model, 'reminder_repeat_on')
                                        ->dropDownList([
                                            'One-time' => 'One-time',
                                            'Daily' => 'Daily',
                                            'Weekly' => 'Weekly',
                                            'Monthly' => 'Monthly',
                                            'Quarterly' => 'Quarterly',
                                            'half-yearly' => 'Half-yearly',
                                            'Yearly' => 'Yearly',
                                        ], ['prompt' => '--Select--', 'class' => 'form-control', 'id' => 'reminder_repeat_on'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder From</label>
                                    <?= $form->field($model, 'reminder_from_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_from_date'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder To</label>
                                    <?= $form->field($model, 'reminder_to_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_to_date'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Content</label>
                                    <?= $form->field($model, 'reminder_content')->textarea(['rows' => 1, 'id' => 'reminder_content'])->label(false) ?>
                                </div>
                            </div>
                        <?php } else { ?>
                            <div class="form-row email_details_update" style="display:none;">
                                <div class="col-md-6 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder Email</label>

                                    <?= $form->field($model, 'reminder_emails')->textarea(['rows' => 1, 'id' => 'reminder_emails'])->label(false) ?>
                                </div>
                                <div class="col-md-6 position-relative form-group">
                                    <label for="exampleFile" class="">Repeat</label>

                                    <?= $form->field($model, 'reminder_repeat_on')
                                        ->dropDownList([
                                            'One-time' => 'One-time',
                                            'Daily' => 'Daily',
                                            'Weekly' => 'Weekly',
                                            'Monthly' => 'Monthly',
                                            'Quarterly' => 'Quarterly',
                                            'half-yearly' => 'Half-yearly',
                                            'Yearly' => 'Yearly',
                                        ], ['prompt' => '--Select--', 'class' => 'form-control', 'id' => 'reminder_repeat_on'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder From</label>
                                    <?= $form->field($model, 'reminder_from_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_from_date'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Reminder To</label>
                                    <?= $form->field($model, 'reminder_to_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'reminder_to_date'])->label(false) ?>
                                </div>
                                <div class="col-md-4 position-relative form-group">
                                    <label for="exampleFile" class="">Content</label>
                                    <?= $form->field($model, 'reminder_content')->textarea(['rows' => 1, 'id' => 'reminder_content'])->label(false) ?>
                                </div>
                            </div>
                        <?php } ?>
                    <?php } ?>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="notes">Terms of Delivery</label>
                            <?= $form->field($model, 'terms_of_delivery')->textInput(['maxlength' => true, 'class' => "form-control"])->textarea(['rows' => '3'])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="exampleFile" class="">Attach Documents</label>
                            <?= $form->field($model, 'files[]')->fileInput(['multiple' => true])->label(false) ?>
                            <?php if (isset($purchase_doc)) {
                                foreach ($purchase_doc as $index => $value) {
                                    if ((substr($value->document_name, -3) == "png") || (substr($value->document_name, -3) == "jpg")) {
                            ?>
                                        <img width="90" height="40" src="<?= Url::base() ?>/setting/purchase_documents/<?= $value->document_name ?>">
                                    <?php } else { ?>
                                        <a href="<?= Url::base() ?>/setting/purchase_documents/<?= $value->document_name ?>"><?= $value->document_name ?></a>
                                    <?php } ?>
                                    <button type="button" value=<?= $value->id ?> style="margin-left:50px" class="dj-danger-btn remove1"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button></br></br>
                            <?php }
                            } ?>
                        </div>
                    </div>
                </div>
                <div class="djsec-text-right dj-btn-sapce-sec">
                    <?= Html::submitButton(($update == "update") ? '<span class="fa fa-file-text-o"></span> Update and Create New' : '<span class="fa fa-file-text-o"></span> Save and Create New', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn createon', 'name' => 'save', 'value' => '1']) ?>
                    <button class="mb-2 mr-2 btn-icon btn dj-danger-btn smssave"><i class="fa fa-commenting" aria-hidden="true"></i> Save and SMS</button>
                    <button class="mb-2 mr-2 btn-icon btn dj-danger-btn emailsave"><i class="fa fa-envelope-o" aria-hidden="true"></i> Save and Email</button>
                    <button class="mb-2 mr-2 btn-icon btn dj-danger-btn convertsave"><i class="fa fa-exchange" aria-hidden="true"></i> Save and Convert Bill</button>
                    <?= Html::submitButton(($update == "update") ? '<span class="fa fa-check-square-o"></span> Update' : '<span class="fa fa-check-square-o"></span> Create', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn saveon', 'name' => 'save', 'value' => '0']) ?>

                    <button type="reset" onclick="location.href='<?= Url::base() ?>/master/purchase-order/index';" class="mb-2 mr-2 btn-icon btn btn-danger dj-le-btn"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</button>
                </div>
                <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>
<?php ob_start(); ?>
<script>
       $(document).on('select2:open', () => {
    document.querySelector('.select2-search__field').focus();
  });
    $(document).ready(function() {
        $('.supply_type').select2();
        $('.select_class').select2();
        $('.select_setting').select2();


        var rowDataArray = [];
        <?php if (
        $update == 'update') { ?>
                    $('#dynamic_field tbody tr:not(.add-more)').each(function(rowindex) {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').find("option:selected").val(),
                    product_amount: $(this).find('.product_amount').val(),
                    rowindex: rowindex,
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    });
                    <?php } ?>
       

          subtotal();
          total();



        $('.setting_default').find("option[value='19']").attr("selected",true).trigger('change');
        <?php if ($update == 'add' && $from == ''){?>
            var rowDataArray = [];
            $('#dynamic_field tbody tr:not(.add-more)').each(function(rowindex) {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').find("option:selected").val(),
                    product_amount: $(this).find('.product_amount').val(),
                    rowindex: rowindex,
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    });
                    subtotal();
                    total();   
            var subTotalValue = $('#purchaseorder-sub_total_amount').val();
            var parsedValue = parseFloat(subTotalValue).toFixed(2);
            var formattedsubTotalValue = parseFloat(parsedValue).toLocaleString('en-US');
            $('.subtotalamt').text(formattedsubTotalValue);

            var totalValue=$('#purchaseorder-total_amount').val();
            var Value = parseFloat(totalValue).toFixed(2);
            var formattedTotalValue = parseFloat(Value).toLocaleString('en-US');
            $('.totalamt').text(formattedTotalValue);
           
          <?php } ?>

          <?php if ($update == 'update') { ?>      
            // $(".product_tax").select2().select2('val','34');
            var subTotalValue = $('#saleorder-sub_total_amount').val();
            var parsedValue = parseFloat(subTotalValue).toFixed(2);
            var formattedsubTotalValue = parseFloat(parsedValue).toLocaleString('en-US');
            $('.subtotalamt').text(formattedsubTotalValue);

            var totalValue=$('#saleorder-total_amount').val();
            var Value = parseFloat(totalValue).toFixed(2);
            var formattedTotalValue = parseFloat(Value).toLocaleString('en-US');
            $('.totalamt').text(formattedTotalValue);
          <?php } ?>


        subtotal();
        total();
        $('.sale_order_intrastate').hide();
        $('.sale_order_interstate').hide();
        if ($('.point_of_supply').val() == 21) {
            $('.sale_order_intrastate').show();
            $('.sale_order_interstate').hide();
            $('.igst_on_update').hide();
            $('.gst_on_update').show();
        } else if ($('.point_of_supply').val() == '') {
            $('.sale_order_interstate').hide();
            $('.sale_order_intrastate').hide();
            $('.igst_on_update').hide();
            $('.gst_on_update').hide();
        } else {
            $('.sale_order_interstate').show();
            $('.sale_order_intrastate').hide();
            $('.igst_on_update').show();
            $('.gst_on_update').hide();
        }
        $('.point_of_supply').change(function() {
            if ($(this).val() == 21) {
                $('.sale_order_intrastate').show();
                $('.sale_order_interstate').hide();
                $('.igst_on_update').hide();
                $('.gst_on_update').show();
            } else {
                $('.sale_order_interstate').show();
                $('.sale_order_intrastate').hide();
                $('.igst_on_update').show();
                $('.gst_on_update').hide();
            }
        })

        $('.b_date').change(function() {
            var due = 0;
            if ($('.terms_of_payment').val() != '') {
                if ($('.terms_of_payment').val() == 'Due within 7 days') {
                    due = 7;
                }
                if ($('.terms_of_payment').val() == 'Due within 10 days') {
                    due = 10;
                }
                if ($('.terms_of_payment').val() == 'Due within 15 days') {
                    due = 15;
                }
                if ($('.terms_of_payment').val() == 'Due within 30 days') {
                    due = 30;
                }
                if ($('.terms_of_payment').val() == 'Due within 45 days') {
                    due = 45;
                }
                if ($('.terms_of_payment').val() == 'Due within 60 days') {
                    due = 60;
                }
                if ($('.terms_of_payment').val() == 'Due within 75 days') {
                    due = 75;
                }
                if ($('.terms_of_payment').val() == 'Due within 90 days') {
                    due = 90;
                }
                if ($('.terms_of_payment').val() == 'Due within 120 days') {
                    due = 120;
                }
            }
            var date = new Date($('.b_date').val());
            if (date != '') {
                date.setDate(date.getDate() + due);
                var day = ("0" + date.getDate()).slice(-2);
                var month = ("0" + (date.getMonth() + 1)).slice(-2);
                var dt = date.getFullYear() + "-" + (month) + "-" + (day);
                $('.due_date').val(dt).trigger('change');
                if ($('.terms_of_payment').val() == 'Due upon receipt') {
                    $('.due_date').val('').trigger('change');
                }
            } else {
                $('.due_date').val('');
            }
        });

        $('.terms_of_payment').change(function() {
            var due = 0;
            if ($(this).val() != '') {
                if ($(this).val() == 'Due within 7 days') {
                    due = 7;
                }
                if ($(this).val() == 'Due within 10 days') {
                    due = 10;
                }
                if ($(this).val() == 'Due within 15 days') {
                    due = 15;
                }
                if ($(this).val() == 'Due within 30 days') {
                    due = 30;
                }
                if ($(this).val() == 'Due within 45 days') {
                    due = 45;
                }
                if ($(this).val() == 'Due within 60 days') {
                    due = 60;
                }
                if ($(this).val() == 'Due within 75 days') {
                    due = 75;
                }
                if ($(this).val() == 'Due within 90 days') {
                    due = 90;
                }
                if ($(this).val() == 'Due within 120 days') {
                    due = 120;
                }
            }
            var date = new Date($('.b_date').val());
            if (date != '') {
                date.setDate(date.getDate() + due);
                var day = ("0" + date.getDate()).slice(-2);
                var month = ("0" + (date.getMonth() + 1)).slice(-2);
                var dt = date.getFullYear() + "-" + (month) + "-" + (day);
                $('.due_date').val(dt).trigger('change');
                if ($(this).val() == 'Due upon receipt') {
                    $('.due_date').val('').trigger('change');
                }
            } else {
                $('.due_date').val('').trigger('change');
            }
        })

        $('.vendor_details').change(function() {
            var customerid = $(this).val();
            if (customerid != '') {
                $.get('../../users/credit-note/findvendordetails', {
                    customerid: customerid
                }, function(data) {
                    var data = $.parseJSON(data);



                    $('.sendor_gstn').val(data.gstin_no);
                    var gstin_value = data.gstin_no;
                    $('.terms_of_payment').val(data.credit_terms).trigger('change');
                    if ($('.sendor_gstn').val() != '') {

                        var gstin_value = data.gstin_no;
                        var state_code = gstin_value.substr(0, 2);
                        
                        $('#purchaseorder-bill_type').val('B2B').trigger('change');
                        $('.point_of_supply').val(state_code).trigger('change');
                        if (state_code == 21) {
                            $('.supply_type').val('Intra-State').trigger('change');
                        } else {
                            $('.supply_type').val('Inter-State').trigger('change');
                        }
                    } else {
                        $('.point_of_supply').val('').trigger('change');
                        $('.supply_type').val('').trigger('change');
                        $('#purchaseorder-bill_type').val('B2C').trigger('change');
                    }
                })
            } else {
                $('.executive').val('').trigger('change');
                $('.sendor_gstn').val('');
                $('.point_of_supply').val('').trigger('change');
                $('.supply_type').val('').trigger('change');
            }

        });


        $('.sendor_gstn').change(function() {
            var gst_no = $(this).val();
            var s_code = gst_no.substr(0, 2);
            $('.point_of_supply').val(s_code).trigger('change');
            if (s_code == 21) {
                $('.supply_type').val('Intra-State').trigger('change');
            } else {
                $('.supply_type').val('Inter-State').trigger('change');
            }

        })
        $('.point_of_supply').change(function() {
            var state_no = $(this).val();
            if (state_no == 21) {
                $('.supply_type').val('Intra-State').trigger('change');
            } else {
                $('.supply_type').val('Inter-State').trigger('change');
            }

        })

        $(document).on('click', ".removeproduct", function() {
    
    $(this).parent().parent().remove();
    var $this = $(this);
    $this.parent().parent().siblings().children().children('.desc').val('');
    $this.parent().parent().siblings().children().children('.product_price').val('');
    $this.parent().parent().siblings().children().children('.unit_price').val('');
    $this.parent().parent().siblings().children().children('.product_tax').val('');
    $this.parent().parent().siblings().children().children('.product_unit').val('').trigger('change');
    $this.parent().parent().siblings().children().children('.product_quantity').val('');
    $this.parent().parent().siblings().children().children('.product_discount').val('');
    $this.parent().parent().siblings().children().children('.discount_type').val('');
    $this.parent().parent().siblings().children().children('.product_amount').val('');
    
    rowDataArray = [];
        $('#dynamic_field tbody tr').each(function() {
          var rowData = {
          product_quantity: $(this).find('.product_quantity').val(),
          product_unit:   $(this).find('.product_unit').find("option:selected").val(),
          unit_price: $(this).find('.unit_price').val(),
          product_discount: $(this).find('.product_discount').val(),
          discount_type: $(this).find('.discount_type').find("option:selected").val(),
          product_tax: $(this).find('.product_tax').find("option:selected").val(),
          product_amount: $(this).find('.product_amount').val(),
          };
          rowDataArray.push(rowData);
          console.log(rowDataArray);
          }); 

          subtotal();
          total();
});




        $('.error-help').hide();
        $('.discount_type').select2();
        $('.product_unit').select2();
        $('.product_tax').select2();
        $('.product_details').select2({
            ajax: {
                url: "../../users/leads-quotes/productdetails",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {
                    // console.log(response);
                    return {
                        results: $.map(response, function(i, item) {
                            // console.log(i,item);
                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };


                },
                cache: true
            }
        })
        $('.findvendor').select2({
            ajax: {
                url: "vendordetails",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {
                    return {
                        results: $.map(response, function(i, item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };

                },
                cache: true
            }
        });
        $(".email_reminder_update").change(function() {
            var value = $('input[name="PurchaseOrder[reminder_through]"]:checked').val();

            if (value == 1) {
                $('.email_details_update').show();
            } else {
                $('.email_details_update').hide();
            }
        });





        $(document).on("click", ".saveon", function(e) {
            e.preventDefault();
            var value = false;
            //    $(".product_discount").each(function()
            //     {
            //         if($(this).val()!=0 && $(this).val()!="" && $(this).val()>0)
            //         {
            //             var discounttype = $(this).parent().parent().siblings().children().children('.discount_type').val();
            //             if(discounttype == null || discounttype == '' || discounttype == '--Select--')
            //             {
            //                 value=true;
            //                 $(this).parent().parent().siblings().children('.error-help').show();
            //                 $(this).parent().parent().siblings().children().children('.error-help').show();
            //             }
            //             else      
            //             {
            //                 $(this).parent().parent().siblings().children('.error-help').hide();
            //                 $(this).parent().parent().siblings().children().children('.error-help').hide();
            //             }
            //         }
            //         else
            //         {  
            //             if($(this).val()!=0 && $(this).val()!="" && $(this).val()<0)
            //             {
            //                 $(this).parent().siblings('.error-help').show();
            //             }
            //             else
            //             {
            //                 $(this).parent().siblings('.error-help').hide();
            //             }

            //             $(this).parent().parent().siblings().children('.error-help').hide();
            //             $(this).parent().parent().siblings().children().children('.error-help').hide();
            //         }
            //     });
            // $(".discount_type").each(function()
            // {
            //     if($(this).val()=='FLAT' || $(this).val()=='%')
            //     {

            //         var discount = $(this).parent().parent().siblings().children().children('.product_discount').val();
            //         if(discount=='')
            //         {
            //             value=true;
            //              $(this).parent().parent().siblings().children('.help-type').show();
            //         }
            //         else
            //         {
            //              $(this).parent().parent().siblings().children('.help-type').hide();
            //         }
            //     }
            // });
            $(".product_amount").each(function() {
                if ($(this).val() < 0) {
                    $(this).parent().siblings('.error-help').show();
                    value = true;
                } else {
                    $(this).parent().siblings('.error-help').hide();
                }
            })

            $(".product_price").each(function() {
                if ($(this).val() < 0) {
                    $(this).parent().siblings('.error-help').show();
                    value = true;
                } else {
                    $(this).parent().siblings('.error-help').hide();
                }
            })
            $(".product_quantity").each(function() {
                if ($(this).val() <= 0 && $(this).val() != "") {
                    value = true;
                    $(this).parent().siblings('.error-help').show();
                    $(this).siblings('.error-help').show();
                } else {
                    $(this).parent().siblings('.error-help').hide();
                    $(this).siblings('.error-help').hide();
                }
            });


            $('#purchaseorder-setting_type').each(function() {
                var setting = $(this).val();
                // alert(setting);
                $.get('fieldpurchaseordersettingtype', {
                    setting: setting
                }, function(data) {
                    var data = $.parseJSON(data);
                    // alert(data);
                    if (data == '0') {
                        //alert('ho');                  
                        $('#purchaseorder-setting_type').parent().siblings('.error-help').show();
                        $('#purchaseorder-setting_type').focus();

                        value = true;
                    } else {
                        // alert('hide');                   
                        $('#purchaseorder-setting_type').parent().siblings('.error-help').hide();
                        value = false;

                    }

                })

            });

            if (value == false) {
                $(this).attr("disabled", "disabled");
                $('.createon').attr("disabled", "disabled");
                $('.smssave').attr("disabled", "disabled");
                $('.convertsave').attr("disabled", "disabled");
                $('.emailsave').attr("disabled", "disabled");
                setTimeout(function() {
                    $('.saveon').removeAttr("disabled");
                    $('.createon').removeAttr("disabled");
                    $('.smssave').removeAttr("disabled");
                    $('.convertsave').removeAttr("disabled");
                    $('.emailsave').removeAttr("disabled");
                }, 10000);
                $("#w0").submit();
            }
        });

        var value = $('input[class="paymentcheck"]:checked').val();
        //alert(value);
        if (value == 1) {
            $('.advancenew').show();
        } else {
            $('.advancenew').hide();

        }
        // $('.reminder_column').hide();
        // $('.reminder_details').hide();
        // $('.email_details').hide();
        $(".reminder").click(function(e) {
            event.preventDefault();

            if ($(this).hasClass("off")) {
                $('.reminder_column').show();
                $('.reminder_details').show();
                //$('.email_details_update').show();
                var value = $('input[name="PurchaseOrder[reminder_through]"]:checked').val();

                if (value == 1) {
                    $('.email_details').show();
                    $('.email_details_update').show();
                } else {
                    $('.email_details').hide();
                    $('.email_details_update').hide();

                }
                $(".email_reminder").change(function() {
                    var value = $('input[name="PurchaseOrder[reminder_through]"]:checked').val();

                    if (value == 1) {
                        $('.email_details').show();
                        $('.email_details_update').show();

                    } else {
                        $('.email_details').hide();
                        $('.email_details_update').hide();


                    }
                });

            } else {
                $('.reminder_column').hide();
                $('.reminder_details').hide();
                $('.email_details').hide();
                $('.email_details_update').hide();

                //  $('#reminder_for').val('');
                //   // $('#reminder_through').val('');
                //   $('#reminder_through').prop('checked', false);
                //  $('#reminder_emails').val('');
                //  $('#reminder_to_date').val('');
                //  $('#reminder_from_date').val('');
                //  $('#reminder_content').val('');
                //  $('#reminder_repeat_on').val('');

            }
        });
        $('.remove1').click(function() {
            var remove_id = $(this).val();
            var confirm = window.confirm("Are u sure you want to Remove document from db?");

            if (confirm == true) {
                $.ajax({
                    url: '<?= Url::to(['purchase-order/delete-attachment']); ?>',
                    type: 'post',
                    data: "remove_id=" + remove_id,
                    success: function(response) {
                        location.reload();
                    }
                });
            }

        })

        $('.paymentcheck').change(function() {
            var value = $('input[class="paymentcheck"]:checked').val();

            if (value == 1) {
                $('.advancenew').show();
            } else {
                $('.advancenew').hide();

            }
        });


      
    $(document).on("change", ".unit_price", function() {
           
           
            
           
            rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                })

                    subtotal();
                    total();
                    var $this = $(this);
                    var $parent = $this.parent().parent().siblings().children();
                    var rowIndex = $('.unit_price').index(this);
            var unitPrice = parseFloat($this.val()) || 0;
            var productQuantity = parseFloat($parent.children('.product_quantity').val()) || 1;
            var productPrice = unitPrice * productQuantity;
            $parent.children('.product_price').val(productPrice);
            var discountType = $parent.children('.discount_type').val();
            var productDiscount = parseFloat($parent.children('.product_discount').val());
            // var taxlabel = $this.parent().parent().siblings().children().children('.product_tax').find('option:selected').text();
            // var taxValue = taxlabel.split(' -')[1];
            // alert(productPrice);
            // alert(productDiscount);
            // alert(discountType);
            // alert(taxValue);
            var accountingTaxId = $this.parent().parent().siblings().children().children('.product_tax').val();
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 
            var productAmount = 0;
            // if(taxValue){
           if(productPrice !== 0 && productPrice !== ' '){  
            if (discountType == 'FLAT' && productPrice != 0) {
                productAmount = productPrice - productDiscount;
            } else if (discountType == '%') {
                var discountValue = productPrice * (productDiscount / 100);
                productAmount = productPrice - discountValue;
            } else {
                productAmount = productPrice;
            }
        }
        else{
            productAmount = productPrice;
        }
            productAmount += (productAmount * (taxValue / 100));
            // alert(productAmount);

        // }
        // else{  
        //           if (discountType == 'FLAT') {
        //         productAmount = productPrice - productDiscount;
        //     } else if (discountType == '%') {
        //         var discountValue = productPrice * (productDiscount / 100);
        //         productAmount = productPrice - discountValue;
        //     } else {
        //         productAmount = productPrice
        //     }
        // }
        // alert(unitPrice)
            rowDataArray[rowIndex].unit_price = unitPrice;
            productAmount = parseFloat(productAmount).toFixed(2);
            rowDataArray[rowIndex].product_amount = productAmount;
            rowDataArray[rowIndex].product_tax = taxValue;
            //  alert(productAmount);
            row = $this.parent().parent().siblings().children().children('.product_amount');
            row.val(productAmount);
            // alert(rowDataArray[0].product_tax)
            console.log(rowDataArray);
            subtotal();
            total();
        }
    })

        });

 

        $(document).on("change", ".product_quantity", function() {
            // alert('11')
              if ($(this).val() > 0) {
                  $(this).parent().siblings('.error-help').hide();
              } else {
                  $(this).parent().siblings('.error-help').show();
              }
            //   var $this = $(this);
            //   $this.parent().parent().siblings().children().children('.product_price').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val())))));
            //   if ($this.parent().parent().siblings().children().children('.discount_type').val() == 'FLAT') {
            //       $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val()))) - (isNaN($this.parent().parent().siblings().children().children('.product_discount').val()) ? 0 : $this.parent().parent().siblings().children().children('.product_discount').val())));
            //   } else if ($this.parent().parent().siblings().children().children('.discount_type').val() == '%') {
            //       $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val()))) - ((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val()))) * (isNaN($this.parent().parent().siblings().children().children('.product_discount').val()) ? 0 : $this.parent().parent().siblings().children().children('.product_discount').val())) / 100)));
            //   } else {
            //       $this.parent().parent().siblings().children().children('.product_amount').val(((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val()))))));
            //   }
            rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 

                    // subtotal();
                    // total();
            var $this = $(this);
            var rowIndex = $('.product_quantity').index(this);
            var newQuantity = parseInt($this.val());
            rowDataArray[rowIndex].product_quantity = newQuantity;
            var unitPrice = parseFloat($this.parent().parent().siblings().children().children('.unit_price').val());
            var discount = parseFloat($this.parent().parent().siblings().children().children('.product_discount').val());
            // var taxlabel = $this.parent().parent().siblings().children().children('.product_tax').find('option:selected').text();
            // var taxValue = taxlabel.split(' -')[1];

            var accountingTaxId = $this.parent().parent().siblings().children().children('.product_tax').val();
            // alert(accountingTaxId)
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 
            //  if(taxValue){
                var productAmount;
          if(unitPrice !== 0 && unitPrice !== ' '){
            if ($this.parent().parent().siblings().children().children('.discount_type').val() == 'FLAT') {
                productAmount = (unitPrice * newQuantity) - discount
            } else if ($this.parent().parent().siblings().children().children('.discount_type').val() == '%') {
                // var discount = parseFloat(rowDataArray[rowIndex].product_discount);
                productAmount = (unitPrice * newQuantity) - ((unitPrice * newQuantity * discount) / 100);
            } else {
                productAmount = (unitPrice * newQuantity);
            }
        }
        else{
            productAmount = (unitPrice * newQuantity);
        }
            productAmount += (productAmount * (taxValue / 100));
        // }
        //   alert(productamount);
             
            row = $this.parent().parent().siblings().children().children('.product_amount');
            rowDataArray[rowIndex].product_amount = productAmount
            row.val(rowDataArray[rowIndex].product_amount);
            console.log(rowDataArray);
              subtotal();
              total();

        }
    })
          });

          $(document).on("change", ".product_discount", function() {

            rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 

                    subtotal();
                    total();
          var $this = $(this);
            var rowIndex = $('.product_discount').index(this);
            var unitPrice = parseFloat($this.parent().parent().siblings().children().children('.unit_price').val());
            var quantity = parseInt($this.parent().parent().siblings().children().children('.product_quantity').val())|| 0;
            var discountType = $this.parent().parent().siblings().children().children('.discount_type').val();
            var discountValue = parseFloat($this.val()) || 0;
            var taxlabel = $this.parent().parent().siblings().children().children('.product_tax').find('option:selected').text();
            var taxValue = taxlabel.split(' -')[1];

            if (discountValue >= 0 && discountValue <= 99) {
                $this.parent().siblings('.error-help').hide();
            } else {
                $this.parent().siblings('.error-help').show();
            }
            var accountingTaxId = $this.parent().parent().siblings().children().children('.product_tax').val();
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 
            var productAmount;
          if(unitPrice !== 0 && unitPrice !== ' '){
            if (discountType == 'FLAT' && unitPrice != 0) {
                productAmount = (unitPrice * quantity) - discountValue;
            } else if (discountType == '%') {
                productAmount = (unitPrice * quantity) - ((unitPrice * quantity * discountValue) / 100);
            } else {
                productAmount = unitPrice * quantity;
            }
        }
        else{
            productAmount = unitPrice * quantity;
        }
            productAmount += (productAmount * (taxValue / 100));
            productAmount = parseFloat(productAmount).toFixed(2);

            rowDataArray[rowIndex].product_discount = discountValue;
            rowDataArray[rowIndex].product_amount = productAmount;

            row = $this.parent().parent().siblings().children().children('.product_amount');
            row.val(productAmount);
            subtotal();
            total();
            console.log(rowDataArray);
        }
    })
        });

$(document).on("change", ".discount_type", function() {
    rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 

                    subtotal();
                    total();
    $(this).parent().siblings('.error-help').hide();
            var $this = $(this);
            var rowIndex = $('.discount_type').index(this);
            var unitPrice = parseFloat($this.parent().parent().siblings().children().children('.unit_price').val());
            var quantity = parseInt($this.parent().parent().siblings().children().children('.product_quantity').val());
            var discountType = $this.val();
            var discountValue = parseFloat($this.parent().parent().siblings().children().children('.product_discount').val());
            var taxlabel = $this.parent().parent().siblings().children().children('.product_tax').find('option:selected').text();
            var taxValue = taxlabel.split(' -')[1];
            var accountingTaxId = $this.parent().parent().siblings().children().children('.product_tax').val();
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 
            var productAmount;
         if(unitPrice !== 0 && unitPrice !== ''){
            if (discountType == 'FLAT' && unitPrice != 0) {
                productAmount = (unitPrice * quantity) - discountValue;
            } else if (discountType == '%') {
                productAmount = (unitPrice * quantity) - ((unitPrice * quantity * discountValue) / 100);
            } else {
            productAmount = unitPrice * quantity;
            }
        }
        else{
            productAmount = unitPrice * quantity;
        }

            productAmount += (productAmount * (taxValue / 100));
            productAmount = parseFloat(productAmount).toFixed(2);

            rowDataArray[rowIndex].discount_type = discountType;
            rowDataArray[rowIndex].product_amount = productAmount;
            rowDataArray[rowIndex].product_discount = discountValue;

            row = $this.parent().parent().siblings().children().children('.product_amount');
            row.val(productAmount);

            subtotal();
            total();
            console.log(rowDataArray);
        }
    })

});

$(document).on("change", ".product_tax", function() {
    //   alert('hii');
    rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 

                    subtotal();
                    total();
    var $this = $(this);
            var rowIndex = $('.product_tax').index(this);
            var unitPrice = parseFloat($this.parent().parent().siblings().children().children('.unit_price').val()) || 0;
            var quantity = parseInt($this.parent().parent().siblings().children().children('.product_quantity').val());
            var discountType = $this.parent().parent().siblings().children().children('.discount_type').val();
            var discountValue = parseFloat($this.parent().parent().siblings().children().children('.product_discount').val()) || 0;
            // var taxValue = parseFloat($this.val());
            // var taxlabel = $this.find("option:selected").text();
            // var taxValue = taxlabel.split(' -')[1];
            // // alert(taxValue)
           
            // if (taxValue >= 0) {
            //     $this.parent().siblings('.error-help').hide();
            // } else {
            //     $this.parent().siblings('.error-help').show();
            // }
            var accountingTaxId = $(this).val();
            // alert(accountingTaxId)
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 

            var productAmount;
        if(unitPrice !== 0 && unitPrice !== ' '){
            if (discountType == '%') {
                productAmount = (unitPrice * quantity) - (((unitPrice * quantity) * discountValue) / 100);
            } else if (discountType == 'FLAT' && unitPrice != 0 ) {
                productAmount = (unitPrice * quantity) - discountValue;
            } else {
                productAmount = unitPrice * quantity;
            }
        }
        else{
            productAmount = unitPrice * quantity;
        }
            productAmount += (productAmount * (taxValue / 100));
            productAmount = parseFloat(productAmount).toFixed(2);
            // alert(productAmount)
            rowDataArray[rowIndex].product_tax = taxValue;
            rowDataArray[rowIndex].product_amount = productAmount;
           
            row = $this.parent().parent().siblings().children().children('.product_amount');
            row.val(productAmount);
                subtotal();
                total();
                console.log(rowDataArray);
                // alert('hii')
        }
    })

});

        $(document).on("change", ".product_tax_inc", function() {
            var $this = $(this);
              //taxIncluded($this)
              if ($(this).closest('tr').find('.product_details').val() == '' || $(this).closest('tr').find('.product_details').val() == "Select Product") {
                $(this).closest('tr').find('.product_amount').val(0); 
            } else {
                taxIncluded($(this));
            }
          })

        

        function taxIncluded($this) {
            rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 

                    subtotal();
                    total();
            var rowIndex = $('.product_tax_inc').index($this);
            var unitPrice = parseFloat($this.parent().parent().parent().siblings().children().children('.unit_price').val()) || 0;
            var unitpriceTax=parseFloat($this.parent().parent().parent().siblings().children().children('.product_price').val());
            var quantity = parseFloat($this.parent().parent().parent().siblings().children().children('.product_quantity').val()) || 1;
            var discountType = $this.parent().parent().parent().siblings().children().children('.discount_type').val();
            var discountValue = parseFloat($this.parent().parent().parent().siblings().children().children('.product_discount').val()) || 0;
            // var taxlabel = $this.parent().parent().parent().siblings().children().children('.product_tax').find('option:selected').text();
            // var taxValue = taxlabel.split(' -')[1];
            var isTaxIncluded = $this.is(':checked');
            var accountingTaxId = $this.parent().parent().parent().siblings().children().children('.product_tax').val();
            // alert(accountingTaxId)
            $.ajax({
        url: 'taxdetails1',
        method: 'GET',
        dataType: 'json',
        data: { item: accountingTaxId },
        success: function(response) {
            console.log(response); 
// console.log(typeof response.tax_rate); 
            // alert(typeof response.tax_rate)
            var taxValue = (response['tax_rate']); 
            var productAmount = 0;

            if (isTaxIncluded) {
              if(unitPrice !== 0 && unitPrice !== ' '){
                if (discountType == '%') {
                productAmount = (unitPrice * quantity) - (((unitPrice * quantity) * discountValue) / 100);
                } else if (discountType == 'FLAT') {
                productAmount = (unitPrice * quantity) - discountValue;
                } else {
                productAmount = unitPrice * quantity;
                }
            }
            else{
                productAmount = unitPrice * quantity;
            }
                // alert(productAmount)
                productAmount =productAmount.toFixed(2);
                unitprice1= (unitPrice / (1+taxValue/100)).toFixed(2);
                $this.parent().parent().parent().siblings().children().children('.unit_price').val(unitprice1);
                row = $this.parent().parent().parent().siblings().children().children('.product_amount');
                // alert(productAmount)
            row.val(productAmount);

                rowDataArray[rowIndex].unit_price = unitprice1;
                rowDataArray[rowIndex].product_amount = productAmount;

            }else{
                
            if(unitpriceTax !== 0 && unitpriceTax !== ' '){  
                if (discountType == '%') {
                productAmount = (unitpriceTax * quantity) - (((unitpriceTax * quantity) * discountValue) / 100);
                } else if (discountType == 'FLAT') {
                productAmount = (unitpriceTax * quantity) - discountValue;
                } else {
                productAmount = unitpriceTax * quantity;
                }
            }
            else{
                productAmount = unitpriceTax * quantity;
            }
                productAmount += (productAmount * (taxValue / 100));
                // alert(productAmount)
                productAmount = parseFloat(productAmount).toFixed(2);
                row = $this.parent().parent().parent().siblings().children().children('.product_amount');
                // alert(row)
            row.val(productAmount);
                $this.parent().parent().parent().siblings().children().children('.unit_price').val(unitpriceTax);

                rowDataArray[rowIndex].unit_price = unitpriceTax;
                rowDataArray[rowIndex].product_amount = productAmount;

            }
            console.log(rowDataArray);
            subtotal();
            total();
        }
    })
    }


        
        $(document).on("change", ".product_details", function() {

            jQuery.ajaxSetup({
                async: false
            });
            // alert($('.product_details').val());
            var $this = $(this).parent().parent().siblings().children();
        if ($(this).val() == '') {
                  $this.children('.desc').val('');
                  $this.children('.product_price').val('');
                  $this.children('.unit_price').val('');
                  $this.children('.product_tax').val('');
                  $this.children('.product_unit').val('').trigger('change');
                  $this.children('.product_quantity').val('');
                  $this.children('.product_discount').val(0);
                  $this.children('.product_amount').val('');
                  $this.children().children('input[class="product_tax_inc"]:checked').prop('checked', false);
                  subtotal();
                  total();
              }
                    
              var productid = $(this).val();
              var rowindex = $(this).closest('tr').index(); 
              $.get('findproduct', {
                  productid: productid
              }, function(data) {
                  var data = $.parseJSON(data);
                //   alert('Stock Available: ' + data.stock_unit);
                  $this.children('.desc').val(data.category);
                  $this.children('.product_price').val(data.bying_price);
                  $this.children('.unit_price').val(data.bying_price);
                  $this.children('.product_unit').find("option[value='" + data.units + "']").attr("selected", true).trigger('change');
                  var tax = data.tax_rate || 0;
                //    alert(tax)
                console.log(data)
                  $this.children('.product_tax').find('option').removeAttr("selected");
                  if (tax) {
                      $this.children('.product_tax').find("option[value='" + tax + "']").attr("selected", true);
                      $this.children('.product_tax').trigger('change.select2');

                  } else {
                      $this.children('.product_tax').find("option[value='38']").attr("selected", true).trigger('change.select2');
                  }
                  $this.children('.product_quantity').val(1);
                  $this.children('.product_discount').val('0.00');
                  $this.children('.discount_type').find("option[value='%']").attr("selected",true).trigger('change');
                  $this.children('input[class="product_tax_inc"]:checked').prop('checked', true);
                  var value = $this.children().children('input[class="product_tax_inc"]:checked').val();
                  if (value == 1) {
                      var amt = (($this.children('.unit_price').val() * $this.children('.product_quantity').val()) + (($this.children('.unit_price').val() * $this.children('.product_quantity').val()) * $this.children('.product_tax').val()) / 100);
                    //   alert(amt);
                  } else {
                      var amt = $this.children('.unit_price').val() * $this.children('.product_quantity').val();
                  }
                  $this.children('.product_amount').val(amt);
                    //   alert(amt);
                
                    
                        
            
                    $('#dynamic_field tbody tr').each(function() {                  
                    var rowData = {
                    productid: productid,
                    desc: $this.children('.desc').val(),
                    product_quantity:   $this.children('.product_quantity').val(),
                    product_unit:   $this.children('.product_unit').find("option:selected").val(),
                    unit_price: $this.children('.unit_price').val(),
                    product_discount: $this.children('.product_discount').val(),
                    discount_type: $this.children('.discount_type').find("option:selected").val(),
                    product_tax: $this.children('.product_tax').find("option:selected").val(),
                    product_amount: $this.children('.product_amount').val(),
                    rowindex: rowindex,
                    product_tax_inc: $this.children('input[class="product_tax_inc"]:checked').val(),
                
                    };
                    var indexToUpdate = rowDataArray.findIndex(item => item.rowindex === rowindex);
                    if (indexToUpdate !== -1) {
                        rowDataArray[indexToUpdate] = rowData;
                    } else {
                    rowDataArray.push(rowData);
                    }
                    console.log(rowDataArray);
                    // alert(rowDataArray[0].product_amount)
                    
                });
               


              });
              if ($(this).val()) {
                  var tax = $(this).parent().parent().siblings().children().children('.product_tax').val();
                   
                  if (tax) {
                    // $(this).parent().parent().siblings().children().children('label').children('.product_tax_inc').prop('checked', true);
                    taxIncluded($(this).parent().parent().siblings().children().children('label').children('.product_tax_inc'));


                }


                      subtotal();
                      total();
                  
              }

        
            });
        
            


        $("#add_new").click(function() {

            var count = $('.add-more').length;
            var dynacount = count + 1;
            $('#dynamic_field').append('<tr class=" add-more ' + count + '"><td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td><td class="rendered"><div class=\"form-group field-product' + count + '\"><select class="product_details form-control" id=\"product' + count + '\" name="productdyn[' + dynacount + '][product]"><option value="">--Select--</option></select></div></td><td><div class=\"form-group field-includedescription' + count + '\"><input type="text" class="desc form-control" id=\"includedescription' + count + '\" name="productdyn[' + dynacount + '][desc]" ></div></td><td><div class=\"form-group field-includequantity' + count + '\"><input type="number" class="product_quantity form-control"  id=\"includequantity' + count + '\" name="productdyn[' + dynacount + '][quantity]" min=1 onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"><div class="error-help">Quantity cant be negative or zero.</div></div></td><td><div class=\"form-group field-includeunits' + count + '\"><select  class="product_unit form-control" id=\"includeunits' + count + '\" name="productdyn[' + dynacount + '][units]"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></div></td><td><div class=\"form-group field-unitprice' + count + '\"><input type="number"  class="unit_price form-control" id=\"unitprice' + count + '\" name="productdyn[' + dynacount + '][unitprice]" min=0 step=.01 placeholder=0.00></div><div class=\"form-group field-includeprice' + count + '\"><input type="hidden" class="product_price form-control" id=\"includeprice' + count + '\" name="productdyn[' + dynacount + '][price]" readonly></div><div class="error-help">Enter valid price.</div></td><td><div class=\"form-group field-includediscount' + count + '\"><input type="number" class="product_discount form-control" id=\"includediscount' + count + '\" name="productdyn[' + dynacount + '][discount]" min=0 step="0.001"></div><div class="error-help help-type">Discount must be less than 99 and greater than 0</div></td><td><div class=\"form-group field-discounttype' + count + '\"><select class="form-control discount_type" id=\"discounttype' + count + '\" name="productdyn[' + dynacount + '][discounttype]"><option value>--Select--</option><option value="%">%</option><option value="FLAT">FLAT</option></select><div class="error-help">Discount Type cannot be blank.</div></div></td><td><div class=\"form-group field-includetax' + count + '\"><select class="product_tax form-control " id=\"includetax' + count + '\" name="productdyn[' + dynacount + '][tax]" ><option value="">--Select Tax--</option></select></div><div class="error-help">Enter Valid tax value.</div></td><td class="text-center"><div class=\"form-group field-tax_included' + count + '\"><input type="hidden"  value="0" name="productdyn[' + dynacount + '][tax_included]" checked><label><input type="checkbox" class="product_tax_inc" id=\"tax_included' + count + '\" value="1" name="productdyn[' + dynacount + '][tax_included]"></label></div></td><td><div class=\"form-group field-includeamount' + count + '\"><input type="text" class="product_amount form-control" id=\"includeamount' + count + '\" name="productdyn[' + dynacount + '][amount]" readonly></div><div class="error-help">Total amount cannot be negative.</div></td></tr>');
            $('#includeunits' + count + '').select2();
            $('#discounttype' + count + '').select2();
            $('#product' + count + '').select2({
                ajax: {
                    url: "../../users/leads-quotes/productdetails",
                    type: "get",
                    dataType: 'json',
                    delay: 250,
                    data: function(params) {
                        return {
                            searchTerm: params.term // search term
                        };
                    },
                    processResults: function(response) {
                        // console.log(response);
                        return {
                            results: $.map(response, function(i, item) {
                                // console.log(i,item);
                                return {
                                    text: i,
                                    slug: "",
                                    id: item
                                }
                            })
                        };


                    },
                    cache: true
                }
            })
            $('.error-help').hide();
            $('#includetax' + count + '').select2();
            $.get('../../users/purchase-bill/finddetails', function(data) {
                $.each(JSON.parse(data), function(i, item) {
                    $('#includetax' + count + '').append($('<option value=\"' + i + '\">' + item + '</option>'));
                });
            });
            $(document).on('click', ".removeind", function() {
                  $(this).parent().parent().remove();
                  var $this = $(this);
                  $this.parent().parent().siblings().children().children('.desc').val('');
                  $this.parent().parent().siblings().children().children('.product_price').val('');
                  $this.parent().parent().siblings().children().children('.unit_price').val('');
                  $this.parent().parent().siblings().children().children('.product_tax').val('');
                  $this.parent().parent().siblings().children().children('.product_unit').val('');
                  $this.parent().parent().siblings().children().children('.product_quantity').val('');
                  $this.parent().parent().siblings().children().children('.product_discount').val('');
                  $this.parent().parent().siblings().children().children('.discount_type').val('');
                  $this.parent().parent().siblings().children().children('.product_amount').val('');

                  rowDataArray = [];
                  $('#dynamic_field tbody tr').each(function() {
                    var rowData = {
                    product_quantity: $(this).find('.product_quantity').val(),
                    product_unit:   $(this).find('.product_unit').find("option:selected").val(),
                    unit_price: $(this).find('.unit_price').val(),
                    product_discount: $(this).find('.product_discount').val(),
                    discount_type: $(this).find('.discount_type').find("option:selected").val(),
                    product_tax: $(this).find('.product_tax').find("option:selected").val(),
                    product_amount: $(this).find('.product_amount').val(),
                    };
                    rowDataArray.push(rowData);
                    console.log(rowDataArray);
                    }); 
                    subtotal();
                    total();

              });

          });




          function subtotal() {
            if (Array.isArray(rowDataArray) && rowDataArray.length > 0) {
            let subtotal = rowDataArray.map(row => {
            let unitPrice = parseFloat(row.unit_price);
            let quantity = parseInt(row.product_quantity);
            let discountType = row.discount_type;
            let discountValue = parseFloat(row.product_discount);

            if (isNaN(unitPrice)) unitPrice = 0;
            if (isNaN(quantity)) quantity = 0;
            if (isNaN(discountValue)) discountValue = 0;

            let subTotalPerRow = 0;

            if (discountValue && unitPrice) {
                if (discountType === '%') {
                    let discount = (unitPrice * quantity) * (discountValue / 100);
                    subTotalPerRow = (unitPrice * quantity) - discount;
                } else {
                    subTotalPerRow = (unitPrice * quantity) - discountValue ;
                }
            } else {
                subTotalPerRow = unitPrice * quantity;
            }

            return subTotalPerRow;
            }).reduce((acc, val) => acc + val, 0);

            $('.subtotal').val(subtotal);
            $('.subtotalamt').text((parseFloat(subtotal)).toLocaleString('en-IN', {
            minimumFractionDigits: 2,
            maximumFractionDigits: 2,
            }));
            } else {
            //console.error('rowDataArray is not defined or is empty');
            }

         
        }




        function total(){
            let total = 0;
            if (!Array.isArray(rowDataArray) || rowDataArray.length === 0) {
             $('.totalamt').text(total.toFixed(2));
            // console.log(total);
            return 0;
            }

            let totalProductAmount = rowDataArray.map(item => parseFloat(item.product_amount || 0))
                                   .reduce((acc, val) => acc + val, 0);
            // let totalTax = rowDataArray.map(item => parseFloat(item.product_tax || 0))
            //                        .reduce((acc, val) => acc + val, 0);
            //   alert(totalTax);
            total = totalProductAmount;
            // $('.totalamt').text(total.toFixed(2));
            // $('.total').val(total);
            //console.log(total);
            var subtotal=$('.subtotal').val() || 0;
            var igst=total-subtotal;
            var csgst=igst/2;
            $('.totaligst').text(igst.toFixed(2));
            $('.total_igst').val(igst);
            $('.cgstvalue').text(csgst.toFixed(2));
            $('.cgst').val(csgst);
            $('.sgstvalue').text(csgst.toFixed(2));
            $('.sgst').val(csgst);
            // tcs();
            
            if ($('.tcs_tax').is(":checked")) {
                 
                 var tcs_rate = <?= $tcs_rate ?>;
                 tcs_amt = parseFloat(parseFloat(tcs_rate) * parseFloat(total) / 100);

                 roundoff_amount = Math.round(parseFloat(total) + parseFloat(tcs_amt)) - (parseFloat(total) + parseFloat(tcs_amt));
               t_amount = parseFloat(total) + tcs_amt;
                 // console.log(tcs_amt)
                 t_amount = parseFloat(total) + tcs_amt;
                 $('.total').val(t_amount);
                 $('.totalamt').text((parseFloat(t_amount)).toLocaleString('en-IN', {
                     minimumFractionDigits: 2,
                     maximumFractionDigits: 2,

                 }));
                 // $('.totalamt').text(t_amount.toFixed(2));
             } else {
                 $('#purchaseorder-tcs').val(0)
                 if (parseFloat($('#purchaseorder-tcs').val()) > 0)
                     tcs_amt = parseFloat($('#purchaseorder-tcs').val())
                 else
                     tcs_amt = 0;

                 $('.total').val(total);
                 $('.totalamt').text((parseFloat(total)).toLocaleString('en-IN', {
                     minimumFractionDigits: 2,
                     maximumFractionDigits: 2,

                 }));
                 // $('.totalamt').text(totalamount.toFixed(2));
             }
             $('.tcsamt').text((tcs_amt).toFixed(2));
             $('.tcsamount').val((tcs_amt).toFixed(2));
             if ($('#round').is(":checked")) {
                 $('#round').prop('checked', false)
                 $('.round_off_amount').val('');
             }


            


        }   
        
          $('.tcs_tax').change(function() {
              total();
          });



        //   function tcs() {
        //       var t_amount = $('.total').val();
        //       var tcs_amt = 0;
        //       var tcsamt;
        //       var totalamount = 0;
        //       $('.product_amount').each(function() {
        //           totalamount += parseFloat($(this).val())
        //       })
        //     // alert('1')
        //       if ($('.tcs_tax').is(":checked")) {
                 
        //           var tcs_rate = <?= $tcs_rate ?>;
        //           tcs_amt = parseFloat(parseFloat(tcs_rate) * parseFloat(totalamount) / 100);

        //           roundoff_amount = Math.round(parseFloat(totalamount) + parseFloat(tcs_amt)) - (parseFloat(totalamount) + parseFloat(tcs_amt));
        //         t_amount = parseFloat(totalamount) + tcs_amt;
        //           // console.log(tcs_amt)
        //           t_amount = parseFloat(totalamount) + tcs_amt;
        //           $('.total').val(t_amount);
        //           $('.totalamt').text((parseFloat(t_amount)).toLocaleString('en-IN', {
        //               minimumFractionDigits: 2,
        //               maximumFractionDigits: 2,

        //           }));
        //           // $('.totalamt').text(t_amount.toFixed(2));
        //       } else {
        //           $('#purchaseorder-tcs').val(0)
        //           if (parseFloat($('#purchaseorder-tcs').val()) > 0)
        //               tcs_amt = parseFloat($('#purchaseorder-tcs').val())
        //           else
        //               tcs_amt = 0;

        //           $('.total').val(totalamount);
        //           $('.totalamt').text((parseFloat(totalamount)).toLocaleString('en-IN', {
        //               minimumFractionDigits: 2,
        //               maximumFractionDigits: 2,

        //           }));
        //           // $('.totalamt').text(totalamount.toFixed(2));
        //       }
        //       $('.tcsamt').text((tcs_amt).toFixed(2));
        //       $('.tcsamount').val((tcs_amt).toFixed(2));
        //       if ($('#round').is(":checked")) {
        //           $('#round').prop('checked', false)
        //           $('.round_off_amount').val('');
        //       }

        //   }


        //   function tcschange() {
        //       var t_amount = $('.total').val();
        //       var tcs_amt = parseFloat($('#purchaseorder-tcs').val());
        //       var tcsamt;
        //       var totalamount = 0;
        //       $('.product_amount').each(function() {
        //           totalamount += parseFloat($(this).val())
        //       })
        //       if ($('.tcs_tax').is(":checked")) {

        //           // console.log(tcs_amt)
        //           t_amount = parseFloat(totalamount) + tcs_amt;
        //           $('.total').val(t_amount);
        //           $('.totalamt').text((parseFloat(t_amount)).toLocaleString('en-IN', {
        //               minimumFractionDigits: 2,
        //               maximumFractionDigits: 2,

        //           }));
        //           // $('.t_amount').text(t_amount.toFixed(2));
        //       } else {
        //           $('#purchaseorder-tcs').val(0)
        //           if (parseFloat($('#purchaseorder-tcs').val()) > 0)
        //               tcs_amt = parseFloat($('#purchaseorder-tcs').val())
        //           else
        //               tcs_amt = 0;

        //           $('.total').val(totalamount);
        //           $('.totalamt').text((parseFloat(totalamount)).toLocaleString('en-IN', {
        //               minimumFractionDigits: 2,
        //               maximumFractionDigits: 2,

        //           }));
        //           // $('.totalamt').text(totalamount.toFixed(2));
        //       }
        //       $('.tcsamt').text((tcs_amt).toFixed(2));
        //       $('.tcsamount').val((tcs_amt).toFixed(2));

        //   }

          $('#round').change(function() {
            if ($(this).is(":checked")) {
                var roundval = Math.round($('.total').val()) - $('.total').val();
                $('.totalamt').text(Math.round($('.total').val()));
                $('.round_off_amount').val(roundval.toFixed(2)).trigger('change');
                $('.roundoffamt').text(roundval.toFixed(2)).trigger('change');
                $('.total').val(Math.round($('.total').val()));
            } else {
                total();
                $('#round').prop('checked', false);
                $('.round_off_amount').val('');
                $('.roundoffamt').text('0.00').trigger('change');
            }
        })
        if ($('.round_off_amount').val() != '') {

            $('#round').prop('checked', true)
        }
        if ($('#round').is(":checked")) {
            var roundval = Math.round($('.total').val()) - $('.total').val();
            $('.totalamt').text(Math.round($('.total').val()));
            $('.round_off_amount').val(roundval.toFixed(2)).trigger('change');
            $('.roundoffamt').text(roundval.toFixed(2)).trigger('change');
            $('.total').val(Math.round($('.total').val()));
        }



        //   $('#purchaseorder-tcs').change(function() {
        //       tcschange();
        //   })
          $('.line').hide();
          $('.advance').hide();
          $('#purchaseorder-advance_payment').change(function() {
              var value = $('input[name="PurchaseOrder[advance_payment]"]:checked').val();
              if (value == 'Advance payment for this Purchase Order') {
                  $('.after_advance_line').show();
                  $('.after_advance_payment').show();
                  $('.line').show();
                  $('.advance').show();
              } else {
                  $('.after_advance_line').hide();
                  $('.after_advance_payment').hide();
                  $('.line').hide();
                  $('.advance').hide();
              }
          });
          $('.match').hide();
          $('.advance_matchreceipt').hide();
          $('#purchaseorder-advance_payment').change(function() {
              var value = $('input[name="PurchaseOrder[advance_payment]"]:checked').val();
              if (value == 'Matched Receipt') {
                  $('.after_matchreceipt').show();
                  $('.after_match').show();
                  $('.match').show();
                  $('.advance_matchreceipt').show();
              } else {
                  $('.after_matchreceipt').hide();
                  $('.after_match').hide();
                  $('.match').hide();
                  $('.advance_matchreceipt').hide();
              }
          });
          var isLoading = false;
          $('.attachments').click(function() {
              $("#dinamic").empty();
              isLoading = true;
              var id = $(this).attr('value');
              $.get('findattachments', {
                  id: id
              }, function(data) {
                  var data = $.parseJSON(data);
                  if (data.length == 0) {
                      $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
                  }
                  for (var i = 0; i < data.length; i++) {
                      $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "  <i class='fa fa-times deleteattachment' style='color:#FF0000'  aria-hidden='true' data-dismiss='modal' value='" + data[i].id + "'></i></td><tr>");
                  }
                  $('.deleteattachment').click(function() {
                      var id = $(this).attr('value');
                      $.get('delattachment', {
                          id: id
                      }, function(data) {

                      })
                  })
                  isLoading = false;
              });
          });

        $("#purchaseorder-date").on("change",function(){
        var selected_date = $(this).val();
        var sel_date = new Date($(this).val());
        $.get('selectdate',{selected_date:selected_date},function(data)
        {  

            var d = new Date();
            var output = d.getFullYear() + '-' +'03'+ '-' +'31';

            if(new Date(selected_date) <= new Date(output))
            {
                var dt = sel_date.getFullYear().toString().substr(-2);
                var prv_dt = sel_date.getFullYear()-1;
                var prefix_date = 'MOHASYN'+prv_dt+'-'+dt;
            }
            else
            {
                var dt = sel_date.getFullYear();
                var new_dt = (sel_date.getFullYear()+1).toString().substr(-2);
                var prefix_date = 'MOHASYN'+dt+'-'+new_dt;
            }


                
                var data =$.parseJSON(data);
                $('#purchaseorder-po_last').val(data).trigger('change');
                $('#purchaseorder-prefix').val(prefix_date).trigger('change');
                // $('#purchaseorder-prefix').val(prefix_date).trigger('change');
                

                $('#po_label').empty();
                $('#po_label').append("PO# Last# "+(data-1));

        })
    });


    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
