<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\AccountingTax;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\SettingTypes;
use backend\modules\master\models\GenericTemplate;

$purchasetemplate = PurchaseTemplates::find()->where(['template_name' => $model->setting_type])->one();
$template = GenericTemplate::find()->where(['gt_id' => $model->setting_type])->one();

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\PurchaseOrder */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Purchase Orders', 'url' => ['index']];
$this->params['breadcrumbs'][] = "View Purchase Order";
\yii\web\YiiAsset::register($this);
?>
<style>
	/* Taken from Invoice temp 1 */
	td.tdpaddingline{ font-weight:normal; text-align:left; padding:5px; border:1px solid #000; }
	td.tdpaddingliner{ font-weight:normal; text-align:left; padding:5px; border-right:1px solid #000; }
	td.tdpaddinglinel{ font-weight:normal; text-align:left; padding:5px; border-left:1px solid #000; }
	.text01{
		color: #000;
		font-family: arial;
		font-weight:bold;
	}
	.text02{
		color: #5c5a5b;
		font-family: arial;
		font-size: 22px;
		font-weight:bold;
		padding-top:10pt;
	}
	table.main {
		color: #000;
		font-family: arial;
		font-size: 12px;		
	}
	.comaddress { font-size:13px;  }
	table.all {
		color: #000;
		font-family: arial;
		font-size: 12px;
		border:1px solid #000;
	}
	td.main {
		border-right: solid 1px #000;
		border-bottom: solid 1px #000;
	}
	.right,td.rightborder {
		border-right: solid 1px #000;
	}
	td.rightl {
		border-right: solid 1px #000;
	}
	td.bottom {
		border-bottom: solid 1px #000;
	}
	td.last {
		border-bottom: solid 1px #000;
		font-weight:normal;
	}
	td.top {
		border-top: solid 1px #000;
	}
	.left {
		border-left: solid 1px #000;
	}
	.padlf2 { padding-left:2px; }
	.font12bold { font-size:12px; font-weight:bold; }
	p{
		padding:2px;
		margin:0px;
	}
	td.tdpaddinglineno{ font-weight:normal; text-align:left; padding:3px; }
	td.bottomborder { font-weight:normal; text-align:left; padding:3px; border-bottom:1px solid #000; border-right:1px solid #000;}
	.prdtMainTbl > tbody > tr:last-child td {  padding-bottom:10px; }
	.autoGenTxt {
		font-size:9px;
	}
	.newv1 {
		font-size:13px; 
		font-weight:bold !important; 
		padding:3px; 
		height:40px; 
		vertical-align:middle;
	}
		
	.algnrght, .pos-right-align {
		text-align:right;
	}
	.bg1 {
		background-color: #eee;
	}
	@media print {
		.dj-print-sec{
			display:none!important ;
		}
		.widget-content-wrapper{
			display:none!important ;	
		}
		.table-responsive{
			overflow:hidden;
		}
		.app-header__menu{
			display:none!important ;
		}
	}
</style>
<?php
$vendor=Vendor::find()->where(['id'=>$model->vendor_name])->one();

function AmountInWords(float $amount)
{
   $amount_after_decimal = round($amount - ($num = floor($amount)), 2) * 100;
   // Check if there is any number after decimal
   $amt_hundred = null;
   $count_length = strlen($num);
   $x = 0;
   $string = array();
   $change_words = array(0 => '', 1 => 'One', 2 => 'Two',
     3 => 'Three', 4 => 'Four', 5 => 'Five', 6 => 'Six',
     7 => 'Seven', 8 => 'Eight', 9 => 'Nine',
     10 => 'Ten', 11 => 'Eleven', 12 => 'Twelve',
     13 => 'Thirteen', 14 => 'Fourteen', 15 => 'Fifteen',
     16 => 'Sixteen', 17 => 'Seventeen', 18 => 'Eighteen',
     19 => 'Nineteen', 20 => 'Twenty', 30 => 'Thirty',
     40 => 'Forty', 50 => 'Fifty', 60 => 'Sixty',
     70 => 'Seventy', 80 => 'Eighty', 90 => 'Ninety');
    $here_digits = array('', 'Hundred','Thousand','Lakh', 'Crore');
    while( $x < $count_length ) {
      $get_divider = ($x == 2) ? 10 : 100;
      $amount = floor($num % $get_divider);
      $num = floor($num / $get_divider);
      $x += $get_divider == 10 ? 1 : 2;
      if ($amount) {
       $add_plural = (($counter = count($string)) && $amount > 9) ? 's' : null;
       $amt_hundred = ($counter == 1 && $string[0]) ? ' and ' : null;
       $string [] = ($amount < 21) ? $change_words[$amount].' '. $here_digits[$counter]. $add_plural.' 
       '.$amt_hundred:$change_words[floor($amount / 10) * 10].' '.$change_words[$amount % 10]. ' 
       '.$here_digits[$counter].$add_plural.' '.$amt_hundred;
        }
   else $string[] = null;
   }
   $implode_to_Rupees = implode('', array_reverse($string));
   $get_paise = ($amount_after_decimal > 0) ? "And " . ($change_words[$amount_after_decimal / 10] . " 
   " . $change_words[$amount_after_decimal % 10]) . ' Paise' : '';
   return ($implode_to_Rupees ? $implode_to_Rupees . 'Rupees ' : '') . $get_paise;
}
?>
<div class="app-main__inner">

<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
    <div class="card">
        <div class="no-gutters row">
            <div class="col-md-12 col-lg-12">
                <ul class="list-group list-group-flush">
                    <li class="bg-transparent list-group-item">
                        <div class="widget-content p-0">
                            <div class="widget-content-outer">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left">
                                        <div class="widget-numbers dj-text-success">View Purchase Order</div>
                                    </div>
                                    <div class="widget-content-right">
                                        <a href="<?=Url::base();?>/master/purchase-order/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </li>
                    
                </ul>
            </div>
            
            
        </div>
    </div>
</div>
<div class="main-card mb-3 card">
  <div class="card-body">   
  <div class="col-md-12">
    <div class="djsec-text-left dj-print-sec">
            

    		<?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/purchase-order-template'])->one()!=''){?>
               <a href="<?=Url::base();?>/master/purchase-order/purchase-order-template?id=<?=$model->id?>"  data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o"></i>PDF</button></a>
              
               <a href="javascript:void(0);" onclick="window.open('<?=Url::base();?>/master/purchase-order/printall?id=<?=$model->id?>&print=print','name','width=700,height=700')"  title="Print" data-method="post" > <button class="mb-2 mr-2 btn-icon btn  btn-info"> <i class="fa fa-print"></i>Print</button></a>  

              
               <?php }else {?>

               <?php } ?>


            
           <!--  <a href="#" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-envelope-o"></i> Send Purchase Order</button></a> -->
            
           <!--  <a href="#" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-ban" aria-hidden="true"></i> Cancel Purchase order</button></a> -->
            <!-- <a  class="printPage" href="#">Print</a> -->

    </div>
        </div>
  <div style="margin:4px; width:99%; border:1px solid #000;">
<!-- Removed Some Css FROm Here && $invtemplate!="56" -->
 

 
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="main">
	
					<tbody><tr>
	            <td valign="top" width="60%" class="" style="padding:5px;">
					<table width="100%" border="0" cellspacing="0" cellpadding="2" class="all">
		                <tbody><tr>
		                  <td width="30%"><p><b><img width="56" height="85" src="../../theme/images/1569578921_Mohapatra_Logo.JPG" alt=""></b></p></td>
		                  <td align="left" width="50%"><p><b style="font-size:14px; font-weight:bold"><?= $template->company_name ?></b><br /> <?= $template->address ?>,<br /> <?= $template->city ?>,<?= $template->state ?> , Code: <?= $template->pin ?>,<br /> <?= $template->country ?> - <br /> Mobile no: <?= $template->mobile ?>, Phone no: <?= $template->phone_no ?>,<br /> GSTIN : <?= $template->gst_no ?>,<br /> Fax no: <?= $template->fax_no ?> : Trade License :-<?= $template->trade_licence ?>,<br /> Email: <?= $template->email ?></td>
						  <td width="20%"><p><b></b></p></td>
		                </tr>
		            </tbody></table>
	       		</td>
	        </tr>
	        <tr>
	        <td class="" style="padding:5px;">
				<table width="100%" border="0" cellspacing="0" cellpadding="" class="all">

	        						<tbody><tr>
	                  	<td class="" colspan="8" align="center" width="100%" style="background-color: #CCC;font-size: 25px;"><p><b><?=$template->template_name?></b></p></td>
	                </tr>
	                					<tr>
	                  	<td class="top" width="25%"><p><b>Purchase Order No: </b></p></td>
	                  	<td class="tdpaddingliner top" colspan="3" width="25%"><p><b> <?= $model->prefix.'-'.$model->id?></b></p></td>
	                  	<td class="top" width="25%"><p><b>Reverse Charge (Y/N): </b></p></td>
	               		<td class="tdpaddingliner top" colspan="2" width="20%"><p><b></b></p></td>
	                    <td class="tdpaddingliner top" width="5%" style="text-align: center;"><p><b><?=$model->supply_attracts?></b></p></td>
	                    <!--<td class="top" width="25%"><p><b>Transport Mode: </b></p></td>
	                    <td class=" top" colspan="3" width="25%"><p><b></b></p></td>-->
	                </tr>
					<tr>
	                     <td class="top" width="25%"><p><b>Purchase Order Date: </b></p></td>
	                     <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b></p><?=date('F d,Y',strtotime($model->date))?></td>	                     
	               		<td class="top" width="25%"><p><b>State: </b></p></td>
	               		<td class="tdpaddingliner top" width="15%"><p><b></b>Odisha</p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b>Code: </b></p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b></b>21</p></td>
	                     <!--<td class="top" width="25%"><p><b>Vehicle Number: </b></p></td>
	                     <td class=" top" colspan="3" width="25%"><p><b></b></p></td>-->
		            </tr>
	                <!--<tr>
	               		<td class="top" width="25%"><p><b>Reverse Charge (Y/N): </b></p></td>
	               		<td class="tdpaddingliner top" colspan="2" width="20%"><p><b></b></p></td>
	                    <td class="tdpaddingliner top" width="5%" style="text-align: center;"><p><b>N</b></p></td>
	                    <td class="top" width="25%"><p><b>Date of Supply:</b></p></td>
	                    <td class=" top" colspan="3" width="25%"><p><b></b></p></td>
	                </tr>
	                <tr>
	               		<td class="top" width="25%"><p><b>State: </b></p></td>
	               		<td class="tdpaddingliner top" width="15%"><p><b></b>Karnataka</p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b>Code: </b></p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b></b>29</p></td>
	                    <td class="top" width="25%"><p><b>Place of Supply:</b></p></td>
	                    <td class=" top" colspan="3" width="25%"><p><b></b></p></td>
	                </tr>-->
	                				    <tr>
		                <td class="top" colspan="4" align="center" width="50%" style="background-color: #CCC;"><p><b>Purchase from Party</b></p></td>
		                <td class="top" colspan="4" align="center" width="50%" style="background-color: #CCC;"><p><b>Ship to Party</b></p></td>
		            </tr>
					<tr>
		                <td class="top" width="25%"><p><b>Name: </b></p></td>
		                <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b> <?=$vendor->business_name?></p></td>
		                <td class="top" width="25%"><p><b>Name: </b></p></td>
		                <td class="top" colspan="3" width="25%"><p><b></b>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</p></td>
		            </tr>
					<tr>
	                     <td class="top" width="25%" style="min-height: 30px; vertical-align: top;"><p><b>Address: </b></p></td>
	                     <td class="tdpaddingliner top" colspan="3" width="25%" style="vertical-align: top;"><p><b></b><?=$vendor->business_name?>,<br><?=$vendor->adderss_line_1?><br><br><?=$vendor->city?><br><?=$vendor->pin_code?></p></td>
	                     <td class="top" width="25%" style="vertical-align: top;"><p><b>Address: </b></p></td>
	                     <td class="top" colspan="3" width="25%" style="vertical-align: top;"><p> <br>F2G/30, INDRADHANU MARKET, IRC VILLAGE,<br>BHUBANESWAR, Odisha.<br></p></td>
	                     <!-- </br></br></br> -->
	             	</tr>
	                <tr>
	                     <td class="top" width="25%"><p><b>GSTIN: </b> </p></td>
	                     <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b><?=$model->sendor_gstin?></p></td>
	                     <td class="top" width="25%"><p><b>GSTIN: </b></p></td>
	                     <td class="top" colspan="3" width="25%"><p><b></b>21AAPCM1333E1ZX</p></td>
	                </tr>
	                <tr>
	                	<td class="top" width="25%"><p><b>State: </b></p></td>
	               		<td class="tdpaddingliner top" width="15%"><p><b></b><?=$vendor->state?></p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b>Code: </b></p></td>
	                    <td class="tdpaddingliner top" width="5%"><p><b></b><?=$model->point_of_supply?></p></td>
	                    <td class="top" width="25%"><p><b>State: </b></p></td>
	               		<td class="tdpaddingliner top" width="15%"><p><b></b></p>Odisha</td>
	                    <td class="tdpaddingliner top" width="5%"><p><b>Code: </b></p></td>
	                    <td class="top" width="5%"><p><b></b>21</p></td>
	                </tr>	     		 
				</tbody></table>
			</td>
			</tr>
		
	    <tr>
      <td colspan="">
        
<div class="mobwidhset">
<div class="table-responsive">
<?php if($model->point_of_supply!=21){?>

<table id="ProdTbl" class="prdtMainTbl " border="0" cellpadding="0" cellspacing="0" width="100%" style="color:#000; font-family:Arial, Helvetica, sans-serif; font-size:12px; ">
    <thead>
    			<tr style="">
		        <td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>S.No</p></td>
		        <td rowspan="2" class="tdpaddingliner top bottom" width="18%" style=" font-weight:bold;"><p>Product Description</p></td>	
				<td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>HSN Code</p></td>
				<td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>Qty</p></td>
				<td rowspan="2" class="tdpaddingliner top bottom" align="center" width="5%" style=" font-weight:bold;"><p>UOM</p></td>
				<td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>Rate</p></td>
		        <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Amount</p></td>
                <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Discount</p></td>
                <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Taxable Val</p></td>
		        <td colspan="2" class="tdpaddingliner top bottom" align="center" width="10%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>IGST</p></td>
                <td rowspan="2" class="top bottom" align="center" width="10%" style=" font-weight:bold; text-align: center;"><p>Total</p></td>
	        </tr>
	        	        <tr>
	        	<td class="tdpaddingliner bottom" style="text-align:center;" align="center">Rate</td>
				<td class="tdpaddingliner bottom" style="text-align:center;" align="center">Amt</td>
				</tr>	
	             </thead>
     <tbody>
     <?php  
                $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;
                        foreach($products as $key=>$value){ 
                            # # FOR TOTAL # #
                            $tot_quant+=$value->quantity;
                            $tot_unitprice+=$value->unit_price;   
                            $grandtot+=$value->amount;                         

                           $amount=$value->quantity*$value->unit_price;
                           if($value->discount_type=='FLAT'){
                            $taxable_value=$amount-$value->discount;
                            $tot_taxablevalue+=$taxable_value;
                           }else if($value->discount_type=='%'){
                            $taxable_value=$amount-($amount*$value->discount*0.01);
                            $tot_taxablevalue+=$taxable_value;
                           }else{
                               $taxable_value=$amount;
                               $tot_taxablevalue+=$taxable_value;
                           }
                            if($value->tax_included==1){
                               if($value->tax!='' && $value!=null)
                            	{
                            		$tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
                                $tax_amount=$taxable_value*$tax_percent*0.01;
                                $tot_taxamount+=$tax_amount;
                            	}
                                
                            }else{
                                $tax_percent=0;
                                $tax_amount=0;
                                $tot_taxamount+=$tax_amount;
                            }
                            ?>
            		<tr>
	        <td class="tdpaddingliner" valign="top"><?=$key+1?></td>		
	        <td class="tdpaddingliner" style="text-align:left" valign="top"><p><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?> </p></td>
	        <td class="tdpaddingliner" style="text-align:center" valign="top"><?=Product::find()->where(['id'=>$value->product_id])->one()->hsn_sac_code?></td>
		    <td class="tdpaddingliner" style="text-align:center" valign="top"><?=$value->quantity?></td>
		    <td class="tdpaddingliner" style="text-align:center" valign="top"><?=$value->units?></td>
			<td class="tdpaddingliner" style="text-align:right;" valign="top"><?=$value->unit_price?></td>        
	        <td class="tdpaddingliner" style="text-align:right;" valign="top"><?=$amount?></td>
            <td class="tdpaddingliner" style="text-align:right;" valign="top"><?=$value->discount . $value->discount_type?></td>
            <td class="tdpaddingliner" style="text-align:right;" valign="top"><?=$taxable_value?></td>
	        <td class="tdpaddingliner" style="text-align:center;" valign="top"><?=$tax_percent?></td> 
	        <td class="tdpaddingliner qty" style="text-align:right;" valign="top"><?=$tax_amount?></td>
	        <td class="" style="text-align:right;padding-right:5px;padding-top:5px;" valign="top"><?=$value->amount?></td>   
	    </tr>
        <?php }?>

        </tbody>
    <tfoot>    
    
	 		<tr>
			<td class="tdpaddingliner top bottom" colspan="3"><b> Total</b></td>
			<td class="tdpaddingliner top bottom" style="text-align: center;"><?=$tot_quant?></td>
			<td class="tdpaddingliner top bottom"> </td>
			<td class="tdpaddingliner top bottom"><?=$tot_unitprice?></td>
            <td class="tdpaddingliner top bottom"></td>
			<td class="tdpaddingliner top bottom"></td>
			<td class="tdpaddingliner top bottom" style="text-align:right;"><?=$tot_taxablevalue?></td>
			<td class="tdpaddingliner top bottom"> </td>
			<td class="tdpaddingliner top bottom" style="text-align:right;"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",number_format((float)($tot_taxamount), 2, '.', '')) ?></td>
			<td class=" top bottom" style="text-align:right;padding-right:5px;padding-top:5px;"><?= $grandtot?></td><!-- $totgstsubtotal+$totcgst+$totsgst+$totigst -->
		</tr>
		<tr>
			<td class="tdpaddingliner" colspan="5" style="text-align: center;"><b>Total Invoice amount in words</b></td>
			<td class="tdpaddingliner bottom" colspan="6" style="text-align: right;"><b>Total Amount before Tax</b></td>
			<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?=$tot_taxablevalue?></b></td> <!-- totgstsubtotal -->
		</tr>
		<!--<tr>
			<td class="tdpaddingliner top bottom" colspan="3"><b> Total</b></td>
						<td class="tdpaddingliner top bottom" style="text-align: center;">1</td>
									<td class="tdpaddingliner top bottom"> </td>
						<td class="tdpaddingliner top bottom"> </td>
			<td class="tdpaddingliner top bottom" style="text-align:right;">4,373.40</td>
										        <td class="tdpaddingliner top bottom" style="text-align:right;" valign="top">4,373.40</td>
	        	        	        	        			<td class="tdpaddingliner top bottom"> </td>
			<td class="tdpaddingliner top bottom" style="text-align:right;">787.21</td>
									<td class=" top bottom" style="text-align:right;padding-right:5px;padding-top:5px;">5,160.61</td>
		</tr>
		<tr>
			<td class="tdpaddingliner" colspan="5" style="text-align: center;"><b>Total Invoice amount in words</b></td>
			<td class="tdpaddingliner bottom" colspan="4" style="text-align: right;"><b>Total Amount before Tax</b></td>
			<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b>4,373.40</b></td>
		</tr>-->
				<tr>
			<td class="tdpaddingliner top" colspan="5" rowspan="6" style="text-align: left; vertical-align: top;"><b></b><?=AmountInWords(round($model->total_amount))?> (INR) Only</td>
			<!--<td class="tdpaddingliner top" colspan="8" style="text-align: left;"><b>Add: IGST</b></td>
			<td class=" top bottom" style="text-align:right;">787.21</td>-->
		</tr>
		<tr><td style="text-align:right;" colspan="6" class="tdpaddingliner allpad"><b>INPUT IGST :</b></td><td class="allpad" style="text-align:right; padding-right:5px;"><b><?= $tot_taxamount?></b></td></tr>		<tr>
			<td class="tdpaddingliner bottom" colspan="6" style="text-align: right; padding-right:5px;padding-top:5px;"><b>Total Amount After Tax</b></td>
			<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?=$grandtot?></b></td>
		</tr>
		<tr>
			<td class="tdpaddingliner bottom" colspan="6" style="text-align: right; padding-right:5px;padding-top:5px;"><b>TCS:</b></td>
			<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?=$model->tcs?></b></td>
		</tr>
		
	    <tr>
        <td style="text-align:right;" colspan="6" class="tdpaddingliner bottom"><b>Add: Round Off (Rs)</b></td>
        <td style="text-align:right;padding-right:5px;padding-top:5px;" class=" bottom"><b><?=$model->round_off_amount?></b></td>
    </tr><tr>
	        <td style="text-align:right;" colspan="6" class="tdpaddingliner"><b>Total (Rs)</b></td>
	        <td style="text-align:right;padding-right:5px;padding-top:5px;" class=""><b><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$model->total_amount) ?></b></td>
	    </tr>    </tfoot>
    </table>
    <?php } else{?>
        <table id="ProdTbl" class="prdtMainTbl " border="0" cellpadding="0" cellspacing="0" width="100%" style="color:#000; font-family:Arial, Helvetica, sans-serif; font-size:12px; ">
        <thead>
    			<tr style="">
		        <td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>S.No</p></td>
		        <td rowspan="2" class="tdpaddingliner top bottom" width="18%" style=" font-weight:bold;"><p>Product Description</p></td>	
				<td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>HSN Code</p></td>
				<td rowspan="2" class="tdpaddingliner top bottom" align="center" width="5%" style=" font-weight:bold;"><p>UOM</p></td>
                <td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>Qty</p></td>
				<td rowspan="2" class="tdpaddingliner top bottom" width="5%" style=" font-weight:bold; text-align: center;"><p>Rate</p></td>
		        <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Amount</p></td>
                <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Discount</p></td>
                <td rowspan="2" class="tdpaddingliner top bottom" width="10%" style=" font-weight:bold; text-align: center;"><p>Taxable Val</p></td>
		        <td colspan="2" class="tdpaddingliner top bottom" align="center" width="10%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>SGST</p></td>
                <td colspan="2" class="tdpaddingliner top bottom" align="center" width="10%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>CGST</p></td>
                <td rowspan="2" class="top bottom" align="center" width="10%" style=" font-weight:bold; text-align: center;"><p>Total</p></td>
	        </tr>
	        	        <tr>
	        	<td class="tdpaddingliner bottom" style="text-align:center;" align="center">Rate</td>
				<td class="tdpaddingliner bottom" style="text-align:center;" align="center">Amt</td>
                <td class="tdpaddingliner bottom" style="text-align:center;" align="center">Rate</td>
				<td class="tdpaddingliner bottom" style="text-align:center;" align="center">Amt</td>
				</tr>	
	             </thead>
			    <tbody>
                <?php  
                $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;
                        foreach($products as $key=>$value){ 
                            # # FOR TOTAL # #
                            $tot_quant+=$value->quantity;
                            $tot_unitprice+=$value->unit_price;   
                            $grandtot+=$value->amount;                         

                           $amount=$value->quantity*$value->unit_price;
                           if($value->discount_type=='FLAT'){
                            $taxable_value=$amount-$value->discount;
                            $tot_taxablevalue+=$taxable_value;
                           }else if($value->discount_type=='%'){
                            $taxable_value=$amount-($amount*$value->discount*0.01);
                            $tot_taxablevalue+=$taxable_value;
                           }else{
                               $taxable_value=$amount;
                               $tot_taxablevalue+=$taxable_value;
                           }
                            if($value->tax_included==1){
                            	if($value->tax!='' && $value!=null)
                            	{
                            		$tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
                                $tax_amount=$taxable_value*$tax_percent*0.01;
                                $tot_taxamount+=$tax_amount;
                            	}
                                
                            }else{
                                $tax_percent=0;
                                $tax_amount=0;
                                $tot_taxamount+=$tax_amount;
                            }
                            ?>
								 <tr> 
				 	<td class="tdpaddingliner top "   align="center"><?=$key+1?></td>
				    <td class="tdpaddingliner top " align="center"><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td>
                    <td class="tdpaddingliner top "   align="center"><?=Product::find()->where(['id'=>$value->product_id])->one()->hsn_sac_code?></td>
					<td class="tdpaddingliner top " align="center"><?=$value->units?></td>
                    <td class="tdpaddingliner top " align="center"><?=$value->quantity?></td>
					<td class="tdpaddingliner top " align="center"><?=$value->unit_price?></td>
                    <td class="tdpaddingliner top " align="center"><?=$amount?></td>
					<td class="tdpaddingliner top " align="center"><?=$value->discount . $value->discount_type?></td>
					<td class="tdpaddingliner top " align="center"><?=$taxable_value?></td>
					<td class="tdpaddingliner top " align="center"><?=$tax_percent/2?></td>
					<td class="tdpaddingliner top " align="center"><?=number_format((float)$tax_amount/2, 2, '.', '')?></td>
					<td class="tdpaddingliner top " align="center"><?=$tax_percent/2 ?></td>
					<td class="tdpaddingliner top " align="center"><?=number_format((float)$tax_amount/2, 2, '.', '')?></td>
	                <td class=" top " align="center" style="text-align:right;"><?=$value->amount?></td>
 					</tr>
                    <?php }?>
				</tbody>
				<tfoot>
			 	<tr>
					<td class="tdpaddingliner  top " style="font-size: 22px;"  colspan="4" align="center"><b>Total</b></td>
					<td class="tdpaddingliner top "  align="center"><?=$tot_quant?></td>
					<td class="tdpaddingliner top "    align="center"><?=$tot_unitprice?></td>
                    <td class="  top "   align="center"></td>
					<td class="  top "   align="center"></td> 
					<td class="tdpaddingliner top "style="border-left:1px solid black"  align="center"><?=$tot_taxablevalue?></td>
                    <td class="  top "   align="center"></td>
				    <td class="tdpaddingliner top " style="border-left:1px solid black"  align="center"><?=number_format((float)$tot_taxamount/2,2,'.','')?></td>
                    <td class="tdpaddingliner top " align="center"></td>
					<td class="tdpaddingliner top "   align="center"><?=number_format((float)$tot_taxamount/2,2,'.','')?></td>
					<td class="  top "   align="center" style="text-align:right;"><?=$grandtot?></td>
				</tr>
				<tr>
                                    <tr>
						<td class="tdpaddingliner top"   colspan="8" align="center"><b>Total amount in words:</b><br><?=AmountInWords(round($model->total_amount))?> (INR) Only</td>
					
						<td class="tdpaddingliner top "   colspan="5"   style="text-align:right;"><b>Total Amount before Tax</b></td>
						<td class=" top "   align="center" style="text-align:right;padding: 2px;"><b><?=$tot_taxablevalue?></b></td>	
					</tr>

					<tr><td style=""  colspan="8" class=" "></td>
			<td style="text-align:right;" colspan="5" class="tdpaddingliner top  left"><b>OUTPUT TCS:</b></td>
			<td style="text-align:right;padding: 2px;"  class="tdpaddingliner top  "><b><?=$model->tcs?></b></td></tr><tr><td style=""  colspan="8" class=" "></td>
            <td style="text-align:right;" colspan="5" class="tdpaddingliner top  left"><b>OUTPUT CGST:</b></td>
			<td style="text-align:right;padding: 2px;"  class="tdpaddingliner top  "><b><?=number_format((float)$tot_taxamount/2,2,'.','')?></b></td></tr><tr><td style=""  colspan="8" class=" "></td>
            <td style="text-align:right;" colspan="5" class="tdpaddingliner top  left"><b>OUTPUT SGST:</b></td>
			<td style="text-align:right;padding: 2px;"  class="tdpaddingliner top  "><b><?=number_format((float)$tot_taxamount/2,2,'.','')?></b></td></tr><tr><td style=""  colspan="8" class=" "></td>
			<td style="text-align:right;" colspan="5" class="tdpaddingliner top  left"><b>Round Off:</b></td>
			<td style="text-align:right;padding: 2px;"  class="tdpaddingliner top  "><b><?=$model->round_off_amount?></b></td></tr>								   </tr>

                <tr>
					<td class="tdpaddingliner   "  colspan="8"align="center"><b></b></td>
					
					<td class="tdpaddingliner top "   colspan="5"   style="text-align:right;"><b>Total Amount after Tax:</b></td>
					<td class="top"   align="center" style="text-align:right;padding: 2px;"><b><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$model->total_amount) ?></b></td>  	
				</tr>	 	
			</tfoot>
		  </table>
    <?php }?>
    </div>
</div>
<script type="text/javascript">
	$(document).ready(function() {
		if ($(window).width() < 800) {
			$('.mobwidthset').css('width', ($('.mobwidthset').parents('div:eq(0)').width())+'px');
		}
	});
	</script>
      </td>
    </tr>
    <tr><td height="1px;"></td></tr>
	    				<tr>
            		<td>
						<table width="100%" class="" cellspacing="0" cellpadding="0">
							<tbody><tr>
			                  <td width="40%" class="tdpaddingliner top" rowspan="5" style="vertical-align: top;"><b>Terms &amp; Conditions</b><br><p style="text-align: left;"></p><?= $template->terms_and_condition ?></td>
			                  <td width="20%" class="tdpaddingliner top"></td>
			                  <td width="40%" style="font-size:10px; text-align: center;" class="top"><b>Ceritified that the particulars given above are true and correct</b></td>
			                </tr>
                			<tr>
			                  <td width="20%" class="tdpaddingliner"><b></b></td>
			                  <td width="40%" class="top" style="text-align: center;"><b><?=$template->company_signature?></b></td>
			                </tr>
			                
	              			<tr>
			                  <td width="20%" class="tdpaddingliner"><b></b></td>
			                  <td width="40%" class=""><b><br></b></td>
	                		</tr>
	                		<tr>
			                  <td width="20%" class="tdpaddingliner top" style="text-align: center;"><b>Common Seal</b></td>
			                  <td width="40%" class="top" style="text-align: center;"><b>Authorised signatory</b>     
			                  </td>
	                		</tr>
							              			</tbody></table>
			
		 			</td>
	 			</tr>	
		</tbody></table>

</div>
</div>
</div>
<?php ob_start(); ?>                        
<script>
	<?php if ($from == 'print') {?>
  window.print();
           return false;
    <?php }?>
$('.print_page').click(function(){
           window.print();
           return false;
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>      
