<?php

namespace backend\modules\reports\controllers;
use Yii;
use Mpdf\Mpdf;
use common\models\User;
use yii\helpers\ArrayHelper;
use yii\data\ArrayDataProvider;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\GroupName;
use backend\modules\reports\models\BudgetReport;

class BudgetReportController extends \yii\web\Controller
{
  public function actionIndex($print=null,$excel=null)
  {
    $model = new BudgetReport();
    $current_month = date("m");
    if($current_month >= 4){
    $from_year = date("Y");
    $from_date = $from_year. '-04-01';
    }
    else 
    {
       $from_year = date("Y") -1;
       $from_date = $from_year. '-04-01';
    }
    $to_date = date("Y-m-d");
    $query = Yii::$app->db->createCommand("CALL budget_report(:params_1,:params_2)")
    ->bindValue(':params_1',$from_date)
    ->bindValue(':params_2',$to_date)
    ->queryAll();

    if($model->load(Yii::$app->request->get())){
      $from_date = $model->from_date;
      $to_date = $model->to_date;
    $query = Yii::$app->db->createCommand("CALL budget_report(:params_1,:params_2)")
    ->bindValue(':params_1',$from_date)
    ->bindValue(':params_2',$to_date)
    ->queryAll();
   }

   $dataProvider = new ArrayDataProvider([ 
      'allModels'=>$query,
      'pagination' => false,
    ]);
   // $groups = Products::find()->select('other_columns,some_column')->distinct();
   if($print=='true')
   {
       $for = 'print';
       $this->actionExportpdf($dataProvider,$model,$for);
   }
   if($print=='false')
   {
       $for = 'pdf';
       $this->actionExportpdf($dataProvider,$model,$for);
   }
    if($excel!='')
    {
      $this->actionExcelreport($dataProvider,$to_date);
    }
    // print_r($model->from_date);die();
    return $this->render('index', [
        'model' => $model,
        'dataProvider' => $dataProvider,
        'print'=>$print,
        'to_date'=>$to_date,
        'from_date'=>$from_date,
    ]);

  }

  public function actionExportPdf($data=null,$model=null,$for=null)
  {
      if($for=='print')
      {
          $data->pagination = false;
          $mpdf = new mPDF;
          $mpdf->showImageErrors = true;
          $mpdf->WriteHTML($this->renderPartial('/budget-report/exportpdf', [
              'dataProvider' => $data,
              'model'=>$model,

          ]));
          $mpdf->Output('Purchase_Order_Report.pdf', 'I');
      }
      else
      {
          $data->pagination = false;
          $mpdf = new mPDF;
          $mpdf->showImageErrors = true;
          $mpdf->WriteHTML($this->renderPartial('/budget-report/exportpdf', [
              'dataProvider' => $data,
              'model'=>$model,

          ]));
          $mpdf->Output('Budget_Report.pdf', 'D');
      }
  }



    public function actionExportprint($data=null,$date=null)
  {
       $data->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('exportprint', [
          'dataProvider' => $data,
            
            'to_date'=>$date,

        ]));
        $mpdf->Output('BudgetReport.pdf', 'I');
  } 
  public function actionExcelreport($dataProvider=null,$excel=null)
  {
     $phpExcel = new \PHPExcel;
     $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();

      
      // Making headers text bold and larger
      $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
      
      $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
      $sheet ->getCell('A2')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
      $sheet ->getCell('A3')->setValue('BHUBANESWAR, Odisha');
      $sheet ->getCell('A4')->setValue('');
      $sheet ->getCell('A5')->setValue('Budget Report');
      $sheet->getStyle('A5')->getFont()->setBold(true)->setSize(11);

      $sheet->mergeCells('A1:D1');
      $sheet->mergeCells('A2:D2');
      $sheet->mergeCells('A3:D3');
      $sheet->mergeCells('A4:D4');
      $sheet->mergeCells('A5:D5');
      $sheet->mergeCells('A6:D6');

      $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A2')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A4')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A5')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A6')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);


      $sheet->getColumnDimension('A')->setWidth(40);
      $sheet->getColumnDimension('B')->setWidth(20);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);

      $sheet->setCellValue('A7',  'Particulars');
      $sheet->setCellValue('B7',  'Budget');
      $sheet->setCellValue('C7',  'Actual');
      $sheet->setCellValue('D7',  'Variance');

      
       $sheet->getStyle('A7')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('B7')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('C7')->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('D7')->getFont()->setBold(true)->setSize(12);
      

        $row=8;
        $total_budget=0;
        $total_actual=0;
        $total_variance=0;

        foreach ($dataProvider as $val) {
            // echo "<pre>";
            // print_r($val);
            $i=0;
            if($val!=null){
                
            $total_budget+=$val[$i]['budget'];
            $total_actual+=$val[$i]['actual'];
            $total_variance+=$val[$i]['variance'];
            $i++;
            }
            
        }
        //die();
          foreach ($dataProvider as $data) {
$i=0;
            $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('D' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
                       
            if($data!=null){   
                if(($data[$i]['particulars'])!=''){   
                         $sheet->setCellValue('A' . $row,  $data[$i]['particulars']);
                         $sheet->setCellValue('B' . $row,  $data[$i]['budget']!=''?$data[$i]['budget']:'0');
                         $sheet->setCellValue('C' . $row,  $data[$i]['actual']!=''?$data[$i]['actual']:'0');
                         $sheet->setCellValue('D' . $row,  $data[$i]['variance']!=''?$data[$i]['variance']:'0');    
                         
                         $row++;

                           }
                          $i++;
                        }
            }         
        
        $sheet->setCellValue('A' . ($row+2), 'Total');
        $sheet->setCellValue('B' . ($row+2), $total_budget);  
        $sheet->setCellValue('C' . ($row+2), $total_actual); 
        $sheet->setCellValue('D' . ($row+2), $total_variance);


       ob_clean();
       ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="BudgetReport.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();
  }

 
}
