<?php

namespace backend\modules\reports\controllers;

use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;

use yii2tech\spreadsheet\Spreadsheet;
use backend\modules\reports\models\DaybookReport;
use yii\helpers\Url;


class DaybookReportController extends \yii\web\Controller
{
    public function actionIndex($print=null,$pdf=null,$excel=null)
    {
    	$model = new DaybookReport();
        $query=DaybookReport::find();
         $vchno = DaybookReport::find()->select('vch_no')->distinct()->all();


         if($model->load(Yii::$app->request->get())){

            $query->andFilterWhere(['like','vch_type',$model->type])
                   ->andFilterWhere(['between', 'date', $model->from_date,$model->to_date]); 

             
        }

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);


        if($print!=null)
        {
            $for = "print";
            $this->actionPdfexport($dataProvider,$model,$for,$vchno);
        }
        if($pdf!=null)
        {
            $for = "pdf";
            $this->actionPdfexport($dataProvider,$model,$for,$vchno);
        }
        if($excel!=null)
        {
            $this->actionExcelexport($dataProvider,$model);
        }


        return $this->render('index', [
            'model' => $model,
            'dataProvider' => $dataProvider,
        ]);
    }
    public function actionPdfexport($data=null,$model=null,$for=null,$vchno=null)
    {
    	if($for=='print')
        {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/daybook-report/pdfexport', [
            'dataProvider' => $data,
            'vchno' => $vchno,
            'model' => $model,
            ]));
            $mpdf->Output('DaybookReport.pdf', 'I');
        }
        else
        {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/daybook-report/pdfexport', [
            'dataProvider' => $data,
            'vchno' => $vchno,
            'model' => $model,
            ]));
            $mpdf->Output('DaybookReport.pdf', 'D');
        }
    }

    public function actionExcelexport($data=null,$model=null)
    {
        if($data!=null){
             $dataProvider = $data; 
        }
        else
        {
          $dataProvider = new ActiveDataProvider([
            'query' => PurchaseVendorLedger::find()->orderBy(['Date' => SORT_DESC]),
        ]);
        }
      $vchno = DaybookReport::find()->select('vch_no')->distinct()->all();
      $phpExcel = new \PHPExcel;
      $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
      $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();
      $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
      $sheet ->getCell('A2')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
      $sheet ->getCell('A3')->setValue('BHUBANESWAR, Odisha');
      $sheet ->getCell('A4')->setValue('');
      $sheet ->getCell('A5')->setValue('Daybook');
      $sheet->getStyle('A5')->getFont()->setBold(true)->setSize(11);


      $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A2')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A4')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A5')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      $sheet->getStyle('A6')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);

      // Making headers text bold and larger
      $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
      $sheet->getStyle('A2:S2')->getFont()->setSize(11);
      $sheet->getStyle('A3:S3')->getFont()->setSize(11);
      $sheet->getStyle('A4:S4')->getFont()->setSize(11);
      $sheet->getStyle('A5:S5')->getFont()->setSize(11);
      $sheet->getStyle('A6:S6')->getFont()->setSize(11);

      $sheet->getColumnDimension('A')->setWidth(20);
      $sheet->getColumnDimension('B')->setWidth(30);
      $sheet->getColumnDimension('C')->setWidth(20);
      $sheet->getColumnDimension('D')->setWidth(20);
      $sheet->getColumnDimension('E')->setWidth(20);
      $sheet->getColumnDimension('F')->setWidth(20);

      $sheet->mergeCells('A1:F1');
      $sheet->mergeCells('A2:F2');
      $sheet->mergeCells('A3:F3');
      $sheet->mergeCells('A4:F4');
      $sheet->mergeCells('A5:F5');
      $sheet->mergeCells('A6:F6');

      if($model->from_date!=null && $model->to_date!=null)
      {
        $sheet->setCellValue('A6', date('d/m/Y', strtotime($model->from_date)).' to '.date('d/m/Y', strtotime($model->to_date)));
      }
      else{
        $sheet->setCellValue('A6', '');
      }


      $sheet->setCellValue('A7',  'Date');
      $sheet->setCellValue('B7',  'Description');
      $sheet->setCellValue('C7',  'Vch Type');
      $sheet->setCellValue('D7',  'Vch No');
      $sheet->setCellValue('E7',  'Debit Amount');
      $sheet->setCellValue('F7',  'Credit Amount');
      $sheet->getStyle('A7')->getFont()->setBold(true)->setSize(11);
      $sheet->getStyle('B7')->getFont()->setBold(true)->setSize(11);
      $sheet->getStyle('C7')->getFont()->setBold(true)->setSize(11);
      $sheet->getStyle('D7')->getFont()->setBold(true)->setSize(11);
      $sheet->getStyle('E7')->getFont()->setBold(true)->setSize(11);
      $sheet->getStyle('F7')->getFont()->setBold(true)->setSize(11);

        $row=8;
        $total_debit_amount = 0;
        $total_credit_amount = 0;



       foreach ($vchno as $key => $val) {

        if($model->from_date!='' && $model->to_date!='' && $model->type=='')
           {
                $ledgerdetails=DaybookReport::find()->where(['vch_no'=>$val->vch_no])->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])->all();
           }
            else if ($model->type!='' && $model->from_date=='' && $model->to_date=='') {
                $ledgerdetails=DaybookReport::find()->where(['vch_no'=>$val->vch_no])->andFilterWhere(['like','vch_type',$model->type])->all();
            }
            else if ($model->from_date!='' && $model->to_date!='' && $model->type!='') {
               $ledgerdetails=DaybookReport::find()->where(['vch_no'=>$val->vch_no])->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])->andFilterWhere(['like','vch_type',$model->type])->all();
            }
           else
           {
            $ledgerdetails=DaybookReport::find()->where(['vch_no'=>$val->vch_no])->all();
           }
           $i = 0;
           foreach ($ledgerdetails as $key => $detail)
           {
              if($key==0)
              {
                $sheet->setCellValue('A' . ($row+$i),  date('F j Y', strtotime($detail->date)));
                $sheet->setCellValue('B' . ($row+$i),  $detail->description);
                $sheet->setCellValue('C' . ($row+$i),  $detail->vch_type);
                $sheet->setCellValue('D' . ($row+$i),  $detail->vch_no);
                if($detail->debit_amount!='')
                {
                    $sheet->setCellValue('E' . ($row+$i),  (string)$detail->debit_amount);
                    $total_debit_amount = $total_debit_amount + $detail->debit_amount;
                } 
                else{
                    $sheet->setCellValue('E' . ($row+$i),  '-');
                    $total_debit_amount = $total_debit_amount + 0;
                } 

                if($detail->credit_amount!='')
                {
                    $sheet->setCellValue('F' . ($row+$i),  (string)$detail->credit_amount);
                    $total_credit_amount = $total_credit_amount + $detail->credit_amount;
                } 
                else
                {
                    $sheet->setCellValue('F' . ($row+$i),  '-');
                    $total_credit_amount = $total_credit_amount + 0;
                }
                
                
              }
              else
              {
                  $sheet->setCellValue('A' . ($row+$i),  '');
                    $sheet->setCellValue('B' . ($row+$i),  $detail->description);
                    $sheet->setCellValue('C' . ($row+$i),  '');
                    $sheet->setCellValue('D' . ($row+$i),  '');
                    if($detail->debit_amount!='')
                    {
                        $sheet->setCellValue('E' . ($row+$i),  (string)$detail->debit_amount);
                        $total_debit_amount = $total_debit_amount + $detail->debit_amount;
                    } 
                    else{
                        $sheet->setCellValue('E' . ($row+$i),  '-');
                        $total_debit_amount = $total_debit_amount + 0;
                    } 

                    if($detail->credit_amount!='')
                    {
                        $sheet->setCellValue('F' . ($row+$i),  (string)$detail->credit_amount);
                        $total_credit_amount = $total_credit_amount + $detail->credit_amount;
                    } 
                    else
                    {
                        $sheet->setCellValue('F' . ($row+$i),  '-');
                         $total_credit_amount = $total_credit_amount + 0;
                    }
              }

              $i++;  
           }
           $row= $row+ $i;
       }




       //  $sheet->setCellValue('A' . $row,  $model->ledgerhead_id);
            
       //  $row++;   

       // } 

       $sheet->setCellValue('A' . $row, 'Total');
       $sheet->setCellValue('E' . $row,  $total_debit_amount);
        $sheet->setCellValue('F' . $row,  $total_credit_amount);

      $sheet->getStyle('A'.$row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');
      $sheet->getStyle('B'.$row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');
      $sheet->getStyle('C'.$row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');

      ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="daybook-report.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();

    }
}
