<?php

namespace backend\modules\reports\controllers;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Leads;
use backend\modules\reports\models\LeadsReport;
use Yii;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\Product;
use yii2tech\spreadsheet\Spreadsheet;
use yii\data\ArrayDataProvider;


class LeadsReportController extends \yii\web\Controller
{
    public function actionIndex($excel=null)
    {
        $model = new LeadsReport();
        $query = LeadsReport::find();

            if($model->load(Yii::$app->request->get())){
            $model->load(Yii::$app->request->queryParams);

            $query->andFilterWhere(['between', 'lead_date', $model->from_date,$model->to_date])
               ->andFilterWhere(['like', 'enquiry_no', $model->enq_no])
              ->andFilterWhere(['like', 'business_type', $model->bus_type])
             // ->andFilterWhere(['like', 'userid', $model->userid])
               ->andFilterWhere(['like', 'city', $model->ct])
               ->andFilterWhere(['like', 'executive', $model->exe])
               ->andFilterWhere(['like', 'product_model', $model->product])
               ->andFilterWhere(['like', 'status', $model->st]);
               // ->andFilterWhere(['like', 'lead_type', $model->lead_type]);

               if($model->search){
                $query
                ->andFilterWhere(['like', 'name', $model->search])
                ->orFilterWhere(['like', 'email', $model->search])
                ->orFilterWhere(['like', 'city', $model->search])
                ->orFilterWhere(['like', 'enquiry_no', $model->search]);
            }
        //     else {
        //         if($model->lead_type=="postponed"){
        //             $query=Leads::find()->where(['not',['postponed_date'=>null]])->orderBy([
        //         'id' => SORT_DESC,
        //       ]);
        //         }
        //         if($model->lead_status=="Disqualified"){
        //             $query=Leads::find()->where(['is_disqualify' =>0])->orderBy([
        //         'id' => SORT_DESC,
        //       ]);
        //              }
        //     $query->andFilterWhere(['between', 'lead_date', $model->from_date,$model->to_date])
        //     ->andFilterWhere(['like', 'enquiry_no', $model->enq_no])
        //    ->andFilterWhere(['like', 'business_type', $model->business_type])
        //   // ->andFilterWhere(['like', 'userid', $model->userid])
        //     ->andFilterWhere(['like', 'city', $model->ct])
        //     ->andFilterWhere(['like', 'lead_executive', $model->executive])
        //     ->andFilterWhere(['like', 'product_model', $model->pro_model])
        //     ->andFilterWhere(['like', 'status', $model->st]);
        //     }
        if ($model->enq_no) {
            $find_enq_no = LeadsReport::find()->select(['enquiry_no'])->where(['enquiry_no' => $model->enq_no])->column(); 
        }
        if($model->bus_type){
            $query->andFilterWhere(['like', 'business_type', $model->bus_type]);
        }
        // if($model->lead_type){
        //     if($model->lead_type =='postponed')
        //     $query->andFilterWhere(['like', 'postponed_date', $model->lead_type]);
        // }else{
            
        // }
        if($model->st){
            $query->andFilterWhere(['like', 'status', $model->st]);
        }
        if($model->ct){
            $query->andFilterWhere(['like', 'city', $model->ct]);
        }
        if($model->exe){
            $query->andFilterWhere(['like', 'executive', $model->exe]); 
        }
        if($model->product){
            $query->andFilterWhere(['like', 'product_model', $model->product]); 
        }
        if($model->from_date!='' && $model->to_date!=''){
            $query->andFilterWhere(['between', 'lead_date', $model->from_date, $model->to_date]);
        }else{

        }

    }

        $dataProvider = new ActiveDataProvider([
            'query'=>$query,

        ]);
        // $dataProvider = new ArrayDataProvider([
        //     'allModels' => $query,
        //     'pagination' => false,
        // ]);


        if($excel !=null){
            $this->actionLeadExcel($dataProvider,$excel = true);
        }

        return $this->render('index',[
            'dataProvider'=>$dataProvider,
            'model'=> $model,
        ]);        
    }

    public function actionLeadExcel($dataProvider, $excel)
    {
      // print_r($dataProvider);die();
    //   if ($dataProvider != null){
    //     $dataProvider = $dataProvider;
    // }else{

    //     $query = LeadsReport::find();

    //     $dataProvider = new ActiveDataProvider([
    //       'query'=> $query,
    //         'pagination'=>false,
    //     ]);

    // }
        $phpExcel = new \PHPExcel;
        $phpExcel->getProperties()->setDescription("Excel SpreadSheet in PHP");
        $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
        $sheet = $phpExcel->getActiveSheet();


        // Making headers text bold and larger
        $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);



        $sheet->getColumnDimension('A')->setWidth(10);
        $sheet->getColumnDimension('B')->setWidth(10);
        $sheet->getColumnDimension('C')->setWidth(20);
        $sheet->getColumnDimension('D')->setWidth(50);
        $sheet->getColumnDimension('E')->setWidth(30);
        $sheet->getColumnDimension('F')->setWidth(20);
        $sheet->getColumnDimension('G')->setWidth(20);
        $sheet->getColumnDimension('H')->setWidth(20);
        $sheet->getColumnDimension('I')->setWidth(20);
        $sheet->getColumnDimension('J')->setWidth(20);
        $sheet->getColumnDimension('K')->setWidth(20);
       // $sheet->getColumnDimension('L')->setWidth(50);
       // $sheet->getColumnDimension('M')->setWidth(20);


        $sheet->setCellValue('A1',  'Enq No');
        $sheet->setCellValue('B1',  'Lead Date');
        $sheet->setCellValue('C1',  'Name');
        $sheet->setCellValue('D1',  'Product');
        $sheet->setCellValue('E1',  'Remaek');
        $sheet->setCellValue('F1',  'Email');
       // $sheet->setCellValue('G1',  ' Phone No');
        $sheet->setCellValue('G1',  'City');
        $sheet->setCellValue('H1',  'Business Type');
        $sheet->setCellValue('I1',  ' Executive');
        $sheet->setCellValue('J1',  ' Status');
        $sheet->setCellValue('K1',  ' Postponed');
       // $sheet->setCellValue('M1',  ' Conv. To');

       



        $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('B1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('C1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('D1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('E1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('F1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('G1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('H1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('I1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('J1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('K1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
       // $sheet->getStyle('L1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
      //  $sheet->getStyle('M1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        
        


        $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('B1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('C1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('D1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('E1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('F1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('G1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('H1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('I1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('J1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('K1')->getFont()->setBold(true)->setSize(12);
       // $sheet->getStyle('L1')->getFont()->setBold(true)->setSize(12);
//$sheet->getStyle('M1')->getFont()->setBold(true)->setSize(12);



        $row = 3;
   
        foreach ($dataProvider->models as $data) {
           // print_r($data);die();
            $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('D' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
                             
                         $sheet->setCellValue('A' . $row,  $data['enquiry_no']);
                         $sheet->setCellValue('B' . $row,  $data['lead_date']);
                         $sheet->setCellValue('C' . $row,  $data['name']); 
                         $sheet->setCellValue('D' . $row,  $data['product_model']);
                         $sheet->setCellValue('E' . $row,  $data['remark']);
                         $sheet->setCellValue('F' . $row,  $data['email']); 
                        // $sheet->setCellValue('G' . $row,  $data['phone_no']);
                         $sheet->setCellValue('G' . $row,  $data['city']);
                         $sheet->setCellValue('H' . $row,  $data['business_type']); 
                         $sheet->setCellValue('I' . $row,  $data['executive']);
                         $sheet->setCellValue('J' . $row,  $data['status']);
                         $sheet->setCellValue('K' . $row,  $data['postponed_date']); 
                        // $sheet->setCellValue('M' . $row,  $data['con_to']); 
                         $row++;
                   
            }         
        

        //     if ($data['Payment Mode'] != '' && $data['Receipt'] == '' && $data['Payment'] == '') {
        //         $sheet->setCellValue('A' . $row,  $data['Payment Mode']);
        //         $sheet->setCellValue('B' . $row,  $data['Receipt'] = 0);
        //         $sheet->setCellValue('C' . $row,  $data['Payment'] = 0);
        //         $row++;
        //     } elseif ($data['Payment Mode'] != '' && $data['Receipt'] == '' && $data['Payment'] != '') {
        //         $sheet->setCellValue('A' . $row,  $data['Payment Mode']);
        //         $sheet->setCellValue('B' . $row,  $data['Receipt'] = 0);
        //         $sheet->setCellValue('C' . $row,  $data['Payment']);
        //         $row++;
        //     } elseif ($data['Payment Mode'] != '' && $data['Receipt'] != '' && $data['Payment'] == '') {
        //         $sheet->setCellValue('A' . $row,  $data['Payment Mode']);
        //         $sheet->setCellValue('B' . $row,  $data['Receipt']);
        //         $sheet->setCellValue('C' . $row,  $data['Payment'] = 0);
        //         $row++;
        //     } else {
        //         $sheet->setCellValue('A' . $row,  $data['Payment Mode']);
        //         $sheet->setCellValue('B' . $row,  $data['Receipt']);
        //         $sheet->setCellValue('C' . $row,  $data['Payment']);
        //         $row++;
        //     }
        

        // $sheet->setCellValue('A' . ($row + 2), 'Total');
        // $sheet->setCellValue('B' . ($row + 2), $total_payment);
        // $sheet->setCellValue('C' . ($row + 2), $total_receipt);

        // $sheet->setCellValue('B' . ($row + 2), number_format($total_payment, 2, '.',','));
        // $sheet->setCellValue('C' . ($row + 2), number_format($total_receipt, 2, '.',','));


        ob_clean();
        ob_start();

        header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
        header('Content-Disposition: attachment; filename="LeadsReport.xls"'); // Write file to the browser 

        $writer->save('php://output');
        ob_flush();
        exit();
    }

    public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'product_name', 'product_name');
        return json_encode($productlist);
    }

    }
