<?php

namespace backend\modules\reports\controllers;

use backend\modules\reports\models\PurchasePendingReport;
use backend\modules\master\models\Vendor;

use Yii;
use yii\helpers\ArrayHelper;
use yii\data\ActiveDataProvider;

class PurchasePendingReportController extends \yii\web\Controller
{
    public function actionIndex()
    {
        $model = new PurchasePendingReport();
        $query = PurchasePendingReport::find();

        if (Yii::$app->request->get()) {
            $model->load(Yii::$app->request->queryParams);
            $query->andFilterWhere(['particulars' => $model->vendor_name])
                ->andFilterWhere(['id' => $model->vch_no])
                ->andFilterWhere(['between', 'Date', $model->from_date, $model->to_date]);

            if ($model->vendor_name) {
                $find_vendor = Vendor::find()->select(['business_name'])->where(['id' => $model->vendor_name])->column(); 
            }
            if ($model->purchase_date) {
                if ($model->purchase_date == 'Today') {
                    $query->andFilterWhere(['like', 'Date', date('Y-m-d')]);
                } elseif ($model->purchase_date == 'Current Week') {
                    $query->andFilterWhere(['>=', 'Date', date('Y-m-d', strtotime('last monday'))]);
                } elseif ($model->purchase_date == 'Current Month') {
                    $query->andFilterWhere(['>=', 'Date', date('Y-m-d', strtotime('first day of this month'))]);
                } elseif ($model->purchase_date == 'Current Year') {
                    $query->andFilterWhere(['>=', 'Date', date('Y-m-d', strtotime(date('Y-01-01')))]);
                } elseif ($model->purchase_date == 'Custom') {

                    $query->andFilterWhere(['between', 'Date', $model->from_date, $model->to_date]);
                }
            }
            if ($model->purchase_orderBy) {
                if ($model->purchase_orderBy == 'Voucher # Asc') {
                    $query->orderBy(['CONCAT( REPEAT( "0", 18 - LENGTH(id) ) , id)' => SORT_ASC]);
                } elseif ($model->purchase_orderBy == 'Voucher # Dsc') {
                    $query->orderBy(['CONCAT( REPEAT( "0", 18 - LENGTH(id) ) , id)' => SORT_DESC]);
                } elseif ($model->purchase_orderBy == 'Date Asc') {
                    $query->orderBy(['Date' => SORT_ASC]);
                } elseif ($model->purchase_orderBy == 'Date Dsc') {
                    $query->orderBy(['Date' => SORT_DESC]);
                } 

            }
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,

        ]);
        return $this->render('index', [
            'dataProvider' => $dataProvider,
            'model' => $model,
        ]);
    }

    
}
