<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "custmor_ledger_details".
 *
 * @property string|null $dated
 * @property string|null $customer
 * @property string|null $vch_no
 * @property string $vch_type
 * @property string|null $notes
 * @property string|null $debit_amount
 * @property string|null $credit_amount
 */
class CustmorLedgerDetails extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'custmor_ledger_details';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['dated'], 'safe'],
            [['notes'], 'string'],
            [['customer'], 'string', 'max' => 254],
            [['vch_no'], 'string', 'max' => 256],
            [['vch_type'], 'string', 'max' => 15],
            [['debit_amount', 'credit_amount'], 'string', 'max' => 18],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'dated' => 'Dated',
            'customer' => 'Customer',
            'vch_no' => 'Vch No',
            'vch_type' => 'Vch Type',
            'notes' => 'Notes',
            'debit_amount' => 'Debit Amount',
            'credit_amount' => 'Credit Amount',
        ];
    }
}
