<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "customer_aging_report".
 *
 * @property string|null $customer_type
 * @property string|null $createdat
 * @property int|null $y
 * @property int|null $m
 * @property string|null $ledgerhead_id
 * @property float|null $first_month
 * @property float|null $second_month
 * @property float|null $third_month
 * @property float|null $fourth_month
 * @property float|null $fifth_month
 * @property float|null $sixth_month
 * @property float|null $total_debit
 * @property float|null $total_credit
 */
class CustomerAgingReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */

    public $type_of_customer;
    public $ledger_id;
    public $record_type;
    public $report_type;
    public $as_on;

    public static function tableName()
    {
        return 'customer_aging_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['createdat','as_on'], 'safe'],
            [['y', 'm'], 'integer'],
            [['first_month', 'second_month', 'third_month', 'fourth_month', 'fifth_month', 'sixth_month', 'total_debit', 'total_credit'], 'number'],
            [['customer_type','type_of_customer','ledger_id','record_type','report_type'], 'string', 'max' => 254],
            [['ledgerhead_id'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'customer_type' => 'Customer Type',
            'createdat' => 'Createdat',
            'y' => 'Y',
            'm' => 'M',
            'ledgerhead_id' => 'Ledgerhead ID',
            'first_month' => 'First Month',
            'second_month' => 'Second Month',
            'third_month' => 'Third Month',
            'fourth_month' => 'Fourth Month',
            'fifth_month' => 'Fifth Month',
            'sixth_month' => 'Sixth Month',
            'total_debit' => 'Total Debit',
            'total_credit' => 'Total Credit',
        ];
    }
}
