<?php

namespace backend\modules\reports\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\reports\models\CustomerLedgerOverview;

/**
 * AccountingLedgerSearch represents the model behind the search form of `backend\modules\master\models\AccountingLedger`.
 */
class CustomerLedgerOverviewSearch extends CustomerLedgerOverview
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $order_by;
    public $ledger_balance;
    public $bs_name;

    public function rules()
    {
        return [
            [['total_debit_amount','Date','total_credit_amount','customer_type', 'business_name', 'executive', 'ledgerhead_id','from_date','to_date','order_by','ledger_balance','bs_name'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query =CustomerLedgerOverview::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => false,

        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        //grid filtering conditions

        return $dataProvider;
    }
}
