<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "Purchase_report_by_product".
 *
 * @property string|null $Date
 * @property string|null $VendorName
 * @property string|null $VChNo
 * @property string|null $TINPurchaseNo
 * @property string|null $Product
 * @property string|null $Qty
 * @property float|null $Rate
 * @property string|null $ItemDiscount
 * @property float|null $BillTotal
 * @property string|null $TaxAmount
 * @property string|null $VendorDEALER
 * @property string|null $Units
 * @property string|null $Description
 * @property string|null $Category
 */
class DeliveredPurchaseReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $vendor;
    public $vendor_catagory;
    public $setting;
    public $searchproduct;
    public $created_by_user;
    public $from_date;
    public $to_date;
    public $purchase_type;
    public static function tableName()
    {
        return 'delivered_purchase_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date', 'from_date', 'to_date'], 'safe'],
            [['Rate', 'BillTotal', 'gr_status'], 'number'],
            [['VendorName', 'ItemDiscount', 'TaxAmount', 'VendorDEALER', 'Units', 'Description', 'vendor', 'vendor_catagory', 'setting', 'searchproduct', 'created_by_user', 'purchase_type', 'vendor_bill_no', 'tax_included'], 'string', 'max' => 254],
            [['VChNo', 'TINPurchaseNo', 'updated_by', 'round_off_amount', 'gross_total', 'discount_type'], 'string', 'max' => 255],
            [['Product'], 'string', 'max' => 512],
            [['Qty'], 'string', 'max' => 30],
            [['Category'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'VendorName' => 'Vendor Name',
            'VChNo' => 'V Ch No',
            'TINPurchaseNo' => 'Tin Purchase No',
            'Product' => 'Product',
            'Qty' => 'Qty',
            'Rate' => 'Rate',
            'ItemDiscount' => 'Item Discount',
            'BillTotal' => 'Bill Total',
            'TaxAmount' => 'Tax Amount',
            'VendorDEALER' => 'Vendor Dealer',
            'Units' => 'Units',
            'Description' => 'Description',
            'Category' => 'Category',
        ];
    }
}
