<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "gstr3_outward".
 *
 * @property string $invoice_id
 * @property string $product_id
 * @property string $quantity
 * @property string $units
 * @property float $unit_price
 * @property float $price
 * @property string $discount_type
 * @property float $amount
 * @property string|null $receiver_gstn
 * @property string|null $sales_type
 * @property string|null $supply_type
 * @property string|null $supply_reverse_change
 * @property string|null $date
 * @property string|null $terms_of_payment
 * @property string|null $point_of_supply
 * @property float|null $total_price
 * @property float|null $igst_amount
 * @property float|null $cgst_amount
 * @property float|null $sgst_amount
 * @property string|null $inv_id
 * @property string|null $settings_id
 * @property string|null $customer_name
 * @property string|null $product_name
 * @property string|null $hsn_sac_code
 */
class Gstr3Outward extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'gstr3_outward';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['invoice_id', 'product_id', 'quantity', 'units', 'unit_price', 'price', 'discount_type', 'amount'], 'required'],
            [['unit_price', 'price', 'amount', 'total_price', 'igst_amount', 'cgst_amount', 'sgst_amount'], 'number'],
            [['date'], 'safe'],
            [['hsn_sac_code'], 'string'],
            [['invoice_id', 'product_id', 'units', 'discount_type', 'receiver_gstn', 'sales_type', 'supply_type', 'supply_reverse_change', 'terms_of_payment', 'point_of_supply', 'inv_id', 'settings_id', 'customer_name'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
            [['product_name'], 'string', 'max' => 512],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'invoice_id' => 'Invoice ID',
            'product_id' => 'Product ID',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'unit_price' => 'Unit Price',
            'price' => 'Price',
            'discount_type' => 'Discount Type',
            'amount' => 'Amount',
            'receiver_gstn' => 'Receiver Gstn',
            'sales_type' => 'Sales Type',
            'supply_type' => 'Supply Type',
            'supply_reverse_change' => 'Supply Reverse Change',
            'date' => 'Date',
            'terms_of_payment' => 'Terms Of Payment',
            'point_of_supply' => 'Point Of Supply',
            'total_price' => 'Total Price',
            'igst_amount' => 'Igst Amount',
            'cgst_amount' => 'Cgst Amount',
            'sgst_amount' => 'Sgst Amount',
            'inv_id' => 'Inv ID',
            'settings_id' => 'Settings ID',
            'customer_name' => 'Customer Name',
            'product_name' => 'Product Name',
            'hsn_sac_code' => 'Hsn Sac Code',
        ];
    }
}
