<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "purchase_order_report".
 *
 * @property int|null $purchase_order_id
 * @property string|null $Date
 * @property string|null $vendor_name
 * @property string|null $vendor_type
 * @property string|null $vch_no
 * @property string|null $vendor_bill_no
 * @property string|null $gst_no
 * @property float|null $qty
 * @property float|null $price
 * @property float|null $gross_total
 * @property float|null $other_charges
 * @property float|null $tax_amount
 * @property float|null $bill_total
 * @property string $category
 */
class PurchaseOrderReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $product_name;
    public $v_name;
    public $user_name;
    public $status;
    public $setting_type;
    public $from_date;
    public $to_date;

    public static function tableName()
    {
        return 'purchase_order_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['purchase_order_id','user_id'], 'integer'],
            [['Date','from_date','to_date','bill_date','product_id'], 'safe'],
            [['vendor_bill_no','product_name','setting_type','user_name'], 'string'],
            [['qty', 'rate', 'gross_total', 'other_charges', 'tax_amount', 'bill_total','paid_amount'], 'number'],
            [['category'], 'required'],
            [['vendor_name', 'vendor_type','status','v_name'], 'string', 'max' => 254],
            [['vch_no', 'gst_no','cheque_ref'], 'string', 'max' => 255],
            [['category'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'purchase_order_id' => 'Purchase Order ID',
            'Date' => 'Date',
            'vendor_name' => 'Vendor Name',
            'vendor_type' => 'Vendor Type',
            'vch_no' => 'Vch No',
            'vendor_bill_no' => 'Vendor Bill No',
            'gst_no' => 'Gst No',
            'qty' => 'Qty',
            'price' => 'Price',
            'gross_total' => 'Gross Total',
            'other_charges' => 'Other Charges',
            'tax_amount' => 'Tax Amount',
            'bill_total' => 'Bill Total',
            'category' => 'Category',
        ];
    }
}
