<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "vendor_ledger_overview".
 *
 * @property string|null $Date
 * @property string|null $vendor_type
 * @property string|null $business_name
 * @property float|null $total_debit_amount
 * @property float|null $total_credit_amount
 * @property string|null $ledgerhead_id
 */
class VendorLedgerOverview extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'vendor_ledger_overview';
    }

    public $from_date;
    public $to_date;
    public $order_by;
    public $ledger_balance;
    public $type;
    public $group;
    public $sort_by;
    public $balance;
    public $bs_name;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['Date','from_date','to_date','order_by','ledger_balance','type','group','sort_by','balance','bs_name'], 'safe'],
            [['total_debit_amount', 'total_credit_amount'], 'number'],
            [['vendor_type', 'business_name', 'ledgerhead_id'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'Date' => 'Date',
            'vendor_type' => 'Vendor Type',
            'business_name' => 'Business Name',
            'total_debit_amount' => 'Total Debit Amount',
            'total_credit_amount' => 'Total Credit Amount',
            'ledgerhead_id' => 'Ledgerhead ID',
        ];
    }
}
