<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use common\models\User;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\DirectPayment;
use backend\modules\users\models\DirectReceipt;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Cash Flow Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .text-wrap{
        white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
        white-space: -pre-wrap;      /* Opera 4-6 */
        white-space: -o-pre-wrap;    /* Opera 7 */
        white-space: pre-wrap;       /* css-3 */
        word-wrap: break-word;       /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }
    .select2-container .select2-selection--single {
        height: 42px !important;
    }
    .select2-container--default .select2-selection--single .select2-selection__rendered
    {
        line-height: 39px;
    }
    .select2-container--default .select2-selection--single .select2-selection__arrow
    {
        height: 39px;
    }
    .add_product .select2-selection__rendered {
        width: 220px !important;
    }
    th a{
        color:#495057;
    }
    th a:hover{
        color:#495057;
    }
    body{
        font-family:Arial, Helvetica, sans-serif;
        font-size:13px;
    }
    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }
    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
    td {
        width: 50%;
    }
    th {
    text-align: center;
    }
    td.table_innerbg3 {
    width: 25%;
    }
    td.table_innerbg4 {
    width: 25%;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>
<?php
$total_inflow=0;$total_outflow=0;
if (!empty($dataProvider1->getModels())) {
    foreach ($dataProvider1->getModels() as $key => $val) {
        $total_inflow+=$val->total_amount;
    }
}
if (!empty($dataProvider2->getModels())) {
    foreach ($dataProvider2->getModels() as $key => $val) {
        $total_outflow+=$val->total_amount;
    }
}

?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Cash Flow Report</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">

                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&print=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print</button></a>
                                                <?php }?>                                                   
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                <a href="<?=Url::current()?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>  Excel</button></a>
                                                <?php } ?>
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&pdf=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Pdf</button></a>
                                                <?php } ?>
                                                   
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a  class="search_field_buttons"  href="<?=Url::base().'/reports/cash-flow/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                    <div class="form-row">
                    <div class="col-md-6">
                            <div class="position-relative form-group">
                                <label for="notes">From Period</label>
                                <?= $form->field($model, 'from_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="position-relative form-group">
                                <label for="notes">To Period</label>
                                <?= $form->field($model, 'to_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                <!-- <select class=" multiselect-dropdown form-control">
                                    <option>Sale Type</option>
                                </select>  -->
                            </div>
                        </div>
                    </div>
                    <div class="col-md-12 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>

                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card ">
        <div class="card-body row">

            <div class="col-md-6">
            <?= GridView::widget([
                'dataProvider' => $dataProvider1,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    

                    
                    [
                        'label'=>'Inflow',
                        'headerOptions' => [
                            'colspan' => '2',
                        ],
                        'attribute'=>'inflow',
                        'value'=>function($data){
                            $against_ledger =  array();
                            $all_ledgers = array();
                            $customer=Customer::find()->where(['id'=>$data->customer_name])->one();
                            if($customer)
                            {
                                return $customer->business_name;
                            }
                            else
                            {
                                  $against = DirectReceipt::find()->where(['receipt_id'=>$data->id])->all();
                                  foreach ($against as $key => $value) {
                                      $against_ledger[$key] = $value->ledger_id;
                                  }
                                  foreach ($against_ledger as $key => $val) {
                                      $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$val])->one();
                                       $all_ledgers[$key] = $ledger->ledger_id;
                                  }
                                  return implode(",",$all_ledgers);
                            }
                            
                            },
                            'footer'=>'Total',
                    ],
                    
                    [
                        'headerOptions' => [
                            'style' => 'display: none;',
                        ],
                        'attribute'=>'net_flow',
                        'value'=>function($data){
                            return $data->total_amount;
                        },
                        'footer'=>$total_inflow,
                    ],
                    

                ],
            ]); ?> 
            </div>
            <div class="col-md-6">

                        <?= GridView::widget([
                'dataProvider' => $dataProvider2,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    

                    
                    [
                        'label'=>'Outflow',
                        'headerOptions' => [
                            'colspan' => '2',
                        ],
                        'attribute'=>'inflow',
                        'value'=>function($data){
                            $against_ledger =  array();
                            $all_ledgers = array();
                            $vendor = Vendor::find()->where(['id'=>$data->vendor_id])->one();
                            if($vendor)
                            {
                                return $vendor->business_name;
                            }
                            else
                            {
                                $against = DirectPayment::find()->where(['payment_id'=>$data->payment_no])->all();
                                foreach ($against as $key => $value) {
                                    $against_ledger[$key] = $value->ledger_id;
                                }
                                foreach ($against_ledger as $key => $val) {
                                    $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$val])->one();
                                     $all_ledgers[$key] = $ledger->ledger_id;
                                }
                                return implode(",",$all_ledgers);
                            }
                            // return $data->vendor_id;
                        },
                        'footer'=>'Total',


                    ],
                    
                    [
                        'headerOptions' => [
                            'style' => 'display: none;',
                        ],
                        'attribute'=>'net_flow',
                        'value'=>function($data){
                            return $data->total_amount;
                        },
                        'footer'=>$total_outflow,
                    ],
                    

                ],
            ]); ?>
            </div>
            <table class="table table-striped table-bordered" >
            <tr>
					<td class="table_innerbg3"  width="25%"><b>Inflow Total</b></td>
					<td class="table_innerbg4" width="25%"><b><?=$total_inflow?></b></td>
					<td class="table_innerbg3" width="25%"><b>Outflow Total</b></td>
					<td class="table_innerbg4" width="25%"><b><?=$total_outflow?></b></td>
					</tr>
                    <tr>
						<td colspan="3" class="table_innerbg3 des08" width="70%" style="color:#FF0000"><b>Net Flow</b></td>
						<td class="table_innerbg4 des08" style="color:#FF0000"><b><?= $total_inflow-$total_outflow?></b></td>
					</tr>
            </table>

        </div>
    </div>
</div>
    <?php ob_start();?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function(){
            $('#search-report').toggle();
        });
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
