<?php

use yii\helpers\Html;
use yii\grid\GridView;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Compilation Stock Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    table,
    th,
    td {
        border: 1px solid black !important;
        border-collapse: collapse !important;

    }

    th,
    td {
        padding: 5px !important;
        text-align: left !important;
        color: black !important;

    }

    th {
        border: none;
        /* background-color: slategray; */
    }
</style>

<div class="row">

    <div class="col-md-12">
        <h4 style="text-align: center">Monthly Summary</h4>
        <?php if ($model->from_date != '' & $model->to_date != '') { ?>
            <p style="text-align: center">For period <?= Yii::$app->formatter->asDate($model->from_date, 'long'); ?> to <?= Yii::$app->formatter->asDate($model->to_date, 'long'); ?></p>
        <?php } ?>
    </div>
    <div style="width: 50%; float:left">
        <h4 style="text-align: center">Purchase</h4>
        <p><b>Name:</b><?= $product; ?> </p>
        <?= GridView::widget([
                        'dataProvider' => $dataProvider_1,
                        // 'showFooter' => true,
                        'footerRowOptions' => ['style' => 'font-weight:bold;'],
                        'options' => [
                            'class' => 'YourCustomTableClass',
                        ],
                        "id" => "grid",
                        'columns' => [
                            [
                                'label' => 'Date',
                                'attribute' => 'date',
                                'value' => function ($data) {
                                    return $data->date;
                                }
                            ],
                            [
                                'label' => 'Qty',
                                'attribute' => 'received_product_quantity',
                                'value' => function ($data) {
                                    return $data->received_product_quantity;
                                }
                            ],
                            [
                                'label' => 'Vch',
                                'attribute' => 'tan_id',
                                'value' => function ($data) {
                                    return $data->tan_id;
                                }
                            ],
                            [
                                'label' => 'Vendor',
                                'attribute' => 'business_name',
                                'value' => function ($data) {
                                    return $data->business_name;
                                }
                            ]
                           

                        ],
                    ]); ?>
    </div>
    <div style="width:50%; float: left; margin-left: 4%">
        <h4 style="text-align: center">Sale</h4>
        <?= GridView::widget([
                        'dataProvider' => $dataProvider_2,
                        'footerRowOptions' => ['style' => 'font-weight:bold;'],
                        'options' => [
                            'class' => 'YourCustomTableClass',
                        ],
                        "id" => "grid",
                        'columns' => [
                            [
                                'label' => 'Date',
                                'attribute' => 'date',
                                'value' => function ($data) {
                                    return $data->date;
                                }
                            ],
                            [
                                'label' => 'Qty',
                                'attribute' => 'delivered_product_quantity',
                                'value' => function ($data) {
                                    return $data->delivered_product_quantity;
                                }
                            ],
                            [
                                'label' => 'Vch',
                                'attribute' => 'tan_id',
                                'value' => function ($data) {
                                    return $data->tan_id;
                                }
                            ],
                            [
                                'label' => 'Customer',
                                'attribute' => 'business_name',
                                'value' => function ($data) {
                                    return $data->business_name;
                                }
                            ]
                           

                        ],
                    ]); ?>


    </div>

</div>


<?php ob_start(); ?>

<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>