<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use common\models\User;
use kartik\grid\GridView;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\GroupName;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$this->title = 'DailyCollectionReport';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>


.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.print_header{
    display:none;
}
@media print {
    .form-row{
        display:none!important ;
    }
		.dj-print-sec{
			display:none!important ;
		}
		.widget-content-wrapper{
			display:none!important ;	
		}
		.table-responsive{
			overflow:hidden;
		}
		.app-header__menu{
			display:none!important ;
		}
        .print_header{
        display:block;
        color:black;
        font-size: 15px;
        }
        .kv-grid-table{
            border: 2px solid #000;
        }
        .kv-table-wrap td {
    border: 2px solid #000!important;
}
.kv-table-wrap th {
    border: 2px solid #000!important;
}
	}
</style>

 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Daily Collection Report</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">

                                                  <?php if(Yii::$app->request->getQueryParams()){?>
                                                        <a href="<?=Url::current()?>&print=true" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Print</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?print=true" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Print</button></a>
                                                <?php } ?>
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                        <a href="<?=Url::current()?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <?php } ?>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
                        <div class="main-card mb-3 card">
        <div class="card-body">
            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
            <form>
                    <div class="form-row">
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">From</label>

                                <?= $form->field($model, 'from_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                <!-- <select class=" multiselect-dropdown form-control">
                                    <option>Sale Type</option>
                                </select>  -->
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">To</label>
                                <?= $form->field($model, 'to_date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control "])->label(false) ?>
                                <!-- <select class=" multiselect-dropdown form-control">
                                    <option>Sale Type</option>
                                </select>  -->
                            </div>
                        </div>
                        <div class="col-md-3 dj-btn-align djsec-text-left">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search']) ?>
                    </div>
                    <div class="col-md-3 dj-btn-align djsec-text-left">
                       <a  class="search_field_buttons"  href="<?=Url::base().'/reports/dailycollectionreport/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                    </div>
                        </div>
                        </form>
                        <?php ActiveForm::end(); ?>
        </div>
            </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
        <div class="print_header">
        <p style="text-align: center"><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong>
        <br>
        <br>ARABINDA MOHAPATRA<br>F2G/30, INDRADHANU MARKETIRC VILLAGE, <br>BHUBANESWAR</p>
        <p style="text-align: center"><strong>Daily Collection Report</strong><br>As on <?= $to_date ?></p>
        </div>                                              
    <table class="kv-grid-table table table-bordered table-striped kv-table-wrap"><thead>                                      
        <tr><th data-col-seq="0" style="width: 68.23%;">Payment Mode</th><th data-col-seq="1" style="width: 15.83%;">Receipt</th><th data-col-seq="2" style="width: 15.83%;">Payment</th></tr>
        </thead>
        <tbody>
            <?php 
            $total_payment=0;
            $total_receipt=0;
            ?>
            <?php foreach ($dataProvider->getModels() as $key => $val){?>
                <?php
                $total_payment+=$val['Payment'];
                $total_receipt+=$val['Receipt'];
                ?>
                <?php }?> 
                
        <?php foreach ($dataProvider->getModels() as $key => $data){ ?>
              <td><?= $data['Payment Mode'] ?></td>
              <td>

                <?php if($data['Payment']!=''){?>
                        <?= $data['Payment'] ?>
                  <?php } else { ?>
                        <?= "0.00" ?>
                  <?php } ?>

               </td>
              <td>
                <?php if($data['Receipt']!=''){?>
                        <?= $data['Receipt'] ?>
                  <?php } else { ?>
                        <?= "0.00" ?>
                  <?php } ?>        
              </td>           
        </tbody>
        <?php }?> 
        <td><b>Total</b></td>
        <td><b><?=number_format((float)$total_payment, 2, '.', '');?></b></td>
        <td><b><?= number_format((float)$total_receipt, 2, '.', '');?></b></td>

    </table>
    

      </div>
  </div>
</div>
<?php ob_start(); ?>                        
<script>
	<?php if ($print == 'true') {?>
        window.print();
        return false;
    <?php }?>
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>   
