<?php
/* @var $dataProvider yii\data\ActiveDataProvider */
/* @var $model backend\modules\reports\models\OverdueInvoiceReportSearch */

use yii\helpers\Html;
use yii\helpers\Url;
?>

<!DOCTYPE html>
<html>
<head>
    <title>Overdue Invoice Report</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 20px;
        }

        .report-header {
            text-align: center;
            margin-bottom: 30px;
        }

        .report-header h1 {
            margin: 0;
            font-size: 24px;
            color: #0a94c4;
        }

        .report-header p {
            margin: 5px 0;
            font-size: 16px;
        }

        table {
            width: 100%;
            border-collapse: collapse;
            margin-bottom: 20px;
        }

        table, th, td {
            border: 1px solid black;
        }

        th, td {
            padding: 8px;
            text-align: left;
        }

        th {
            background-color: #0a94c4;
            color: #fff;
        }

        .total {
            font-weight: bold;
        }

        .footer {
            text-align: center;
            font-size: 12px;
            margin-top: 30px;
        }
    </style>
</head>
<body>

<div class="report-header">
    <h1>Overdue Invoice Report</h1>
    <p>Company Name</p>
    <p>Company Address</p>
    <p>Report Date: <?= date('Y-m-d') ?></p>
</div>

<table>
    <thead>
        <tr>
            <?php if ($is_customer): ?><th>Customer</th><?php endif; ?>
            <?php if ($is_invoiceid): ?><th>Invoice ID</th><?php endif; ?>
            <?php if ($is_mobile): ?><th>Mobile</th><?php endif; ?>
            <?php if ($is_phone): ?><th>Phone</th><?php endif; ?>
            <?php if ($is_date): ?><th>Date</th><?php endif; ?>
            <?php if ($is_amt): ?><th>Amount</th><?php endif; ?>
            <?php if ($is_paidamt): ?><th>Paid Amount</th><?php endif; ?>
            <?php if ($is_unpaidamt): ?><th>Unpaid Amount</th><?php endif; ?>
            <?php if ($is_duedate): ?><th>Due Date</th><?php endif; ?>
            <?php if ($is_days): ?><th>Days</th><?php endif; ?>
            <?php if ($is_executives): ?><th>Executive</th><?php endif; ?>
            <?php if ($is_notes): ?><th>Notes</th><?php endif; ?>
            <?php if ($is_terms): ?><th>Terms</th><?php endif; ?>
            <?php if ($is_currentoutstanding): ?><th>Current Outstanding</th><?php endif; ?>
            <?php if ($is_overdue): ?><th>Overdue</th><?php endif; ?>
            <?php if ($is_totaloutstanding): ?><th>Total Outstanding</th><?php endif; ?>
        </tr>
    </thead>
    <tbody>
        <?php
        $total_qty = 0; // Initialize as needed
        foreach ($dataProvider->getModels() as $model):
            // Calculate totals if needed
            ?>
            <tr>
                <?php if ($is_customer): ?><td><?= Html::encode($model->customer_name) ?></td><?php endif; ?>
                <?php if ($is_invoiceid): ?><td><?= Html::encode($model->invoice_id) ?></td><?php endif; ?>
                <?php if ($is_mobile): ?><td><?= Html::encode($model->mobile) ?></td><?php endif; ?>
                <?php if ($is_phone): ?><td><?= Html::encode($model->phone) ?></td><?php endif; ?>
                <?php if ($is_date): ?><td><?= Html::encode($model->date) ?></td><?php endif; ?>
                <?php if ($is_amt): ?><td><?= Html::encode($model->amount) ?></td><?php endif; ?>
                <?php if ($is_paidamt): ?><td><?= Html::encode($model->paid) ?></td><?php endif; ?>
                <?php if ($is_unpaidamt): ?><td><?= Html::encode($model->pending) ?></td><?php endif; ?>
                <?php if ($is_duedate): ?><td><?= Html::encode($model->due_date) ?></td><?php endif; ?>
                <?php if ($is_days): ?><td><?= Html::encode($model->due_days) ?></td><?php endif; ?>
                <?php if ($is_executives): ?><td><?= Html::encode($model->executive) ?></td><?php endif; ?>
                <?php if ($is_notes): ?><td><?= Html::encode($model->notes) ?></td><?php endif; ?>
                <?php if ($is_terms): ?><td><?= Html::encode($model->terms) ?></td><?php endif; ?>
                <?php if ($is_currentoutstanding): ?><td><?= Html::encode($model->pending) ?></td><?php endif; ?>
                <?php if ($is_overdue): ?><td><?= Html::encode($model->pending) ?></td><?php endif; ?>
                <?php if ($is_totaloutstanding): ?><td><?= Html::encode($model->pending) ?></td><?php endif; ?>
            </tr>
        <?php endforeach; ?>
    </tbody>
</table>

<div class="footer">
    <p>&copy; <?= date('Y') ?> Company Name. All rights reserved.</p>
</div>

</body>
</html>
