<?php

use yii\helpers\Html;
// use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\CustomerType;
use common\models\User;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Product;
use backend\modules\master\models\Category;
use backend\modules\master\models\PurchaseOrder;
use yii\grid\GridView;
use backend\modules\users\models\PurchaseBill;
use backend\modules\users\models\PurchasePayment;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Outstanding Expense';
$this->params['breadcrumbs'][] = $this->title;
$category=Category::find()->all();
$users=ArrayHelper::map(User::find()->all(),'id','username');


$gtotal =0;
$paid_amount = 0;
$pending_amount =0;
$totalsum =0;
$paidsum =0;
$pendingsum =0;
if (!empty($dataProvider->getModels())) {   
    foreach ($dataProvider->getModels() as $key => $val) {
        

        if($val->bill_id!='')
        {
            $bill = PurchaseBill::find()->where(['id'=>$val->bill_id])->one();
            $payment = PurchasePayment::find()->where(['against_bill'=>$bill->id])->all();
            

            //FOR OVERALL TOTAL
            $gtotal = $gtotal+$bill->total;
            $totalsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$gtotal);

            //FOR OVERALL PAID TOTAL
            $paid_amount = $paid_amount+($bill->total-($bill->pending_amount));
            $paidsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$paid_amount);
            
            //FOR OVERALL OTHERS CHARGES TOTAL
            $pending_amount = $pending_amount+$bill->pending_amount;
            $pendingsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$pending_amount);

        }
        else
        {
            //FOR OVERALL TOTAL
            $gtotal = $gtotal+$val->amount;
            $totalsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$gtotal);

            //FOR OVERALL PAID TOTAL
            $paid_amount = $paid_amount+$val->paid_amount;
            $paidsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$paid_amount);

            //FOR OVERALL OTHERS CHARGES TOTAL
            $pending_amount = $pending_amount+($val->amount-$val->paid_amount);
            $pendingsum = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$pending_amount);
        }

        

    }
}


?>
<style>
	.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>











<div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Purchase Outstanding Expense</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                                <div class="djsec-text-right dj-print-sec">
                                                                       
                                                                       

                                                                       <?php if(Yii::$app->request->getQueryParams()){?>
                                                                    <a href='' data-toggle="modal" data-target="#pe" >  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print&nbsp;/&nbsp;<i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel&nbsp;/&nbsp;<i class="fa fa-file-pdf-o" aria-hidden="true"></i> Pdf</button></a>
                                                                <?php } else{ ?>
                                                                    <a href='' data-toggle="modal" data-target="#pe" >  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print &nbsp;/&nbsp;<i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel&nbsp;/&nbsp;<i class="fa fa-file-pdf-o" aria-hidden="true"></i> Pdf</button></a>
                                                                <?php } ?>


                                                                       
								                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           
                           <div class="row dj-adv-search-row">
                           <div class="col-md-11">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/reports/purchase-outstanding-expense/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>
                              <div class="dj-sale-form collapse" id="search-report">
                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                    <form>
                                        <!--  -->
                                        <div class="form-row">
                                        
                                        <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From Date</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['type'=>'date','class'=>"form-control from_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To Date</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['type'=>'date','class'=>"form-control to_date_val"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Vendor</label>
                                                    

                                                    <?php if($model->vendor!=''){?>

                                                    <?php $customer=Vendor::find()->where(['business_name'=>$model->vendor])->one()?>
                                                   <?=$form->field($model, 'vendor')->dropDownList([$model->vendor=>$customer->business_name], ['options' => [$model->vendor => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "vendor form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'vendor') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control vendor",])->label(false)?>            
                                                   <?php } ?>
                                                </div>
                                            </div>

                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Settings</label>
                                                    
                                                   <?= $form->field($model, 'setting')
                                                        ->dropDownList([ 
                                                        'Tax Bill'=>'Tax Bill'],['prompt'=>'--Select--','class'=>'form-control setting select_class'])->label(false) ?>
                                                </div>
                                            </div>

                                             <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Order By</label>
                                                   
                                                     <?= $form->field($model, 'sort') ->dropDownList(['name.asc'=>'Vendor Name ASC','name.desc'=>'Vendor Name DESC','duedays.asc'=>'Due Days ASC','duedays.desc'=>'Due Days DESC'],['prompt'=>'--Select--','class' => " select_class form-control",])->label(false)?>    
                                                </div>
                                            </div>

                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Over due days crossed</label>
                                                   
                                                     <?= $form->field($model, 'due_days') ->dropDownList(['7days'=>'7 days','10days'=>'10 days','15days'=>'15 days','30days'=>'30 days','45days'=>'45 days','60days'=>'60 days','75days'=>'75 days','90days'=>'90 days','120days'=>'120 days','120days>'=>'120 days above'],['prompt'=>'--Select--','class' => " select_class form-control",])->label(false)?>    
                                                </div>
                                            </div>
                                            
                                            
                                            <div class="col-md-12 dj-btn-align" style="padding-top: 5px">
                                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                                            </div>
                                        </div>
                                      </form>
                                      <?php ActiveForm::end(); ?>
                                      </div>  
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                       
                         <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                // 'filterModel' => $searchModel,
                                'showFooter' => true,
                                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                                "id" => "grid",
                                'columns' => [
                                	[
                                        'label'=>'Vendor/Catagory',
                                        'attribute'=>'vendor_category',
                                        'value'=>function($data)
                                        {
                                            return $data->vendor_category;
                                        },
                                        'footer' => 'Total(Rs)',
                                    ],
                                    [
                                        'label'=>'Bill#',
                                        'attribute'=>'bill_id',
                                        'value'=>function($data)
                                        {
                                            return $data->vendor_bill_no;
                                        },
                                    ],
                                    [
                                        'label' => 'Date',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        'attribute' => 'date',
                                        'value' => function ($data) { 
                                        if($data->date!='')   
                                            return date('d/m/Y', strtotime($data->date));
                                    },
                                    ],
                                    
                                    [
                                        'label'=>'Amount',
                                        'attribute'=>'amount',
                                        'value'=>function($data)
                                        {
                                           if($data->bill_id!='')
                                           {
                                               
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->total);
                                                return $num;
                                           }
                                           else
                                           {
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->amount);
                                                return $num;
                                           }
                                            

                                        },
                                        'footer' => $totalsum,
                                    ],
                                    [
                                        'label'=>'Paid Amount',
                                        'attribute'=>'paid_amount',
                                        'value'=>function($data)
                                        {
                                            if($data->bill_id!='')
                                            {
                                              
                                                
                                                $total = $data->total-($data->pending_amount);  
                                                return number_format($total,2);
                                            }
                                            else
                                            {
                                                if($data->paid_amount!='')
                                                {
                                                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->paid_amount);
                                                 return $num;
                                                }
                                                else
                                                  return '0.00';
                                            }
                                        			
                                        },
                                        'footer' =>$paidsum,
                                    ],
                                    [
                                        'label'=>'Pending Amount',
                                        'value'=>function($data)
                                        {
                                            if($data->bill_id!='')
                                            {
                                              return $data->pending_amount;
                                            }
                                            else
                                            {
                                                $finalamount = number_format((float)($data->amount-$data->paid_amount), 2, '.', '');
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$finalamount);
                                                return $num; 
                                            }
                                            
                                              

                                        },
                                        'footer' =>$pendingsum,
                                    ],
                                    [
                                        'label'=>'Overdue Days Crossed',
                                        
                                        'value'=>function($data)
                                        {
                                            if($data->due_date!='')
                                            {
                                            	$today= time();
							                    $date = strtotime($data->due_date);
							                    $diff= $date-$today;
							                    $age = floor($diff/(60*60*24)).' Days';
						                        if($age<0)
                                                {
                                                    $final_age = -1 * (int)$age ;
						                            return (int) $final_age;
                                                }
                                                else
                                                    return '0';
                                            }
                                            else
                                            	return '0'; 
                                        },
                                    ],
                                    [
                                        'label'=>'Status',
                                        'format'=>'raw',
                                        'value'=>function($data)
                                        {
                                            if($data->bill_id!='')
                                            {
                                                
                                                    if(($data->pending_amount)==0)
                                                       {
                                                        return '<span class="label-paid">PAID</span>';
                                                    }
                                                    //    else if($total<$data->total && $total!=0)
                                                       else if(($data->total-($data->pending_amount))>0)
                                                       {
                                                        return '<span class="label-partial">PARTIAL</span>';
                                                    }
                                                    //    else if($total==0)
                                                       else if($data->total==($data->pending_amount))
                                                       {
                                                        return '<span class="label-draft">PENDING</span>';
                                                    }
                                            }
                                            

                                        },
                                    ],
                                     [
                                            'label' => 'Action',
                                            // 'attribute' => 'username',
                                            'headerOptions' => ['style' => 'color:#495057'],
                                            'format'=>'raw',
                                            'contentOptions'=>[ 'style'=>'width: 35px'],
                                            'value' => function ($data) {
                                                if($data->bill_id!='')
                                                {
                                                                    return '<div class="d-inline-block dropdown">
                                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                            <ul class="nav flex-column">
                                                            <li class="nav-item">
                                                                    <a class="nav-link" target=.blank href='.Url::base().'/users/purchase-bill/view?id='.$data->bill_id.' data-method=post>
                                                                       <i class="fa fa-eye"></i>
                                                                        <span class="dj-icon-gap">  View</span>
                                                                    </a>
                                                                </li>
                                                                
                                                            </ul>
                                                        </div>
                                                    </div>';
                                                }
                                                else
                                                {
                                                    return '<div class="d-inline-block dropdown">
                                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                            <ul class="nav flex-column">
                                                            <li class="nav-item">
                                                                    <a class="nav-link" href=# data-method=post>
                                                                       <i class="fa fa-eye"></i>
                                                                        <span class="dj-icon-gap">  View</span>
                                                                    </a>
                                                                </li>
                                                                
                                                            </ul>
                                                        </div>
                                                    </div>';
                                                }
                                                
                                            },
                                        ],
                                    
                            ],
                                   
                            ]); ?>

                        </div>
                    </div>
                </div>

<div class="modal fade" id="pe" >
    <div class="modal-dialog modal-md" >
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content" >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Choose the fields </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <div class="col-md-12">
                      <div class="position-relative form-group">
                        <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'is_vendor')->checkBox(['label' =>'','class'=>'customer'])->label('Vendor') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'vendor_mobile')->checkBox(['label' =>'','class'=>'customer'])->label('Vendor No.') ?>
                            </div>
                      </div> 
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_date')->checkBox(['label' =>'','class'=>'customer'])->label('Bill Date') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_referance')->checkBox(['label' =>'','class'=>'customer'])->label('Bill Ref.') ?>
                            </div>
                      </div>  
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_amount')->checkBox(['label' =>'','class'=>'customer'])->label('Bill Amt.') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_paid_amount')->checkBox(['label' =>'','class'=>'customer'])->label('Ant. Paid') ?>
                            </div>
                      </div> 
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_unpaid_amount')->checkBox(['label' =>'','class'=>'customer'])->label('Unpaid Amt.') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_bue_date')->checkBox(['label' =>'','class'=>'customer'])->label('Due date') ?>
                            </div>
                      </div> 
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_days')->checkBox(['label' =>'','class'=>'customer'])->label('Days') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_notes')->checkBox(['label' =>'','class'=>'customer'])->label('Notes') ?>
                            </div>
                      </div> 
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_terms')->checkBox(['label' =>'','class'=>'customer'])->label('Terms') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_current_outstanding')->checkBox(['label' =>'','class'=>'customer'])->label('Current Outstanding') ?>
                            </div>
                      </div> 
                      <div style="width: 100%">
                            <div style="width: 50%; float: left;" >
                                <?= $form->field($model, 'bill_over_due')->checkBox(['label' =>'','class'=>'customer'])->label('Over Due') ?>
                            </div>
                            <div style="width: 50%; float: left;">
                                <?= $form->field($model, 'bill_total_outstanding')->checkBox(['label' =>'','class'=>'customer'])->label('Total Outstanding') ?>
                            </div>
                      </div> 
                         
                    </div>
                          
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::submitButton('<i class="fa fa-print" aria-hidden="true"></i> Print', ['class' => 'btn dj-blue-btn submit-btn' , 'value'=>'export_print', 'name'=>'print','formtarget' => '_blank']) ?>
                    <?= Html::submitButton('<i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel', ['class' => 'btn dj-blue-btn submit-btn', 'value'=>'export_excel', 'name'=>'excel']) ?>
                     <?= Html::submitButton('<i class="fa fa-file-excel-o" aria-hidden="true"></i> PDF', ['class' => 'btn dj-blue-btn submit-btn', 'value'=>'export_pdf', 'name'=>'pdf']) ?>
                    <a href="" class="btn dj-red-btn" data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>

<?php ob_start();?>
 <script type="text/javascript">
$(function() {
$('.select_class').select2();  
$('.vendor_catagory').select2();  
$('#advance-search').click(function(){
    $('#search-report').toggle();
});
    $('.vendor').select2({
        ajax: { 
        url: "vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.searchproduct').select2({
        ajax: { 
        url: "productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
