<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use common\models\User;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\GroupName;
use backend\modules\master\models\AccountType;
use backend\modules\users\models\AccountingDetails;
use backend\modules\reports\models\VendorLedgerDetails;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Vendor Ledger';
$this->params['breadcrumbs'][] = $this->title;
$group=GroupName::find()->all();
$type = AccountType::find()->all();
$vendor_items = ArrayHelper::map(Vendor::find()->all(), 'business_name', 'business_name');
?>
<style>
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>

<div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Purchase Vendor Ledger</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                                <div class="djsec-text-right dj-print-sec">
                                                                       
                                                                        <?php if(Yii::$app->request->getQueryParams()){?>
                                                                        <a href="<?=Url::current()?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel</button></a>
                                                                    <?php } else{ ?>
                                                                        <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel</button></a>
                                                                    <?php } ?>


                                                                    <?php if(Yii::$app->request->getQueryParams()){?>
                                                                     <!--    <a href="<?=Url::current()?>&detailexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Detailed Excel</button></a> -->
                                                                    <?php } else{ ?>
                                                                      <!--   <a href="<?=Url::current()?>?detailexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Detailed Excel</button></a>-->
                                                                    <?php } ?>

                                                                   

                                                                    <?php if(Yii::$app->request->getQueryParams()){?>
                                                                        <a href="<?=Url::current()?>&detailprint=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Detailed PDF</button></a>
                                                                    <?php } else{ ?>
                                                                        <a href="<?=Url::current()?>?detailprint=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Detailed PDF</button></a>
                                                                    <?php } ?>

                                                					<?php if(Yii::$app->request->getQueryParams()){?>
								                                        <a href="<?=Url::current()?>&print=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Ledgers Pdf</button></a>
								                                    <?php } else{ ?>
								                                    	<a href="<?=Url::current()?>?print=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Ledgers Pdf</button></a>
								                                    <?php } ?>
								                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div> 
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           	<?php $form = ActiveForm::begin(['method' => 'get']); ?>
                           <div class="row dj-adv-search-row">
                           	<div class="col-md-5">
                               <div class="position-relative form-group">
                                  <?= $form->field($searchModel, 'business_name')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Ledger Name"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                                <button type="submit" class="search_field_buttons"><i class="fa fa-search"></i> Search</button>
                            </div>
                           <?php ActiveForm::end(); ?>
                           <div class="col-md-4">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/reports/purchase-vendor-ledger/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>
                            <div class="dj-sale-form collapse" id="search-report">
                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                <form>
                                    <div class="form-row">
                                        

					<div class="col-md-3">
                                            <div class="position-relative form-group">
                                                <label for="notes">Vendor Name</label>
                                              
                                                <?= $form->field($searchModel, 'bs_name')->dropDownList($vendor_items, ['prompt' => '-Select Vendor-', 'class' => 'select form-control select_class'])->label(false) ?>
                                            </div>
                                        </div>

                                        <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From Date</label>
                                                    <?= $form->field($searchModel, 'from_date')->textInput(['type'=>'date','class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To Date</label>
                                                    <?= $form->field($searchModel, 'to_date')->textInput(['type'=>'date','class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Type</label>
                                                    
                                                   <?=$form->field($searchModel, 'type')->dropDownList(ArrayHelper::map($type,'account_type_id','account_name'), ['prompt' => '--Select--', 'class' => "form-control type select_class", 'maxlength' => true])->label(false)?>                                    
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Group</label>

                                                         <?=$form->field($searchModel, 'group')->dropDownList(ArrayHelper::map($group,'group_name_id','name_group'), ['prompt' => '--Select--', 'class' => "form-control group select_class", 'maxlength' => true])->label(false)?>
    
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Sort by</label>
                                                    
                                                   <?= $form->field($searchModel, 'sort_by')
                                                                       ->dropDownList(['Acc ID Asc'=>'Acc ID Asc', 
                                                                                       'Acc ID Desc'=>'Acc ID Desc',
                                                                                   ],['prompt'=>'--Select--','class'=>'form-control sort_by select_class'])->label(false) ?> 
                                                </div>
                                            </div>
                                             <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Ledger Balance</label>
                                                    
                                                   <?= $form->field($searchModel, 'balance')
                                                                       ->dropDownList(['Zero Balance'=>'Zero Balance', 
                                                                                       'Non-zero Balance'=>'Non-zero Balance',
                                                                                   ],['prompt'=>'--Select--','class'=>'form-control balance select_class'])->label(false) ?> 
                                                </div>
                                            </div>
                                            
                                            <div class="col-md-6 dj-btn-align" style="padding-top: 5px">
                                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                                            </div>
                                        
                                    </div>
                                </form>
                            <?php ActiveForm::end(); ?>
                            </div>  
                            </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                       
                                <?= GridView::widget([
                                'dataProvider' => $dataProvider,
              //                   'showFooter' => true,
        						// 'footerRowOptions'=>['style'=>'font-weight:bold;'],
                                "id" => "grid",
                                'columns' => [
				                    [
				                      'label'=>'Ledger Name',
                                       'format'=>'raw',
				                        'value' => function ($data)  use($searchModel) { 
                                            $vendor = Vendor::find()->where(['business_name'=>$data->business_name])->one();
                                            if($vendor)
					    {
						if($searchModel->from_date != '' && $searchModel->to_date !='')
                                                    {
                                                        $vendor_details = '<a class="nav-link" href=' . Url::base() . '/reports/purchase-vendor-ledger/vendordetails?id=' . "$vendor->id" . '&fromdate=' . "$searchModel->from_date" . '&todate=' . "$searchModel->to_date" . ' data-method=post>' . $data->business_name . ' </a>';
                                                    }
                                                    else{
                                                        $vendor_details = '<a class="nav-link" href=' . Url::base() . '/reports/purchase-vendor-ledger/vendordetails?id=' . "$vendor->id" . ' data-method=post>' . $data->business_name . ' </a>';
                                                    }
					    }
   //                                            $vendor_details = '<a class="nav-link" href='.Url::base().'/reports/purchase-vendor-ledger/vendordetails?id='."$vendor->id".' data-method=post>'.$data->business_name.' </a>';
                                            //  $vendor_details = $data->ledgerhead_id;
                                            else
                                              $vendor_details = $data->ledgerhead_id;
				                            return $vendor_details;
				                          },
				                    ],
                                	[
                                    	'label'=>'Debit (Rs)',
                                        'headerOptions'=>[ 'style'=>'text-align:right'],
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                    	'value' => function ($data) use($searchModel){ 
                                            if($searchModel['from_date']!='' && $searchModel['to_date']!='')
                                            {
                                                $vendor = Vendor::find()->where(['business_name'=>$data->business_name])->one();
                                                $debit = VendorLedgerDetails::find() ->andFilterWhere(['in', 'vendor',$vendor->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                                $credit = VendorLedgerDetails::find() ->andFilterWhere(['in', 'vendor',$vendor->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                                $debit_amount = 0;
                                                $credit_amount = 0;
                                                foreach ($debit as $key => $value) {
                                                    $debit_amount = $debit_amount + $value->debit_amount;
                                                }
                                                foreach ($credit as $key => $value) {
                                                    $credit_amount = $credit_amount + $value->credit_amount;
                                                }
                                                if (($debit_amount - $credit_amount) > 0) {
                                                    return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($debit_amount - $credit_amount), 2, '.', '')));
                                                } else {
                                                    return '0.00';
                                                }
                                            }
                                            else
                                            {
                                                if($data->total_credit_amount-$data->total_debit_amount<0)
                                                {
                                                    return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)(-1*($data->total_credit_amount-$data->total_debit_amount)), 2, '.', '')));
                                                }
                                                else{
                                                    return "0.00";
                                                }
                                                // return $data->total_credit_amount-$data->total_debit_amount;
                                                // return $data->total_debit_amount;
                                            }
                                        },
                                    ],
                                    [
                                    	'label'=>'Credit (Rs)',
                                        'headerOptions'=>[ 'style'=>'text-align:right'],
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                    	'value' => function ($data) use($searchModel){ 


                                            if($searchModel['from_date']!='' && $searchModel['to_date']!='')
                                            {
                                                $vendor = Vendor::find()->where(['business_name'=>$data->business_name])->one();
                                                $debit = VendorLedgerDetails::find() ->andFilterWhere(['in', 'vendor',$vendor->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                                $credit = VendorLedgerDetails::find() ->andFilterWhere(['in', 'vendor',$vendor->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                                $debit_amount = 0;
                                                $credit_amount = 0;
                                                foreach ($debit as $key => $value) {
                                                    $debit_amount = $debit_amount + $value->debit_amount;
                                                }
                                                foreach ($credit as $key => $value) {
                                                    $credit_amount = $credit_amount + $value->credit_amount;
                                                }
                                                if (($credit_amount - $debit_amount) > 0) {
                                                    $a_amt = $credit_amount - $debit_amount;
                                                    if ($a_amt < 0)
                                                        $a_amt = -1 * ($a_amt);
                
                                                    $ac_amount =  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($a_amt), 2, '.', '')));
                                                    if ($ac_amount > 0)
                                                        return $ac_amount;
                                                    else
                                                        return ($ac_amount);
                                                } else {
                                                    return '0.00';
                                                }
                                            }
                                            else
                                            {
                                                if($data->total_credit_amount-$data->total_debit_amount>0)
                                                {
                                                    return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)(($data->total_credit_amount-$data->total_debit_amount)), 2, '.', '')));
                                                }
                                                else{
                                                    return "0.00";
                                                }
                                                // return $data->total_credit_amount-$data->total_debit_amount;
                                                // return $data->total_credit_amount;
                                            }
                                        },
                                    	

                                    ],
                                    
                                    
                                    ],
                            ]); ?>
                        </div>
                    </div>
                </div>


<?php ob_start();?>
 <script type="text/javascript">
    $(function() {
		$('#advance-search').click(function(){
        $('#search-report').toggle();
    });
        $('.select_class').select2();		
        $('form').on('beforeSubmit', function() {
            $(this).find('input[name="page"]').val(1);
        });
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>

