<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\master\models\Product;
use backend\modules\users\models\SaleOrder;
use backend\modules\users\models\AccountingDetails;
use backend\modules\users\models\PurchaseBill;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;
use backend\modules\users\models\PurchasePayment;
use backend\modules\users\models\CreditNote;
use backend\modules\users\models\DebitNote;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\users\models\AccountingJournal;
use backend\modules\reports\models\VendorLedgerDetails;
$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id' => $id])->one();

$settingtypes = GenericTemplate::find()->where(['template_for' => 'Invoice'])->all();
$invsettinglist = ArrayHelper::map($settingtypes, 'gt_id', 'template_name');


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\InvoiceSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Accounts';
$this->params['breadcrumbs'][] = $this->title;

$debit_total = 0;
$credit_total = 0;
?>
<style>
    .select2-container .select2-selection--single {
        height: 42px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    .add_product .select2-selection__rendered {
        width: 220px !important;
    }

    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
</style>

<?php if (Yii::$app->session->hasFlash('success')) { ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success'); ?></strong>
    </div>
<?php } ?>
<?php if (Yii::$app->session->hasFlash('error')) : ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success"><?php echo $user ?> Account</div>
                                        </div>
                                        <div class="widget-content-right">

                                            <a href="<?= Url::base(); ?>/reports/purchase-vendor-ledger/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">

            <div class="col-md-12" style="display:flex ; justify-content:space-between;">

                <!-- <a id="advance-search" class="btn btn-rounded dj-adv-search" data-toggle="collapse" href="#search-invoice" role="button" aria-expanded="false" aria-controls="search-invoice">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a> -->
                <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                <a class="search_field_buttons" href="<?= Url::base() . '/reports/purchase-vendor-ledger/vendordetails?id=' . $vendor_id . '' ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'> <i class="fa fa-refresh" aria-hidden="true"></i></a>

            </div>
            <!-- <div class="col-md-1">

                <a  class="search_field_buttons"  href="<?= Url::base() . '/users/invoice/index' ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'> <i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>

            </div> -->

            <div class="dj-sale-form collapse" id="search-invoice">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                    <div class="form-row">

                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">From</label>
                                <?= $form->field($model, 'details_from_date')->textInput(['type' => "date", 'class' => "form-control "])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">To</label>
                                <?= $form->field($model, 'details_to_date')->textInput(['type' => "date", 'class' => "form-control tcal"])->label(false) ?>
                            </div>
                        </div>
                        <!-- <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Type</label>
                                                    

                      
                                                   
                                                
                                                </div>
                                                
                                            </div> -->
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Vehicle Type</label>
                                <?= $form->field($model, 'details_type')->dropDownList(['Debit Note' => 'Debit Note', 'Credit Note' => 'Credit Note', 'Bill' => 'Purchase Bill', 'Payment' => 'Payment'], ['prompt' => 'Select Option', 'class' => 'select_type'])->label(false) ?>
                            </div>
                        </div>
                        <!-- <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Invoice Type</label>
                                                     <select class="multiselect-dropdown form-control">
                                                        <option value="4">Select a Type</option>
                                                        <option value="0">CREDIT</option>
                                                        <option value="1">CASH</option>
                                                        <option value="2">CARD</option>
                                                        <option value="3">SAMPLE</option>
                                                    </select>
                                                </div>
                                                
                                            </div> -->

                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="date">Users</label>
                                <?= $form->field($model, 'details_user')->dropDownList(ArrayHelper::map(LeadExecutive::find()->select(['name', 'id'])
                                    ->orderBy('name')
                                    ->asArray()
                                    ->all(), 'name', 'name'), ['prompt' => 'Select User', 'class' => "executives_name form-control "])->label(false) ?>
                            </div>

                        </div>

                        <!-- <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Referance</label>
                                                   <?= $form->field($model, 'details_ref')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                            </div> -->
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Total Amount From</label>
                                <?= $form->field($model, 'details_total_from')->textInput(['maxlength' => true, 'type' => 'number', 'min' => 1, 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Total Amount To</label>
                                <?= $form->field($model, 'details_total_to')->textInput(['maxlength' => true, 'type' => 'number', 'min' => 1, 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-12 dj-btn-align" style="padding-top: 5px">
                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search', 'style' => "padding: 9px 21px"]) ?>
                        </div>
                    </div>
                </form>
                <?php ActiveForm::end(); ?>
            </div>

        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row">

                <div class="col-sm-6">
                    <div class="djsec-text-left dj-print-sec">

                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="djsec-text-right dj-print-sec">


                        <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/users/invoice/excel-export'])->one() != '') { ?>
                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                              <!--  <a href="<?= Url::current() ?>&totalexcel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                                 <a href="<?= Url::current() ?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a> -->
                            <?php } else { ?>
                               <!--   <a href="<?= Url::current() ?>?totalexcel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                               <a href="<?= Url::current() ?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a> -->
                            <?php } ?>
                        <?php } else { ?>

                        <?php } ?>

                        <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/users/invoice/index'])->one() != '') { ?>
                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                 <a href="<?= Url::current() ?>&printpdf=true" data-method="post" target='_blank'> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Download PDF</button></a>
                            <?php } else { ?>
                                 <a href="<?= Url::current() ?>?printpdf=true" data-method="post" target='_blank'> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Download PDF</button></a>
                            <?php } ?>
                        <?php } else { ?>
                            
                        <?php } ?>

                    </div>
                </div>

            </div>

            <table class="kv-grid-table table table-bordered table-striped kv-table-wrap">
                <thead>

                    <tr>
                        <th data-col-seq="0">Date</th>
                        <th data-col-seq="0">Vch No.</th>
                        <th data-col-seq="0">Description</th>
                        <th data-col-seq="0">Vch Type</th>
                        <th data-col-seq="0">Notes</th>
                        <th data-col-seq="1">Debit Amount</th>
                        <th data-col-seq="2">Credit Amount</th>
                        <th data-col-seq="0">Action</th>
                    </tr>

                    </tr>

                </thead>
                <tbody>

                    <tr class="w1" data-key="0">
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0">Opening</td>
                        <td class="w1" data-col-seq="1" style="text-align:right"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 0.00) ?></td>
                        <td class="w1" data-col-seq="2" style="text-align:right"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 0.00)  ?></td>
                        <td class="w1" data-col-seq="0"></td>
                    </tr>
                    <?php if (!empty($dataProvider->getModels())) { ?>
                        <?php $group = '' ?>


                        <?php foreach ($dataProvider->getModels() as $key => $data) : ?>
                            <?php if ($data['vch_type'] == 'Bill') { ?>
                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        // $bill = PurchaseBill::find()->where(['id' => $data['vch_no']])->one();
                                        echo $data['vch_no'];
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = PurchaseBill::find()->where(['full_bill_name' => $data['vch_no']])->one();
                                        if ($bill->igst == null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable';
                                        }

                                        if ($bill->igst != null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable';
                                        }
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = PurchaseBill::find()->where(['full_bill_name' => $data['vch_no']])->one();
                                        echo $bill->notes;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="1" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="2" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])
                                        ?>
                                        <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                        $bill = PurchaseBill::find()->where(['full_bill_name' => $data['vch_no']])->one();
                                        echo '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">  <li class="nav-item">
                                            <a class="nav-link" href=' . Url::base() . '/users/purchase-bill/view?id=' . $bill->id . ' target=_blank data-method=post>
                                               <i class="fa fa-eye"></i>
                                                <span class="dj-icon-gap">View</span>
                                            </a>
                                        </li>  </ul></div></div>' ?>

                                    </td>

                                </tr>
                            <?php } elseif ($data['vch_type'] == 'Payment') { ?>

                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        // $bill = PurchasePayment::find()->where(['id' => $data['vch_no']])->one();
                                        $str = rtrim($data['vch_no'], 'p');
				        $start = strpos($data['vch_no'], '/') + 1;
                                        $result = substr($data['vch_no'], $start);
                                        $str = trim($str, "P!");
                                        $str = substr($str, 0, strpos($str, '/'));
                                        echo $data['vch_no'];
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                       // $bill = PurchasePayment::find()->where(['id' =>$str])->one();
					$bill = PurchasePayment::find()->where(['payment_no' =>trim($str)])->andWhere(['suffix' =>$result])->one();
					

                                          echo $bill->payment_mode;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php


                                       // $bill = PurchasePayment::find()->where(['id' => $str])->one();
					$bill = VendorLedgerDetails::find()->where(['vch_no' => $data['vch_no']])->one();
                                        echo $bill->notes;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="1" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount']) ?>
                                        <?php $debit_total = $debit_total + $data['debit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="2" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount']) ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                       // $bill = PurchasePayment::find()->where(['id' => $str])->one();
					$bill = PurchasePayment::find()->where(['payment_no' =>trim($str)])->andWhere(['suffix' =>$result])->one();
                                        echo '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">  <li class="nav-item">
                                            <a class="nav-link" href=' . Url::base() . '/users/purchase-payment/view?id=' . $bill->id . ' target=_blank data-method=post>
                                               <i class="fa fa-eye"></i>
                                                <span class="dj-icon-gap">View</span>
                                            </a>
                                        </li>  </ul></div></div>' ?>

                                    </td>
                                </tr>

                            <?php } elseif ($data['vch_type'] == 'Debit Note') { ?>

                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = DebitNote::find()->where(['LIKE', 'full_debit_id', $data['vch_no']])->one();
                                        echo $bill->full_debit_id;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = DebitNote::find()->where(['LIKE', 'full_debit_id', $data['vch_no']])->one();
                                        if ($bill->igst == null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable';
                                        }

                                        if ($bill->igst != null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable';
                                        }
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = DebitNote::find()->where(['LIKE', 'full_debit_id', $data['vch_no']])->one();
                                        echo $bill->notes;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="1" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])  ?>
					<?php $debit_total = $debit_total + $data['debit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="2" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])  ?>
                                        <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                        $bill = DebitNote::find()->where(['LIKE', 'full_debit_id', $data['vch_no']])->one();
                                        echo '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">  <li class="nav-item">
                                            <a class="nav-link" href=' . Url::base() . '/users/debit-note/view?id=' . $bill->id . ' target=_blank data-method=post>
                                               <i class="fa fa-eye"></i>
                                                <span class="dj-icon-gap">View</span>
                                            </a>
                                        </li>  </ul></div></div>' ?>

                                    </td>
                                </tr>


                            <?php } elseif ($data['vch_type'] == 'Credit Note') { ?>

                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = CreditNote::find()->where(['LIKE', 'credit_note_id', $data['vch_no']])->one();
                                        echo $bill->credit_note_id;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = CreditNote::find()->where(['LIKE', 'credit_note_id', $data['vch_no']])->one();
                                        if ($bill->igst_amount == null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off_amount != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off_amount == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off_amount != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>CGST Payable<br>SGST Payable';
                                        }

                                        if ($bill->igst_amount != null) {
                                            if ($bill->is_tcs == 1 && $bill->round_off_amount != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount<br>Round off';
                                            elseif ($bill->is_tcs == 1 && $bill->round_off_amount == '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>TCS Amount';
                                            elseif ($bill->is_tcs == 0 && $bill->round_off_amount != '')
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable<br>Round off';
                                            else
                                                echo $result =  '<br>Purchases - Registered Dealer<br>IGST Payable';
                                        }
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = CreditNote::find()->where(['LIKE', 'credit_note_id', $data['vch_no']])->one();
                                        echo $bill->notes;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="1" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])  ?>
                                        <?php $credit_total = $credit_total + $data['debit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="2" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])  ?>
                                        <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                        $bill = CreditNote::find()->where(['LIKE', 'credit_note_id', $data['vch_no']])->one();
                                        echo '<div class="d-inline-block dropdown">
        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
            <ul class="nav flex-column">  <li class="nav-item">
            <a class="nav-link" href=' . Url::base() . '/users/debit-note/view?id=' . $bill->id . ' target=_blank data-method=post>
               <i class="fa fa-eye"></i>
                <span class="dj-icon-gap">View</span>
            </a>
        </li>  </ul></div></div>' ?>

                                    </td>
                                </tr>


                            <?php } elseif ($data['vch_type'] == 'Journal' && $data['vendor'] != NULL) { ?>

                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $str = ltrim($data['vch_no'], 'J');
                                        $bill = AccountingJournal::find()->where(['=', 'jv_no', $str])->one();
                                        echo $bill->prefix . $bill->jv_no;
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = AccountingJournal::find()->where(['=', 'jv_no', $str])->one();
                                        echo $result =  '<br>Sales-Transfered Amount';
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        $bill = AccountingJournal::find()->where(['=', 'jv_no', $str])->one();
                                        echo $bill->notes;
                                        ?>
                                    </td>

                                    <?php if ($data['vch_type'] == 'Debit') { ?>
                                        <td class="w1" data-col-seq="1" style="text-align:right">

					    <?php if($data['debit_amount']==''){ ?>
                                                <?= "0.00" ?>
                                            <?php } else { ?>
                                                <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])  ?>
                                                <?php $debit_total = $debit_total + $data['debit_amount']; ?>
                                            <?php } ?>
                                        </td>
                                        <td class="w1" data-col-seq="2" style="text-align:right">
					    <?php if($data['credit_amount']==''){ ?>
                                                <?= "0.00" ?>
                                            <?php } else { ?>
                                                <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])  ?>
                                                <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                            <?php } ?>
                                        </td>
                                    <?php } else { ?>
                                        <td class="w1" data-col-seq="1" style="text-align:right">
					    <?php if($data['debit_amount']==''){ ?>
						<?= "0.00" ?>
					    <?php } else { ?>
						<?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])  ?>
                                                <?php $debit_total = $debit_total + $data['debit_amount']; ?>
                                            <?php } ?>
                                        </td>
                                        <td class="w1" data-col-seq="2" style="text-align:right">

					    <?php if($data['credit_amount']==''){ ?>
                                                <?= "0.00" ?>
                                            <?php } else { ?>
                                                <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])  ?>
                                                <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                            <?php } ?>
                                        </td>
                                    <?php } ?>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                        $bill = AccountingJournal::find()->where(['=', 'jv_no', $str])->one();
                                        echo '<div class="d-inline-block dropdown">
            <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
            <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                <ul class="nav flex-column">  <li class="nav-item">
                <a class="nav-link" href=' . Url::base() . '/users/accounting-journal/view?id=' . $bill->id . ' target=_blank data-method=post>
                    <i class="fa fa-eye"></i>
                    <span class="dj-icon-gap">View</span>
                </a>
            </li>  </ul></div></div>' ?>

                                    </td>
                                </tr>


                            <?php } elseif ($data['vch_type'] == 'Adjusted Amount') { ?>

                                <tr class="w1" data-key="0">
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['dated'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        // $bill = CreditNote::find()->where(['LIKE', 'credit_note_id', $data['vch_no']])->one();
                                        echo $data['vch_no'];
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        echo "Adjusted";
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?= $data['vch_type'] ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">
                                        <?php
                                        echo $data['notes'];
                                        ?>
                                    </td>
                                    <td class="w1" data-col-seq="1" style="text-align:right">
                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['debit_amount'])  ?>
                                    </td>
                                    <td class="w1" data-col-seq="2" style="text-align:right">

                                        <?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data['credit_amount'])  ?>
                                        <?php $credit_total = $credit_total + $data['credit_amount']; ?>
                                    </td>
                                    <td class="w1" data-col-seq="0">

                                        <?php
                                        echo '' ?>

                                    </td>
                                </tr>


                            <?php } ?>

                            <!-- <tr class="w1" data-key="0"><td class="w1" data-col-seq="0"></td><td class="w1" data-col-seq="0"></td><td class="w1" data-col-seq="0"></td><td class="w1" data-col-seq="0"></td><td class="w1" data-col-seq="0">Opening</td><td class="w1" data-col-seq="1" style="text-align:right"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 0.00) ?></td><td class="w1" data-col-seq="2" style="text-align:right"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", 0.00)  ?></td><td class="w1" data-col-seq="0"></td></tr> -->



                        <?php endforeach; ?>

                    <?php } ?>
                    <tr class="w1" data-key="0">
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"><strong style="color:green;">Total</strong></td>
                        <td class="w1" data-col-seq="1" style="text-align:right"><strong style="color:green;"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $debit_total) ?></strong></td>
                        <td class="w1" data-col-seq="2" style="text-align:right"><strong style="color:green;"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $credit_total)  ?></strong></td>
                        <td class="w1" data-col-seq="0"></td>
                    </tr>
                    <tr class="w1" data-key="0">
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"></td>
                        <td class="w1" data-col-seq="0"><strong style="color:orange;">Ledger Balance</strong></td>
                        <td class="w1" data-col-seq="1" style="text-align:right"><strong></strong></td>
                        <td class="w1" data-col-seq="2" style="text-align:right;"><strong style="color:orange;"><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($credit_total - $debit_total))  ?></strong></td>
                        <td class="w1" data-col-seq="0"></td>
                    </tr>



                </tbody>

            </table>

        </div>
    </div>
</div>





<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {


        $('.select_type').select2();


        $('.sendwhatapp').click(function() {
            var country_code = $('.c_code').val();
            var mobile = $('.c_mobile').val();
            var mobile_no = country_code.concat(mobile);
            var g_text = $('.send_text').val();
            var url = "https://wa.me/" + mobile_no + "/?text=" + g_text;
            window.location.href = url;
        })

        $('.senddetails').click(function() {
            var id = $(this).attr('value');
            $('.reason').val('');
            $('.cancel_id').val(id);
            // alert($('.cancel_id').val());
            jQuery.ajaxSetup({
                async: false
            });
            $.get('findinvoicealldetails', {
                id: id
            }, function(data) {
                var data = $.parseJSON(data);
                $('.c_code').val('91');
                $('.reason').val('');
                jQuery.ajaxSetup({
                    async: false
                });
                $.get('create-url', {
                    id: id
                }, function(st) {
                    var st = $.parseJSON(st);
                    $('.send_text').text('We have confirmed your Invoice ' + (data.invoice_id) + ' has been raised for Rs ' + data.total_price + '. Thank you! You can find the attachment below:');
                })


            });

        })

        $('.sendemail').click(function() {
            var id = $(this).attr('value');
            // $('.reason').val('');
            $('.cancel_id').val(id);
            // alert($('.cancel_id').val());
            jQuery.ajaxSetup({
                async: false
            });
            $.get('finduseralldetails', {
                id: id
            }, function(data) {
                var data = $.parseJSON(data);
                $('.send_email').val(data.email);
                $('.mail_bbc').val('');


                // jQuery.ajaxSetup({async:false});
                $.get('findinvoicealldetails', {
                    id: id
                }, function(st) {
                    var st = $.parseJSON(st);
                    var sub = 'Invoice # ' + st.invoice_id + " Date:" + st.date;
                    $('.mail_subject').val(sub);
                    $.get('create-url', {
                        id: id
                    }, function(link) {
                        var link = $.parseJSON(link);
                        var obj = $('.message').html('Dear ' + (data.business_name) + "\n We have confirmed your order for Invoice # MS/389/21-22. The Invoice has been raised for Rs" + st.total_price + '\n Thank you! \n MOHASYN \n \n Download attached invoice at: \n' + link).wrap('<pre />');
                    })
                    // var obj = $("#example").text('this\n has\n newlines');

                })


            });

        })
        $('.matchdetails').click(function() {
            var data = $(this).attr('value').split('|');
            var id = $(this).attr('value');
            $.get('findinvoicealldetails', {
                id: id
            }, function(data) {
                var data = $.parseJSON(data);

                $('.amt').text(data.pending_amount);

            });
        })

        $('.customer').select2({
            ajax: {
                url: '<?php echo Url::toRoute('sale-order/customerdetails'); ?>',
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {


                    $('#customersearch').trigger('change');
                    return {
                        results: $.map(response, function(i, item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };
                },
                cache: true
            }
        });
        $('.find_product').select2({
            ajax: {
                url: '<?php echo Url::toRoute('leads-quotes/productdetails'); ?>',
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {

                    return {
                        results: $.map(response, function(i, item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };


                },
                cache: true
            }
        });
        $('.search_supply').select2({
            'width': '100%'
        });
        $('.executives_name').select2({
            'width': '100%'
        });
        $('.shipment').select2({
            'width': '100%'
        });
        $('.bill_type').select2({
            'width': '100%'
        });
        $('.setting').select2({
            'width': '100%'
        });

        $('#bulkdelete').click(function() {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            if (ids != 0) {
                var x = confirm("Are you sure you want to delete selected items?");
                if (x) {
                    var ids = $('#grid').yiiGridView('getSelectedRows');
                    console.log(ids);
                    $.post('delete', {
                        data: ids
                    }, function(data) {});
                } else {
                    return false;
                }
            } else {
                var x = alert("Please select some items to delete!");
            }

        });
        $('#search-invoice').hide();
        $('#advance-search').click(function() {
            $('#search-invoice').toggle();
        })

        $('.deleteinvoice').click(function() {
            var confirm = window.confirm("Are u sure you want to delete the selected item?");
            if (confirm == true)
                return true;
            else
                return false;
        })

        var isLoading = false;
        $('.attachments').click(function() {
            $("#dinamic").empty();
            isLoading = true;
            var id = $(this).attr('value');
            $.get('findattachments', {
                id: id
            }, function(data) {
                var data = $.parseJSON(data);
                if (data.length == 0) {
                    $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
                }
                for (var i = 0; i < data.length; i++) {
                    // $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "</td><tr>");

                    $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?= Url::base(); ?>/users/invoice/download?id=" + data[i].id + "'>" + data[i].document_name + "</a></td><tr>");


                }
                isLoading = false;

            });
        })
        $('#id_invoice').change(function() {
            if ($(this).val() == '') {
                window.location = window.location;
            }
        });
        $('input[name="InvoiceSearch[date]"]').attr('type', 'date');

        $('.properprint').click(function(e) {
            e.preventDefault();
            canelUrl = $(this).attr("value");

            window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - " + $(this).attr("title"), "width=700,height=700,scrollbars=yes");


        });


    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
