<?php
/* @var $dataProvider yii\data\ActiveDataProvider */
/* @var $model backend\modules\reports\models\SalesFastSlowMovingReportSearch */

use yii\helpers\Html;
use yii\helpers\Url;

?>

<!DOCTYPE html>
<html>
<head>
    <title>Sales Moving Product Report</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 20px;
        }

        .report-header {
            text-align: center;
            margin-bottom: 30px;
        }

        .report-header h1 {
            margin: 0;
            font-size: 24px;
            color: #0a94c4;
        }

        .report-header p {
            margin: 5px 0;
            font-size: 16px;
        }

        table {
            width: 100%;
            border-collapse: collapse;
            margin-bottom: 20px;
        }

        table, th, td {
            border: 1px solid black;
        }

        th, td {
            padding: 8px;
            text-align: left;
        }

        th {
            background-color: #0a94c4;
            color: #fff;
        }

        .total {
            font-weight: bold;
        }

        .footer {
            text-align: center;
            font-size: 12px;
            margin-top: 30px;
        }

        .download-button {
            position: absolute;
            top: 20px;
            right: 20px;
        }
    </style>
</head>
<body>

<div class="report-header">
    <h1>Sales Fast/Slow Moving Product Report</h1>
    <p>Company Name</p>
    <p>Company Address</p>
    <p>Report Date: <?= date('Y-m-d') ?></p>
</div>

<table>
    <thead>
        <tr>
            <th>Sl. No.</th>
            <th>Product Name</th>
            <th>Description</th>
            <th>Barcode</th>
            <th>Product Sold</th>
        </tr>
    </thead>
    <tbody>
        <?php
        $total_qty = 0;
        $total_items = 0;
        $index = 1;
        foreach ($dataProvider->getModels() as $model):
            $total_qty += $model->product_sold;
            $total_items++;
            ?>
            <tr>
                <td><?= $index ?></td>
                <td><?= Html::encode($model->product_name) ?></td>
                <td><?= Html::encode($model->description) ?></td>
                <td><?= Html::encode($model->barcode) ?></td>
                <td><?= Html::encode($model->product_sold) ?></td>
            </tr>
            <?php
            $index++;
        endforeach; ?>
        <tr>
            <td class="total" colspan="2">Total Items Sold:</td>
            <td class="total" colspan="3"><?= $total_items ?></td>
        </tr>
        <tr>
            <td class="total" colspan="3">Total Quantity Sold:</td>
            <td class="total" colspan="2"><?= $total_qty ?></td>
        </tr>
    </tbody>
</table>

<div class="footer">
    <p>&copy; <?= date('Y') ?> Company Name. All rights reserved.</p>
</div>

<script>
function downloadPDF() {
    window.location.href = '<?= Url::to(['sales-moving-product/download-pdf']) ?>';
}
</script>

</body>
</html>
