<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\CreditNote;
use backend\modules\users\models\CreditNoteSearch;
use backend\modules\users\models\CreditNoteDocument;
use backend\modules\users\models\CreditNoteProduct;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\master\models\AccountingTax;
use backend\modules\users\models\AccountingDetails;
use yii\web\Controller;
use backend\models\AuthAssignment;
use backend\modules\master\models\Product;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use yii\helpers\ArrayHelper;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use yii\helpers\Json;
use yii\helpers\Url;
use backend\models\UserClient;
use backend\modules\master\models\salesTemplates;
use backend\modules\master\models\GenericTemplate;


/**
 * CreditNoteController implements the CRUD actions for CreditNote model.
 */
class CreditNoteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $sales_type=["B2B"=>"B2B",
    "B2C"=>"B2C",
    "EXPORT"=>"EXPORT",
    "ADV PAYMENT" =>"ADV PAYMENT",
    ]
    ;
     public static $supply_types=["Inter-State"=>"Inter-State",
    "Intra-State"=>"Intra-State",
    "Export"=>"Export",
    "Exempted" =>"Exempted",
    ]
    ;
    public static $payment_mode=["Cash"=>"Cash",
    "Cheque"=>"Cheque",
    "Card"=>"Card",
    "Mobile Payments"=>"Mobile Payments",
    ]
    ;

    /**
     * Lists all CreditNote models.
     * @return mixed
     */
    public function actionIndex()
    {
        Yii::$app->view->params['active']=38;
        $searchModel = new CreditNoteSearch();
        $model = new CreditNote();
        $product=Product::find()->all();
        $allproduct=ArrayHelper::map($product, 'id', 'product_name');

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();

        if($user_type->item_name == 'Admin')
        {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        }
        else
        {      
            $accessed[] = Yii::$app->user->identity->id;
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams,$accessed);
        }
        // $query = CreditNote::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        
        if ($model->load(Yii::$app->request->get()) ) {

            if($model->findid!='')
            {
                if($model->send_email!='')
                {
                    $message = Yii::$app->mailer->compose()
                   ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                   ->setTo(trim($model->send_email))
                   ->setSubject($model->email_subject)
                   ->setHtmlBody(nl2br($model->email_message));
                   
                     if(!empty($model->cc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }   
                     if(!empty($model->bcc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }      
                     Yii::$app->mailer->send($message);
                     Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                     return $this->redirect(['credit-note/index']);
                }
                else
                {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                    return $this->redirect(['credit-note/index']);
                }
            }
            else
            {

                    if($user_type->item_name == 'Admin')
                    {
                        $query=CreditNote::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
                    }
                    else
                    {      
                        $customers = UserClient::find()->where(['user_id'=>$accessed])->all();
                        $customer_ids = [];
                        $j = 0;
                        foreach($customers as $data)
                        {
                            $customer_ids[$j] = $data->client_id;
                            $j++;
                        }
                        $query = CreditNote::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
                    }
                    
                    $query->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                    ->andFilterWhere(['like', 'customer_type', $model->type_of_customer])
                    ->andFilterWhere(['like', 'customer_name', $model->customer])
                    ->andFilterWhere(['like', 'setting_type', $model->setting])
                    ->andFilterWhere(['like', 'total_amount', $model->amount]);
                    if($model->product){
                        $productlists=CreditNoteProduct::find()->where(['product_id'=>$model->product,'is_deleted'=>0])->groupBy(['credit_note_id'])->all();
                        $productid=ArrayHelper::map($productlists, 'credit_note_id','credit_note_id');
                        $query->andFilterWhere(['in', 'id', $productid]) ; 
                    }
            }

             $dataProvider = new ActiveDataProvider([
                'query' => $query,
                'sort'=> ['defaultOrder' => ['id' => SORT_DESC]],
            ]);

        }

       


        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,
            'allproduct' => $allproduct,
        ]);
    }

    /**
     * Displays a single CreditNote model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id,$from=null)
    {
        Yii::$app->view->params['active']=38;

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = CreditNote::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_name])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['credit-note/index']);
            }
        }


        $products=CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
        // $df = public string asSpellout(1534);
        return $this->render('view', [
            'model' => $this->findModel($id),
            'products'=>$products,
            'from'=>$from,
        ]);
    }

    /**
     * Creates a new CreditNote model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        Yii::$app->view->params['active']=38;
        $model = new CreditNote();
        $document = new CreditNoteDocument();
        $product = new CreditNoteProduct();
        $data=Yii::$app->request->post();

        //$last_entry=CreditNote::find()->count();
        $selected_date=date('Y-m-d');
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if( strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=CreditNote::find()->where(['<=', 'date', $dynamic_date])->count();
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=CreditNote::find()->where(['>=', 'date', $dynamic_date])->count();
            }
            else{
                $last_entry=0;
            }


        if(CreditNote::find()->count() > 0) { 
            $total=CreditNote::find()->orderBy(['id' => SORT_DESC])->one();
            $count=$total->id;  
        }
        else{
            $count=0;
        } 

        if ($model->load(Yii::$app->request->post()) && $document->load(Yii::$app->request->post()) ) {


            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$model->customer_name])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['credit-note/index']);
                }
            }

           // $credit_id=$count+1;
            $model->credit_note_id = $model->prefix.''.$model->credit_note_no.''.$model->suffix;
            $model->created_by = Yii::$app->user->identity->id;
            $model->save();

            foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                    $product = new CreditNoteProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->credit_note_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);
                } 
            }


            $demo = new AccountingDetails();
              $cgst = $model->cgst_amount;
              $igst = $model->igst_amount;
              $sgst = $model->sgst_amount;
              $roundoff = $model->round_off_amount;
              $totalamt = $model->total_amount;
              $amt = $model->sub_total_amount;
              $gsttype = $model->point_of_supply;
              $tan_id = $model->credit_note_id;
              $tan_date = $model->date;
               if($model->customer_type=='vendor')
                  $paid_by = Vendor::find()->where(['id'=>$model->customer_name])->one();
               else
                  $paid_by = Customer::find()->where(['id'=>$model->customer_name])->one(); 
              $amtfrom = $paid_by->business_name;
              $tcs = $model->tcs_amount;
              $is_tcs = $model->is_tcs;
              $demo->leadgerentrycredit($cgst,$sgst,$igst,$roundoff,$totalamt,$gsttype,$tan_id,$amtfrom,$amt,$tcs,$is_tcs,$tan_date);

            

            if($document->validate())
             {
                $names=UploadedFile::getInstances($document,'document_name');
                foreach ($names as $name) {
                    $path='creditnote_documents/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('credit_note_document',['document_name'=>$filename,'credit_note_id'=>$model->id])->execute();
                    }
                    
                }

             }
             if (Yii::$app->request->post('save') == 0) {
                     Yii::$app->getSession()->setFlash('success', 'Successfully Created New Credit Note');
                     return $this->redirect(['credit-note/index']);
              }

            if (Yii::$app->request->post('save') == 1) {
                   Yii::$app->getSession()->setFlash('success', 'Successfully Created New Credit Note');
            return $this->redirect(['credit-note/create']);
              }



        }

        return $this->render('create', [
            'model' => $model,
            'sales_type' => CreditNoteController::$sales_type,
            'supply_types' => CreditNoteController::$supply_types,
            'document' => $document,
            'product' => $product,
            'last_entry'=>$last_entry+1,

        ]);
    }

    /**
     * Updates an existing CreditNote model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=38;


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = CreditNote::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_name])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['credit-note/index']);
            }
        }


        $model = $this->findModel($id);
        $document = new CreditNoteDocument();
        $product = new CreditNoteProduct();
        $last_entry=CreditNote::find()->count();
        $data=Yii::$app->request->post();
        $products =CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
        $number = count($products);
        if($model->customer_type=='customer')
        $customer=Customer::find()->all();
        else
        $customer=Vendor::find()->all();
        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');



        if ($model->load(Yii::$app->request->post()) && $document->load(Yii::$app->request->post()) ) {

             $model->save();
             $product_delete=CreditNoteProduct::deleteAll(['credit_note_id'=>$id]);
             if(isset($data['productdyn'])){
                foreach ($data['productdyn'] as $value) {
                    if($value['price']!='')
                    {
                    $product = new CreditNoteProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->credit_note_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);
                }
                }
             }

             if(isset($data['productdynupdate'])){
                foreach ($data['productdynupdate'] as $value) {
                    if($value['price']!='')
                    {
                    $cnote = new CreditNoteProduct();
                    $cnote->product_id = $value['product'];
                    $cnote->description = $value['desc'];
                    $cnote->quantity = $value['quantity'];
                    $cnote->units = $value['units'];
                    $cnote->price = $value['price'];
                    $cnote->unit_price = $value['unitprice'];
                    $cnote->discount = $value['discount'];
                    $cnote->tax=$value['tax'];
                    $cnote->discount_type=$value['discounttype'];
                    $cnote->tax_included = $value['tax_included'];
                    $cnote->amount = $value['amount'];
                    $cnote->credit_note_id = $model->id;
                    $cnote->created_at=date('Y-m-d H:i:s');
                    $cnote->updated_at=date('Y-m-d H:i:s');
                    $cnote->save(false);
                }
                }
            }


             if($document->validate())
             {
                $names=UploadedFile::getInstances($document,'document_name');
                foreach ($names as $name) {
                    $path='creditnote_documents/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('credit_note_document',['document_name'=>$filename,'credit_note_id'=>$model->id])->execute();
                    }
                    
                }

             }
             if (Yii::$app->request->post('save') == 0) {
                     Yii::$app->getSession()->setFlash('success', 'Successfully Updated Credit Note');
                     return $this->redirect(['credit-note/index']);
              }

            if (Yii::$app->request->post('save') == 1) {
                   Yii::$app->getSession()->setFlash('success', 'Successfully Updated Credit Note');
            return $this->redirect(['credit-note/create']);
              }            
        }

        return $this->render('update', [
            'model' => $model,
            'sales_type' => CreditNoteController::$sales_type,
            'supply_types' => CreditNoteController::$supply_types,
            'document' => $document,
            'product' => $product,
            'last_entry'=>$last_entry+1,
            'products'=>$products,
            'number'=>$number,
            'customerlist'=>$customerlist,

        ]);
    }

    /**
     * Deletes an existing CreditNote model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            if($ids){
            foreach($ids as $id){
                 $document=CreditNoteDocument::find()->where(['credit_note_id'=>$id])->all();
                 foreach($document as $value){$value->is_deleted=1;$value->save(false);}
                 $creditnoteproducts = CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
                 foreach($creditnoteproducts as $creditnoteproducts)
                  {
                    $creditnoteproducts->is_deleted=1;
                    $creditnoteproducts->save(false);
                  }
                  $data=$this->findModel($id);
                  $data->is_deleted=1;$data->save(false);
            }
            } 
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
            return $this->redirect(['credit-note/index']);
        }
        else
        {
            $data=$this->findModel($id);
            $data->is_deleted=1;$data->save(false);
            $document=CreditNoteDocument::find()->where(['credit_note_id'=>$id])->all();
            foreach($document as $value){$value->is_deleted=1;$value->save();}
            $creditnoteproducts = CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
             foreach($creditnoteproducts as $creditnoteproducts)
              {
                $creditnoteproducts->is_deleted=1;
                $creditnoteproducts->save(false);
              }
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
            return $this->redirect(['index']);
        }   
    }
    public function actionFindattachments($id)
    {
        $find=CreditNoteDocument::find()->select(['document_name','id'])->where(['credit_note_id'=>$id])->asArray ()->all();
        echo Json::encode($find);
        // return $exporter->send($find);
        // return $find;
    }
    public function actionDelattachment($id)
    {
        $file=CreditNoteDocument::find()->where(['id'=>$id])->one();
        $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
    public function actionExcelExport($detail=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $query=CreditNote::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {      
            $customers = UserClient::find()->where(['user_id'=>$check_id])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = CreditNote::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
        }

        $dataProvider = new ActiveDataProvider([
            'query' =>$query,
        ]);

        if($detail){
         $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'setting_type',
            'customer_type',
            [
                'label'=>'Customer',
               'attribute' => 'customer_name',
               'value' => function ($data) {
                if($data->customer_type=='customer')
                {
                    $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                else
                {
                    $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                
               }
            ],
            'notes:ntext',
            'receiver_gstn',
            'sales_type',
            'supply_type',
            'supply_reverse_charge',
            'pricelist',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'prefix',
            'credit_note_no',
            'suffix',
            'credit_note_id',
             [
                'label' => 'Show To Store Keeper',
                'attribute' => 'show_to_store_keeper',
                'value' => function ($data) {
                    if($data->show_to_store_keeper==1)
                    {
                        return 'Yes';
                    }
                    else
                    {
                        return 'No';
                    }
            },
            ],
            'order_type',
            [
                'label' => 'Date',
                'attribute' => 'date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['date']));
                    return $newDate;
            },
            ],
            'invoice_no',
            [
                'label' => 'Invoice Date',
                'attribute' => 'invoice_date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['invoice_date']));
                    return $newDate;
            },
            ],
            'sub_total_amount',
            'total_amount',
            'credit_note_terms:ntext',
            'credit_notes:ntext',
            [
                'label' => 'Created Date',
                'attribute' => 'created_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                    return $newDate;
            },
            ],
            [
                'label' => 'Updated Date',
                'attribute' => 'updated_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                    return $newDate;
            },
            ],
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= CreditNoteDocument::find()->select(['document_name'])->where(['credit_note_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],
            
        ],
    ]);
        }else{
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [

                        'setting_type',
                        [
                            'label'=>'Customer',
                           'attribute' => 'customer_name',
                           'value' => function ($data) {
                            if($data->customer_type=='customer')
                            {
                                $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                                return $val->business_name;
                            }
                            else
                            {
                                $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                                return $val->business_name;
                            }
                            
                           }
                        ],
                        'total_amount',
                        'date',
                    ],
            ]);
        }

      return $exporter->send('CreditNote-details.xlsx');
    }

    public function actionCreditnotePdf($id=null,$from=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $query=CreditNote::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {      
            $customers = UserClient::find()->where(['user_id'=>$check_id])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = CreditNote::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
        }
        if($from=='all')
        {
            $dataProvider = new ActiveDataProvider([
            'query' => $query,
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/credit-note/export-pdf', [
                'dataProvider' => $dataProvider,

            ]));
            $mpdf->Output('CreditNote-details.pdf', 'D');
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = CreditNote::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_name])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['credit-note/index']);
                }
            }
            $dataProvider = new ActiveDataProvider([
            'query' => CreditNote::find()->where(['id'=>$id]),
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $products=CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
            $mpdf->WriteHTML($this->renderPartial('/credit-note/creditnote-pdf', [
                'model' => $this->findModel($id),
                'products'=>$products,
                        ]));
            $find=CreditNote::findOne($id);
            $credit_note_id=$find->credit_note_id;
            if($from=='print')
            {
                $mpdf->Output($credit_note_id.'-CreditNote.pdf', 'I');
            }
            else
            {
                $mpdf->Output($credit_note_id.'-CreditNote.pdf', 'D');
            }   
        }  
    }
    public function actionExcelCreditnote($id)
    {
        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = CreditNote::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_name])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['credit-note/index']);
            }
        }
        
        $dataProvider = new ActiveDataProvider([
            'query' => CreditNote::find()->where(['id'=>$id]),
        ]);
      $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'setting_type',
            'customer_type',
            [
                'label'=>'Customer',
               'attribute' => 'customer_name',
               'value' => function ($data) {
                if($data->customer_type=='customer')
                {
                    $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                else
                {
                    $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                
               }
            ],
            'notes:ntext',
            'receiver_gstn',
            'sales_type',
            'supply_type',
            'supply_reverse_charge',
            'pricelist',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'prefix',
            'credit_note_no',
            'suffix',
            'credit_note_id',
             [
                'label' => 'Show To Store Keeper',
                'attribute' => 'show_to_store_keeper',
                'value' => function ($data) {
                    if($data->show_to_store_keeper==1)
                    {
                        return 'Yes';
                    }
                    else
                    {
                        return 'No';
                    }
            },
            ],
            'order_type',
            [
                'label' => 'Date',
                'attribute' => 'date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['date']));
                    return $newDate;
            },
            ],
            'invoice_no',
            [
                'label' => 'Invoice Date',
                'attribute' => 'invoice_date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['invoice_date']));
                    return $newDate;
            },
            ],
            'sub_total_amount',
            'total_amount',
            'credit_note_terms:ntext',
            'credit_notes:ntext',
            [
                'label' => 'Created Date',
                'attribute' => 'created_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                    return $newDate;
            },
            ],
            [
                'label' => 'Updated Date',
                'attribute' => 'updated_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                    return $newDate;
            },
            ],
             [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= CreditNoteDocument::find()->select(['document_name'])->where(['credit_note_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;       
            },
            ],  
        ],
    ]);
       $find=CreditNote::findOne($id);
        $credit_note_id=$find->credit_note_id; 
     return $exporter->send($credit_note_id.'-Creditnotes.xlsx');
    }

     public function actionDownload($id) {
    // This will need to be the path relative to the root of your app.
        $model=CreditNoteDocument::find()->where(['id'=>$id])->one();
        if($model->document_name!=null)
        {
            $local=yii::getAlias('@webroot/creditnote_documents/');
            $name=$model->document_name;
            $find=$local.$name;
            if(file_exists($find))
            {
               return yii::$app->response->sendFile($find);
            }
        }
   }

   public function actionFindproduct($productid)
   {
        $productdetails= Product::find()->where(['id' =>$productid])->one();
        echo Json::encode($productdetails);
   }
   public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
    public function actionFindCustomer()
    {
        $customer=Customer::find()->all();
        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }
    public function actionFindVendor()
    {
        $customer=Vendor::find()->all();
        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }
    /**
     * Finds the CreditNote model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return CreditNote the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = CreditNote::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionCustomerdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Customer::find()->limit(10)->all();
        else
        $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }
    public function actionVendordetails($searchTerm=null)
    {   

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();


        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Vendor::find()->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }   
        else
        {
            $vendor_ids = [];
            $i =0;

            $vendors = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Vendor'])->all();
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Vendor::find()->where(['in','id',$vendor_ids])->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$vendor_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }


        
    }
    public function actionFinddetails()
    { 
        $taxdetails= Accountingtax::find()->select(['tax_name','accounting_tax_id'])->where(['is_deleted'=>0])
              ->andWhere(['tax_sub_type'=>'Output'])
              ->andWhere(['status'=>1])
              ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])->all();      
        $taxlist=ArrayHelper::map($taxdetails, 'accounting_tax_id','tax_name');
        return Json::encode($taxlist);
    }
    public function actionFindcustomerdetails($customerid)
    {
       $customerdetails= Customer::find()->where(['id' =>$customerid])->one();
        echo Json::encode($customerdetails);
    }
    public function actionFindvendordetails($customerid)
    {
       $vendordetails= Vendor::find()->where(['id' =>$customerid])->one();
        echo Json::encode($vendordetails);
    }

    public function actionTaxdetails($item)
    {
       $taxdetails= AccountingTax::find()->where(['accounting_tax_id' =>$item])->one();
        echo Json::encode($taxdetails);
    }

    public function actionFindcreditalldetails($id)
    {
        $all= CreditNote::find()->where(['id' =>$id])->one();
        echo Json::encode($all);
    } 
    public function actionCreateUrl($id)
    {
       // $ids=Yii::$app->request->post('data');
        $url = Url::to(['creditnote-pdf', 'id' => $id],'https');
        echo Json::encode($url);
            // print_r($url);

    }
    public function actionFinduseralldetails($id)
    {
        $all= CreditNote::find()->where(['id' =>$id])->one();
        $userdetails = Customer::find()->where(['id'=>$all->customer_name])->one();
        echo Json::encode($userdetails);
    }
    public function actionCreditnotesettingtype($setting=null,$template=null)
    {   
        //print_r(1);die();
        $find = GenericTemplate::find()->where(['template_for'=>'Credit Note'])->andWhere(['gt_id'=>$setting])->count();
        echo Json::encode($find);
    }

    public function actionSelectdate($selected_date=null)
    {   $selected_date=$_GET['selected_date']; 
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        $count_before_year=CreditNote::find()->where(['<=', 'date', $dynamic_date])->count();
        $count_after_year=CreditNote::find()->where(['>=', 'date', $dynamic_date])->count();

        if(strtotime($selected_date) <= strtotime($dynamic_date)) { 
            $last_entry=$count_before_year+1;
        }
        else if(strtotime($selected_date) > strtotime($dynamic_date)){
            $last_entry=$count_after_year+1;
        } 
        else{
            $last_entry=0;
        }
        echo $last_entry;
    }

}
