<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\PurchaseBill;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use common\models\User;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Product;
use backend\modules\master\models\AccountingTax;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\DebitNote;
use backend\modules\users\models\CreditNote;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\SaleOrderDocument;
use backend\modules\master\models\PurchaseOrder;
use backend\modules\master\models\PurchaseOrderProduct;
use backend\modules\users\models\DebitNoteProduct;
use backend\modules\users\models\CreditNoteProduct;
use backend\modules\users\models\DebitNoteDocument;
use backend\modules\users\models\InventoryPendingView;
use yii\helpers\Json;
use backend\models\UserClient;
use backend\models\AuthAssignment;

/**
 * PurchaseBillController implements the CRUD actions for PurchaseBill model.
 */
class InventoryPendingController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public function actionIndex($print=null)
    {
        Yii::$app->view->params['active']=120;
        $model = new SaleOrder();
        $purchasemodel = new PurchaseOrder();

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
           $query = InventoryPendingView::find()->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $accessed=LeadExecutive::find()->where(['user_id'=>$check_id])->one();
            if($accessed!='')
            {
              $accessed_id[] = $accessed['type'];
            }
            else
            {
                $loged_user = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
                $accessed_id[] = $loged_user['item_name'];
            }
            $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;
                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }

            $sale_ids = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->all();

            $assigned_sale_ids = [];
            $k = 0;
            foreach($sale_ids as $value)
            {
                $assigned_sale_ids[$k] = $value->id;
                $k++;
            }

            //CREDIT NOTE


            $credit_customers = UserClient::find()->where(['user_id'=>$accessed])->all();
            $credit_customer_ids = [];
            $j = 0;
            foreach($credit_customers as $data)
            {
                $credit_customer_ids[$j] = $data->client_id;
                $j++;
            }
            $credit_ids = CreditNote::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_name', $credit_customer_ids])->all();
            $assigned_credit_ids = [];
            $k = 0;
            foreach($credit_ids as $value)
            {
                $assigned_credit_ids[$k] = $value->id;
                $k++;
            }

            //DEBIT NOTE

            $accessed = Yii::$app->user->identity->id;
            $vendors = UserClient::find()->where(['user_id'=>$accessed])->all();
            $vendor_ids= [];
            $i = 0;
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            }
            $debit_ids = DebitNote::find()->where(['in', 'party_id', $vendor_ids])->andWhere(['is_deleted' =>0])->all();
            $assigned_debit_ids = [];
            $k = 0;
            foreach($debit_ids as $value)
            {
                $assigned_debit_ids[$k] = $value->id;
                $k++;
            }

            //PURCHASE ORDER

            $accessed = Yii::$app->user->identity->id;
            $vendors = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Vendor'])->all();
            $vendor_ids= [];
            $i = 0;
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            } 

            $purchase_ids = PurchaseOrder::find()->where(['in', 'vendor_name', $vendor_ids])->andWhere(['is_deleted' =>0])->all();
            $assigned_purchase_ids = [];
            $k = 0;
            foreach($purchase_ids as $value)
            {
                $assigned_purchase_ids[$k] = $value->id;
                $k++;
            }
            $query = InventoryPendingView::find()->where(['and',['in','id',$assigned_sale_ids],['type'=>'saleorder']])
            ->orWhere(['and',['in','id',$assigned_credit_ids],['type'=>'credit_note']])
            ->orWhere(['and',['in','id',$assigned_debit_ids],['type'=>'debit_note']])
            ->orWhere(['and',['in','id',$assigned_purchase_ids],['type'=>'purchaseorder']]);
        }

        
       if($model->load(Yii::$app->request->get()) && $purchasemodel->load(Yii::$app->request->get()) ){


             $query->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                   ->andFilterWhere(['order_id'=> $model->ref]);

             if($model->type_inventory!='')
             {
                if($model->type_inventory=='To Be Shipped')
                {
                   $query->andFilterWhere(['type'=>'saleorder']);
                }
                else if($model->type_inventory=='To be Received')
                {
                   $query->andFilterWhere(['type'=>'purchaseorder']);
                }
             }
             if($model->customer!='')
             {
                // print_r($model->customer);
                // die();
                $query->andFilterWhere(['name' => $model->customer])
                      ->andFilterWhere(['user_type'=>'customer']);  
             }
             if($purchasemodel->vendor!='')
             {
                $query->andFilterWhere(['name' => $purchasemodel->vendor])
                      ->andFilterWhere(['user_type'=>'vendor']);  
             }
       
       }
       

       // $data=Yii::$app->db->createCommand($sql)->queryAll();
      
       $provider = new  ActiveDataProvider([
        'query' => $query,
        ]);
       $provider->setSort([
            'attributes' => [
                'date' => [
                    'asc' => ['date' => SORT_ASC],
                    'desc' => ['date' => SORT_DESC],
                    'default' => SORT_DESC,
                ],
            ],
            'defaultOrder' => [
                'date' => SORT_DESC
            ]
        ]);


       if($print==true)
       {
            $this->actionInventoryPdf($provider);
       }

        return $this->render('index', [
             'data'=>$provider,
             'model'=>$model,
             'purchasemodel'=>$purchasemodel,
        ]);
    }
    public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
     public function actionCustomerdetails($searchTerm=null)
    {   



        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Customer::find()->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
            return json_encode($customerlist);
        }
        else
        {
            $customer_ids = [];
            $i =0;

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            foreach($customers as $data)
            {
                $customer_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Customer::find()->where(['in','id',$customer_ids])->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$customer_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
            return json_encode($customerlist); 
        }




    }
    public function actionView($id)
    {

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['inventory-pending/index']);
            }
        }


        $model = SaleOrder::find()->where(['id'=>$id])->one();

        $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        return $this->render('view', [
            'model' => $model,
            'products'=>$products,
            
        ]);
    }

    public function actionViewPurchase($id)
    {

        $accessed = Yii::$app->user->identity->id;


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_purchase = PurchaseOrder::find()->where(['id'=>$id])->one();
            $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->vendor_name])->andWhere(['client_type'=>'Vendor'])->one(); 
            if($check_vendor == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['inventory-pending/index']);
            }
        }

        $model = PurchaseOrder::find()->where(['id'=>$id])->one();
        $products=PurchaseOrderProduct::find()->where(['purchase_order_id'=>$id])->all();
        return $this->render('view-purchase', [
            'model' => $model,
            'products'=>$products,
            
        ]);
    }
    public function actionVendordetails($searchTerm=null)
    {   



         $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();


        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Vendor::find()->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
            return json_encode($customerlist);
        }   
        else
        {
            $vendor_ids = [];
            $i =0;

            $vendors = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Vendor'])->all();
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Vendor::find()->where(['in','id',$vendor_ids])->limit(10)->all();
            else
            $customer=Vendor::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$vendor_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
            return json_encode($customerlist);
        }
    }
    public function actionViewDebit($id)
    {

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_purchase = DebitNote::find()->where(['id'=>$id])->one();
            $check_vendor = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_purchase->party_id])->one(); 
            if($check_vendor == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['inventory-pending/index']);
            }
        }
        $model = DebitNote::find()->where(['id'=>$id])->one();
        $products=DebitNoteProduct::find()->where(['debit_note_id'=>$id])->all();
         $data1=DebitNoteDocument::find()->where(['debit_note_id'=>$id,'is_deleted'=>0])->all();
        return $this->render('view-debit', [
            'model' => $model,
            'products'=>$products,
            'documents'=>$data1,
            
        ]);
    }
    public function actionViewCredit($id)
    {
        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = CreditNote::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_name])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['inventory-pending/index']);
            }
        }
        $model = CreditNote::find()->where(['id'=>$id])->one();
        $products=CreditNoteProduct::find()->where(['credit_note_id'=>$id])->all();
        return $this->render('view-credit', [
            'model' => $model,
            'products'=>$products,
            
        ]);
    }

    public function actionInventoryPdf($data=null)
    {
        $dataProvider = $data;
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/inventory-pending/inventory-pdf', [
            'dataProvider' => $dataProvider,
        ]));
        $mpdf->Output('Inventory-details.pdf', 'I');
    }

 }
