<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\LeadsQuotes;
use backend\modules\users\models\LeadsQuotesSearch;
use backend\modules\users\models\LeadsQuotesProduct;
use backend\modules\users\models\LeadsQuotesDocument;
use backend\modules\master\models\Product;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\Json;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\modules\master\models\LeadsEnquiry;
use backend\modules\master\models\AccountingTax;
use yii\helpers\Url;
use backend\models\AuthAssignment;
use backend\models\UserClient;
/**
 * LeadsQuotesController implements the CRUD actions for LeadsQuotes model.
 */
class LeadsQuotesController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $sales_types=["B2B"=>"B2B",
    "B2C"=>"B2C",
    "EXPORT"=>"EXPORT",
    "ADV PAYMENT" =>"ADV PAYMENT",
    ]
    ;
     public static $supply_types=["Inter-State"=>"Inter-State",
    "Intra-State"=>"Intra-State",
    "Export"=>"Export",
    "Exempted" =>"Exempted",
    ]
    ;
    /**
     * Lists all LeadsQuotes models.
     * @return mixed
     */
    public function actionIndex()
    {
        Yii::$app->view->params['active']=41;
        $searchModel = new LeadsQuotesSearch();
        // $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $product=Product::find()->all();
        $allproduct=ArrayHelper::map($product, 'id', 'product_name');
        $model = new LeadsQuotes();
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        }
        else
        {

             $accessed=LeadExecutive::find()->where(['user_id'=>$check_id])->one();
            if($accessed!='')
            {
                $accessed_id[] = $accessed['type'];
            }
            else
            {
                $loged_user = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
                $accessed_id[] = $loged_user['item_name'];
            }
            
           $dataProvider = $searchModel->search(Yii::$app->request->queryParams,$accessed_id);
            
        }
        if ($model->load(Yii::$app->request->get()) ) {

            if($model->findid!='')
            {
              if($model->send_email!='')
              {
                    $message = Yii::$app->mailer->compose()
                     ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                     ->setTo(trim($model->send_email))
                     ->setSubject($model->email_subject)
                     ->setHtmlBody(nl2br($model->email_message));
                     
                   if(!empty($model->cc_to_email!="")){
                      $message->setBcc(trim($model->bcc_to_email));
                     }   
                   if(!empty($model->bcc_to_email!="")){
                      $message->setBcc(trim($model->bcc_to_email));
                     }      
                   Yii::$app->mailer->send($message); 
                   Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                    return $this->redirect(['leads-quotes/index']);
              }
              else
              {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                    return $this->redirect(['leads-quotes/index']);
              }
               
            }
            else
            {
                if($user_type->item_name == 'Admin')
                {
                    $query=LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
                }
                else
                {   
                    $all = LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all();
                    $exe_array= [];
                     $i=0;
                    foreach ($all as $key => $val) {
                        $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive']])->one();
                        if($executivedetails!='')
                        {
                           if($executivedetails->type == $accessed_id[0]) 
                              $exe_array[$i] = $executivedetails->id;
                            $i++;
                        }
                    }
                    $exe_array = array_unique($exe_array);
                    $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
                    $customer_ids = [];
                    $j = 0;
                    foreach($customers as $data)
                    {
                        $customer_ids[$j] = $data->client_id;
                        $j++;
                    }

                     $query = LeadsQuotes::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
                }
                $query->andFilterWhere(['between', 'closure_property', $model->closure_from,$model->closure_to])
                ->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                ->andFilterWhere(['in', 'quotes_id', $model->lead_quote_id])
                ->andFilterWhere(['in', 'customer', $model->customer_name])
                ->andFilterWhere(['in', 'supply_attracts', $model->setting])
                ->andFilterWhere(['in', 'status', $model->quote_status])
                ->andFilterWhere(['in', 'converted_to',$model->convert_status])
                ->andFilterWhere(['in', 'executive',$model->executive_name]);
                if($model->amount_compare)
                {
                    if($model->amount_compare=='<')
                    {
                       $query->andFilterWhere(['<', 'total_amount',$model->amount]);
                    }
                    elseif ($model->amount_compare=='<=') {
                        $query->andFilterWhere(['<=', 'total_amount',$model->amount]);
                    }
                    elseif ($model->amount_compare=='>') {
                        $query->andFilterWhere(['>', 'total_amount',$model->amount]);
                    }
                    elseif ($model->amount_compare=='>=') {
                        $query->andFilterWhere(['>=', 'total_amount',$model->amount]);
                    }
                    elseif ($model->amount_compare=='=') {
                        $query->andFilterWhere(['=', 'total_amount',$model->amount]);
                    }
                }
                if($model->find_product){
                    $productlists=LeadsQuotesProduct::find()->where(['product_id'=>$model->find_product,'is_deleted'=>0])->groupBy(['leads_quotes_id'])->all();
                    $productid=ArrayHelper::map($productlists, 'leads_quotes_id','leads_quotes_id');
                    $query->andFilterWhere(['in', 'id', $productid]) ; 
                }
                $dataProvider = new ActiveDataProvider([
                    'query' => $query,
                    'sort'=> ['defaultOrder' => ['id' => SORT_DESC]],
                ]);
            }
          
        }
        
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,
            'allproduct' => $allproduct,
        ]);
    }

    /**
     * Displays a single LeadsQuotes model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        Yii::$app->view->params['active']=41;

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = LeadsQuotes::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['leads-quotes/index']);
            }
        }

        $leadsquote = LeadsQuotes::find()->where(['id'=>$id])->one();
        $find = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
        $tax_amount= LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
        $taxable_amount = 0;
        foreach ($tax_amount as $tax_amount) {
          if($tax_amount->discount_type=="FLAT")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - $tax_amount->discount);
          }
          if($tax_amount->discount_type=="%")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - (($tax_amount->price * $tax_amount->discount)/100));
          }
          if($tax_amount->discount_type=="")
          {
             $taxable_amount = $taxable_amount+$tax_amount->price;
          }
         }
            $customer = Customer::find()->where(['id'=>$leadsquote->customer])->one();
        $total_product = 0;
        foreach ($find as $find) {
          $total_product = $total_product+ $find->quantity;
          # code...
        }
        $products=LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
        return $this->render('view', [
            'model' => $this->findModel($id),
            'products' => $products,
            'customer' => $customer,
            'total_product' => $total_product,
            'taxable_amount' => $taxable_amount,
        ]);
    }

    /**
     * Creates a new LeadsQuotes model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($id=null,$from=null)
    {
        Yii::$app->view->params['active']=41;
        $model = new LeadsQuotes();
        $quortsproduct = new LeadsQuotesProduct();
        $lqtproducts = new LeadsQuotesProduct();
        $leadsquotedocuments = new LeadsQuotesDocument();
        if($id)
        { 
          if($from=='leads-quotes')
          {
                $data = $this->findModel($id)->attributes;
                $model->setAttributes($data);
                $quortsproduct = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
          }
          if($from == 'leads-enquiry')
          {
             $enquiry_details = LeadsEnquiry::find()->where(['id'=>$id])->one();
             $find_cunstomer = Customer::find()->where(['business_name'=>$enquiry_details->name])->one();
             if($find_cunstomer=='')
             {
                Yii::$app->getSession()->setFlash('error', 'First create a customer then try again.');
                return $this->redirect(['/master/leads-enquiry/index']);
             }
             else
             {
                $model->customer = $find_cunstomer->id;
                // print_r($model->customer);
                // die();
                $quortsproduct = Array();
             }
          }
      }
        $last_entry=LeadsQuotes::find()->count();
        $data=Yii::$app->request->post();
        if(LeadsQuotes::find()->count() > 0) { 
            $total=LeadsQuotes::find()->orderBy(['id' => SORT_DESC])->one();
            $count=$total->id;  
        }
        else{
            $count=0;
        } 
        if ($model->load(Yii::$app->request->post()) && $leadsquotedocuments->load(Yii::$app->request->post()) ) {


            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
            if($user_type->item_name != 'Admin')
            {
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$model->customer])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['leads-quotes/index']);
                }
            }

          $model->round_off=Yii::$app->request->post('roundoffval');
          if($from =='leads-enquiry')
          {
            $enquiry = LeadsEnquiry::find()->where(['id'=>$id])->one();
            $enquiry->converted_to = "Leads Quote";
            $enquiry->save(false);
          }
            $id_of_quotes=$count+1;  
            $model->quotes_id = $model->prefix.''.$id_of_quotes.''.$model->suffix;
            if(Yii::$app->request->post('reminder'))
                $model->set_reminder='Yes';
                else
                $model->set_reminder='No';
            if(Yii::$app->request->post('delivery_details'))
                $model->add_delivery_details='Yes';
                else
                $model->add_delivery_details='No';
            if(Yii::$app->request->post('packing_details'))
                $model->packing_details='Yes';
                else
                $model->packing_details='No';
            if($model->reminder_through==1)
            {
              $model->reminder_through='Yes';
            }   
            else
            {
               $model->reminder_through='No';
            }
            if($model->set_reminder=='No')
            {
              $model->reminder_for='';
              $model->reminder_through='No';
              $model->reminder_content='';
              $model->reminder_email='';
              $model->reminder_repeat='';
              $model->reminder_from_date='';
              $model->reminder_to_date='';
            }
            if($model->add_delivery_details=='No')
            {
              $model->delivery_note='';
              $model->suppliers_ref='';
              $model->other_reference='';
            }
            if($model->packing_details=='No')
            {
                $model->net_weight='';
                $model->gross_weight='';
                $model->dimention_of_primary='';
                $model->dimention_of_master='';
                $model->dimention_of_pallet='';
                $model->no_of_pallets='';
            }
            if($model->pointof_supply==21)
              {
                $model->igst_amount = 0;
              }
              if($model->pointof_supply!=21)
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
              }
              if($model->pointof_supply=='')
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
                $model->igst_amount=0;
              }
              $model->status = "Pending Quotes";
              $model->converted_to = "Pending";
            if($model->validate() && $model->save(false) ){
                if(isset($data['productdyn'])){
                foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                    $product = new LeadsQuotesProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->leads_quotes_id = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');
                    $product->save(false);
                }  
            }
           }
            if(isset($data['productdynupdate'])){
                foreach ($data['productdynupdate'] as $value) {
                    if($value['price']!='')
                    {
                    $quotesproduct = new LeadsQuotesProduct();
                    $quotesproduct->product_id = $value['product'];
                    $quotesproduct->description = $value['desc'];
                    $quotesproduct->quantity = $value['quantity'];
                    $quotesproduct->units = $value['units'];
                    $quotesproduct->price = $value['price'];
                    $quotesproduct->unit_price = $value['unitprice'];
                    $quotesproduct->discount = $value['discount'];
                    $quotesproduct->tax=$value['tax'];
                    $quotesproduct->discount_type=$value['discounttype'];
                    $quotesproduct->tax_included = $value['tax_included'];
                    $quotesproduct->amount = $value['amount'];
                    $quotesproduct->leads_quotes_id = $model->id;
                    $quotesproduct->created_at=date('Y-m-d H:i:s');
                    $quotesproduct->updated_at=date('Y-m-d H:i:s');
                    $quotesproduct->save(false);
                }
                }
            }
            if($leadsquotedocuments->validate())
                 {
                    $names=UploadedFile::getInstances($leadsquotedocuments,'document_name');
                    foreach ($names as $name) {
                        // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                        $path='leadsquote_documents/'.$name->baseName.'.'.$name->extension;
                        if($name->saveAs($path))
                        {
                            $filename = $name->baseName.'.'.$name->extension;
                            $filepath = $path;
                            yii::$app->db->createCommand()->insert('leads_quotes_document',['document_name'=>$filename,'leads_quotes_id'=>$model->id])->execute();
                        }
                        
                    }

                 }
            if (Yii::$app->request->post('save') == 0) {
                         Yii::$app->getSession()->setFlash('success', 'Successfully created the Leads Quotes');
                         return $this->redirect(['leads-quotes/index']);
                  }
                if (Yii::$app->request->post('save') == 1) {
                       Yii::$app->getSession()->setFlash('success', 'Successfully created the Leads Quotes');
                       return $this->redirect(['leads-quotes/create']);
                  }
        }
     }
        return $this->render('create', [
            'model' => $model,
            'leadsquotedocuments'=>$leadsquotedocuments,
            'sales_types' => LeadsQuotesController::$sales_types,
            'supply_types' => LeadsQuotesController::$supply_types,
            'last_entry'=> $last_entry+1,
            'quortsproduct' => $quortsproduct,
            'from' => $from,
            'lqtproducts' => $lqtproducts,

        ]);
    }
    /**
     * Updates an existing LeadsQuotes model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=41;


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = LeadsQuotes::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['leads-quotes/index']);
            }
        }

        
        $model = $this->findModel($id);
        $last_entry=LeadsQuotes::find()->count();
        $data=Yii::$app->request->post();
        $quotes_products = new LeadsQuotesProduct();
        $leadsquotedocuments = new LeadsQuotesDocument();
        $products =LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
        if ($model->load(Yii::$app->request->post()) && $leadsquotedocuments->load(Yii::$app->request->post()) ) {
            $model->round_off=Yii::$app->request->post('roundoffval');

            if(Yii::$app->request->post('reminder'))
                $model->set_reminder='Yes';
                else
                $model->set_reminder='No';
            if(Yii::$app->request->post('delivery_details'))
                $model->add_delivery_details='Yes';
                else
                $model->add_delivery_details='No';
            if(Yii::$app->request->post('packing_details'))
                $model->packing_details='Yes';
                else
                $model->packing_details='No';
            if($model->reminder_through==1 || $model->reminder_through=='Yes')
            {
              $model->reminder_through='Yes';
            }   
            else
            {
               $model->reminder_through='No';
            }
            if($model->set_reminder=='No')
            {
              $model->reminder_for='';
              $model->reminder_through='No';
              $model->reminder_content='';
              $model->reminder_email='';
              $model->reminder_repeat='';
              $model->reminder_from_date='';
              $model->reminder_to_date='';
            }
            if($model->reminder_through=='No')
            {
               $model->reminder_content='';
               $model->reminder_email='';
               $model->reminder_repeat='';
               $model->reminder_from_date='';
               $model->reminder_to_date='';
            }
            if($model->add_delivery_details=='No')
            {
              $model->delivery_note='';
              $model->suppliers_ref='';
              $model->other_reference='';
            }
            if($model->packing_details=='No')
            {
                $model->net_weight='';
                $model->gross_weight='';
                $model->dimention_of_primary='';
                $model->dimention_of_master='';
                $model->dimention_of_pallet='';
                $model->no_of_pallets='';
            }
            if($model->pointof_supply==21)
              {
                $model->igst_amount = 0;
              }
              if($model->pointof_supply!=21)
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
              }
              if($model->pointof_supply=='')
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
                $model->igst_amount=0;
              }
            if($model->validate() && $model->save(false) ){
            $purchase_order_product_delete=LeadsQuotesProduct::deleteAll(['leads_quotes_id'=>$id]);
            if(isset($data['productdyn'])){
            foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                $product = new LeadsQuotesProduct();
                $product->product_id = $value['product'];
                $product->description = $value['desc'];
                $product->quantity = $value['quantity'];
                $product->units = $value['units'];
                $product->price = $value['price'];
                $product->unit_price = $value['unitprice'];
                $product->discount = $value['discount'];
                $product->tax=$value['tax'];
                $product->discount_type=$value['discounttype'];
                $product->tax_included = $value['tax_included'];
                $product->amount = $value['amount'];
                $product->leads_quotes_id = $model->id;
                $product->created_at=date('Y-m-d H:i:s');
                $product->updated_at=date('Y-m-d H:i:s');
                $product->save(false);
            }
            }
         }
         if(isset($data['productdynupdate'])){
          
            foreach ($data['productdynupdate'] as $value) {
                if($value['price']!='')
                {
                $quotesproduct = new LeadsQuotesProduct();
                $quotesproduct->product_id = $value['product'];
                $quotesproduct->description = $value['desc'];
                $quotesproduct->quantity = $value['quantity'];
                $quotesproduct->units = $value['units'];
                $quotesproduct->price = $value['price'];
                $quotesproduct->unit_price = $value['unitprice'];
                $quotesproduct->discount = $value['discount'];
                $quotesproduct->tax=$value['tax'];
                $quotesproduct->discount_type=$value['discounttype'];
                $quotesproduct->tax_included = $value['tax_included'];
                $quotesproduct->amount = $value['amount'];
                $quotesproduct->leads_quotes_id = $model->id;
                $quotesproduct->created_at=date('Y-m-d H:i:s');
                $quotesproduct->updated_at=date('Y-m-d H:i:s');
                $quotesproduct->save(false);
            }
            }
        }
        if($leadsquotedocuments->validate())
             {
                $names=UploadedFile::getInstances($leadsquotedocuments,'document_name');
                foreach ($names as $name) {
                    // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                    $path='leadsquote_documents/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('leads_quotes_document',['document_name'=>$filename,'leads_quotes_id'=>$model->id])->execute();
                    }
                    
                }

             }
        if (Yii::$app->request->post('save') == 0) {
                 Yii::$app->getSession()->setFlash('success', 'Data Updated Successfully');
                 return $this->redirect(['leads-quotes/index']);
          }

        if (Yii::$app->request->post('save') == 1) {
               Yii::$app->getSession()->setFlash('success', 'Data Updated Successfully');
               return $this->redirect(['leads-quotes/create']);
          }
        } 

            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
            'sales_types' => LeadsQuotesController::$sales_types,
            'supply_types' => LeadsQuotesController::$supply_types,
            'last_entry'=> $last_entry,
            'products' => $products,
            'quotes_products' => $quotes_products,
            'leadsquotedocuments' => $leadsquotedocuments,
        ]);
    }

    public function actionFindproduct($productid)
   {
        $productdetails= Product::find()->where(['id' =>$productid])->one();
        echo Json::encode($productdetails);
   }
   public function actionFinddetails()
    { 
        $taxdetails= Accountingtax::find()->select(['tax_name','accounting_tax_id'])->where(['is_deleted'=>0])
              ->andWhere(['tax_sub_type'=>'Output'])
              ->andWhere(['status'=>1])
              ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])->all();      
        $taxlist=ArrayHelper::map($taxdetails, 'accounting_tax_id','tax_name');
        return Json::encode($taxlist);
    }
 public function actionFinddetailsdropdown()
    {
        $taxdetails = Accountingtax::find()->select(['tax_rate', 'tax_name'])->where(['is_deleted' => 0])
            ->andWhere(['tax_sub_type' => 'Output'])
            ->andWhere(['status' => 1])
            ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])->all();
        $taxlist = ArrayHelper::map($taxdetails, 'tax_rate', 'tax_name');
        return Json::encode($taxlist);
    }
   public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }

    public function actionPdfLeadsquote($id=null,$from=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if($user_type->item_name == 'Admin')
        {
            $query=LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $all = LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;
                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = LeadsQuotes::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
        }
        if($from=='all')
        {
            $dataProvider = new ActiveDataProvider([
            'query' => $query,
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/leads-quotes/export-pdf', [
                'dataProvider' => $dataProvider,
            ]));
            $mpdf->Output('LeadsQuotes.pdf', 'D');
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = LeadsQuotes::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['leads-quotes/index']);
                }
            }
            $model = LeadsQuotes::find()->where(['id'=>$id])->one();
            $leadsquote = LeadsQuotes::find()->where(['id'=>$id])->one();
            $find = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
            $count = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->count();

            $tax_amount= LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
            $taxable_amount = 0;
            foreach ($tax_amount as $tax_amount) {
              if($tax_amount->discount_type=="FLAT")
              {
                  $taxable_amount = $taxable_amount+($tax_amount->price - $tax_amount->discount);
              }
              if($tax_amount->discount_type=="%")
              {
                  $taxable_amount = $taxable_amount+($tax_amount->price - (($tax_amount->price * $tax_amount->discount)/100));
              }
              if($tax_amount->discount_type=="")
              {
                 $taxable_amount = $taxable_amount+$tax_amount->price;
              }
             }
            
                $customer = Customer::find()->where(['id'=>$leadsquote->customer])->one();
            
            $total_product = 0;
            foreach ($find as $find) {
              $total_product = $total_product+ $find->quantity;
              # code...
            }
            $products=LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
            $dataProvider = new ActiveDataProvider([
                'query' => LeadsQuotes::find()->where(['id'=>$id]),
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/leads-quotes/pdf-leadsquote', [
                'dataProvider' => $dataProvider,
                'model' => $model,
                'products' => $products,
                'customer' => $customer,
                'total_product' => $total_product,
                'taxable_amount' => $taxable_amount,
                'count'=>$count,
            ]));
            $find=LeadsQuotes::findOne($id);
            $quotes_id=$find->quotes_id;
            if($from == 'print')
            {
                $mpdf->Output($quotes_id.'-LeadsQuotes.pdf', 'I');
            }
            else
            {
                $mpdf->Output($quotes_id.'-LeadsQuotes.pdf', 'D');
            }
        }
        
        
    }
    public function actionExcelLeadsquote($id=null,$detail=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if($user_type->item_name == 'Admin')
        {
            $query=LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $all = LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;
                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = LeadsQuotes::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
        }
        
        if($id==null)
        {
            $dataProvider = new ActiveDataProvider([
            'query' =>$query,
                ]);

                if($detail){
                 $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'label' => 'Setting Type',
                        'attribute' => 'supply_attracts',
                        'value' => function ($data) {
                         return $data->supply_attracts;
                    },
                    ],
                     [
                        'label'=>'Customer',
                       'attribute' => 'customer',
                       'value' => function ($data) {
                            $val=Customer::find()->where(['id'=>$data->customer])->one();
                            return $val->business_name;
                       }
                    ],
                    [
                        'label' => 'Executive',
                        'attribute' => 'executive',
                        'value' => function ($data) {
                        $user= Leadexecutive::find()->where(['id' =>$data['executive']])->one();
                        return $user['name'];
                    },
                    ],
                    'notes:ntext',
                    'receiver_gstn',
                    'sales_type',
                    'supply_type',
                    'supply_attracts_rcharge',
                    'pointof_supply',
                    'pricelist',
                    'terms:ntext',
                    'Is_tax_paid',
                    'prefix',
                    'quotes_no',
                    'suffix',
                    'quotes_id',
                    'closure_property',
                    'sub_total_amount',
                    'total_amount',
                    'set_reminder',
                    'reminder_for',
                    'reminder_through',
                    'reminder_email',
                    'reminder_content',
                    'reminder_repeat',
                    'reminder_from_date',
                    'reminder_to_date',
                    'add_delivery_details',
                    'delivery_note',
                    'suppliers_ref',
                    'other_reference',
                    'packing_details',
                    'net_weight',
                    'gross_weight',
                    'dimention_of_primary',
                    'dimention_of_master',
                    'dimention_of_pallet',
                    'no_of_pallets',
                    [
                        'label' => 'Date',
                        'attribute' => 'date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y", strtotime($data['date']));
                            return $newDate;
                    },
                    ],
                    'status',
                    'converted_to',
                    [
                        'label' => 'Created Date',
                        'attribute' => 'created_date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['created_date']));
                            return $newDate;
                    },
                    ],
                    [
                        'label' => 'Updated Date',
                        'attribute' => 'updated_date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['updated_date']));
                            return $newDate;
                    },
                    ],
                ],
            ]);
                }else{
                    $exporter = new Spreadsheet([
                        'dataProvider' => $dataProvider,
                        'columns' => [
                           'quotes_id',
                           'total_amount',
                             [
                                'label'=>'Customer',
                               'attribute' => 'customer',
                               'value' => function ($data) {
                                    $val=Customer::find()->where(['id'=>$data->customer])->one();
                                    return $val->business_name;
                               }
                            ],
                           [
                            'label' => 'Executive',
                            'attribute' => 'executive',
                            'value' => function ($data) {
                                $user= Leadexecutive::find()->where(['id' =>$data['executive']])->one();
                                return $user['name'];
                            },
                            ],
                            [
                                'label' => 'Date',
                                'attribute' => 'date',
                                'value' => function ($data) {
                                    $newDate = date("d-m-Y", strtotime($data['date']));
                                    return $newDate;
                            },
                            ],
                            [
                                'label' => 'Age of Quote',
                                'value' => function ($data) {
                                    $today= time();
                                    $date = strtotime($data->date);
                                    $diff= $date-$today;
                                    return floor($diff/(60*60*24)).' Days';
                                    
                            },
                            ],
                            'closure_property',
                            'status',
                            'converted_to',
                        ],
                    ]);
                }
               
            return $exporter->send('LeadsQuotes-details.xlsx');
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = LeadsQuotes::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['leads-quotes/index']);
                }
            }
                $dataProvider = new ActiveDataProvider([
            'query' => LeadsQuotes::find()->where(['id'=>$id]),
                ]);
              $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'label' => 'Setting Type',
                        'attribute' => 'supply_attracts',
                        'value' => function ($data) {
                         return $data->supply_attracts;
                    },
                    ],
                     [
                        'label'=>'Customer',
                       'attribute' => 'customer',
                       'value' => function ($data) {
                            $val=Customer::find()->where(['id'=>$data->customer])->one();
                            return $val->business_name;
                       }
                    ],
                    [
                        'label' => 'Executive',
                        'attribute' => 'executive',
                        'value' => function ($data) {
                        $user= Leadexecutive::find()->where(['id' =>$data['executive']])->one();
                        if($user)
                        return $user['name'];
                    },
                    ],
                    'notes:ntext',
                    'receiver_gstn',
                    'sales_type',
                    'supply_type',
                    'supply_attracts_rcharge',
                    'pointof_supply',
                    'pricelist',
                    'terms:ntext',
                    'Is_tax_paid',
                    'prefix',
                    'quotes_no',
                    'suffix',
                    'quotes_id',
                    'closure_property',
                    'sub_total_amount',
                    'total_amount',
                    'set_reminder',
                    'reminder_for',
                    'reminder_through',
                    'reminder_email',
                    'reminder_content',
                    'reminder_repeat',
                    'reminder_from_date',
                    'reminder_to_date',
                    'add_delivery_details',
                    'delivery_note',
                    'suppliers_ref',
                    'other_reference',
                    'packing_details',
                    'net_weight',
                    'gross_weight',
                    'dimention_of_primary',
                    'dimention_of_master',
                    'dimention_of_pallet',
                    'no_of_pallets',
                    [
                        'label' => 'Date',
                        'attribute' => 'date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y", strtotime($data['date']));
                            return $newDate;
                    },
                    ],
                    'status',
                    'converted_to',
                    [
                        'label' => 'Created Date',
                        'attribute' => 'created_date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['created_date']));
                            return $newDate;
                    },
                    ],
                    [
                        'label' => 'Updated Date',
                        'attribute' => 'updated_date',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['updated_date']));
                            return $newDate;
                    },
                    ],
                ],
            ]);
               $find=LeadsQuotes::findOne($id);
                $quotes_id=$find->quotes_id; 
            return $exporter->send($quotes_id.'-LeadsQuotes.xlsx');
        }
        
        
    }
    /**
     * Deletes an existing LeadsQuotes model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            if($ids){
            foreach($ids as $id){
                 $leadsproducts = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
                 foreach($leadsproducts as $leadsproducts)
                  {
                    $leadsproducts->is_deleted=1;
                    $leadsproducts->save(false);
                  }
                  $data=$this->findModel($id);
                  $data->is_deleted=1;
                  $data->save(false);
            }
            } 
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
            return $this->redirect(['leads-quotes/index']);
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = LeadsQuotes::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['leads-quotes/index']);
                }
            }
            $this->findModel($id)->delete();
            return $this->redirect(['index']);
        }
        
    }
    // public function actionFindCustomer()
    // {
    //     $customer=Customer::find()->all();
    //     $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
    //     return json_encode($customerlist);
    // }
    public function actionCustomer($searchTerm=null)
    {   
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        // $accessed_id[] = $user_type->item_name;
        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Customer::find()->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }   
        else
        {

            $customer_ids = [];
            $i =0;

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            foreach($customers as $data)
            {
                $customer_ids[$i] = $data->client_id;
                $i++;
            }
            // print_r($customer_ids);
            // die();
            if(!$searchTerm)
            $customer=Customer::find()->where(['in','id',$customer_ids])->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$customer_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        } 


        
    }
    public function actionFindVendor()
    {
        $customer=Vendor::find()->all();
        $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }
    public function actionFindcustomerdetails($customerid)
    {
       $customerdetails= Customer::find()->where(['id' =>$customerid])->one();
        echo Json::encode($customerdetails);
    }
     public function actionFindexecutivedetails($executivedata)
    {
       $executivedetails= LeadExecutive::find()->where(['name' =>$executivedata])->one();
        echo Json::encode($executivedetails);
    }

    public function actionFindattachments($id)
    {
        $find=LeadsQuotesDocument::find()->select(['document_name','id'])->where(['leads_quotes_id'=>$id])->asArray ()->all();
        echo Json::encode($find);
        // return $exporter->send($find);
        // return $find;
    }
    public function actionDelattachment($id)
    {
        $file=LeadsQuotesDocument::find()->where(['id'=>$id])->one();
         $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
    public function actionDownload($id) 
    {
        $model=LeadsQuotesDocument::find()->where(['id'=>$id])->one();
        if($model->document_name!=null)
        {
            $local=yii::getAlias('@webroot/leadsquote_documents/');
            $name=$model->document_name;
            $find=$local.$name;
            if(file_exists($find))
            {
               return yii::$app->response->sendFile($find);
            }
        }
    }
    public function actionClosequote($id)
    {
        $findquote=LeadsQuotes::find()->where(['id'=>$id])->one();
        $findquote->status = "Closed Quotes";
        $findquote->save(false);
        Yii::$app->getSession()->setFlash('success', 'Successfully closed leadquote.');
                 return $this->redirect(['leads-quotes/index']);
    }
    public function actionTaxdetails($item)
    {
       $taxdetails= AccountingTax::find()->where(['accounting_tax_id' =>$item])->one();
        echo Json::encode($taxdetails);
    }

    public function actionFindleadsalldetails($id)
    {
        $all= LeadsQuotes::find()->where(['id' =>$id])->one();
        echo Json::encode($all);
    } 
    public function actionCreateUrl($id)
    {
        $url = Url::to(['pdf-leadsquote', 'id' => $id],'https');
        echo Json::encode($url);
    } 
    public function actionFinduseralldetails($id)
    {
        $all= LeadsQuotes::find()->where(['id' =>$id])->one();
        $userdetails = Customer::find()->where(['id'=>$all->customer])->one();
        echo Json::encode($userdetails);
    } 



    /**
     * Finds the LeadsQuotes model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return LeadsQuotes the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = LeadsQuotes::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
