<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\users\models\ReceiptDetailsSearch;
use backend\modules\users\models\ReceiptDocuments;
use backend\modules\users\models\PaymentMode;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrder;
use backend\modules\users\models\Invoice;
use backend\modules\users\models\AccountingDetails;
use backend\modules\users\models\AdjustedInvoices;
use backend\modules\users\models\DirectReceipt;
use backend\modules\master\models\AccountingLedger;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;
use yii\helpers\ArrayHelper;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\helpers\Json;
use backend\modules\users\models\SaleorderAgainstDc;
use yii\helpers\Url;
use backend\models\UserClient;
use backend\models\AuthAssignment;
use backend\modules\master\models\salesTemplates;
use backend\modules\master\models\GenericTemplate;
/**
 * ReceiptDetailsController implements the CRUD actions for ReceiptDetails model.
 */
class ReceiptDetailsController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    // 'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $payment_mode=["Cash"=>"Cash",
    "Cheque"=>"Cheque",
    "Card"=>"Card",
    "Mobile Payments"=>"Mobile Payments",
    ]
    ;
    public static $payment_type=["Payment Against Invoice"=>"Payment Against Invoice",
    "Advance against invoice"=>"Advance against invoice",
    "Direct Receipt"=>"Direct Receipt",

    ]
    ;
    public static $banks_name=["Punjab National Bank"=>"Punjab National Bank",
    "Bank of India"=>"Bank of India",
    "State Bank of India"=>"State Bank of India"        
    ]
    ;
    /**
     * Lists all ReceiptDetails models.
     * @return mixed
     */
    public function actionIndex()
    {
        Yii::$app->view->params['active']=16;
        $model = new ReceiptDetails();
        $searchModel = new ReceiptDetailsSearch();

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        }
        else
        {
            $accessed[] = Yii::$app->user->identity->id;
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams,$accessed);
        }

        
         // $query=ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
        // $dataProvider = new ActiveDataProvider([
        //     'query' => $query,
        // ]);
        if($model->load(Yii::$app->request->post())){

            if($model->findid!='')
            {
                if($model->send_email!='')
                {
		if($model->email_attachment!='')
		{
		$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                        $file=$model->email_attachment->baseName;
                        $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                        $model->email_attachment=$file.'.'.$model->email_attachment->extension;	
	
                    $message = Yii::$app->mailer->compose()
                   ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                   ->setTo(trim($model->send_email))
                   ->setSubject($model->email_subject)
                   ->setHtmlBody(nl2br($model->email_message))
		   ->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                       
                     if(!empty($model->cc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }   
                     if(!empty($model->bcc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }      
                     Yii::$app->mailer->send($message);
		}
		else
		{
			 $message = Yii::$app->mailer->compose()
                   ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                   ->setTo(trim($model->send_email))
                   ->setSubject($model->email_subject)
                   ->setHtmlBody(nl2br($model->email_message));

                     if(!empty($model->cc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }
                     if(!empty($model->bcc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }
                     Yii::$app->mailer->send($message);
		}
		     if($model->email_attachment!='')
		      {
		          unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
		      }

                     Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                     return $this->redirect(['receipt-details/index']);
                }
                else
                {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                     return $this->redirect(['receipt-details/index']);
                }
                
            }
            else
            {

                    if($user_type->item_name == 'Admin')
                    {
                        $query=ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
                    }
                    else
                    {
                        $accessed = Yii::$app->user->identity->id;
                        $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Vendor'])->all();
                        $customer_ids = [];
                        $j = 0;
                        foreach($customers as $data)
                        {
                            $customer_ids[$j] = $data->client_id;
                            $j++;
                        }
                        $query = ReceiptDetails::find()->where(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
                    }

                    if($model->receipt_prifix!=null && $model->r_number!=null &&$model->receipt_suffix!=null)
                    {
                     $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                     $query=ReceiptDetails::find()->where(['receipt_id'=>$receiptsearch]);
                     $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    if($model->receipt_prifix!=null && $model->r_number!=null &&$model->receipt_suffix==null)
                    {
                        $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                        $query=ReceiptDetails::find()->where(['receipt_id'=>$receiptsearch]);
                        $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    if($model->receipt_prifix==null && $model->r_number!=null &&$model->receipt_suffix==null)
                    {
                        // $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                        $query=ReceiptDetails::find()->where(['receipt_no'=>$model->r_number]);
                        $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    else
                    {


                        $query
                            
                            ->andFilterWhere(['between', 'receipt_date', $model->from_date,$model->to_date])
                            ->andFilterWhere(['customer_name'=>$model->customer])
                            ->andFilterWhere(['like', 'customer_type', $model->type_of_customer])
                            ->andFilterWhere(['like', 'bank_name', $model->bank])
                            ->andFilterWhere(['setting_type'=>$model->setting])
                            ->andFilterWhere(['payment_type'=>$model->type_of_payment])
                            ->andFilterWhere(['between', 'amount',$model->amount_from,$model->amount_upto])
                            ->andFilterWhere(['notes'=>$model->receipt_note])
                            ->andFilterWhere(['cheque_no'=>$model->cheque_number]);
                     // print_r($model->amount_from);
                     // exit();
                    }
               

                $dataProvider = new ActiveDataProvider(['query' => $query]);
            }
        }

        

	        if($model->load(Yii::$app->request->get())){

            if($model->findid!='')
            {
                if($model->send_email!='')
                {
		if($model->email_attachment!='')
		{
		$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                        $file=$model->email_attachment->baseName;
                        $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                        $model->email_attachment=$file.'.'.$model->email_attachment->extension;	
	
                    $message = Yii::$app->mailer->compose()
                   ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                   ->setTo(trim($model->send_email))
                   ->setSubject($model->email_subject)
                   ->setHtmlBody(nl2br($model->email_message))
		   ->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                       
                     if(!empty($model->cc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }   
                     if(!empty($model->bcc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }      
                     Yii::$app->mailer->send($message);
		}
		else
		{
			 $message = Yii::$app->mailer->compose()
                   ->setFrom([trim('ticket.system11@gmail.com')=>"Mohapatra scientific"])
                   ->setTo(trim($model->send_email))
                   ->setSubject($model->email_subject)
                   ->setHtmlBody(nl2br($model->email_message));

                     if(!empty($model->cc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }
                     if(!empty($model->bcc_to_email!="")){
                        $message->setBcc(trim($model->bcc_to_email));
                       }
                     Yii::$app->mailer->send($message);
		}
		     if($model->email_attachment!='')
		      {
		          unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
		      }

                     Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                     return $this->redirect(['receipt-details/index']);
                }
                else
                {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                     return $this->redirect(['receipt-details/index']);
                }
                
            }
            else
            {

                    if($user_type->item_name == 'Admin')
                    {
                        $query=ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
                    }
                    else
                    {
                        $accessed = Yii::$app->user->identity->id;
                        $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Vendor'])->all();
                        $customer_ids = [];
                        $j = 0;
                        foreach($customers as $data)
                        {
                            $customer_ids[$j] = $data->client_id;
                            $j++;
                        }
                        $query = ReceiptDetails::find()->where(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
                    }

                    if($model->receipt_prifix!=null && $model->r_number!=null &&$model->receipt_suffix!=null)
                    {
                     $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                     $query=ReceiptDetails::find()->where(['receipt_id'=>$receiptsearch]);
                     $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    if($model->receipt_prifix!=null && $model->r_number!=null &&$model->receipt_suffix==null)
                    {
                        $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                        $query=ReceiptDetails::find()->where(['receipt_id'=>$receiptsearch]);
                        $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    if($model->receipt_prifix==null && $model->r_number!=null &&$model->receipt_suffix==null)
                    {
                        // $receiptsearch=$model->receipt_prifix.''.$model->r_number.''.$model->receipt_suffix;
                        $query=ReceiptDetails::find()->where(['receipt_no'=>$model->r_number]);
                        $dataProvider = new ActiveDataProvider(['query' => $query]); 
                    }
                    else
                    {


                        $query
                            
                            ->andFilterWhere(['between', 'receipt_date', $model->from_date,$model->to_date])
                            ->andFilterWhere(['customer_name'=>$model->customer])
                            ->andFilterWhere(['like', 'customer_type', $model->type_of_customer])
                            ->andFilterWhere(['like', 'bank_name', $model->bank])
                            ->andFilterWhere(['setting_type'=>$model->setting])
                            ->andFilterWhere(['payment_type'=>$model->type_of_payment])
                            ->andFilterWhere(['between', 'amount',$model->amount_from,$model->amount_upto])
                            ->andFilterWhere(['notes'=>$model->receipt_note])
                            ->andFilterWhere(['cheque_no'=>$model->cheque_number]);
                     // print_r($model->amount_from);
                     // exit();
                    }
               

                $dataProvider = new ActiveDataProvider(['query' => $query]);
            }
        }


        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,
            'banks_name'=> ReceiptDetailsController::$banks_name,
            'payment_types'=> ReceiptDetailsController::$payment_type,
        ]);
    }

    /**
     * Displays a single ReceiptDetails model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        Yii::$app->view->params['active']=16;


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_sale = ReceiptDetails::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_sale->customer_name])->andWhere(['client_type'=>'Customer'])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'You are not allowed to perform this action.');
                return $this->redirect(['receipt-details/index']);
            }
        }

        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new ReceiptDetails model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($invoice=0,$id=0,$from=null)
    {
        Yii::$app->view->params['active']=16;
        $model = new ReceiptDetails();
        $document = new ReceiptDocuments();
        $total_amount_adjusted = 0;
        $paymentmode=PaymentMode::find()->all();
        $paymentmodelist=ArrayHelper::map($paymentmode, 'payment_mode_name', 'payment_mode_name');

        if($id)
        {
            // if($from=='saleorder')
            // {
            //       $saleorder_data= SaleOrder::find()->where(['id' =>$id])->one();
            //       $invoice_data= Invoice::find()->where(['sale_order_id' =>$id])->count();
            //       if($invoice_data)
            //       {
            //           $name = Customer::find()->where(['id' =>$saleorder_data->customer_id])->one();
            //           $model->customer_name= $saleorder_data->customer_id;
            //           $paymentagenstsaleorder = ReceiptDetails::find()->where(['sale_order_no'=>$id])->all();
                      
            //           $model->payment_type='Payment Against Invoice';
            //           // $model->tds_amount=0;
            //           $model->sale_order_no=$id;
            //       }  
            //       else
            //       {
            //         Yii::$app->getSession()->setFlash('success', 'No invoice Found For The Saleorder To Pay.');
            //              return $this->redirect(['sale-order/saleorder-pending']);
            //       }
            //       // $model->setAttributes($saleorder_data->attributes);
                  
            // }
            if($from=='against_dc')
            {
                  $saleorderagainstdc = SaleorderAgainstDc::find()->where(['id'=>$id])->one();
                  $invoice_data= Invoice::find()->where(['id' =>$saleorderagainstdc->invoice_no])->one(); 
                   if($invoice_data->pending_amount>0)
                   {
                         $paymentagenstsaleorder = ReceiptDetails::find()->where(['invoice_no'=>$invoice_data->invoice_id])->all();
                         $amountagenstsaleorder = 0;
                            foreach ($paymentagenstsaleorder as $key => $value) {
                              $amountagenstsaleorder = $amountagenstsaleorder + $value->amount;
                            }
                          $model->amount =$invoice_data->total_price - $amountagenstsaleorder;
                          $model->total_amount =$invoice_data->total_price - $amountagenstsaleorder;
                          $customer = Customer::find()->where(['id'=>$invoice_data->customer_name])->one();
                         $model->customer_name= $invoice_data->customer_name;
                         $model->invoice_amount = $invoice_data->total_price;
                         $model->balance_amount = $invoice_data->pending_amount;
                         $model->payment_type='Payment Against Invoice';
                         $model->tds_amount = 0;
                         $model->invoice_no=$invoice_data->invoice_id;
                         $model->sale_order_no=$invoice_data->sale_order_id;     
                   }else
                   {
                       Yii::$app->getSession()->setFlash('success', 'Full amount for this invoice is already paid.');
                             return $this->redirect(['invoice/index']);
                   }
            }
            if($from=='invoice')
            {

               $invoice_data= Invoice::find()->where(['id' =>$id])->one(); 
               if($invoice_data->pending_amount>0)
               {
                     $paymentagenstsaleorder = ReceiptDetails::find()->where(['invoice_no'=>$invoice_data->invoice_id])->all();

                     $amountagenstsaleorder = 0;
                        foreach ($paymentagenstsaleorder as $key => $value) {
                          $amountagenstsaleorder = $amountagenstsaleorder + $value->amount;
                        }
                      $model->amount =$invoice_data->total_price - $amountagenstsaleorder;
                      $model->total_amount =$invoice_data->total_price - $amountagenstsaleorder;
                      $customer = Customer::find()->where(['id'=>$invoice_data->customer_name])->one();
                     $model->customer_name= $invoice_data->customer_name;
                     $model->invoice_amount = $invoice_data->total_price;
                     $model->balance_amount = $invoice_data->pending_amount;
                     $model->payment_type='Payment Against Invoice';
                     $model->tds_amount = 0;
                     $model->invoice_no=$invoice_data->invoice_id;
                     $model->sale_order_no=$invoice_data->sale_order_id; 
               }else
               {
                   Yii::$app->getSession()->setFlash('success', 'Full amount for this invoice is already paid.');
                         return $this->redirect(['invoice/index']);
               } 
            }
        }

        $selected_date=date('Y-m-d');
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if( strtotime($selected_date) <= strtotime($dynamic_date))
            {
               // $last_entry=ReceiptDetails::find()->where(['<=', 'receipt_date', $dynamic_date])->count();
               $last=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->orderBy(['id' => SORT_DESC])->one();
	       if($last)
                 $last_entry = $last->id;
               else
                 $last_entry = 0;
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
               // $last_entry=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->count();
                $last=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->orderBy(['id' => SORT_DESC])->one();
                if($last)
                 $last_entry = $last->id;
                else
                 $last_entry = 0;
            }
            else{
                $last_entry=0;
            }


        if(ReceiptDetails::find()->count() > 0) { 
            $total=ReceiptDetails::find()->orderBy(['id' => SORT_DESC])->one();
            $count=$total->id;  
        }
        else{
            $count=0;
        } 
         
        if ($model->load(Yii::$app->request->post()) && $document->load(Yii::$app->request->post()) ) {


            if($model->customer_name!='')
            {
                $loged_by = Yii::$app->user->identity->id; 
                $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

                if($user_type->item_name != 'Admin')
                {
                    $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$model->customer_name])->andWhere(['client_type'=>'Customer'])->one(); 
                    if($check_customer == '')
                    {
                        Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                        return $this->redirect(['receipt-details/index']);
                    }
                }
            }

            $data= Yii::$app->request->post();
            $model->created_at=date('Y-m-d H:i:s');
            $model->updated_at=date('Y-m-d H:i:s');
            $model->total_amount= $model->total_amount;

             $model->receipt_id = $model->prefix.''.$model->receipt_no.''.$model->suffix;
             $type=Customer::find()->where(['id'=>$model->customer_name])->one();
             // $model->customer_type=$type->customer_type; 
            
             if($model->save(false) ){
                if(Yii::$app->request->post('Bill')){
                    $billdata=Yii::$app->request->post()['Bill'];
                    // echo '<pre>';
                    // print_r($billdata);
                    // die();
                    foreach($billdata as $value){
                        if($value['ledger_os_id']){
                        $bill=Invoice::find()->where(['id'=>$value['ledger_os_id']])->one();

                        if($bill->pending_amount-($value['totamount'] + $value['tds_amount'])>=0)
                        {
                          $sale_odr = SaleOrder::find()->where(['id'=>$bill->sale_order_id])->one();
                          if($sale_odr)
                          {
                            $sale_odr->paid_amount = $sale_odr->paid_amount + ($value['totamount']+ $value['tds_amount']);
                            $sale_odr->save(false);
                          }
                          
                          $bill->pending_amount=$bill->pending_amount-($value['totamount']+ $value['tds_amount']);
                        }
                        else{
                            $sale_odr = SaleOrder::find()->where(['id'=>$bill->sale_order_id])->one();
                            $bill->extra_paid_amount=($value['totamount']+ $value['tds_amount'])-$bill->pending_amount;
                            if($sale_odr)
                            {
                              $sale_odr->paid_amount = $sale_odr->paid_amount + $bill->pending_amount;
                              $sale_odr->save(false);
                            }
                            
                            $bill->pending_amount=0;
                             

                        }
                        $bill->save(false);
                        $saleorderagainstdc = SaleorderAgainstDc::find()->where(['invoice_no'=>$bill->id])->andWhere(['is_deleted'=>0])->all();
                            if($bill->pending_amount<=0)
                            {
                                 foreach ($saleorderagainstdc as $key => $salevalue) {
                                   $salevalue->convert_to = "Completed";
                                   $salevalue->save(false);
                                 }
                            }
                    }else{
                        $customerind=Customer::find()->where(['id'=>$model->customer_name])->one();
                       $customerind->opening_as_on=$customerind->opening_as_on-($value['totamount']+ $value['tds_amount']);
                       $customerind->save(false);
                    }
                        if($value['totamount']||$value['tds_amount']){
                        $adjust=new AdjustedInvoices();
                        $adjust->customer_id=$model->customer_name;
                        if($value['ledger_os_id'])
                        {
                            $adjust->type="invoice";
                            if($value['ledger_os_id'])
                            {
                                $find_inv_data = Invoice::find()->where(['id'=>$value['ledger_os_id']])->one();
                                $req_invoice_amount = $find_inv_data->total_price;
                                if($find_inv_data->point_of_supply == '21')
                                {
                                    $total_tax = $find_inv_data->cgst_amount + $find_inv_data->sgst_amount;
                                }
                                else
                                {
                                    $total_tax = $find_inv_data->igst_amount;
                                }
                                $gst_percentage = ((($total_tax/$req_invoice_amount))*100);
                                $receipt_gst_amount = $value['totamount']*($gst_percentage/100);
                                if($find_inv_data->point_of_supply == '21')
                                {
                                    $cgst_tax = $receipt_gst_amount/2;
                                    $sgst_tax = $receipt_gst_amount/2;
                                    $adjust->cgst_amount=$cgst_tax;
                                    $adjust->sgst_amount=$sgst_tax;
                                }
                                else
                                {
                                    $adjust->igst_amount=$receipt_gst_amount;
                                }

                                $receipt_taxable_amount =  $value['totamount'] - $receipt_gst_amount;
                                if($find_inv_data->is_tcs==1)
                                {
                                    $receipt_tds_amount = $value['totamount']*(1/100);
                                    $adjust->tcs_amount=$receipt_tds_amount;
                                    $receipt_taxable_amount =  $receipt_taxable_amount - $receipt_tds_amount;
                                }
                                $adjust->taxable_amount = $receipt_taxable_amount;


                            }
                        }
                        
                        else
                        $adjust->type="opening";
                        $adjust->receipt_id=$model->id;
                        $adjust->invoice_id=$value['ledger_os_id'];
                        $adjust->tds_amount=$value['tds_amount'];
                        $adjust->notes=$value['notes'];
                        $adjust->amount_adjusted=$value['totamount'];
                        $adjust->save(false);


                         $total_amount_adjusted = $total_amount_adjusted + $adjust->amount_adjusted;
                        }
                    }



                    if($total_amount_adjusted < $model->amount)
                    {
                        $custinds=Customer::findOne($model->customer_name);
                        // print_r($vendorinds->opening_as_on);
                        // die();
                        if($custinds->opening_as_on=='')
                        {
                            $custinds->opening_as_on = 0;
                        }
                       

                        $custinds->opening_as_on=$custinds->opening_as_on+($model->amount-$total_amount_adjusted);
                        $custinds->save(false);
                    } 



                }
                if($model->payment_type=="Direct Receipt"){
                    $model->tds_amount=Yii::$app->request->post('Invoice')['taxVal']; 

                $model->amount= Yii::$app->request->post('Invoice')['sumTotal']; 
                $model->total_amount= Yii::$app->request->post('Invoice')['sumTotal'];
                    $model->save(false);
                    $ledger=Yii::$app->request->post()['Products'];
                    foreach($ledger as $val){
                    $adjust=new DirectReceipt();
                    $adjust->ledger_id=$val['accountDD'];
                    $adjust->receipt_id=$model->id;
                    if($val['item_price']=='')
                    {
                        $adjust->price='0.00';
                    }
                    else
                    {
                        $adjust->price=$val['item_price'];
                    }

                    if($val['tax_amount']=='')
                    {
                        $adjust->tds_amount='0.00';
                    }
                    else
                    {
                        $adjust->tds_amount=$val['tax_amount'];
                    }
                    
                    $adjust->total=$val['total'];
                    $adjust->save(false);
                    }

                }

            if($id!=0)
            {

                if($from=='against_dc')
                {
                    $invoice_amount_paid = 0;
                    $invoice = Invoice::find()->where(['id'=>$invoice_data->id])->one();
                    // $saleorder_data = SaleOrder::find()->where()
                    $agenestreceipt = ReceiptDetails::find()->where(['invoice_no'=>$invoice_data->invoice_id])->all();
                    $invoiceaganestinvoice = AdjustedInvoices::find()->where(['invoice_id'=>$invoice_data->invoice_id])->all();

                   
                      if($invoice->sale_order_id!='')
                        {
                          $saleorderaginestinvoice = SaleOrder::find()->where(['id'=>$invoice->sale_order_id])->one();
                          if($saleorderaginestinvoice)
                          {
                              $saleorderaginestinvoice->paid_amount = $saleorderaginestinvoice->paid_amount + ($model->amount+$model->tds_amount);
                              if($saleorderaginestinvoice->paid_amount>=$saleorderaginestinvoice->total_amount)
                              {
                                $saleorderaginestinvoice->converted_to ='Receipt';
                                $saleorderaginestinvoice->order_status='Paid';
                                $saleorderaginestinvoice->dc_status = 2;
                                $saleorderaginestinvoice->save(false);
                              }
                              else if($saleorderaginestinvoice->paid_amount>0 && $saleorderaginestinvoice->paid_amount<$saleorderaginestinvoice->total_amount)
                              {
                                  $saleorderaginestinvoice->order_status='Partially Paid';
                                  $saleorderaginestinvoice->save(false);
                              }
                              else
                              {
                                  $saleorderaginestinvoice->order_status='Pending';
                                  $saleorderaginestinvoice->save(false);
                              }
                          }
                } 

                $invoice->pending_amount = $invoice->pending_amount-($model->amount+$model->tds_amount);
                $invoice->save(false); 

                $saleorderagainstdc = SaleorderAgainstDc::find()->where(['invoice_no'=>$invoice->id])->andWhere(['is_deleted'=>0])->all();
                if($invoice->pending_amount<=0)
                {
                     foreach ($saleorderagainstdc as $key => $value) {
                       $value->convert_to = "Completed";
                       $value->save(false);
                     }
                }



                 // if($value['ledger_os_id'])
                 // {
                    $find_inv_data = Invoice::find()->where(['id'=>$invoice_data->id])->one();
                    $req_invoice_amount = $find_inv_data->total_price;
                    if($find_inv_data->point_of_supply == '21')
                    {
                        $total_tax = $find_inv_data->cgst_amount + $find_inv_data->sgst_amount;
                    }
                    else
                    {
                        $total_tax = $find_inv_data->igst_amount;
                    }
                    $gst_percentage = ((($total_tax/$req_invoice_amount))*100);
                    $receipt_gst_amount = $model->total_amount*($gst_percentage/100);
                    if($find_inv_data->point_of_supply == '21')
                    {
                        $cgst_tax = $receipt_gst_amount/2;
                        $sgst_tax = $receipt_gst_amount/2;
                        $model->cgst_amount=$cgst_tax;
                        $model->sgst_amount=$sgst_tax;
                    }
                    else
                    {
                        $model->igst_amount=$receipt_gst_amount;
                    }
                    $receipt_taxable_amount =  $model->total_amount - $receipt_gst_amount;
                    if($find_inv_data->is_tcs==1)
                    {
                        $receipt_tds_amount = $model->total_amount*(1/100);
                        $model->tcs_amount=$receipt_tds_amount;
                        $receipt_taxable_amount =  $receipt_taxable_amount - $receipt_tds_amount;
                    }
                    $model->taxable_amount = $receipt_taxable_amount;
                    $model->save(false);
                // }



                }
                if($from=='invoice')
                {
                    $invoice_amount_paid = 0;
                    $invoice = Invoice::find()->where(['id'=>$invoice_data->id])->one();
                    // $saleorder_data = SaleOrder::find()->where()
                    $agenestreceipt = ReceiptDetails::find()->where(['invoice_no'=>$invoice_data->invoice_id])->all();
                    $invoiceaganestinvoice = AdjustedInvoices::find()->where(['invoice_id'=>$invoice_data->invoice_id])->all();

                   
                      if($invoice->sale_order_id!='')
                        {
                          $saleorderaginestinvoice = SaleOrder::find()->where(['id'=>$invoice->sale_order_id])->one();
                          if($saleorderaginestinvoice)
                          {
                              $saleorderaginestinvoice->paid_amount = $saleorderaginestinvoice->paid_amount + ($model->amount+$model->tds_amount);
                              if($saleorderaginestinvoice->paid_amount>=$saleorderaginestinvoice->total_amount)
                              {
                                $saleorderaginestinvoice->converted_to ='Receipt';
                                $saleorderaginestinvoice->order_status='Paid';
                                $saleorderaginestinvoice->dc_status = 2;
                                $saleorderaginestinvoice->save(false);
                              }
                              else if($saleorderaginestinvoice->paid_amount>0 && $saleorderaginestinvoice->paid_amount<$saleorderaginestinvoice->total_amount)
                              {
                                  $saleorderaginestinvoice->order_status='Partially Paid';
                                  $saleorderaginestinvoice->save(false);
                              }
                              else
                              {
                                  $saleorderaginestinvoice->order_status='Pending';
                                  $saleorderaginestinvoice->save(false);
                              }
                          }
                          
                          
                } 

                $invoice->pending_amount = $invoice->pending_amount-($model->amount+$model->tds_amount);
                    // $sale->converted_to ='Receipt';
                $invoice->save(false); 
                $saleorderagainstdc = SaleorderAgainstDc::find()->where(['invoice_no'=>$invoice->id])->andWhere(['is_deleted'=>0])->all();
                if($invoice->pending_amount<=0)
                {
                     foreach ($saleorderagainstdc as $key => $value) {
                       $value->convert_to = "Completed";
                       $value->save(false);
                     }
                }

                $find_inv_data = Invoice::find()->where(['id'=>$invoice_data->id])->one();
                $req_invoice_amount = $find_inv_data->total_price;
                if($find_inv_data->point_of_supply == '21')
                {
                    $total_tax = $find_inv_data->cgst_amount + $find_inv_data->sgst_amount;
                }
                else
                {
                    $total_tax = $find_inv_data->igst_amount;
                }
                $gst_percentage = ((($total_tax/$req_invoice_amount))*100);
                $receipt_gst_amount = $model->total_amount*($gst_percentage/100);
                if($find_inv_data->point_of_supply == '21')
                {
                    $cgst_tax = $receipt_gst_amount/2;
                    $sgst_tax = $receipt_gst_amount/2;
                    $model->cgst_amount=$cgst_tax;
                    $model->sgst_amount=$sgst_tax;
                }
                else
                {
                    $model->igst_amount=$receipt_gst_amount;
                }
                $receipt_taxable_amount =  $model->total_amount - $receipt_gst_amount;
                if($find_inv_data->is_tcs==1)
                {
                    $receipt_tds_amount = $model->total_amount*(1/100);
                    $model->tcs_amount=$receipt_tds_amount;
                    $receipt_taxable_amount =  $receipt_taxable_amount - $receipt_tds_amount;
                }
                $model->taxable_amount = $receipt_taxable_amount;
                $model->save(false);  
            } 
          }
            
            


            if($model->payment_type=="Direct Receipt"){
                $ledgerind=Yii::$app->request->post()['Products'];
                foreach($ledgerind as $val){
                $accounting=AccountingLedger::findOne($val['accountDD']);
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $accounting->ledger_id;
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                if( $val['item_price']=='')
                {
                    $ledger->amount = '0.00';
                }
                else
                {
                    $ledger->amount = $val['item_price'];
                }
                
                $ledger->date = $model->receipt_date;
                $ledger->save(false);
                if($val['tax_amount']){
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "TDS Amount";
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $val['tax_amount'];
                $ledger->date = $model->receipt_date;
                $ledger->save(false);
                }
                }
                $ledger = new AccountingDetails();
                
                if($model->payment_mode=='Cash')
                {
                    $ledger->ledgerhead_id = $model->payment_mode;
                }
                else
                {
                    $ledger->ledgerhead_id = $model->bank_name;
                }
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $model->total_amount;
                $ledger->date = $model->receipt_date;
                $ledger->save(false);
            }

            else{
                if($model->payment_type=="Payment Against Invoice")
                {
                    $amt = $model->amount;
                    $tds_amount = $model->tds_amount;
                    $final_amt = $model->total_amount;
                    $tan_id = $model->id;
                    $tan_date = $model->receipt_date;
                    if($model->invoice_no!='')
                    {
                      $paid_by = Invoice::find()->where(['invoice_id'=>$model->invoice_no])->one();
                      $customer_name = Customer::find()->where(['id'=>$paid_by->customer_name])->one();
                      $amtfrom = $customer_name->business_name;

                    }
                    else
                    {
                        $customer_name = Customer::find()->where(['id'=>$model->customer_name])->one();
                        $amtfrom = $customer_name->business_name;

                    }
                    $payment_mode = $model->payment_mode;
                    $bank_name = $model->bank_name;
                $ledger = new AccountingDetails();
                $ledger->leadgerentryreceipt($amt,$tds_amount,$final_amt,$tan_id,$amtfrom,$payment_mode,$bank_name,$tan_date);
                }
                if($model->payment_type=="Advance against invoice")
                {
                    $customer_name = Customer::find()->where(['id'=>$model->customer_name])->one();
                    $customer_name->opening_as_on = ($customer_name->opening_as_on) + ($model->amount);
                    $customer_name->save(false);
                }   
                
            }
                 if($document->validate())
                 {
                    $names=UploadedFile::getInstances($document,'document_name');
                    foreach ($names as $name) {
                        $path='receiptdocuments/'.$name->baseName.'.'.$name->extension;
                        if($name->saveAs($path))
                        {
                            $filename = $name->baseName.'.'.$name->extension;
                            $filepath = $path;
                            yii::$app->db->createCommand()->insert('receipt_documents',['document_name'=>$filename,'receipt_id'=>$model->id])->execute();
                        }  
                    }
                 }
                if (Yii::$app->request->post('save') == 0) {
                         Yii::$app->getSession()->setFlash('success', 'Successfully created the receipt');
                         return $this->redirect(['receipt-details/index']);
                  }

                if (Yii::$app->request->post('save') == 1) {
                       Yii::$app->getSession()->setFlash('success', 'Successfully created the receipt');
                       return $this->redirect(['receipt-details/create']);
                  }
               
            }
          
                 
        }
        // print_r($from);
        // die();
        return $this->render('create', [
            'model' => $model,
            'count' => $count,
            'document' => $document,
            'from' => $from,
            'id' => $id,
            'last_entry'=>$last_entry+1,
            'payment_modes'=> $paymentmodelist,
            'payment_types'=> ReceiptDetailsController::$payment_type,
            'banks_name'=> ReceiptDetailsController::$banks_name,

        ]);
    }

    /**
     * Updates an existing ReceiptDetails model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        Yii::$app->view->params['active']=16;
        $model = $this->findModel($id);

        $prv_model_amount = $model->amount;
        $extra_amount_paid_by_customer = 0;
        $prv_adjusted_bill_amt = 0;

        $paymentmode=PaymentMode::find()->all();
        $paymentmodelist=ArrayHelper::map($paymentmode, 'payment_mode_name', 'payment_mode_name');



        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        $selected_date=$model->receipt_date;
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if( strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=ReceiptDetails::find()->where(['<=', 'receipt_date', $dynamic_date])->count();
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->count();
            }
            else{
                $last_entry=0;
            }

        if($user_type->item_name != 'Admin')
        {
            $check_for_sale = ReceiptDetails::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_sale->customer_name])->andWhere(['client_type'=>'Customer'])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'You are not allowed to perform this action.');
                return $this->redirect(['receipt-details/index']);
            }
        }


        $document = new ReceiptDocuments();
         $oldfile = $model->receipt_documents;
         $from=null;
         $id = null;
        if ($model->load(Yii::$app->request->post()) && $document->load(Yii::$app->request->post()) ) {

            if($model->payment_type=="Direct Receipt"){
                DirectReceipt::deleteAll(['receipt_id'=>$model->id]);
                AdjustedInvoices::deleteAll(['receipt_id'=>$model->id]);
                $model->tds_amount=Yii::$app->request->post('Invoice')['taxVal'];
                $model->amount= Yii::$app->request->post('Invoice')['sumTotal']; 
                $model->total_amount= Yii::$app->request->post('Invoice')['sumTotal'];
                // $model->receipt_id = $model->prefix.''.$model->receipt_no.''.$model->suffix;
                $model->save(false);
                $model->receipt_id = $model->prefix.''.$model->receipt_no.''.$model->suffix;
                $model->save(false);
                $ledger=Yii::$app->request->post()['Products'];
                foreach($ledger as $val){
                $adjust=new DirectReceipt();
                $adjust->ledger_id=$val['accountDD'];
                $adjust->receipt_id=$model->id;

                if($val['item_price']=='')
                {
                    $adjust->price='0.00';
                }
                else
                {
                    $adjust->price=$val['item_price'];
                }

                if($val['tax_amount']=='')
                {
                    $adjust->tds_amount='0.00';
                }
                else
                {
                    $adjust->tds_amount=$val['tax_amount'];
                }
                $adjust->total=$val['total'];
                $adjust->save(false);
                }

            }

             if($model->invoice_amount !='' && $model->balance_amount!= '')
              {
                  $findinvoice = Invoice::find()->where(['invoice_id'=>$model->invoice_no])->one();
                  $findreceipt = ReceiptDetails::find()->where(['id'=>$model->id])->one();
                      $findinvoice->pending_amount = $findinvoice->pending_amount + $findreceipt->amount;
                      $findinvoice->save(false);
                      $findsaleorder = SaleOrder::find()->where(['id'=>$findinvoice->sale_order_id])->one();
                      if($findsaleorder)
                      {
                            $findsaleorder->paid_amount = $findsaleorder->paid_amount + $findreceipt->amount;
                            $findsaleorder->save(false);
                      }
                      
              }

            if(Yii::$app->request->post('Bill')){


                DirectReceipt::deleteAll(['receipt_id'=>$model->id]);
                $adjusted=AdjustedInvoices::find()->where(['receipt_id'=>$model->id,'type'=>'invoice'])->all();
                foreach($adjusted as $value){
                    $adjbill=Invoice::find()->where(['id'=>$value->invoice_id])->one();
                    $adjsaleorder = SaleOrder::find()->where(['id'=>$adjbill->sale_order_id])->one();
                    if($adjsaleorder!='')
                    {
                        $adjsaleorder->paid_amount = $adjsaleorder->paid_amount - $value->amount_adjusted;
                        $adjsaleorder->save(false);
                    } 
                    $adjbill->pending_amount=$adjbill->pending_amount+$value->amount_adjusted;
                    $adjbill->tds_amount=$adjbill->tds_amount+$value->tds_amount;
                    $adjbill->save(false);
                    $prv_adjusted_bill_amt = $prv_adjusted_bill_amt + $value->amount_adjusted;
                    $value->delete();
                }
                $billdata=Yii::$app->request->post()['Bill'];
                foreach($billdata as $value){
                    if($value['ledger_os_id']){
                    $bill=Invoice::find()->where(['id'=>$value['ledger_os_id']])->one();
                    if($bill->pending_amount-($value['totamount'] + $value['tds_amount'])>=0){
                      $sale_odr = SaleOrder::find()->where(['id'=>$bill->sale_order_id])->one();
                      if($sale_odr)
                      {
                        $sale_odr->paid_amount = $sale_odr->paid_amount + ($value['totamount']+$value['tds_amount']);
                        $sale_odr->save(false);
                      }
                    
                    $bill->pending_amount=$bill->pending_amount-($value['totamount']+$value['tds_amount']);
                    $bill->tds_amount=$bill->tds_amount+$value['tds_amount'];
                    
                    }else{
                      $bill->extra_paid_amount=($value['totamount']+$value['tds_amount'])-$bill->pending_amount;
                      $sale_odr = SaleOrder::find()->where(['id'=>$bill->sale_order_id])->one();
                      if($sale_odr)
                      {
                        $sale_odr->paid_amount = $sale_odr->paid_amount + $bill->pending_amount; 
                         $sale_odr->save(false);
                      }
                      
                      $bill->pending_amount=0;
                     

                        
                    }
                    $bill->save(false);
                    $saleorderagainstdc = SaleorderAgainstDc::find()->where(['invoice_no'=>$bill->id])->andWhere(['is_deleted'=>0])->all();
                    if($bill->pending_amount<=0)
                            {
                                 foreach ($saleorderagainstdc as $key => $dc) {
                                   $dc->convert_to = "Completed";
                                   $dc->save(false);
                                 }
                            }

                    // $sale = SaleOrder::find()->where(['id'=>$saleorder_data->id])->one();
                    if($sale_odr)
                    {
                       if($sale_odr->paid_amount>=$sale_odr->total_amount)
                        {
                          $sale_odr->converted_to ='Receipt';
                          $sale_odr->order_status='Paid';
                          $sale_odr->dc_status = 2;
                          $sale_odr->save(false);
                        }
                        else if($sale_odr->paid_amount>0 && $sale_odr->paid_amount<$sale_odr->total_amount)
                        {
                            $sale_odr->order_status='Partially Paid';
                            $sale_odr->save(false);
                        }
                        else
                        {
                            $sale_odr->order_status='Pending';
                            $sale_odr->save(false);
                        }
                    }

                }else{
                    $adjustedopening=AdjustedInvoices::find()->where(['receipt_id'=>$model->id,'type'=>'opening'])->one();
                    if($adjustedopening)
                    {
                        // $customerind=Customer::findOne($model->customer_name)->one();
                        $customerind=Customer::find()->where(['id'=>$model->customer_name])->one();
                        $customerind->opening_as_on=($customerind->opening_as_on+$adjustedopening->amount_adjusted)-($value['totamount']);
                        $customerind->save(false);
                        $adjustedopening->delete();
                    }
                    
                 }
                    if($value['totamount']||$value['tds_amount']){
                    $adjust=new AdjustedInvoices();
                    $adjust->customer_id=$model->customer_name;
                    $adjust->receipt_id=$model->id;
                    $adjust->invoice_id=$value['ledger_os_id'];
                    if(!$value['ledger_os_id'])
                    {
                        $adjust->type="opening";
                        if($value['ledger_os_id'])
                            {
                                $find_inv_data = Invoice::find()->where(['id'=>$value['ledger_os_id']])->one();
                                if($find_inv_data)
                                {
                                    $req_invoice_amount = $find_inv_data->total_price;
                                    if($find_inv_data->point_of_supply == '21')
                                    {
                                        $total_tax = $find_inv_data->cgst_amount + $find_inv_data->sgst_amount;
                                    }
                                    else
                                    {
                                        $total_tax = $find_inv_data->igst_amount;
                                    }
                                    $gst_percentage = ((($total_tax/$req_invoice_amount))*100);
                                    $receipt_gst_amount = $value['totamount']*($gst_percentage/100);
                                    if($find_inv_data->point_of_supply == '21')
                                    {
                                        $cgst_tax = $receipt_gst_amount/2;
                                        $sgst_tax = $receipt_gst_amount/2;
                                        $adjust->cgst_amount=$cgst_tax;
                                        $adjust->sgst_amount=$sgst_tax;
                                    }
                                    else
                                    {
                                        $adjust->igst_amount=$receipt_gst_amount;
                                    }

                                    $receipt_taxable_amount =  $value['totamount'] - $receipt_gst_amount;
                                    if($find_inv_data->is_tcs==1)
                                    {
                                        $receipt_tds_amount = $value['totamount']*(1/100);
                                        $adjust->tcs_amount=$receipt_tds_amount;
                                        $receipt_taxable_amount =  $receipt_taxable_amount - $receipt_tds_amount;
                                    }
                                    $adjust->taxable_amount = $receipt_taxable_amount;
                                }
                                


                            }
                    }
                    
                    else
                    $adjust->type="invoice";
                    $adjust->tds_amount=$value['tds_amount'];
                    $adjust->notes=$value['notes'];
                    $adjust->amount_adjusted=$value['totamount'];
                    $extra_amount_paid_by_customer = $extra_amount_paid_by_customer + $adjust->amount_adjusted;
                    $adjust->save(false);
                }

                }

                if($extra_amount_paid_by_customer < $model->amount)
                {
                    $custinds=Customer::findOne($model->customer_name);
                    if($custinds->opening_as_on=='')
                    {
                        $custinds->opening_as_on = 0;
                    }
                    $custinds->opening_as_on = $custinds->opening_as_on - ($prv_model_amount - $prv_adjusted_bill_amt);

                    $custinds->opening_as_on=$custinds->opening_as_on+($model->amount-$extra_amount_paid_by_customer);
                    $custinds->save(false);
                } 
            }
           

            $accountingdetails=AccountingDetails::find()->where(['transaction_id'=>$model->id,'edit_status'=>0])->all();
            foreach($accountingdetails as $value){
                $accountind=new AccountingDetails();
                // $accountind->setAttributes($value);
                if($value->accounting_type=='Debit')
                $accountind->accounting_type='Credit';
                else
                $accountind->accounting_type='Debit';
                $accountind->amount=$value->amount;
                $accountind->ledgerhead_id = $value->ledgerhead_id;
                $accountind->transaction_type = $value->transaction_type;
                $accountind->transaction_id =$value->transaction_id ;
                $accountind->inc_exp = $value->inc_exp;
                $accountind->edit_status=1;
                $accountind->date = $value->date;
                $accountind->save(false);
                $value->edit_status=1;
                $value->save(false);
            }
            if($model->payment_type=="Direct Receipt"){
                $ledgerind=Yii::$app->request->post()['Products'];
                foreach($ledgerind as $val){
                $accounting=AccountingLedger::findOne($val['accountDD']);
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $accounting->ledger_id;
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                if($val['item_price']=='')
                {
                    $ledger->amount ='0.00';
                }
                else
                {
                    $ledger->amount = $val['item_price'];
                }
                
                $ledger->date =$model->receipt_date ;
                $ledger->save(false);
                if($val['tax_amount']){
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "TDS Amount";
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $val['tax_amount'];
                $ledger->date =$model->receipt_date ;
                $ledger->save(false);
                }
                }
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $model->payment_mode;
                $ledger->transaction_type = "Receipt";
                $ledger->transaction_id =$model->id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $model->total_amount;
                $ledger->date =$model->receipt_date ;
                $ledger->save(false);
            }
            else{
                 $amt = $model->amount;
                    $tds_amount = $model->tds_amount;
                    $final_amt = $model->total_amount;
                    $tan_id = $model->id;
                    $tan_date = $model->receipt_date ;
                    if($model->invoice_no!='')
                    {
                      $paid_by = Invoice::find()->where(['invoice_id'=>$model->invoice_no])->one();
                      $customer_name = Customer::find()->where(['id'=>$paid_by->customer_name])->one();
                      $amtfrom = $customer_name->business_name;

                    }
                    else
                    {
                        $customer_name = Customer::find()->where(['id'=>$model->customer_name])->one();
                        $amtfrom = $customer_name->business_name;
                    }
                    $payment_mode = $model->payment_mode;
                    $bank_name = $model->bank_name;
                $ledger = new AccountingDetails();
                $ledger->leadgerentryreceipt($amt,$tds_amount,$final_amt,$tan_id,$amtfrom,$payment_mode,$bank_name,$tan_date);


                    $find_inv_data = Invoice::find()->where(['invoice_id'=>$model->invoice_no])->one();
                    if ($find_inv_data) {
                        $req_invoice_amount = $find_inv_data->total_price;
                        if($find_inv_data->point_of_supply == '21')
                        {
                            $total_tax = $find_inv_data->cgst_amount + $find_inv_data->sgst_amount;
                        }
                        else
                        {
                            $total_tax = $find_inv_data->igst_amount;
                        }
                        $gst_percentage = ((($total_tax/$req_invoice_amount))*100);
                        $receipt_gst_amount = $model->total_amount*($gst_percentage/100);
                        if($find_inv_data->point_of_supply == '21')
                        {
                            $cgst_tax = $receipt_gst_amount/2;
                            $sgst_tax = $receipt_gst_amount/2;
                            $model->cgst_amount=$cgst_tax;
                            $model->sgst_amount=$sgst_tax;
                        }
                        else
                        {
                            $model->igst_amount=$receipt_gst_amount;
                        }
                        $receipt_taxable_amount =  $model->total_amount - $receipt_gst_amount;
                        if($find_inv_data->is_tcs==1)
                        {
                            $receipt_tds_amount = $model->total_amount*(1/100);
                            $model->tcs_amount=$receipt_tds_amount;
                            $receipt_taxable_amount =  $receipt_taxable_amount - $receipt_tds_amount;
                        }
                        $model->taxable_amount = $receipt_taxable_amount;
                    }
                    
                    $model->save(false);  

                }
            // $data= Yii::$app->request->post();
            if($model->payment_mode!='Cheque')
            {
               
                $model->cheque_no='';
                $model->cheque_date=Null;
            }
            $type=Customer::find()->where(['id'=>$model->customer_name])->one();
             // $model->customer_type=$type->customer_type; 
             if (Yii::$app->request->post('save') == 0) {
                $model->updated_at=date('Y-m-d H:i:s');
                    $model->receipt_no = $model->receipt_no;
                    $model->prefix = $model->prefix;  
                    $model->suffix = $model->suffix;

                    $model->receipt_id = $model->prefix.''.$model->receipt_no.''.$model->suffix;
                // $model->save(false);
                    $model->total_amount =$model->total_amount;
            $model->save(false);

            if($model->invoice_amount !='' && $model->balance_amount!= '')
                {
                    $invoice_amount_paid = 0;
                    $invoice = Invoice::find()->where(['invoice_id'=>$model->invoice_no])->one();
                   
                      if($invoice->sale_order_id!='')
                        {
                          $saleorderaginestinvoice = SaleOrder::find()->where(['id'=>$invoice->sale_order_id])->one();
                          $saleorderaginestinvoice->paid_amount = $saleorderaginestinvoice->paid_amount + $model->amount;
                          if($saleorderaginestinvoice->paid_amount<=$saleorderaginestinvoice->total_amount)
                          {
                            $saleorderaginestinvoice->converted_to ='Receipt';
                            $saleorderaginestinvoice->order_status='Paid';
                            $saleorderaginestinvoice->dc_status = 2;
                            $saleorderaginestinvoice->save(false);
                          }
                          else if($saleorderaginestinvoice->paid_amount>0 && $saleorderaginestinvoice->paid_amount<$saleorderaginestinvoice->total_amount)
                          {
                              $saleorderaginestinvoice->order_status='Partially Paid';
                              $saleorderaginestinvoice->save(false);
                          }
                          else
                          {
                            $saleorderaginestinvoice->order_status='Pending';
                              $saleorderaginestinvoice->save(false);
                          }
                         
                    $invoice->pending_amount = $invoice->pending_amount-$model->amount;
                    // $sale->converted_to ='Receipt';
                    $invoice->save(false);
                    $saleorderagainstdc = SaleorderAgainstDc::find()->where(['invoice_no'=>$invoice->id])->andWhere(['is_deleted'=>0])->all();
                    if($invoice->pending_amount<=0)
                            {
                                 foreach ($saleorderagainstdc as $key => $value) {
                                   $value->convert_to = "Completed";
                                   $value->save(false);
                                 }
                            }   
                }   
            }  
            if($document->validate())
             {
                $names=UploadedFile::getInstances($document,'document_name');
                foreach ($names as $name) {
                    // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                    $path='receiptdocuments/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('receipt_documents',['document_name'=>$filename,'receipt_id'=>$model->id])->execute();
                    }
                    
                }

             }
                     Yii::$app->getSession()->setFlash('success', 'Successfully updated the receipt'); 
                     return $this->redirect(['receipt-details/index']);
            }

            if (Yii::$app->request->post('save') == 1) {
                $model->updated_at=date('Y-m-d H:i:s');
                    $model->receipt_no = $model->receipt_no;  
                    $model->total_amount =$model->total_amount;
                    $model->save(false);
            if($document->validate())
             {
                $names=UploadedFile::getInstances($document,'document_name');
                foreach ($names as $name) {
                    // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                    $path='receiptdocuments/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('receipt_documents',['document_name'=>$filename,'receipt_id'=>$model->id])->execute();
                    }
                    
                }

             }
                     Yii::$app->getSession()->setFlash('success', 'Successfully updated the receipt');
                     return $this->redirect(['receipt-details/create']);
            }
            
        }

        return $this->render('update', [
            'model' => $model,
            'document' => $document,
            'payment_modes'=> $paymentmodelist,
            'payment_types'=> ReceiptDetailsController::$payment_type,
            'banks_name'=> ReceiptDetailsController::$banks_name,
            'from'=>$from,
            'id'=>$id,
            'last_entry'=>$last_entry+1,
        ]);
    }

    /**
     * Deletes an existing ReceiptDetails model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {
        Yii::$app->view->params['active']=16;
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            foreach($ids as $id){
            $this->findModel($id)->delete();
            $attachments=ReceiptDocuments::find()->where(['receipt_id'=>$id])->all();
            foreach($attachments as $attachment)
              {
                $attachment->delete();
              }

	      $accounting = AccountingDetails::find()->where(['transaction_id'=>$id])->andWhere(['transaction_type'=>"Receipt"])->all();
              foreach ($accounting as $account) {
                  $account->edit_status = 1;
                  $account->save(false);
              }
	
            }
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
            return $this->redirect(['receipt-details/index']);
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_sale = ReceiptDetails::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_sale->customer_name])->andWhere(['client_type'=>'Customer'])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'You are not allowed to perform this action.');
                    return $this->redirect(['receipt-details/index']);
                }
            }

	    $accounting = AccountingDetails::find()->where(['transaction_id'=>$id])->andWhere(['transaction_type'=>"Receipt"])->all();
            foreach ($accounting as $account) {
                $account->edit_status = 1;
                $account->save(false);
            }

            $this->findModel($id)->delete();
            $doc= new ReceiptDocuments();
            $attachments=ReceiptDocuments::find()->where(['receipt_id'=>$id])->all();
            foreach($attachments as $attachment){
                $attachment->delete();
            }
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
            return $this->redirect(['index']);
        }
    }
    

    public function actionExcelExport($detail=null)
    {
        Yii::$app->view->params['active']=16;


        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $query=ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $accessed = Yii::$app->user->identity->id;
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = ReceiptDetails::find()->andWhere(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
        }
        $dataProvider = new ActiveDataProvider([
            'query' =>$query,
        ]);

        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'setting_type',
            'payment_type',
            'receipt_no',
            'prefix',
            'suffix',
            'receipt_id',
            'receipt_date',
            'invoice_no',
            'cheque_no',
            'cheque_date',
            'payment_mode',
            'bank_name',
            'amount',
            'tds_amount',
            'total_amount',
            [
                'label' => 'Customer/Account',
                // 'contentOptions'=>[ 'style'=>'font-weight: bold'],
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                  $against_ledger =  array();
                  $all_ledgers = array();
                    $customer=Customer::find()->where(['id'=>$data->customer_name])->one();

                    if($customer!='')
                      {
                         return $customer->business_name;
                      }
                      else
                      {
                          $against = DirectReceipt::find()->where(['receipt_id'=>$data->id])->all();
                          foreach ($against as $key => $value) {
                              $against_ledger[$key] = $value->ledger_id;
                          }
                          foreach ($against_ledger as $key => $val) {
                              $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$val])->one();
                              if($ledger)
                                $all_ledgers[$key] = $ledger->ledger_id;
                          }
                          return implode(",",$all_ledgers);
                          
                      }
            },
            ],
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= ReceiptDocuments::find()->select(['document_name'])->where(['receipt_id' =>$data['id']])->asArray()->column();
                    $documents = implode(",", $user);
                    return $documents;

                    
            },
            ],
            'notes:ntext',
            'created_at',
            'updated_at',
        ],
    ]);
        }else{
            // print_r("xxxxx");
            // exit();
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    'receipt_id',
                    [
                        'label' => 'Customer',
                        'attribute' => 'customer_name',
                        'value' => function ($data) {
			   $customer = CUstomer::find()->where(['id'=>$data->customer_name])->one();
                           if($customer)
	                            return $customer->business_name;
                    },
                    ],
                    'receipt_date',
                    'total_amount',
                    'bank_name',
                    'notes',
                ],
            ]);
        }
       
    return $exporter->send('Receipt_Details.xlsx');
    }

    public function actionReceiptPdf($id=null,$for=null,$from=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $query=ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $accessed = Yii::$app->user->identity->id;
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = ReceiptDetails::find()->andWhere(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
        }


        Yii::$app->view->params['active']=16;
        if($for=='all')
        {
            $dataProvider = new ActiveDataProvider([
            'query' => $query,
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/receipt-details/export-pdf', [
                'dataProvider' => $dataProvider,

            ]));
            $mpdf->Output('Receipt_Details.pdf', 'D');
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_sale = ReceiptDetails::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_sale->customer_name])->andWhere(['client_type'=>'Customer'])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'You are not allowed to perform this action.');
                    return $this->redirect(['receipt-details/index']);
                }
            }

            $model = ReceiptDetails::find()->where(['id'=>$id])->one();
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;

            if($from=='pdf')
            {
                $find=ReceiptDetails::findOne($id);
                $receipt_id=$find->receipt_id;
                $mpdf->WriteHTML($this->renderPartial('/receipt-details/receipt-pdf', [
                    'model' => $model,
                ]));
                $mpdf->Output($receipt_id.'-Receipt.pdf', 'D');
            }
            else
            {
                return $this->renderPartial('/receipt-details/receipt-pdf', [
                 'model' => $model,
                ]);
            }
          
            // $find=ReceiptDetails::findOne($id);
            // $receipt_id=$find->receipt_id;
            // if($for == 'print')
            // {
            //     $mpdf->Output($receipt_id.'-Receipt.pdf', 'I');
            // }
            // else
            // {
            //     $mpdf->Output($receipt_id.'-Receipt.pdf', 'D');
            // }
        }  
    }
    public function actionExcelReceipt($id)
    {
        Yii::$app->view->params['active']=16;
        $dataProvider = new ActiveDataProvider([
            'query' => ReceiptDetails::find()->where(['id'=>$id]),
        ]);
      $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'setting_type',
            'payment_type',
            'receipt_no',
            'prefix',
            'suffix',
            'receipt_id',
            'receipt_date',
            'invoice_no',
            'cheque_no',
            'cheque_date',
            'payment_mode',
            'bank_name',
            'amount',
            'tds_amount',
            'total_amount',
            [
                'label' => 'Customer',
                'attribute' => 'customer_name',
                'value' => function ($data) {
                    return $data->customer_name;
            },
            ],
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= ReceiptDocuments::find()->select(['document_name'])->where(['receipt_id' =>$data['id']])->asArray()->column();
                    $documents = implode(",", $user);
                    return $documents;

                    
            },
            ],
            'notes:ntext',
            'created_at',
            'updated_at',
        ],
    ]);
       $find=ReceiptDetails::findOne($id);
        $receipt_id=$find->receipt_id; 
    return $exporter->send($receipt_id.'-Receipt.xlsx');
    }
    
    public function actionFindattachments($id)
    {
        Yii::$app->view->params['active']=16;
        $find=ReceiptDocuments::find()->select(['document_name','id'])->where(['receipt_id'=>$id])->asArray ()->all();
        echo Json::encode($find);
        // return $exporter->send($find);
        // return $find;
    }
    public function actionDelattachment($id)
    {
        Yii::$app->view->params['active']=16;
        $file=ReceiptDocuments::find()->where(['id'=>$id])->one();
         $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
     public function actionDownload($id) {
    // This will need to be the path relative to the root of your app.
    Yii::$app->view->params['active']=16;
        $model=ReceiptDocuments::find()->where(['id'=>$id])->one();
        if($model->document_name!=null)
        {
            $local=yii::getAlias('@webroot/receiptdocuments/');
            $name=$model->document_name;
            $find=$local.$name;
            if(file_exists($find))
            {
               return yii::$app->response->sendFile($find);
            }
        }
   }
   public function actionCustomer($searchTerm=null)
    {   
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Customer::find()->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }
        else
        {
            $customer_ids = [];
            $i =0;

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            foreach($customers as $data)
            {
                $customer_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Customer::find()->where(['in','id',$customer_ids])->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$customer_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist); 
        }

        
    }
    public function actionPendingInvoice()
    {
        $customer=Yii::$app->request->post('data');
        $invoice="SELECT * FROM `invoice` WHERE pending_amount>0 and customer_name=$customer and is_deleted=0";
        $invoices=Yii::$app->db->createCommand($invoice)->queryAll();
        $customer=Customer::find()->where(['id'=>$customer])->asArray()->one();
        return json_encode(['invoices'=>$invoices,
        'customer'=>$customer]);
    }

    public function actionPendingSaleorderInvoice()
    {
      $customer=Yii::$app->request->post('customer');
       $sale_id=Yii::$app->request->post('sale_id');
        $invoice="SELECT * FROM `invoice` WHERE pending_amount>0 and customer_name=$customer and sale_order_id=$sale_id";
        $invoices=Yii::$app->db->createCommand($invoice)->queryAll();
        $customer=Customer::find()->where(['id'=>$customer])->asArray()->one();
        return json_encode(['invoices'=>$invoices,
        'customer'=>$customer]);
    }
    public function actionPendingOpening()
    {
        $customerid=Yii::$app->request->post('data');
        $customer=Customer::find()->where(['id'=>$customerid])->one();
        $openingtotal=AdjustedInvoices::find()->where(['type'=>"opening",'customer_id'=>$customer])->sum('`amount_adjusted`')+$customer->opening_as_on;
        return $openingtotal;
    }

    public function actionFindreceiptalldetails($id)
    {
        $all= ReceiptDetails::find()->where(['id' =>$id])->one();
        echo Json::encode($all);
    } 
    public function actionCreateUrl($id)
    {
       // $ids=Yii::$app->request->post('data');
        $url = Url::to(['receipt-pdf', 'id' => $id],'https');
        echo Json::encode($url);
            // print_r($url);

    }
    public function actionFinduseralldetails($id)
    {
        $all= ReceiptDetails::find()->where(['id' =>$id])->one();
        $userdetails = Customer::find()->where(['id'=>$all->customer_name])->one();
        echo Json::encode($userdetails);
    }

    /**
     * Finds the ReceiptDetails model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return ReceiptDetails the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = ReceiptDetails::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionReceiptdetailssettingtype($setting=null,$template=null)
    {   
        //print_r(1);die();
        $find = GenericTemplate::find()->where(['template_for'=>'Receipt'])->andWhere(['gt_id'=>$setting])->count();
        echo Json::encode($find);
    }

    public function actionSelectdate($selected_date=null)
    {  
        $selected_date=$_GET['selected_date']; 
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        // $count_before_year=ReceiptDetails::find()->where(['<=', 'receipt_date', $dynamic_date])->count();
        // $count_after_year=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->count();

	$count_before=ReceiptDetails::find()->where(['<=', 'receipt_date', $dynamic_date])->orderBy(['id' => SORT_DESC])->one();
	//print_r($count_before);
        if($count_before)
          $count_before_year = $count_before->id;
       else
          $count_before_year = 0;


        $count_after=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->orderBy(['id' => SORT_DESC])->one();
       // $count_after_year = $count_after->id;
	 if($count_after)
           $count_after_year = $count_after->id;
         else
           $count_after_year = 0;

        if(strtotime($selected_date) <= strtotime($dynamic_date)) { 
            $last_entry=$count_before_year+1;
        }
        else if(strtotime($selected_date) > strtotime($dynamic_date)){
            $last_entry=$count_after_year+1;
        } 
        else{
            $last_entry=0;
        }
        echo $last_entry;
    }

}
