<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "accounting_contra".
 *
 * @property int $contra_id
 * @property string $contra_type
 * @property string $date
 * @property string|null $from_date
 * @property string|null $to_date
 * @property string $voucher_no
 * @property string $bank
 * @property string $prefix
 * @property string $contra_no
 * @property string $suffix
 * @property string $notes
 * @property float $amount
 * @property string $source_bank
 * @property string $destination_bank
 * @property string $user
 * @property string $ceated_at
 * @property string $update_at
 */
class AccountingContra extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'accounting_contra';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['contra_type', 'date', 'notes', 'amount'], 'required'],
            [['contra_id'], 'integer'],
            [['date', 'ceated_at', 'update_at','bank','contra_no'], 'safe'],
            [['amount'], 'number'],
            [['contra_type', 'prefix', 'suffix','contra_no','user'], 'string', 'max' => 10],
            [['voucher_no', 'source_bank', 'destination_bank'], 'string', 'max' => 50],
            [['notes',], 'string', 'max' => 100],
            [['contra_id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'contra_id' => 'Contra ID',
            'contra_type' => 'Contra Type',
            'date' => 'Date',
            'voucher_no' => 'Voucher No',
            'prefix' => 'Prefix',
            'contra_no' => 'Contra No',
            'suffix' => 'Suffix',
            'notes' => 'Notes',
            'user' => 'User',
            'amount' => 'Amount',
            'source_bank' => 'Source Bank',
            'destination_bank' => 'Destination Bank',
            'ceated_at' => 'Ceated At',
            'update_at' => 'Update At',
        ];
    }
}
