<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "accounting_journal".
 *
 * @property int $id
 * @property string|null $journal_type
 * @property string|null $date
 * @property string|null $prefix
 * @property string|null $jv_no
 * @property string|null $suffix
 * @property string $notes
 * @property string $ref_no
 * @property string|null $document_name
 * @property int $is_deleted
 * @property int|null $updated_by
 * @property string $created_at
 * @property string $updated_at
 */
class AccountingJournal extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'accounting_journal';
    }
public $journal;
public $from_date;
public $to_date;
public $account;
public $journaltype;
public $user_name;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['journal_type', 'date','jv_no'], 'required'],
            [['notes', 'ref_no'], 'string'],
            [['is_deleted', 'updated_by'], 'integer'],
            [['journaltype','user_name','journal','from_date','to_date','account','journal_type','total_debit','total_credit','totalamt','created_at', 'updated_at'], 'safe'],
            [['journal_type'], 'string', 'max' => 68],
            [['date', 'prefix', 'suffix'], 'string', 'max' => 32],
            // [['document_name'], 'string', 'max' => 128],
            ['totalamt', 'compare', 'compareValue' => 0, 'operator' => '=='],
            ['document_name', 'file', 'extensions' => ['png', 'jpg', 'gif','xlsx','xls','doc','txt'], 'maxSize' => 1024 * 1024 * 2],
            ['to_date', 'required', 'when' => function($model) {
                return $model->from_date;
            },'whenClient' => "function (attribute, value) {
                return $('#accountingjournal-from_date').val();
            }"],
            ['from_date', 'required', 'when' => function($model) {
                return $model->to_date;
            },'whenClient' => "function (attribute, value) {
                return $('#accountingjournal-to_date').val();
            }"],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'journal_type' => 'Journal Type',
            'date' => 'Date',
            'prefix' => 'Prefix',
            'jv_no' => 'Jv No',
            'total_credit' => 'Total Credit',
            'total_debit' => 'Total Debit',
            'suffix' => 'Suffix',
            'notes' => 'Notes',
            'ref_no' => 'Ref No',
            'document_name' => 'Document Name',
            'is_deleted' => 'Is Deleted',
            'updated_by' => 'Updated By',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
            'totalamt'=>'Total Amount'
        ];
    }
}
