<?php

namespace backend\modules\users\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\AccountingJournal;

/**
 * AccountingJournalSearch represents the model behind the search form of `backend\modules\users\models\AccountingJournal`.
 */
class AccountingJournalSearch extends AccountingJournal
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'is_deleted', 'updated_by'], 'integer'],
            [['total_credit','total_debit','journal_type', 'date', 'prefix', 'jv_no', 'suffix', 'notes', 'ref_no', 'document_name', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = AccountingJournal::find()->where(['is_deleted'=>0]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort'=> ['defaultOrder' => ['id' => SORT_DESC]],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'is_deleted' => $this->is_deleted,
            'updated_by' => $this->updated_by,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
            'jv_no' => $this->jv_no,
        ]);

        $query->andFilterWhere(['like', 'journal_type', $this->journal_type])
            ->andFilterWhere(['like', 'date', $this->date])
            ->andFilterWhere(['like', 'prefix', $this->prefix])
            ->andFilterWhere(['like', 'suffix', $this->suffix])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'ref_no', $this->ref_no])
            ->andFilterWhere(['like', 'total_credit', $this->total_credit])
            ->andFilterWhere(['like', 'total_debit', $this->total_debit])
            ->andFilterWhere(['like', 'document_name', $this->document_name]);

        return $dataProvider;
    }
}
