<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "adjusted_invoices".
 *
 * @property int $id
 * @property int $payment_id
 * @property int $bill_id
 * @property float|null $amount_adjusted
 * @property float|null $tds_amount
 * @property string|null $notes
 * @property string $created_at
 * @property string $updated_at
 */
class AdjustedInvoices extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'adjusted_invoices';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['receipt_id', 'invoice_id'], 'required'],
            [['receipt_id', 'invoice_id'], 'integer'],
            [['amount_adjusted', 'tds_amount'], 'number'],
            [['notes'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'payment_id' => 'Receipt ID',
            'invoice_id' => 'Invoice ID',
            'amount_adjusted' => 'Amount Adjusted',
            'tds_amount' => 'Tds Amount',
            'notes' => 'Notes',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
