<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "bills_adjusted_amounts".
 *
 * @property int $id
 * @property int|null $bill_id
 * @property int|null $account
 * @property float|null $amount
 * @property string|null $notes
 * @property string $created_at
 * @property string $updated_at
 */
class BillsAdjustedAmounts extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'bills_adjusted_amounts';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['bill_id', 'account','id'], 'integer'],
            [['amount'], 'number'],
            [['notes'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'bill_id' => 'Bill ID',
            'account' => 'Account',
            'amount' => 'Amount',
            'notes' => 'Notes',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
