<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "debit_note_product".
 *
 * @property int $id
 * @property int $product_id
 * @property string|null $description
 * @property int $qty
 * @property int $unit
 * @property float $price
 * @property float $discount
 * @property string $tax
 * @property int $incl_tax
 * @property float $amount
 * @property float $total_amount
 * @property float $subtotal_amount
 * @property string $created_at
 * @property string $updated_at
 */
class DebitNoteProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'debit_note_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_id', 'qty', 'unit', 'price', 'amount'], 'required'],
            [['product_id','qty','incl_tax'], 'integer'],
            [['description','unit','discount_type'], 'string'],
            [['price', 'discount', 'amount'], 'number'],
            [['created_at', 'updated_at'], 'safe'],
            [['tax'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'qty' => 'Qty',
            'unit' => 'Unit',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'incl_tax' => 'Incl Tax',
            'amount' => 'Amount',
            'total_amount' => 'Total Amount',
            'subtotal_amount' => 'Subtotal Amount',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
