<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "delivered_product_list".
 *
 * @property int $id
 * @property int $delivered_id
 * @property int $product_id
 * @property string|null $description
 * @property int|null $qty
 * @property string|null $unit
 * @property string $created_at
 * @property string $updated_at
 */
class DeliveredProductList extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'delivered_product_list';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['delivered_id', 'product_id'], 'required'],
            [['delivered_id', 'product_id', 'qty'], 'integer'],
            [['description'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
            [['unit'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'delivered_id' => 'Delivered ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'qty' => 'Qty',
            'unit' => 'Unit',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
