<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "leads_quotes_document".
 *
 * @property int $id
 * @property int $leads_quotes_id
 * @property string $document_name
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class LeadsQuotesDocument extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'leads_quotes_document';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['leads_quotes_id', 'is_deleted'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['document_name'], 'file','maxSize'=>2097152, 'message'=>'File has to be smaller than 2MB', 'maxFiles' => 5],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'leads_quotes_id' => 'Leads Quotes ID',
            'document_name' => 'Document Name',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
