<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "leads_quotes_product".
 *
 * @property int $id
 * @property string $leads_quotes_id
 * @property string $product_id
 * @property string $description
 * @property string $quantity
 * @property string $units
 * @property float $price
 * @property float $unit_price
 * @property string $discount
 * @property string $tax
 * @property string $discount_type
 * @property string $tax_included
 * @property float $amount
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class LeadsQuotesProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'leads_quotes_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['price', 'unit_price', 'amount'], 'number'],
            [['is_deleted'], 'integer'],
            [['created_at', 'updated_at','tax'], 'safe'],
            [['leads_quotes_id', 'product_id', 'description', 'units', 'discount','discount_type', 'tax_included'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'leads_quotes_id' => 'Leads Quotes ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'price' => 'Price',
            'unit_price' => 'Unit Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'discount_type' => 'Discount Type',
            'tax_included' => 'Tax Included',
            'amount' => 'Amount',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
