<?php

namespace backend\modules\users\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\ProformaInvoice;
use backend\modules\master\models\LeadExecutive;
use backend\models\UserClient;
use backend\modules\master\models\Customer;


/**
 * ProformaInvoiceSearch represents the model behind the search form of `backend\modules\users\models\ProformaInvoice`.
 */
class ProformaInvoiceSearch extends ProformaInvoice
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['setting_id', 'customer_name', 'notes', 'executive', 'receiver_gstn', 'sales_type', 'supply_type', 'supply_reverse_change', 'point_of_supply', 'is_invoice_paid_provisional', 'proforma_invoice_no', 'date', 'due_date', 'terms_of_payment', 'sub_total_price', 'total_price', 'reminder', 'add_delivery_details', 'proforma_documents', 'terms','status','proforma_invoice_id','converted_to'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params,array $accessed=null)
    {
        if($accessed == null)
        {
           $query = ProformaInvoice::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $check_id = Yii::$app->user->identity->id;
            $all = ProformaInvoice::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array= [];
            $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;

                }
            }
            $exe_array = array_unique($exe_array);

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer = Customer::find()->where(['id'=>$data->client_id])->one();
                if($customer)
                {
                    $customer_ids[$j] = $customer->business_name;
                    $j++;
                }
                
            }
            // print_r($customer_ids);
            // die();
            $query = ProformaInvoice::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_name', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
            // $query = ProformaInvoice::find()->where(['is_deleted'=>0])->andWhere(['in', 'executive', $accessed])->orderBy(['id' => SORT_DESC]);
        }
        

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'date' => $this->date,
            'due_date' => $this->due_date,
        ]);

        $query->andFilterWhere(['like', 'setting_id', $this->setting_id])
            ->andFilterWhere(['like', 'customer_name', $this->customer_name])
            ->andFilterWhere(['like', 'proforma_invoice_id', $this->proforma_invoice_id])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'executive', $this->executive])
            ->andFilterWhere(['like', 'receiver_gstn', $this->receiver_gstn])
            ->andFilterWhere(['like', 'sales_type', $this->sales_type])
            ->andFilterWhere(['like', 'supply_type', $this->supply_type])
            ->andFilterWhere(['like', 'supply_reverse_change', $this->supply_reverse_change])
            ->andFilterWhere(['like', 'point_of_supply', $this->point_of_supply])
            ->andFilterWhere(['like', 'is_invoice_paid_provisional', $this->is_invoice_paid_provisional])
            ->andFilterWhere(['like', 'proforma_invoice_no', $this->proforma_invoice_no])
            ->andFilterWhere(['like', 'terms_of_payment', $this->terms_of_payment])
            ->andFilterWhere(['like', 'sub_total_price', $this->sub_total_price])
            ->andFilterWhere(['like', 'total_price', $this->total_price])
            ->andFilterWhere(['like', 'reminder', $this->reminder])
            ->andFilterWhere(['like', 'add_delivery_details', $this->add_delivery_details])
            ->andFilterWhere(['like', 'converted_to', $this->converted_to])
            ->andFilterWhere(['like', 'terms', $this->terms]);

             if($this->status){
                $find=ProformaInvoice::find()->select('status')->where(['status'=>$this->status])->column();
               $query->andFilterWhere(['in', 'status', $find]);}


        return $dataProvider;
    }
}
