<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "purchase_payment".
 *
 * @property int $id
 * @property int $vendor_id
 * @property string|null $setting_type
 * @property string|null $payment_type
 * @property string|null $payment_no
 * @property string|null $date
 * @property string|null $cheque_no
 * @property string|null $cheque_date
 * @property string|null $payment_mode
 * @property float|null $amount
 * @property float|null $tds_amount
 * @property string|null $notes
 * @property int|null $updated_by
 * @property int|null $is_deleted
 * @property float|null $total_amount
 */
class PurchasePayment extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_payment';
    }
    public $image;
    public $from_date;
    public $to_date;
    public $vendor;
    public $bank;
    public $account_category;
    public $centre_category;
    public $settingtype;
    public $amount_from;
    public $amount_to;
    public $amountfrom;
    public $amountto;

    public $c_code;
    public $c_mobile;
    public $findid;
    public $text_send;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_type','date','payment_mode','amount','tds_amount','payment_type'], 'required'],
            [['updated_by', 'is_deleted'], 'integer'],
            [['amount', 'tds_amount', 'total_amount','balance_amount'], 'number'],
            [['from_date', 'to_date', 'vendor','bank', 'account_category', 'centre_category','payment_type','settingtype','amount_from','amount_to','amountfrom','amountto','total_bill_amount','transaction_date'], 'safe'],
            [['notes','text_send'], 'string'],
            [['setting_type', 'payment_type', 'payment_no', 'payment_mode','against_bill','findid'], 'string', 'max' => 255],
            [['date', 'cheque_date','prefix','suffix','c_code','c_mobile'], 'string', 'max' => 32],
            [['cheque_no'], 'string', 'max' => 6],
	    [['transaction_no'],'string'],
            ['cheque_date', 'required', 'when' => function($model) {
                return $model->payment_mode == 'Cheque';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_mode').val() == 'Cheque';
            }"],
            ['cheque_no', 'required', 'when' => function($model) {
                return $model->payment_mode == 'Cheque';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_mode').val() == 'Cheque';
            }"],


	    ['transaction_date', 'required', 'when' => function($model) {
                return $model->payment_mode == 'Cheque';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_mode').val() == 'Online Transaction';
            }"],
            ['transaction_no', 'required', 'when' => function($model) {
                return $model->payment_mode == 'Cheque';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_mode').val() == 'Online Transaction';
            }"],


            ['vendor_id', 'required', 'when' => function($model) {
                return $model->payment_type == 'For advances against payment';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_type').val() == 'For advances against payment';
            }"],
            ['vendor_id', 'required', 'when' => function($model) {
                return $model->payment_type == 'Payment against bill';
            },'whenClient' => "function (attribute, value) {
                return $('#purchasepayment-payment_type').val() == 'Payment against bill';
            }"],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'vendor_id' => 'Vendor',
            'setting_type' => 'Setting Type',
            'payment_type' => 'Payment Type',
            'payment_no' => 'Payment No',
            'date' => 'Date',
            'cheque_no' => 'Cheque No',
            'cheque_date' => 'Cheque Date',
            'payment_mode' => 'Payment Mode',
            'amount' => 'Amount',
            'tds_amount' => 'Tds Amount',
            'notes' => 'Notes',
            'updated_by' => 'Updated By',
            'is_deleted' => 'Is Deleted',
            'total_amount' => 'Total Amount',
        ];
    }
}
