<?php

namespace backend\modules\users\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\master\models\Customer;
use backend\models\UserClient;

/**
 * ReceiptDetailsSearch represents the model behind the search form of `backend\modules\users\models\ReceiptDetails`.
 */
class ReceiptDetailsSearch extends ReceiptDetails
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['setting_type', 'payment_type', 'receipt_no', 'receipt_date', 'cheque_no', 'cheque_date', 'payment_mode', 'bank_name', 'amount', 'tds_amount', 'customer_name', 'receipt_documents', 'notes', 'created_at', 'updated_at','total_amount','receipt_id'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params, array $accessed=null)
    {
        if($accessed == null)
        {
            $query = ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $check_id = Yii::$app->user->identity->id;
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = ReceiptDetails::find()->where(['in', 'customer_name', $customer_ids])->orderBy(['id' => SORT_DESC]);
        }
        // $query = ReceiptDetails::find()->orderBy(['id' => SORT_DESC]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'receipt_date' => $this->receipt_date,
            'cheque_date' => $this->cheque_date,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'setting_type', $this->setting_type])
            ->andFilterWhere(['like', 'payment_type', $this->payment_type])
            ->andFilterWhere(['like', 'receipt_no', $this->receipt_no])
            ->andFilterWhere(['like', 'receipt_id', $this->receipt_id])
            ->andFilterWhere(['like', 'cheque_no', $this->cheque_no])
            ->andFilterWhere(['like', 'payment_mode', $this->payment_mode])
            ->andFilterWhere(['like', 'bank_name', $this->bank_name])
            ->andFilterWhere(['like', 'amount', $this->amount])
            ->andFilterWhere(['like', 'tds_amount', $this->tds_amount])
            ->andFilterWhere(['like', 'total_amount', $this->total_amount])
            ->andFilterWhere(['like', 'customer_name', $this->customer_name])
            ->andFilterWhere(['like', 'receipt_documents', $this->receipt_documents])
            ->andFilterWhere(['like', 'notes', $this->notes]);
            
            

        return $dataProvider;
    }
}
