<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "sale_order_document".
 *
 * @property int $id
 * @property int $sale_order_id
 * @property string $document_name
 * @property string $created_at
 * @property string $updated_at
 */
class SaleOrderDocument extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sale_order_document';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            // [['document_name'], 'required'],
            [['sale_order_id'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['document_name'], 'file', 'maxFiles' => 5,'maxSize'=>2097152, 'message'=>'File has to be smaller than 2MB'],
            
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'sale_order_id' => 'Sale Order ID',
            'document_name' => 'Document Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
