<?php

namespace backend\modules\users\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\models\UserClient;


/**
 * SaleOrderSearch represents the model behind the search form of `backend\modules\users\models\SaleOrder`.
 */
class SaleOrderSearch extends SaleOrder
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id',  'executive_id'], 'integer'],
            [['customer_id','note', 'receiver', 'sale_type', 'supply_type', 'reverse_charge', 'priority', 'price_list', 'po_details', 'point_of_supply', 'is_invoice_paid_provisional', 'po_date', 'po_exp_date', 'prefix', 'sale_order', 'suffix', 'sale_order_id', 'date', 'delivery_date', 'due_date', 'terms_of_payment', 'product_code', 'advance_payment', 'receipt_id', 'set_reminder', 'show_to_store_keeper', 'full_order_product_wise', 'other_note', 'terms', 'created_at', 'updated_at','saleorder_source','converted_to','po_no'], 'safe'],
            [['total_amount'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params, array $accessed=null)
    {
        if($accessed == null)
        {
            $query=SaleOrder::find()->where(['is_deleted'=>0])
               ->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $check_id = Yii::$app->user->identity->id;
            $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                if($executivedetails!='')
                { 
                   if($executivedetails->type == $accessed[0]) 
                   {
                      $exe_array[$i] = $executivedetails->id;
                       $i++;
                   }
                   

                }
            }
            $exe_array = array_unique($exe_array);

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->orderBy(['id' => SORT_DESC]);
        }
         

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'executive_id' => $this->executive_id,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'note', $this->note])
            ->andFilterWhere(['like', 'receiver', $this->receiver])
            ->andFilterWhere(['like', 'sale_type', $this->sale_type])
            ->andFilterWhere(['like', 'supply_type', $this->supply_type])
            ->andFilterWhere(['like', 'reverse_charge', $this->reverse_charge])
            ->andFilterWhere(['like', 'priority', $this->priority])
            ->andFilterWhere(['like', 'price_list', $this->price_list])
            ->andFilterWhere(['like', 'po_no', $this->po_no])
            ->andFilterWhere(['like', 'po_details', $this->po_details])
            ->andFilterWhere(['like', 'point_of_supply', $this->point_of_supply])
            ->andFilterWhere(['like', 'is_invoice_paid_provisional', $this->is_invoice_paid_provisional])
            ->andFilterWhere(['like', 'po_date', $this->po_date])
            ->andFilterWhere(['like', 'po_exp_date', $this->po_exp_date])
            ->andFilterWhere(['like', 'prefix', $this->prefix])
            ->andFilterWhere(['like', 'sale_order', $this->sale_order])
            ->andFilterWhere(['like', 'suffix', $this->suffix])
            ->andFilterWhere(['like', 'sale_order_id', $this->sale_order_id])
            ->andFilterWhere(['like', 'date', $this->date])
            ->andFilterWhere(['like', 'delivery_date', $this->delivery_date])
            ->andFilterWhere(['like', 'due_date', $this->due_date])
            ->andFilterWhere(['like', 'terms_of_payment', $this->terms_of_payment])
            ->andFilterWhere(['like', 'product_code', $this->product_code])
            ->andFilterWhere(['like', 'advance_payment', $this->advance_payment])
            ->andFilterWhere(['like', 'receipt_id', $this->receipt_id])
            ->andFilterWhere(['like', 'set_reminder', $this->set_reminder])
            ->andFilterWhere(['like', 'show_to_store_keeper', $this->show_to_store_keeper])
            ->andFilterWhere(['like', 'full_order_product_wise', $this->full_order_product_wise])
            ->andFilterWhere(['like', 'other_note', $this->other_note])
            ->andFilterWhere(['like', 'terms', $this->terms])
            ->andFilterWhere(['like', 'saleorder_source', $this->saleorder_source])
            ->andFilterWhere(['like', 'converted_to', $this->converted_to])
            ->andFilterWhere(['like', 'total_amount', $this->total_amount]);
            if($this->customer_id){
                $customer=Customer::find()->select('id')->where(['like','business_name',$this->customer_id])->column();
               $query->andFilterWhere(['in', 'customer_id', $customer]);}

        return $dataProvider;
    }
}
