<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "sales_product".
 *
 * @property int $id
 * @property string $invoice_no
 * @property string $product_name
 * @property string $quantity
 * @property string $units
 * @property string $price
 * @property string $discount
 * @property string $tax
 * @property string $tax_included
 * @property string $amount
 * @property string $created_at
 * @property string $updated_at
 */
class SalesProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sales_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['invoice_no', 'product_name', 'quantity', 'units', 'price', 'tax'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['invoice_no', 'product_name', 'units', 'price', 'discount', 'tax', 'tax_included', 'amount','description'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
            [['quantity'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Quantity Can Contain only numeric characters.'],
            [['price'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Price should be only numeric characters.'],
            [['tax_included'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Tax should be only numeric characters.'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'invoice_no' => 'Invoice No',
            'product_name' => 'Product Name',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'tax_included' => 'Tax Included',
            'amount' => 'Amount',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
