<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\AccountingTax;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;

$tcs_rate=AccountingTax::findOne(35)->tax_rate;
if($model->customer_type=='vendor')
{
    $customer=Vendor::find()->select('business_name')->where(['id'=>$model->customer_name])->one();
}
else
{
    $customer=Customer::find()->select('business_name')->where(['id'=>$model->customer_name])->one();
}

$settingtypes = GenericTemplate::find()->where(['template_for'=>'Credit Note'])->all();
$prosettinglist=ArrayHelper::map($settingtypes, 'template_name', 'template_name');


if(date("m")>=4)
{
    $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
}
else
{
    $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
}




$prosettinglist=ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\CreditNote */
/* @var $form yii\widgets\ActiveForm */
?>

<style>
.select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.rendered .select2-selection__rendered{
    width:144.406px;px !important;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
input#creditnote-tcs_amount{
    float: right;
    width: 141px;
    margin-bottom:25px;
}
.error-help
{
    color:red;
    margin-top: -15px;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>

 <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                
                                                                <?php if($update=='add'){?>
                                                                          <div class="widget-numbers dj-text-success">Create Credit Note</div>  
                                                                <?php }
                                                               else {?>
                                                                            <div class="widget-numbers dj-text-success">Update Credit Note</div>
                                                                <?php } ?>

                                                            </div>
                                                            <div class="widget-content-right">
                                                                <a href="<?=Url::base();?>/users/credit-note/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                                <a href="<?=Url::base();?>/master/customer/create" target='Blank' class="dj-danger-btn" id="btn-show-modal"><i class="fa fa-plus-circle" aria-hidden="true" onExit="reload"></i>  Add a Customer</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <?php $form = ActiveForm::begin(['options'=>['encrypt'=>'multipart/form-data']]); ?>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                            <div class="form-row">
                            <div class="col-md-6">
                              <div class="position-relative form-group">
                                                    <label for="customer" >Settings Type <span class="dj-red">*</span></label>
                                                    
                                                    <?php if($model->setting_type=='') { ?>
                                                        <?= $form->field($model, 'setting_type')->dropDownList($prosettinglist,['class'=>'select_class setting_default form-control','prompt'=>'--select--'])->label(false) ?>
                                                    <div class="error-help">This template is already deleted.</div>
                                                    <?php } else { ?>
                                                        <?= $form->field($model, 'setting_type')->dropDownList($prosettinglist,['class'=>'select_class form-control','prompt'=>'--select--'])->label(false) ?>
                                                    <div class="error-help">This template is already deleted.</div>
                                                    <?php } ?>


                                                    
                                                </div>
                            </div>
                            <div class="col-md-6">
                              <div class="position-relative form-group">
                                                    <label for="customer" >Customer Type <span class="dj-red">*</span></label>
                                                    
                                                    <?=$form->field($model, 'customer_type')->dropDownList(['vendor'=>'Vendor','customer' => 'Customer'], ['prompt'=>'--Select--','class' => "select_class customer_type form-control", 'maxlength' => true])->label(false)?>
                                                </div>
                            </div>
                            
                                    </div>
                                    <hr class="dj-hr">
                                    <form class="dj-sale-form">
                                      <div class="form-row">
                                            <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="customer" >Customer Name <span class="dj-red">*</span></label>   
                                                    <?php if($update=='update'){?>
                                                    <?= $form->field($model, 'customer_name') ->dropDownList([$model->customer_name=>$customer->business_name],['options' => [$model->customer_name => ['Selected'=>'selected']],'prompt'=>'--Select--','class' => "form-control customer_details",'id'=>'customersearch'])->label(false)?>
                                                    <?php } else{?>
                                                    <?=$form->field($model, 'customer_name')->dropDownList([''=>'--Selcet--'], [ 'class' => "form-control customer_details", 'maxlength' => true])->label(false)?>
                                                    <?php } ?>

                                                </div></div>
                                            <div class="col-md-6">
                                            <div class="position-relative form-group">
                                                    <label for="gstn">Receiver GSTN/ UID </label>
                                                     <?= $form->field($model, 'receiver_gstn')->textInput(['maxlength' => true,'class'=>'receiver_gstn form-control'])->label(false) ?>
                                                </div>
                                                </div>
                                             <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="salestype">Sales Type </label>
                                                     <?= $form->field($model, 'sales_type')->dropDownList($sales_type,['class'=>"select_class form-control",'maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($model, 'notes')->textarea(['rows' => 2])->label(false) ?>
                                                </div>
                                            </div>
                                           
                                        </div>
                                        <hr class="dj-hr">
                                         <div class="form-row">
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Supply Type </label>
                                                   <?= $form->field($model, 'supply_type')->dropDownList($supply_types,['prompt'=>'--Select--','class'=>"select_class supply_type form-control",'maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Supply Attracts Reverse Charge </label>
                                                   <?= $form->field($model, 'supply_reverse_charge')->dropDownList(['Yes'=>'Yes', 'No'=>'No'],['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                              <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Pricelist </label>
                                                   <?= $form->field($model, 'pricelist')->dropDownList(['Default Sale Price'=>'Default Sale Price'],['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
                                             </div>
                                             <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Point of Supply (Only if different from location of recipient)</label>
                                                   <?= $form->field($model, 'point_of_supply')->textInput(['maxlength' => true,'class'=>'form-control point_of_supply'])->label(false) ?>
                                                </div>
                                                
                                             </div>                              
                                             <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Is tax on this Invoice paid under provisional assessment </label>
                                                   <?= $form->field($model, 'is_invoice_paid_provisional')->dropDownList(['Yes'=>'Yes', 'No'=>'No'],['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                    </div>
                                    <hr class="dj-hr">
                                             <h5 class="card-title">Credit Note #</h5>

                                              <?php if($update=='add'){?>
                                                <div class="form-row">
                                               <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="prefix" class="">Prefix Ex:RA</label>
                                                   <?= $form->field($model, 'prefix')->textInput(['maxlength' => true,'value'=>'C','readonly'=>true])->label(false) ?>
                                                </div>
                                             </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="salesorder" class="credit" id="creditnote_label">Credit Note # <?=$last_entry-1?></label>
                                                  <?= $form->field($model, 'credit_note_no')->textInput(['maxlength' => true,'readonly'=>true,'value'=>$last_entry])->label(false) ?>
                                                </div>
                                             </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                 <label for="suffix" class="">Suffix EX: RT</label>
                                                  <?= $form->field($model, 'suffix')->textInput(['maxlength' => true,'value'=>'/'.$dt,'readonly'=>true])->label(false) ?>
                                                </div>
                                             </div>
                                             </div>
                                             <?php }else {?>
                                              <div class="form-row">
                                               <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="prefix" class="">Prefix Ex:RA</label>
                                                   <?= $form->field($model, 'prefix')->textInput(['maxlength' => true,'readonly'=>true])->label(false) ?>
                                                </div>
                                             </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="salesorder" class="credit" id="creditnote_label">Credit Note # <?=$last_entry-1?></label>
                                                  <input name="salesorder" id="salesorder" type="text" class="form-control" value="1" readonly>
                                                </div>
                                             </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                 <label for="suffix" class="">Suffix EX: RT</label>
                                                  <?= $form->field($model, 'suffix')->textInput(['maxlength' => true,'readonly'=>true,'value'=>'/'.$dt])->label(false) ?>
                                                </div>
                                             </div>
                                             </div>
                                             <?php } ?>
                                             
                                               
                                             <div class="form-row">
                                              <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Date <span class="dj-red">*</span></label>
                                                   <?= $form->field($model, 'date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                             </div>
                                             <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Invoice Number <span class="dj-red">*</span></label>
                                                   <?= $form->field($model, 'invoice_no')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                             </div>
                                               <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Invoice Date <span class="dj-red">*</span></label>
                                                   <?= $form->field($model, 'invoice_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                             </div>
                                             </div>
                                             <hr class="dj-hr">
                                             <div class="form-group row">
                                    <!-- <label class="col-form-label col-md-2">Product Code</label>
                                    <div class="col-md-10">
                                        <input type="text" class="form-control">
                                    </div> -->
                                    </div>
                                    <div class="form-row">
                                    

                                      <table class="mb-0 table table-bordered dj-table-form " id="dynamic_field">
                                        <thead>
                                            <tr>
                                                <th colspan="2" width="20%">Product *</th>
                                                <th width="10%">Desc</th>
                                                <th width="10%">Qty</th>
                                                <th width="10%">Units</th>
                                                <th width="10%">Price</th>
                                                <th width="10%">Discount</th>
                                                <th>Discount Type</th>
                                                <th width="20%">Tax</th>
                                                <th>Incl Tax</th>
                                                <th width="10%">Amount</th>
                                            </tr>
                                        </thead>
                                        <tbody id="dj-table-body">
                                            <?php if($update=='add'){?>
                                            <tr>
                                                <!-- <td class="text-center"><input type="checkbox"></td> -->
                                                 <td></td><td style="width: 200px" class="rendered"><?= $form->field($product, 'product_id') ->dropDownList([],['prompt'=>'Select Product','class' => "product_details form-control",'id'=>'product','name'=>'productdyn[0][product]'])->label(false)?>
                                                 </td>                                     
                                                
                                                <td>
                                                    <?= $form->field($product, 'description')->textInput(['maxlength' => true,'id'=>'includedescription','class' => "desc form-control",'name'=>'productdyn[0][desc]'])->label(false) ?>    
                                                </td>

                                                <td>
                                                    <?= $form->field($product, 'quantity')->textInput(['type' => 'number','maxlength' => true,'id'=>'includequantity','class' => "product_quantity form-control",'name'=>'productdyn[0][quantity]','min'=>1])->label(false) ?> 
                                                    <div class="error-help">Quantity cant be negative or zero.</div>       
                                                </td>
                                                <td>
                                                    <?= $form->field($product, 'units')->dropDownList(['Nos'=>'Nos','Pcs'=>'Pcs','Pkt'=>'Pkt'],['maxlength' => true,'id'=>'includeunits','class' => "product_unit form-control select_class",'name'=>"productdyn[0][units]"])->label(false) ?> 
                                                </td>
                                                <td>
                                                    
                                                    <?= $form->field($product, 'unit_price')->textInput(['maxlength' => true,'id'=>'unitprice','class' => "unit_price form-control",'name'=>'productdyn[0][unitprice]','type'=>'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>
                                                    <?= $form->field($product, 'price')->textInput(['maxlength' => true,'id'=>'includeprice','class' => "product_price form-control",'name'=>'productdyn[0][price]','type'=>'hidden'])->label(false) ?>
                                                    
                                                    <div class="error-help">Price cannot be negative.</div>                              
                                                </td>
                                                <td>
                                                    <?= $form->field($product, 'discount')->textInput(['maxlength' => true,'id'=>'includediscount','class' => "product_discount form-control",'name'=>'productdyn[0][discount]','type' => 'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>  
                                                    <div class="error-help">Discount  cannot be negative.</div>
                                                    <div class="error-help help-type">Discount Type cannot be blank.</div>                                                         
                                                </td>
                                                <td style="width: 150px">
                                                    <?= $form->field($product, 'discount_type')->dropDownList(['%'=>'%', 'FLAT'=>'FLAT'],['prompt'=>'--Select--','class'=>' discount_type form-control select_class','id'=>'discounttype','name'=>'productdyn[0][discounttype]'])->label(false) ?>
                                                    <div class="error-help">Discount Type cannot be blank.</div>  

                                                </td>  
                                                <td>

                                                     <?= $form->field($product, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name','accounting_tax_id'])->asArray()
                                                                    ->where(['is_deleted'=>0])
                                                                    ->andWhere(['tax_sub_type'=>'Output'])
                                                                    ->andWhere(['status'=>1])
                                                                    ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])
                                                                      ->all(),'accounting_tax_id','tax_name'),['prompt'=>'--Select Tax--','class' => "product_tax form-control select_class",'style'=>'width:50px','name'=>"productdyn[0][tax]",'id'=>'tax'])->label(false)?>           
                                                </td>
                                                
                                                <td class="text-center">
                                                    <?= $form->field($product, 'tax_included')->checkBox(['label' =>'','class'=>'product_tax_inc','name'=>'productdyn[0][tax_included]']) ?>
                                                </td>
                                                <td>
                                                    <?= $form->field($product, 'amount')->textInput(['maxlength' => true,'readonly'=>true,'id'=>'includeamount','class' => "product_amount form-control",'name'=>'productdyn[0][amount]'])->label(false) ?>
                                                    <div class="error-help">Total amount cannot be negative.</div>
                                                </td>                                                   
                                            </tr>
                                            <?php }else {?>
                                                <?php if(count($products)>0){?>
                                                
                                                    <?php foreach($products as $key=>$products): ?>
                                                    <?php 
                                                   
                                                    $product = Product::find()->select('product_name')->where(['id'=>$products->product_id])->one(); ?>
                                                        <tr>
                                                            <td class="text-center"><i class="fa fa-close removeproduct" aria-hidden="true" style="color: blue;"></i></td>
                                                            <td style="width: 200px" class="rendered">
                                                                
                                                                <?= $form->field($products, 'product_id') ->dropDownList([$products->product_id=>$product->product_name],['options' => [$products->product_id => ['Selected'=>'selected']],'prompt'=>'--Select--','class' => "product_details form-control",'id'=>'product','name'=>"productdynupdate[$key][product]"])->label(false)?>    
                                                            </td>                                     
                                                            
                                                            <td>
                                                                <?= $form->field($products, 'description')->textInput(['maxlength' => true,'id'=>'includedescription','class' => "desc form-control",'name'=>"productdynupdate[$key][desc]"])->label(false) ?>    
                                                            </td>

                                                            <td>
                                                                <?= $form->field($products, 'quantity')->textInput(['type' => 'number','maxlength' => true,'id'=>'includequantity','class' => "product_quantity form-control",'name'=>"productdynupdate[$key][quantity]",'min'=>1])->label(false) ?> 
                                                                <div class="error-help">Quantity cant be negative or zero.</div>       
                                                            </td>
                                                            <td>
                                                                <?= $form->field($products, 'units')->dropDownList(['Nos'=>'Nos','Pcs'=>'Pcs','Pkt'=>'Pkt'],['maxlength' => true,'id'=>'includeunits','class' => "product_unit form-control select_class",'name'=>"productdynupdate[$key][units]"])->label(false) ?> 
                                                            </td>
                                                            <td>
                                                                <?= $form->field($products, 'unit_price')->textInput(['maxlength' => true,'id'=>'unitprice','class' => "unit_price form-control",'name'=>"productdynupdate[$key][unitprice]",'type'=>'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>
                                                                <?= $form->field($products, 'price')->textInput(['maxlength' => true,'id'=>'includeprice','class' => "product_price form-control",'name'=>"productdynupdate[$key][price]",'type'=>'hidden'])->label(false) ?>
                                                                
                                                                <div class="error-help">Price cannot be negative.</div>                               
                                                            </td>
                                                            <td>
                                                                <?= $form->field($products, 'discount')->textInput(['maxlength' => true,'id'=>'includediscount','class' => "product_discount form-control",'name'=>"productdynupdate[$key][discount]",'type' => 'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?> 
                                                                <div class="error-help">Discount  cannot be negative.</div> 
                                                                <div class="error-help help-type">Discount Type cannot be blank.</div>        
                                                            </td>
                                                            <td style="width: 150px">
                                                                <?= $form->field($products, 'discount_type')->dropDownList(['%'=>'%', 'FLAT'=>'FLAT'],['prompt'=>'--Select--','class'=>' discount_type select_class form-control','id'=>'discounttype','name'=>"productdynupdate[$key][discounttype]"])->label(false) ?> 
                                                                <div class="error-help">Discount Type cannot be blank.</div> 
                                                            </td>  
                                                            <td>
                                                               
                                                                <?php 
                                                             
                                                                foreach (explode(',',$products->tax) as $taxind) {$sel_groups_array[$taxind] = array("selected"=>true);
                                                               
                                                                }?>

                                                                  <?= $form->field($products, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name','accounting_tax_id'])->asArray()
                                                                    ->where(['is_deleted'=>0])
                                                                    ->andWhere(['tax_sub_type'=>'Output'])
                                                                    ->andWhere(['status'=>1])
                                                                    ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])
                                                                      ->all(),'accounting_tax_id','tax_name'),['options' => $sel_groups_array,'class' => "product_tax form-control select_class",'style'=>'width:50px','name'=>"productdynupdate[$key][tax]",'id'=>'tax'])->label(false)?>

                                                                 <?php $sel_groups_array=[]?> 
                                                            </td>
                                                            
                                                            <td class="text-center">
                                                                <?= $form->field($products, 'tax_included')->checkBox(['label' =>'','class'=>'product_tax_inc','name'=>"productdynupdate[$key][tax_included]"]) ?>
                                                            </td>
                                                            <td>
                                                                <?= $form->field($products, 'amount')->textInput(['maxlength' => true,'readonly'=>true,'id'=>'includeamount','class' => "product_amount form-control",'name'=>"productdynupdate[$key][amount]"])->label(false) ?>
                                                                <div class="error-help">Total amount cannot be negative.</div>
                                                            </td>                                                   
                                                        </tr>

                                        
                                                <?php endforeach; ?>
                                                <?php }else {?>

                                                      <tr>
                                                      <!-- <td class="text-center"><input type="checkbox"></td> -->
                                                      <td></td> <td style="width: 200px" class="rendered"><?= $form->field($product, 'product_id') ->dropDownList([],['prompt'=>'Select Product','class' => "product_details form-control",'id'=>'product','name'=>'productdyn[0][product]'])->label(false)?>
                                                       </td>                                     
                                                      
                                                      <td>
                                                          <?= $form->field($product, 'description')->textInput(['maxlength' => true,'id'=>'includedescription','class' => "desc form-control",'name'=>'productdyn[0][desc]'])->label(false) ?>    
                                                      </td>

                                                      <td>
                                                          <?= $form->field($product, 'quantity')->textInput(['type' => 'number','maxlength' => true,'id'=>'includequantity','class' => "product_quantity form-control",'name'=>'productdyn[0][quantity]','min'=>1])->label(false) ?> 
                                                          <div class="error-help">Quantity cant be negative or zero.</div>       
                                                      </td>
                                                      <td>
                                                          
                                                          <?= $form->field($product, 'units')->dropDownList(['Nos'=>'Nos','Pcs'=>'Pcs','Pkt'=>'Pkt'],['maxlength' => true,'id'=>'includeunits','class' => "product_unit form-control select_class",'name'=>"productdyn[0][units]"])->label(false) ?>
                                                      </td>
                                                      <td>
                                                        

                                                          <?= $form->field($product, 'unit_price')->textInput(['maxlength' => true,'id'=>'unitprice','class' => "unit_price form-control",'name'=>'productdyn[0][unitprice]','type'=>'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>
                                                    <?= $form->field($product, 'price')->textInput(['maxlength' => true,'id'=>'includeprice','class' => "product_price form-control",'name'=>'productdyn[0][price]','type'=>'hidden'])->label(false) ?>
                                                          
                                                          <div class="error-help">Price cannot be negative.</div>                              
                                                      </td>
                                                      <td>
                                                          <?= $form->field($product, 'discount')->textInput(['maxlength' => true,'id'=>'includediscount','class' => "product_discount form-control",'name'=>'productdyn[0][discount]','type' => 'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>  
                                                          <div class="error-help">Discount  cannot be negative.</div>      
                                                      </td>
                                                      <td style="width: 150px">
                                                          <?= $form->field($product, 'discount_type')->dropDownList(['%'=>'%', 'FLAT'=>'FLAT'],['prompt'=>'--Select--','class'=>' discount_type form-control select_class','id'=>'discounttype','name'=>'productdyn[0][discounttype]'])->label(false) ?>
                                                          <div class="error-help">Discount Type cannot be blank.</div> 
                                                         
                                                      </td>  
                                                      <td>

                                                             <?= $form->field($product, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name','accounting_tax_id'])->asArray()
                                                                    ->where(['is_deleted'=>0])
                                                                    ->andWhere(['tax_sub_type'=>'Output'])
                                                                    ->andWhere(['status'=>1])
                                                                    ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])
                                                                      ->all(),'accounting_tax_id','tax_name'),['prompt'=>'--Select Tax--','class' => "product_tax form-control select_class",'style'=>'width:50px','name'=>"productdyn[0][tax]",'id'=>'tax'])->label(false)?>  
                                                      </td>
                                                      
                                                      <td class="text-center">
                                                          <?= $form->field($product, 'tax_included')->checkBox(['label' =>'','class'=>'product_tax_inc','name'=>'productdyn[0][tax_included]']) ?>
                                                      </td>
                                                      <td>
                                                          <?= $form->field($product, 'amount')->textInput(['maxlength' => true,'readonly'=>true,'id'=>'includeamount','class' => "product_amount form-control",'name'=>'productdyn[0][amount]'])->label(false) ?>
                                                          <div class="error-help">Total amount cannot be negative.</div>
                                                      </td>                                                   
                                                  </tr>
       
                                                <?php } ?>        
                                            <?php } ?>
                                        </tbody>
                                    </table>
                                    
                                    </div>
                                      <div class="form-row">
                                    <table class="mb-0 table table-bordered">
                                          <tr>
                                            <td width="25%" rowspan="7"><?= Html::Button(' <i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Line', ['class' => 'dj-danger-btn','id'=>"add_new"]) ?></td>
                                            <td width="25%" rowspan="7" class="text-right"><a href="<?=Url::base();?>/master/product/create" target='Blank' class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Product</a></td>
                                            <td width="25%"><label class="dj-sub-total-amt">Subtotal:</label></td>
                                            <td width="25%" class="text-right"><label class="subtotalamt dj-sub-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sub_total_amount')->hiddenInput(['maxlength' => true,'readonly'=>true,'class' => "form-control subtotal",'id'=>'sub_total_price'])->label(false) ?></td>
                                          </tr>
                                          <!-- <tr>
                                            <td><label class="dj-sub-total-amt">Add: Round Off</label></td>
                                            <td><input name="desc" id="desc" type="text" class="form-control"></td>
                                          </tr> -->
                                          </tr>
                                          <?php if($update=='add'){?>
                                              <tr>

                                                <td class="sale_order_intrastate"><label class="dj-total-amt">CGST:</label></td>
                                                <td width="25%" class="text-right sale_order_intrastate">
                                                    <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model,'cgst_amount')->hiddenInput(['maxlength' => true,'class' => "form-control cgst"])->label(false) ?>
                                                   
                                                </td> 
                                              </tr>
                                              <tr>
                                                <td class="sale_order_intrastate"><label class="dj-total-amt">SGST:</label></td>
                                                <td width="25%" class="text-right sale_order_intrastate">
                                                    <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model,'sgst_amount')->hiddenInput(['maxlength' => true,'class' => "form-control sgst"])->label(false) ?>
            
                                                </td>
                                              </tr>
                                          <?php }else {?>
                                                  
                                              <tr>
                                                <td class="gst_on_update"><label class="dj-total-amt">CGST:</label></td>
                                                <td width="25%" class="text-right gst_on_update">
                                                    <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model,'cgst_amount')->hiddenInput(['maxlength' => true,'class' => "form-control cgst"])->label(false) ?>
                                                   
                                                </td> 
                                              </tr>
                                              <tr>
                                                <td class="gst_on_update"><label class="dj-total-amt">SGST:</label></td>
                                                <td width="25%" class="text-right gst_on_update">
                                                    <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model,'sgst_amount')->hiddenInput(['maxlength' => true,'class' => "form-control sgst"])->label(false) ?>
                                                    
                                                </td>
                                              </tr>
                                              
                                           <?php } ?>
                                           <tr>
                                            <?php if($update=='add'){?>
                                            <td class="sale_order_interstate"><label class="dj-total-amt">IGST:</label></td>
                                            <td width="25%" class="text-right sale_order_interstate"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                                <?= $form->field($model, 'igst_amount')->hiddenInput(['maxlength' => true,'class'=>"form-control total_igst"])->label(false) ?>  
                                            </td>
                                            <?php }else {?>
                                               
                                             <td class="igst_on_update"><label class="dj-total-amt ">IGST:</label></td>
                                              <td width="25%" class="text-right igst_on_update"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                                <?= $form->field($model, 'igst_amount')->hiddenInput(['maxlength' => true,'class'=>"form-control total_igst"])->label(false) ?>  
                                             </td>  
                                            <?php } ?>      
                                          </tr>
                                         
                                          <tr>
                                              <td width="25%"><label class="dj-sub-total-amt"><?= $form->field($model, 'is_tcs')->checkBox(['label' =>'','class'=>'tcs_tax'])->label(false) ?></label>&nbsp;&nbsp;<label class="dj-sub-total-amt">TCS:</label></td>
                                            <td width="25%" class="text-right"><label class="dj-sub-total-amt tcsam" style="padding-top: 10px"></label><?= $form->field($model, 'tcs_amount')->textInput(['maxlength' => true,'class' => "form-control tcsamount"])->label(false) ?>
                                            </td>
                                          </tr>
                                          <tr>
                                            <td><input type="checkbox" id="round" type="text" class="">&nbsp;&nbsp<label class="dj-total-amt">Round Off: Amount:</label></td>
                                            <td  class="text-right"><label class="roundoffamt dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'round_off_amount')->hiddenInput(['maxlength' => true,'readonly'=>true,'class' => "form-control round_off_amount"])->label(false) ?>
                                                <!-- <div class="error-help">Total cannot be negative.</div> -->
                                            </td>
                                          </tr>
                                          <tr>
                                            <td><label class="dj-total-amt">Total(INR):</label></td>
                                            <td  class="text-right"><label class="totalamt dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'total_amount')->hiddenInput(['maxlength' => true,'readonly'=>true,'class' => "form-control total"])->label(false) ?></td>
                                          </tr>
                                        </table>

                                        </div>
                                            <hr class="dj-hr">
                                    
                                      <div class="form-row">
                                      <div class="col-md-6">
                                
                                        <div class="text-left mt-3"><label for="checkbox"> </label><?= $form->field($model, 'show_to_store_keeper')->checkBox(['label' =>'Show to Store Keeper?']) ?>
                                        </div>

                                <div class="form-group">
                                            <div class="form-check form-check-inline">
                                                <?= $form->field($model, 'order_type')->radioList(['Full Order'=>'Full Order','Product Wise'=>'Product Wise'])->label(false); ?>
                                                &nbsp;&nbsp;
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Terms</label>
                                                    <?= $form->field($model, 'credit_note_terms')->textarea(['rows' => 2])->label(false) ?>
                                                </div>
                                            </div>
                                </div>
                                        <div class="form-row">
                                        
                                            
                                      <div class="col-md-6" style="margin-top: 32px;">
                                       <div class="position-relative form-group">
                                                    <?= $form->field($document, 'document_name[]')->fileInput(['maxlength' => true,'class'=>"form-control",'multiple'=>true])->label(false) ?>
                                                   <span class="form-text text-muted">Allowed File Formats *.jpg,*.png,*.gif,*.txt,*.xls,*.doc,*.xlsx (Allowed Size 2M)</span>
                                                </div>
                                                
                                                <?php if($update=='add'){?>
                                                 <?php }else {?>
                                                    <a class="dj-danger-btn attachments" href=#  data-toggle="modal" data-target="#attachemnts_find" value=<?=$_GET['id']?>><i class="fa fa-plus-circle" aria-hidden="true"></i> View Attachments</a>
                                                 <?php } ?>

                                         </div>
                                         <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($model, 'credit_notes')->textarea(['rows' => 4])->label(false) ?>
                                                </div>
                                            </div>
                                            
                                         </div>
                                     </div>
                                    <div class="djsec-text-right dj-btn-sapce-sec">
                                            <?= Html::submitButton(($update=="update")?'<span class="fa fa-file-text-o"></span> Update and Create New':'<span class="fa fa-file-text-o"></span> Save and Create New', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn createon','name' => 'save', 'value' => '1']) ?>
                                            <button class="mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-commenting" aria-hidden="true"></i> Save and SMS</button>
                                            <button class="mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-envelope-o" aria-hidden="true"></i> Save and Email</button>
                                            <?= Html::submitButton(($update=="update")?'<span class="fa fa-check-square-o"></span> Update':'<span class="fa fa-check-square-o"></span> Create', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn                                                saveon','name' => 'save', 'value' => '0']) ?>
                                            <a href="<?=Url::base();?>/users/credit-note/index" class="mb-2 mr-2 btn-icon btn btn-danger"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</a>
                                            
                                     </div>
                                     </form> 
                                </div>
                                 <?php ActiveForm::end(); ?>
                        </div>
                </div>

<div class="modal fade" id="attachemnts_find" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Receipt Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            <table id="dinamic">
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>
<?php ob_start(); ?>                        
<script>
$(document).ready(function()
{
 $('.setting_default').find("option[value='17']").attr("selected",true).trigger('change');
  subtotal();
  total();
    $('.sale_order_intrastate').hide();
    $('.sale_order_interstate').hide();
    if($('.point_of_supply').val()==21)
    {
        $('.sale_order_intrastate').show();
        $('.sale_order_interstate').hide();
        $('.igst_on_update').hide();
        $('.gst_on_update').show();
    }
    else if($('.point_of_supply').val()=='')
    {
        $('.sale_order_interstate').hide();
        $('.sale_order_intrastate').hide();
        $('.igst_on_update').hide();
        $('.gst_on_update').hide();
    }
    else
    {
        $('.sale_order_interstate').show();
        $('.sale_order_intrastate').hide();
        $('.igst_on_update').show();
        $('.gst_on_update').hide();
    }
    $('.point_of_supply').change(function()
    {  
        if($(this).val()==21)
        {
            $('.sale_order_intrastate').show();
            $('.sale_order_interstate').hide();
            $('.igst_on_update').hide();
            $('.gst_on_update').show();
        }
        else
        {
            $('.sale_order_interstate').show();
            $('.sale_order_intrastate').hide();
             $('.igst_on_update').show();
            $('.gst_on_update').hide();
        }
    });
 $('.customer_details').change(function()
 {
    var customerid = $(this).val();
    var customertype = $('.customer_type').val();
    if(customerid!='' && customertype=="vendor")
    { 
     $.get('findvendordetails',{customerid:customerid},function(data)
     {   
        var data =$.parseJSON(data);
        $('.receiver_gstn').val(data.gstin_no);
        var gstin_value = data.gstin_no;
        $('.terms_of_payment').val(data.credit_terms).trigger('change');
        if($('.receiver_gstn').val()!='')
        {
            
            var gstin_value = data.gstin_no;    
            var state_code = gstin_value.substr(0,2);
            $('.point_of_supply').val(state_code).trigger('change');
            if(state_code==21)
            {
               $('.supply_type').val('Intra-State').trigger('change'); 
            }
            else
            {
                $('.supply_type').val('Inter-State').trigger('change');
            }
        }
        else
        {   $('.point_of_supply').val('').trigger('change');
            $('.supply_type').val('').trigger('change');
        }
    })
    }
    else if(customerid!='' && customertype=="customer")
    { 
     $.get('../leads-quotes/findcustomerdetails',{customerid:customerid},function(data)
     {   
        var data =$.parseJSON(data);

        $('.receiver_gstn').val(data.gstin_no);
        var gstin_value = data.gstin_no;
        $('.terms_of_payment').val(data.credit_terms).trigger('change');
        if($('.receiver_gstn').val()!='')
        {
            
            var gstin_value = data.gstin_no;    
            var state_code = gstin_value.substr(0,2);
            $('.point_of_supply').val(state_code).trigger('change');
            if(state_code==21)
            {
               $('.supply_type').val('Intra-State').trigger('change'); 
            }
            else
            {
                $('.supply_type').val('Inter-State').trigger('change');
            }
        }
        else
        {   $('.point_of_supply').val('').trigger('change');
            $('.supply_type').val('').trigger('change');
        }
    })
    }
    else
    {
        $('.receiver_gstn').val('');
        $('.point_of_supply').val('').trigger('change');
        $('.supply_type').val('').trigger('change');
    }

  });

   $('.select_class').select2(); 
   $('.product_details').select2({
        ajax: { 
        url: "../leads-quotes/productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
  $('.error-help').hide();


  $(document).on('click', ".removeproduct", function() {
                    $(this).parent().parent().remove();
                    var $this = $(this);
                    $this.parent().parent().siblings().children().children('.desc').val('');
                    $this.parent().parent().siblings().children().children('.product_price').val('');
                    $this.parent().parent().siblings().children().children('.unit_price').val('');
                    $this.parent().parent().siblings().children().children('.product_tax').val('');
                    $this.parent().parent().siblings().children().children('.product_unit').val('');
                    $this.parent().parent().siblings().children().children('.product_quantity').val('');
                    $this.parent().parent().siblings().children().children('.product_discount').val('');
                    $this.parent().parent().siblings().children().children('.discount_type').val('');
                    $this.parent().parent().siblings().children().children('.product_amount').val('');

                    subtotal();
                    total(); 
                    });
$('.customer_details').select2();
  $('#creditnote-customer_type').change(function(){
    if($(this).val()=='vendor')
    {
            $('.customer_details').empty();
            $('.customer_details').append('<option value="">--Select--</option>');
            $('.customer_details').select2({
            ajax: { 
            url: "vendordetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                return {
                    results: $.map(response, function (i,item) {
                        
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };  
            },
            cache: true
            }
        });
    }
    else if($(this).val()=='customer')
    {
        $('.customer_details').empty();
        $('.customer_details').append('<option value="">--Select--</option>');
            $('.customer_details').select2({
            ajax: { 
            url: "../sale-order/customerdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                return {
                    results: $.map(response, function (i,item) {
                        
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
        });
    }
    else
    {
        $('.customer_details').empty();
        $('.customer_details').append('<option value="">--Select--</option>');
        $('.customer_details').select2();

    }    
    })
 

    $(document).on("click",".saveon",function(e)
    {
        e.preventDefault();
        var value=false;

        $(".total").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).siblings('.help-block').text('Total cannot be negative.');
                value=true;
            }
            else
            {
                 $(this).siblings('.help-block').text('');
            }
        })
        $(".subtotal").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).siblings('.help-block').text('SubTotal cannot be negative.');
                value=true;
            }
            else
            {
                $(this).siblings('.help-block').text('');
            }
        })
        
    //     $(".product_discount").each(function()
    //    // $(document).on("each",".discount",function()
    //     {
    //         if($(this).val()!=0 && $(this).val()!="" && $(this).val()>0)
    //         {
    //             var discounttype = $(this).parent().parent().siblings().children().children('.discount_type').val();
    //             if(discounttype == null || discounttype == '' || discounttype == '--Select--')
    //             {
    //                 value=true;
    //                 $(this).parent().parent().siblings().children('.error-help').show();
    //                 $(this).parent().parent().siblings().children().children('.error-help').show();
    //             }
    //             else      
    //             {
    //                 $(this).parent().parent().siblings().children('.error-help').hide();
    //                 $(this).parent().parent().siblings().children().children('.error-help').hide();
    //             }
    //         }
    //         else
    //         {  
    //             if($(this).val()!=0 && $(this).val()!="" && $(this).val()<0)
    //             {
    //                 $(this).parent().siblings('.error-help').show();
    //             }
    //             else
    //             {
    //                 $(this).parent().siblings('.error-help').hide();
    //             }
 
    //             $(this).parent().parent().siblings().children('.error-help').hide();
    //             $(this).parent().parent().siblings().children().children('.error-help').hide();
    //         }
    //     });
        // $(".discount_type").each(function()
        // {
        //     if($(this).val()=='FLAT' || $(this).val()=='%')
        //     {

        //         var discount = $(this).parent().parent().siblings().children().children('.product_discount').val();
        //         if(discount=='')
        //         {
        //             value=true;
        //              $(this).parent().parent().siblings().children('.help-type').show();
        //         }
        //         else
        //         {
        //              $(this).parent().parent().siblings().children('.help-type').hide();
        //         }
        //     }
        // });
        $(".product_amount").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).parent().siblings('.error-help').show();
                value=true;
            }
            else
            {
                $(this).parent().siblings('.error-help').hide();
            }
        })
        
        $(".product_price").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).parent().siblings('.error-help').show();
                value=true;
            }
            else
            {
                $(this).parent().siblings('.error-help').hide();
            }
        })
        $(".product_quantity").each(function()
        {
            if($(this).val()<=0 && $(this).val()!="")
            {
                value=true;
                $(this).parent().siblings('.error-help').show();
                $(this).siblings('.error-help').show();
            }
            else      
            {
                $(this).parent().siblings('.error-help').hide();
                $(this).siblings('.error-help').hide();
            }
        }); 
        $('#creditnote-setting_type').each(function(){
        var setting= $(this).val();
       
       $.get('creditnotesettingtype',{setting:setting},function(data)
         {
            
            var data =$.parseJSON(data);
           
           if(data=='0')
                {
                   
                    $('#creditnote-setting_type').parent().siblings('.error-help').show();
                    $('#creditnote-setting_type').focus();
                   
                    value=true;
                  
                }
                else{ 
                                  
                $('#creditnote-setting_type').parent().siblings('.error-help').hide();    
                value=false;

                }

         })

        });

        if(value==false)
        {
           
           $(this).attr("disabled", "disabled");
           $('.createon').attr("disabled", "disabled");
           setTimeout(function() {
           $('.saveon').removeAttr("disabled");
           $('.createon').removeAttr("disabled");      
           }, 7000);
           $("#w0").submit();
        }
    });


    $(document).on("click",".createon",function(e)
    {
        e.preventDefault();
        var value=false;
        

        $(".product_discount").each(function()
       // $(document).on("each",".discount",function()
        {
            if($(this).val()!=0 && $(this).val()!="" && $(this).val()>0)
            {
                var discounttype = $(this).parent().parent().siblings().children().children('.discount_type').val();
                if(discounttype == null || discounttype == '' || discounttype == '--Select--')
                {
                    value=true;
                    $(this).parent().parent().siblings().children('.error-help').show();
                    $(this).parent().parent().siblings().children().children('.error-help').show();
                }
                else      
                {
                    $(this).parent().parent().siblings().children('.error-help').hide();
                    $(this).parent().parent().siblings().children().children('.error-help').hide();
                }
            }
            else
            {  
                if($(this).val()!=0 && $(this).val()!="" && $(this).val()<0)
                {
                    $(this).parent().siblings('.error-help').show();
                }
                else
                {
                    $(this).parent().siblings('.error-help').hide();
                }
 
                $(this).parent().parent().siblings().children('.error-help').hide();
                $(this).parent().parent().siblings().children().children('.error-help').hide();
            }
        });
        $(".discount_type").each(function()
        {
            if($(this).val()=='FLAT' || $(this).val()=='%')
            {

                var discount = $(this).parent().parent().siblings().children().children('.product_discount').val();
                if(discount=='')
                {
                     value=true;
                     $(this).parent().parent().siblings().children('.help-type').show();
                }
                else
                {
                     $(this).parent().parent().siblings().children('.help-type').hide();
                }
            }
        });
        $(".product_amount").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).parent().siblings('.error-help').show();
                value=true;
            }
            else
            {
                $(this).parent().siblings('.error-help').hide();
            }
        })
        $(".total").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).siblings('.help-block').text('Total cannot be negative.');
                value=true;
            }
            else
            {
                 $(this).siblings('.help-block').text('');
            }
        })
        $(".subtotal").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).siblings('.help-block').text('SubTotal cannot be negative.');
                value=true;
            }
            else
            {
                $(this).siblings('.help-block').text('');
            }
        })
        $(".product_price").each(function()
        {
            if($(this).val()<0)
            {
                 $(this).parent().siblings('.error-help').show();
                value=true;
            }
            else
            {
                $(this).parent().siblings('.error-help').hide();
            }
        })

         $('.product_tax').each(function()
        {
           var inc_check = $(this).parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').val();
           if($(this).parent().parent().siblings().children().children().children('.product_tax_inc').is(":checked") && $(this).val()=="")
           { alert('product_tax');
                value = true;
                $(this).parent().siblings('.error-help').show();
                $(this).focus();
           }
           else if( $(this).val()>100)
           {    
                value = true;
                $(this).parent().siblings('.error-help').show();
                $(this).focus();
           }
           else
           {
               $(this).parent().siblings('.error-help').hide();
           }
        })

      
        
    


        $(".product_quantity").each(function()
        {
            if($(this).val()<=0 && $(this).val()!="")
            {
                value=true;
                $(this).parent().siblings('.error-help').show();
                $(this).siblings('.error-help').show();
            }
            else      
            {
                $(this).parent().siblings('.error-help').hide();
                $(this).siblings('.error-help').hide();
            }
        });
        
        $('#creditnote-setting_type').each(function(){
        var setting= $(this).val();
       
       $.get('creditnotesettingtype',{setting:setting},function(data)
         {
            
            var data =$.parseJSON(data);
           
           if(data=='0')
                {
                   
                    $('#creditnote-setting_type').parent().siblings('.error-help').show();
                    $('#creditnote-setting_type').focus();
                   
                    value=true;
                  
                }
                else{ 
                                  
                $('#creditnote-setting_type').parent().siblings('.error-help').hide();    
                value=false;

                }

         })

        });
        



        if(value==false)
        {
           
           $(this).attr("disabled", "disabled");
           $('.saveon').attr("disabled", "disabled");
           setTimeout(function() {
           $('.createon').removeAttr("disabled");
           $('.saveon').removeAttr("disabled");     
           }, 7000);
           $(".createon").submit();
        }
    });

  $(document).on("change",".unit_price",function(){   
        if($(this).val()>0)
        {
            $(this).parent().siblings('.error-help').hide();
        }
        else
        {
            $(this).parent().siblings('.error-help').show();
        }
        var $this = $(this);
        $(this).is(":checked")
        $this.parent().siblings().children('.product_price').val((((isNaN($(this).val())?0:$(this).val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))))); 
         if($this.parent().parent().siblings().children().children('.discount_type').val()=='FLAT')
         {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($(this).val())?0:$(this).val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(  isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())));
         } 
         else if($this.parent().parent().siblings().children().children('.discount_type').val()=='%')
         {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($(this).val())?0:$(this).val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($(this).val())?0:$(this).val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())  )/100   )));
         }
         else
         {
                $this.parent().parent().siblings().children().children('.product_amount').val(( ( ((isNaN($(this).val())?0:$(this).val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))) ) ));
         }
        subtotal();
        total();      
        });
     $(document).on("change",".product_quantity",function(){
        if($(this).val()>0)
        {
            $(this).parent().siblings('.error-help').hide();
        }
        else
        {
            $(this).parent().siblings('.error-help').show();
        }
        var $this = $(this);
         $this.parent().parent().siblings().children().children('.product_price').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($(this).val())?1:$(this).val()))))); 
         if($this.parent().parent().siblings().children().children('.discount_type').val()=='FLAT')
         {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($(this).val())?1:$(this).val())))-(  isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val()))); 
         }
         else if($this.parent().parent().siblings().children().children('.discount_type').val()=='%')
         {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($(this).val())?1:$(this).val())))-(   (  ((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($(this).val())?1:$(this).val()))) * (isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())  )/100   )));
         }
         else
         {
                $this.parent().parent().siblings().children().children('.product_amount').val(( ( ((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($(this).val())?1:$(this).val()))) ) ));
         }
        subtotal();
        total();      
        });
     $(document).on("change",".product_discount",function(){
        var $this = $(this);
        if($(this).val()>0 || $(this).val()==0)
            {
                $(this).parent().siblings('.error-help').hide();
            }
            else
            {
                $(this).parent().siblings('.error-help').show();
            }
        if($this.parent().parent().siblings().children().children('.discount_type').val()=='FLAT')
        {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(isNaN($(this).val())?0:$(this).val())));
                subtotal();
                    total();
        }
        else if($this.parent().parent().siblings().children().children('.discount_type').val()=='%')
        {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($(this).val())?0:$(this).val())  )/100   )));
                subtotal();
             total();        
        } 
        else
        {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))));
                subtotal();
                    total();
        }
     
        });
     $(document).on("change",".discount_type",function(){
        $(this).parent().siblings('.error-help').hide();
        var $this = $(this);
        if($(this).val()=='FLAT')
        {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())));
                subtotal();
                total();   
        }
        else if($(this).val()=='%')
        {
                 $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())  )/100   )));
                 subtotal();
                total();  
        } 
        else 
        {
                $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))));
                subtotal();
                total();   
        } 
     });
    $(document).on("change",".product_tax",function(){
        var $this = $(this);
        if($this.parent().parent().siblings().children().children('.discount_type').val()=='%')
        {
            $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())  )/100   )));
             subtotal();
             total();
        }
        else if($this.parent().parent().siblings().children().children('.discount_type').val()=='FLAT')
        {
          $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))-    (isNaN($this.parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().siblings().children().children('.product_discount').val())     ));
             subtotal();
             total();
        }
        else
        {
           $this.parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().siblings().children().children('.product_quantity').val())))   ));
             subtotal();
             total();
        }
        tcs();
    })
      $(document).on("change",".product_tax_inc",function(){
          taxIncluded($(this))
      })
      function taxIncluded(val){
        var $this = $(this);
         if($this.parent().parent().parent().siblings().children().children('.discount_type').val()=='%')
         {
            $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   )));
             subtotal();
             total();
         }
         else if($this.parent().parent().parent().siblings().children().children('.discount_type').val()=='FLAT')
         {
              $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-    (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())     ));
                 subtotal();
                 total();
         }
          else
          {
               $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) ));
                 subtotal();
                 total();
          }
     }
 $(document).on("change",".product_details",function()
  {  
  
      jQuery.ajaxSetup({async:false});
        // alert($('.product_details').val());
        var $this = $(this);
        if($(this).val()=='')
        {
                $this.parent().parent().siblings().children().children('.desc').val('');
                $this.parent().parent().siblings().children().children('.product_price').val('');
                $this.parent().parent().siblings().children().children('.unit_price').val('');
                $this.parent().parent().siblings().children().children('.product_tax').val('');
                $this.parent().parent().siblings().children().children('.product_unit').val('');
                $this.parent().parent().siblings().children().children('.product_quantity').val('');
                $this.parent().parent().siblings().children().children('.product_discount').val('');
                $this.parent().parent().siblings().children().children('.discount_type').val('');
                $this.parent().parent().siblings().children().children('.product_amount').val('');
                subtotal();
                total(); 
        }
        var productid = $(this).val();
       $.get('findproduct',{productid:productid},function(data)
            {

                var data =$.parseJSON(data);
                $this.parent().parent().siblings().children().children('.desc').val(data.category);
                $this.parent().parent().siblings().children().children('.product_price').val(data.selling_price);
                $this.parent().parent().siblings().children().children('.unit_price').val(data.selling_price);
                var tax_details = data.selling_tax_rate;
                $this.parent().parent().siblings().children().children('.product_tax').find('option').removeAttr("selected");
                // tax_details.split(',').forEach(function(item) {

                //   $this.parent().parent().siblings().children().children('.product_tax').find("option[value='"+item+"']").attr("selected",true);
                //   $this.parent().parent().siblings().children().children('.product_tax').trigger('change.select2');
                // });
                 $this.parent().parent().siblings().children().children('.product_tax').find("option[value='37']").attr("selected",true).trigger('change');
                if(data.units!='')
                {
                    $this.parent().parent().siblings().children().children('.product_unit').val(data.units).trigger('change');
                }
                else
                {
                    $this.parent().parent().siblings().children().children('.product_unit').val('Nos').trigger('change');
                }
                $this.parent().parent().siblings().children().children('.product_quantity').val(1);
                $this.parent().parent().siblings().children().children('.product_discount').val('0.00');
                //$this.parent().parent().siblings().children().children('.discount_type').find("option[value='%']").attr("selected",true).trigger('change');

                var value=$this.parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').val();
                if(value==1)
                {
                    var amt=(($this.parent().parent().siblings().children().children('.unit_price').val()*$this.parent().parent().siblings().children().children('.product_quantity').val())+    (   ($this.parent().parent().siblings().children().children('.unit_price').val()*$this.parent().parent().siblings().children().children('.product_quantity').val())*$this.parent().parent().siblings().children().children('.product_tax').val())/100              );
                }
                else
                {
                    var amt=$this.parent().parent().siblings().children().children('.unit_price').val()*$this.parent().parent().siblings().children().children('.product_quantity').val();
                }
                $this.parent().parent().siblings().children().children('.product_amount').val(amt);
                subtotal();
                total();  
            });
            if($(this).val()){
          var tax=$(this).parent().parent().siblings().children().children('.product_tax').val();
          if(tax){
        $(this).parent().parent().siblings().children().children('label').children('.product_tax_inc').prop('checked', true);   
          taxIncluded($(this).parent().parent().siblings().children().children('label').children('.product_tax_inc'));
          }
      }
    });

  $("#add_new").click(function () { 

     var count=$('.add-more').length;
     var dynacount=count+1;
       $('#dynamic_field').append('<tr class=" add-more '+count+'"><td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td><td class="rendered"><div class=\"form-group field-product'+count+'\"><select class="product_details form-control" id=\"product'+count+'\" name="productdyn['+dynacount+'][product]"><option value="">--Select--</option></select></div></td><td><div class=\"form-group field-includedescription'+count+'\"><input type="text" class="desc form-control" id=\"includedescription'+count+'\" name="productdyn['+dynacount+'][desc]" ></div></td><td><div class=\"form-group field-includequantity'+count+'\"><input type="number" class="product_quantity form-control"  id=\"includequantity'+count+'\" name="productdyn['+dynacount+'][quantity]" min=1 onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"><div class="error-help">Quantity cant be negative or zero.</div></div></td><td><div class=\"form-group field-includeunits'+count+'\"><select  class="product_unit form-control" id=\"includeunits'+count+'\" name="productdyn['+dynacount+'][units]"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></div></td><td><div class=\"form-group field-unitprice'+count+'\"><input type="number"  class="unit_price form-control" id=\"unitprice'+count+'\" name="productdyn['+dynacount+'][unitprice]" min=0 step=.01 placeholder=0.00></div><div class=\"form-group field-includeprice'+count+'\"><input type="hidden" class="product_price form-control" id=\"includeprice'+count+'\" name="productdyn['+dynacount+'][price]" readonly></div><div class="error-help">Enter valid price.</div></td><td><div class=\"form-group field-includediscount'+count+'\"><input type="number" class="product_discount form-control" id=\"includediscount'+count+'\" name="productdyn['+dynacount+'][discount]" min=0 step=.01 placeholder=0.00 ></div><div class="error-help">Discount  cannot be negative.</div>  </td><td><div class=\"form-group field-discounttype'+count+'\"><select class="form-control discount_type" id=\"discounttype'+count+'\" name="productdyn['+dynacount+'][discounttype]"><option value>--Select--</option><option value="%">%</option><option value="FLAT">FLAT</option></select><div class="error-help">Discount Type cannot be blank.</div></div></td><td><div class=\"form-group field-includetax'+count+'\"><select class="product_tax form-control " id=\"includetax'+count+'\" name="productdyn['+dynacount+'][tax]" ><option value=" ">--Select Tax--</option></select></div><div class="error-help">Enter Valid tax value.</div></td><td class="text-center"><div class=\"form-group field-tax_included'+count+'\"><input type="hidden"  value="0" name="productdyn['+dynacount+'][tax_included]" checked><label><input type="checkbox" class="product_tax_inc" id=\"tax_included'+count+'\" value="1" name="productdyn['+dynacount+'][tax_included]"></label></div></td><td><div class=\"form-group field-includeamount'+count+'\"><input type="text" class="product_amount form-control" id=\"includeamount'+count+'\" name="productdyn['+dynacount+'][amount]" readonly></div><div class="error-help">Total amount cannot be negative.</div></td></tr>');
    var listItems= "";
        // $('.product_details').empty();
        $('#includeunits'+count+'').select2();
         $('#discounttype'+count+'').select2();
          $('.product_details').select2({
            ajax: { 
            url: "../leads-quotes/productdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                        // console.log(i,item);
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
            })
        $('.error-help').hide();
        $('#includetax'+count+'').select2();
        $.get('../leads-quotes/finddetails',function(data)
           {
             $.each(JSON.parse(data), function(i, item) {
               $('#includetax'+count+'').append($('<option value=\"'+i+'\">'+item+'</option>'));
          });
        });
        $(document).on('click', ".removeind", function() {
        $(this).parent().parent().remove();
        var $this = $(this);
        $this.parent().parent().siblings().children().children('.desc').val('');
        $this.parent().parent().siblings().children().children('.product_price').val('');
        $this.parent().parent().siblings().children().children('.unit_price').val('');
        $this.parent().parent().siblings().children().children('.product_tax').val('');
        $this.parent().parent().siblings().children().children('.product_unit').val('');
        $this.parent().parent().siblings().children().children('.product_quantity').val('');
        $this.parent().parent().siblings().children().children('.product_discount').val('');
        $this.parent().parent().siblings().children().children('.discount_type').val('');
        $this.parent().parent().siblings().children().children('.product_amount').val('');
        subtotal();
        total(); 
        });
});


function subtotal(){
     var subtotal= 0;
     var discount=0;
    //  $('.product_discount').each(function(){
        
    //  });

    $('.product_price').each(function(){
        var sub= parseFloat($(this).val());
        var qty=$(this).parent().parent().siblings().children().children('.product_quantity').val();
        // alert(qty);
        if(isNaN(sub))
        sub =0;
        subtotal += parseFloat(sub);      
        var discounttype=$(this).parent().siblings().parent().siblings().children().children('.discount_type').val();
        var discountval=parseFloat($(this).parent().siblings().parent().siblings().children().children('.product_discount').val());
        if(isNaN(discountval))
        discountval=0;
        if(discountval){
        if(discounttype=='%'){
            discount+=parseFloat(parseFloat(sub)*(parseFloat(discountval)/100));
        }else{
            discount+=parseFloat(discountval*qty);
        }
        }else{
            discount+=0;
        }
    });
    var finalval=parseFloat(parseFloat(subtotal)-parseFloat(discount));
    $('.subtotal').val(finalval.toFixed(2));
    $('.subtotalamt').text(finalval.toFixed(2));
}
function total()
    {

     var total= 0;
     var igst = 0;
     var sub_igst =0;
    // $('.unit_price').each(function(){
    //     var sub= parseFloat($(this).val());
    //     if(isNaN(sub))
    //     sub =0;
        
    //     total += parseFloat(sub);
        
    // });



    
    $('.product_tax_inc').each(function()
    {   
        $this = $(this);
        // var total= 0;
        var igst = 0;
        if($(this).is(":checked"))
        {
            var tax_details = $(this).parent().parent().parent().siblings().children().children('.product_tax').val();
            var tax =0;
             jQuery.ajaxSetup({async:false});
             var item = tax_details;
               $.get('../leads-quotes/taxdetails',{item:item},function(data)
               { 
                    var data =$.parseJSON(data);
                    tax = tax +parseFloat(data.tax_rate);
               }) 
            // sub_igst = parseFloat(sub_igst+((thisprice*tax)/100));
            // igst += parseFloat(sub_igst);
            $this = $(this);
            var dis_type= $this.parent().parent().parent().siblings().children().children('.discount_type').val();
            if(dis_type=='%')
             {  
               
                $this.parent().parent().parent().siblings().children().children('.product_amount').val(((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   ))+(   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   )) * (parseFloat(tax))  )/100   )).toFixed(2));  
                total =total +  parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());
                sub_igst =sub_igst+ (   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   )) * (parseFloat(tax))  )/100   );
             }
             else if(dis_type=='FLAT')
             {
            
                $this.parent().parent().parent().siblings().children().children('.product_amount').val(((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-    ((isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))))+(   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-((isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))) * (parseFloat(tax))  )/100   )).toFixed(2));
                total = total +parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());
                sub_igst=sub_igst+(   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-((isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))) * (parseFloat(tax))  )/100   );
             }
             else
             {
            
                $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) + (   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))) * ((parseFloat(tax)) )/100)   )   ).toFixed(2));
                total = total + parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());
                sub_igst=sub_igst+(   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))) * ((parseFloat(tax)) )/100)   );
             }

        } 
        else{
            var dis_type= $this.parent().parent().parent().siblings().children().children('.discount_type').val();
            if(dis_type=='%')
             {
                $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   )).toFixed(2));  
                total = total + parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());
             }
             else if(dis_type=='FLAT')
             {
                $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-    (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))     ).toFixed(2));
                 total = total +parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());
             }
             else
             {
                $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) ).toFixed(2));
                 total = total + parseFloat($this.parent().parent().parent().siblings().children().children('.product_amount').val());

             }
                        
        }
    }); 
    if($('#round').is(":checked")){
        $('#round').prop('checked',false)
        $('.round_off_amount').val('');
        $('.roundoffamt').text('0.00').trigger('change'); 
    }
    // alert(sub_igst);
    var final_amount =parseFloat(total);
    igst += parseFloat(sub_igst);
    $('.totaligst').text(igst.toFixed(2));
    $('.total_igst').val(igst); 
    $('.cgstvalue').text((igst/2).toFixed(2));
    $('.sgstvalue').text((igst/2).toFixed(2));
    $('.sgst').val(igst/2);
    $('.cgst').val(igst/2);
    $('.total').val(final_amount.toFixed(2));
    $('.totalamt').text(final_amount.toFixed(2));
    // $('.round_off_amount').val(roundoff_amount);
    // alert($('.round_off_amount').val());
    // $('.roundoffamt').text(roundoff_amount.toFixed(2));
    tcs();
  }
 $('.tcs_tax').change(function()
  {
        tcs();
  });
  function tcschange()
  {
    var t_amount = $('.total').val();
    var tcs_amt = parseFloat($('#creditnote-tcs_amount').val());
    var tcsamt;
    var totalamount = 0;
    var roundoff_amount =0;

        $('.product_amount').each(function(){
            totalamount+=parseFloat($(this).val())
        })
    if($('.tcs_tax').is(":checked"))
    { 
       
        t_amount = parseFloat(totalamount)+ tcs_amt;
        roundoff_amount = Math.round(parseFloat(totalamount)+ parseFloat(tcs_amt)) - (parseFloat(totalamount)+ parseFloat(tcs_amt));
        t_amount = parseFloat(t_amount);     

        $('.total').val(t_amount);
        $('.totalamt').text(t_amount.toFixed(2));
        // $('.round_off_amount').val(roundoff_amount);
        // $('.roundoffamt').text(roundoff_amount.toFixed(2));
    }
    else
    { 
        $('#creditnote-tcs_amount').val(0)
        if(parseFloat($('#creditnote-tcs_amount').val())>0)
        tcs_amt=parseFloat($('#creditnote-tcs_amount').val())
        else
        tcs_amt = 0;
        t_amount = parseFloat(totalamount)+ tcs_amt;
        roundoff_amount = Math.round(parseFloat(totalamount)+ parseFloat(tcs_amt))-(parseFloat(totalamount)+ parseFloat(tcs_amt));
        t_amount = parseFloat(t_amount);  

        $('.total').val(t_amount);
        $('.totalamt').text(t_amount.toFixed(2));
        // $('.round_off_amount').val(roundoff_amount);
        // $('.roundoffamt').text(roundoff_amount.toFixed(2));
    }
    if($('#round').is(":checked")){
        $('#round').prop('checked',false)
        $('.round_off_amount').val('');
        $('.roundoffamt').text('0.00').trigger('change'); 
    }
    $('.tcsamt').text((tcs_amt).toFixed(2));
    $('.tcsamount').val((tcs_amt).toFixed(2));
    
  }
  function tcs()
  {
    var t_amount = $('.total').val();
    var tcs_amt = 0;
    var tcsamt;
    var totalamount = 0;
    var roundoff_amount =0;

        $('.product_amount').each(function(){
            totalamount+=parseFloat($(this).val())
        })
    if($('.tcs_tax').is(":checked"))
    { 
        var tcs_rate=<?=$tcs_rate?>;
        if(parseFloat($('#creditnote-tcs_amount').val())>0)
        {
            tcs_amt=parseFloat($('#creditnote-tcs_amount').val());
        }
        
        else
        {
            tcs_amt = parseFloat(parseFloat(tcs_rate)*parseFloat(totalamount)/100);
        }
        t_amount = parseFloat(totalamount)+ tcs_amt;
        roundoff_amount = Math.round(parseFloat(totalamount)+ parseFloat(tcs_amt))-(parseFloat(totalamount)+ parseFloat(tcs_amt));
        t_amount = parseFloat(t_amount);     

        $('.total').val(t_amount);
        $('.totalamt').text(t_amount.toFixed(2));
        // $('.round_off_amount').val(roundoff_amount);
        // $('.roundoffamt').text(roundoff_amount.toFixed(2));
    }
    else
    { 
        $('#creditnote-tcs_amount').val(0)
        if(parseFloat($('#creditnote-tcs_amount').val())>0)
        tcs_amt=parseFloat($('#creditnote-tcs_amount').val())
        else
        tcs_amt = 0;
        t_amount = parseFloat(totalamount)+ tcs_amt;
        roundoff_amount = Math.round(parseFloat(totalamount)+ parseFloat(tcs_amt))-(parseFloat(totalamount)+ parseFloat(tcs_amt));
        t_amount = parseFloat(t_amount);  

        $('.total').val(t_amount);
        $('.totalamt').text(t_amount.toFixed(2));
        // $('.round_off_amount').val(roundoff_amount);
        // $('.roundoffamt').text(roundoff_amount.toFixed(2));
    }
    if($('#round').is(":checked")){
        $('#round').prop('checked',false)
        $('.round_off_amount').val('');
        $('.roundoffamt').text('0.00').trigger('change'); 
    }

    $('.tcsamt').text((tcs_amt).toFixed(2));
    $('.tcsamount').val((tcs_amt).toFixed(2));
    
  }
  $('#round').change(function(){
    if($(this).is(":checked")){
        var roundval= Math.round($('.total').val()) - $('.total').val();
        $('.totalamt').text(Math.round($('.total').val()));
        $('.round_off_amount').val(roundval.toFixed(2)).trigger('change');
        $('.roundoffamt').text(roundval.toFixed(2)).trigger('change');
        $('.total').val(Math.round($('.total').val()));
    }else{
        total();
        $('#round').prop('checked',false);
        $('.round_off_amount').val('');
        $('.roundoffamt').text('0.00').trigger('change');
        }
    })
    if($('.round_off_amount').val()!='')
    {
        
        $('#round').prop('checked',true)
    }
        if($('#round').is(":checked")){
            var roundval=Math.round($('.total').val()) - $('.total').val();
        $('.totalamt').text(Math.round($('.total').val()));
        $('.round_off_amount').val(roundval.toFixed(2)).trigger('change');
        $('.roundoffamt').text(roundval.toFixed(2)).trigger('change');
        $('.total').val(Math.round($('.total').val()));
        }
 
  $('#creditnote-tcs_amount').change(function(){
    tcschange();
  })
  var isLoading = false;
  $('.attachments').click(function(){
       
       $("#dinamic").empty();
       isLoading = true;
       var id = $(this).attr('value');
       // alert(id);

       $.get('findattachments',{id:id},function(data)
       {
             var data =$.parseJSON(data);
             if(data.length==0)
             {
                 $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
             }
             for (var i = 0; i < data.length; i++){
                   // $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "</td><tr>");

                  $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "  <i class='fa fa-times deleteattachment' style='color:#FF0000'  aria-hidden='true' data-dismiss='modal' value='" + data[i].id + "'></i></td><tr>");
                 

                    }
                    $('.deleteattachment').click(function(){
                           var id = $(this).attr('value');
                              // alert(id);
                           $.get('delattachment',{id:id},function(data)
                           {
                               
                           })
                            
                    })
           isLoading = false;        

       });

  });

 if($('#creditnote-customer_details').val()!=''){
    if($('#creditnote-customer_type').val()=='vendor')
    {
            $('.customer_details').select2({
            ajax: { 
            url: "vendordetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                return {
                    results: $.map(response, function (i,item) {
                        
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };  
            },
            cache: true
            }
        });
    }
    else if($('#creditnote-customer_type').val()=='customer')
    {
            $('.customer_details').select2({
            ajax: { 
            url: "../sale-order/customerdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                return {
                    results: $.map(response, function (i,item) {
                        
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
        });
    }
    else
    {
        $('.customer_details').empty();
        $('.customer_details').append('<option value="">--Select--</option>');
        $('.customer_details').select2();

    }    
}

    $("#creditnote-date").on("change",function(){
        var selected_date = $(this).val();
         var sel_date = new Date($(this).val());
        $.get('selectdate',{selected_date:selected_date},function(data)
        {  
                var d = new Date();
                var output = d.getFullYear() + '-' +'03'+ '-' +'31';

                if(new Date(selected_date) <= new Date(output))
                {
                    var dt = sel_date.getFullYear().toString().substr(-2);
                    var prv_dt = sel_date.getFullYear()-1;
                    var prefix_date = '/'+prv_dt+'-'+dt;
                }
                else
                {
                    var dt = sel_date.getFullYear();
                    var new_dt = (sel_date.getFullYear()+1).toString().substr(-2);
                    var prefix_date = '/'+dt+'-'+new_dt;
                }


                var data =$.parseJSON(data);
                $('#creditnote-credit_note_no').val(data).trigger('change');
                $('#creditnote-suffix').val(prefix_date).trigger('change');
                $('#creditnote_label').empty();
                $('#creditnote_label').append("Credit Note # "+(data-1));

        })
    });



});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?> 

