<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\users\models\CreditNoteDocument;
use backend\modules\users\models\CreditNoteProduct;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Credit Note Details';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Credit Note Details</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'setting_type',
            'customer_type',
            [
                'label'=>'Customer',
               'attribute' => 'customer_name',
               'value' => function ($data) {
                if($data->customer_type=='customer')
                {
                    $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                else
                {
                    $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                
               }
            ],
            'notes:ntext',
            'receiver_gstn',
            'sales_type',
            'supply_type',
            'supply_reverse_charge',
            'pricelist',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'prefix',
            'credit_note_no',
            'suffix',
            'credit_note_id',
            [
                'label' => 'Show To Store Keeper',
                'attribute' => 'show_to_store_keeper',
                'value' => function ($data) {
                    if($data->show_to_store_keeper==1)
                    {
                        return 'Yes';
                    }
                    else
                    {
                        return 'No';
                    }
            },
            ],
            'order_type',
            [
                'label' => 'Date',
                'attribute' => 'date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['date']));
                    return $newDate;
            },
            ],
            'invoice_no',
            [
                'label' => 'Invoice Date',
                'attribute' => 'invoice_date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['invoice_date']));
                    return $newDate;
            },
            ],
            'sub_total_amount',
            'total_amount',
            'credit_note_terms:ntext',
            'credit_notes:ntext',
            [
                'label' => 'Created Date',
                'attribute' => 'created_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                    return $newDate;
            },
            ],
            [
                'label' => 'Updated Date',
                'attribute' => 'updated_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                    return $newDate;
            },
            ],
             [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= CreditNoteDocument::find()->select(['document_name'])->where(['credit_note_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],

        ],
    ]); ?>


</div>
</div>
</div>