<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Debit Note';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Debit Note</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'label'=>'Debit Note #',
               'attribute' => 'po',
               'value' => function ($data) {
                return $data->po;
               }
            ],
            [
                'label'=>'Amount',
               'attribute' => 'total',
               'value' => function ($data) {
                return $data->total;
               }
            ],
            [
                'label'=>'Vendor Name / Financial Category',
               'attribute' => 'party_id',
               'value' => function ($data) {
                if($data->party_type=='customer')
                $val=Customer::find()->where(['id'=>$data->party_id])->one();
                else
                $val=Vendor::find()->where(['id'=>$data->party_id])->one();
                return $val->business_name;
               }
            ],
            'date:date',
            'setting_type',
            'sender_gst:ntext',
            'bill_type',
            'notes:ntext',
            'supply_type',
            // 'supply_attracts',
            [
                'label'=>'Supply Attracts Reverse Charge',
               'attribute' => 'supply_attracts',
               'value' => function ($data) {
                return $data->supply_attracts?"YES":"NO";
               }
            ],
            'pricelist',
            'point_of_supply',
            // 'ineligible_itc',
         
            [
                'label'=>'Is ineligible ITC?',
               'attribute' => 'ineligible_itc',
               'value' => function ($data) {
                return $data->ineligible_itc?"YES":"NO";
               }
            ],
            'prefix',
            'suffix',
            'bill_no',
            [
                'label'=>'Bill Date',
               'attribute' => 'bill_date',
               'value' => function ($data) {
                return $data->bill_date?date("d-m-Y", strtotime($data->bill_date)):'';
               }
            ],
            'product_code:ntext',
            'sub_total',
            'total',
            'match_bill',
            [
                'label'=>'Show To Store Keeper',
               'attribute' => 'show_to_store_keeper',
               'value' => function ($data) {
                return $data->show_to_store_keeper?"YES":"NO";
               }
            ],
            [
                'label'=>'Order',
               'attribute' => 'full_order',
               'value' => function ($data) {
                return $data->full_order;
               }
            ],
            'debit_notes:ntext',
            'created_at:date',
            'updated_at:date',
           
           
        ],
    ]); ?>


</div>
</div>
</div>