<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\users\models\PurchasePayment;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\PurchaseTemplates;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\GenericTemplate;


$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

$debit = GenericTemplate::find()->where(['template_for'=>'Debit Note'])->all();
$debitnote=ArrayHelper::map($debit, 'gt_id', 'template_name');

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\DebitNoteSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Debit Notes';
$this->params['breadcrumbs'][] = $this->title;

?>
<style>
.select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.btn-danger.disabled, .btn-danger:disabled {
    color: #fff;
    background-color: red;
    border-color: red;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
<?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Debit Note</div>
                                                            </div>
															<div class="widget-content-right">

                                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/create'])->one()!=''){?>
                                                               <a href="<?=Url::base().'/users/debit-note/create'?>" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Debit Note</a>
                                                               <?php }else {?>

                                                               <?php } ?>


                                                            
                           
                                                                <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-creditote" role="button" aria-expanded="false" aria-controls="search-creditote">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                                                                <a  class="search_field_buttons"  href="<?=Url::base().'/users/debit-note/index'?>" role="button" aria-expanded="false" aria-controls="search-look" title="Refresh Page"><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                      
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card collapse" id="search-creditnote">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                        <div class="form-row">
										
										<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'class'=>'form-control','type'=>'date'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'class'=>'form-control','type'=>'date'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Party Type</label>
                                                    <?=$form->field($model, 'partytype')->dropDownList(['customer'=>'Customer','vendor'=>'Vendor'], ['prompt' => '--Select--', 'class' => "form-control select_class", 'maxlength' => true])->label(false)?>

                                                </div>
												
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Vendor/Sender</label>



                                                    <?php if($model->partytype=='vendor'){?>

                                                                <?php if($model->party!=''){?>

                                                                <?php $customer=Vendor::find()->where(['id'=>$model->party])->one()?>
                                                               <?=$form->field($model, 'party')->dropDownList([$model->party=>$customer->business_name], ['options' => [$model->party => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "select_class customer form-control", 'maxlength' => true])->label(false)?>

                                                               <?php }else {?>
                                                                          
                                                                <?=$form->field($model, 'party')->dropDownList([], ['prompt' => '--Select--', 'class' => "select_class customer form-control", 'maxlength' => true])->label(false)?>           
                                                               <?php } ?>

                                                   <?php }else if($model->partytype=='customer') {?>
                                                              
                                                                <?php if($model->party!=''){?>

                                                                <?php $customer=Customer::find()->where(['id'=>$model->party])->one()?>
                                                               <?=$form->field($model, 'party')->dropDownList([$model->party=>$customer->business_name], ['options' => [$model->party => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "select_class customer form-control", 'maxlength' => true])->label(false)?>

                                                               <?php }else {?>
                                                                          
                                                                <?=$form->field($model, 'party')->dropDownList([], ['prompt' => '--Select--', 'class' => "select_class customer form-control", 'maxlength' => true])->label(false)?>           
                                                               <?php } ?>

                                                   <?php }else{?> 

                                                     <?=$form->field($model, 'party')->dropDownList([], ['prompt' => '--Select--', 'class' => "select_class customer form-control", 'maxlength' => true])->label(false)?>

                                                   <?php } ?>

                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Setting Type</label>
                                                    <?=$form->field($model, 'setting')->dropDownList($debitnote, ['prompt' => '--Select--', 'class' => "select_class form-control", 'maxlength' => true])->label(false)?>

                                                </div>
												
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Product</label>

                                                    <?php if($model->product!=''){?>

                                                    <?php $product=Product::find()->where(['id'=>$model->product])->one()?>
                                                   <?=$form->field($model, 'product')->dropDownList([$model->product=>$product->product_name], ['options' => [$model->product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "select_class product form-control", 'maxlength' => true])->label(false)?>

                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($model, 'product')->dropDownList([], ['prompt' => '--Select--', 'class' => "select_class product form-control", 'maxlength' => true])->label(false)?>           
                                                   <?php } ?>

                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Amount</label>
                                                    <?= $form->field($model, 'amount')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											 
											<div class="col-md-3 dj-btn-align" style="padding-top: 5px">
                                            <button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i>Search</button>
											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/delete'])->one()!=''){?>
                               <button id="delete" class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                               <?php }else {?>

                               <?php } ?>
						
                        
							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/excel-export'])->one()!=''){?>
                               <a href="<?=Url::base();?>/users/debit-note/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                               <a href="<?=Url::base();?>/users/debit-note/excel-export" data-method="post">    <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                               <?php }else {?>

                               <?php } ?>

                               <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/debitnote-pdf'])->one()!=''){?>
                                  <a href="<?=Url::base();?>/users/debit-note/debitnote-pdf?from=all" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                               <?php }else {?>

                               <?php } ?>
		
                                     </div>
							 </div>
							 </div>
                             <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            [
                'label'=>'Debit Note #',
               'attribute' => 'po',
               'value' => function ($data) {
                return $data->prefix.'/'.$data->po.'/'.$data->suffix;
               }
            ],
            [
                'label'=>'Amount',
                'contentOptions'=>[ 'style'=>'text-align:right'],

               'attribute' => 'total',
               'value' => function ($data) {
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->total);
                 return $num; 
               
               }
            ],
           
            [
                'label'=>'Vendor Name / Financial Category',
                'contentOptions'=>['style'=>'font-weight:bold'],
               'attribute' => 'party_id',
               'value' => function ($data) {
                if($data->party_type=='customer')
                $val=Customer::find()->where(['id'=>$data->party_id])->one();
                else
                $val=Vendor::find()->where(['id'=>$data->party_id])->one();
                return $val->business_name;
               }
            ],

            // 'date:date',
            [
                'header'=> 'Date',
                'value'=> function($data){
                    return date(("\ F j  Y"), strtotime($data->date));
                } 
            ],
             [
                'label'=>'Paid',
                'contentOptions'=>[ 'style'=>'text-align:right'],

               'value' => function ($data) {
               $payment = PurchasePayment::find()->where(['against_bill'=>$data->bill_no])->all();
                $total = 0;
                foreach ($payment as $key => $value) {
                      $total = $total + $value->amount;
                }
                
                // return number_format($total,2);
                $amount = number_format((float)$total, 2, '.', '');
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$amount);
                return $num;    
               }
            ],
            [
                'label'=>'Pending',
                'contentOptions'=>[ 'style'=>'text-align:right'],

               'value' => function ($data) {
               $payment = PurchasePayment::find()->where(['against_bill'=>$data->bill_no])->all();
                $total = 0;
                foreach ($payment as $key => $value) {
                      $total = $total + $value->amount;
                }
                $total = $data->total-$total;
                 $amount = number_format((float)$total, 2, '.', '');
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$amount);
                return $num;  
                // return number_format($total,2);
               }
            ],
            [
                'label'=>'Status',
               'format'=>'raw',
               'value' => function ($data) {
                   $payment = PurchasePayment::find()->where(['against_bill'=>$data->bill_no])->all();
                    $total = 0;
                    foreach ($payment as $key => $value) {
                          $total = $total + $value->amount;
                    }
                   if($total>=$data->total)
                   {
                        return '<span class="label-paid">PAID</span>';
                   }
                   else if($total<$data->total && $total!=0)
                   {
                        return '<span class="label-parital">PARTIAL</span>';
                   }
                   else if($total==0)
                   {
                         return '<span class="label-draft">PENDING</span>';
                   }
               }
            ],
            [
                'label' => 'Action',
                'contentOptions'=>['style'=>'width:35px'],
                'headerOptions' => ['style' => 'color:#495057'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {


                    $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/debit-note/view?id='.$data->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap"> View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }


                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/debit-note/update?id='.$data->id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/debit-note/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/download-attachment'])->one()!='')
                    {
                        $attachmentstring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/debit-note/download-attachment?id='.$data->id.'>
                                <i class="fa fa-file"></i>
                                <span class="dj-icon-gap"> Download Attachment</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $attachmentstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/debitnote-pdf'])->one()!='')
                    {
                        $pdfstring = '<li class="nav-item">
                                <a class="nav-link" href='.Url::base().'/users/debit-note/debitnote-pdf?id='.$data->id.'>
                                    <i class="fa fa-file"></i>
                                    <span class="dj-icon-gap"> PDF Debit Note </span>
                                </a>
                            </li>';
                    }
                    else
                    {
                        $pdfstring = '';
                    }

                    return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$attachmentstring.''.$pdfstring.''.$downstring;

                  
                },
            ],
           
        ],
    ]); ?>
                        </div>
                    </div>
                </div>

                <?php ob_start();?>
 <script type="text/javascript">
$(function() {
    $('.select_class').select2();
    $('.product').select2({
        ajax: { 
        url: "../leads-quotes/productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
$('#debitnote-partytype').change(function(){
    if($(this).val()=='vendor')
    {
        $('.customer').empty();
        $('.customer').append('<option value="">--Select--</option>');
        $('.customer').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($(this).val()=='customer')
    {
        $('.customer').empty();
         $('.customer').append('<option value="">--Select--</option>');
        $('.customer').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    }
    else
    {
        $('.customer').empty();
         $('.customer').append('<option value="">--Select--</option>');
        $('.customer').select2();
    }

    // $.post( 'get-'+$(this).val(), function( data ) {
    //  $('#debitnote-party').empty();
    // $('#debitnote-party').append('<option value="">Select Product</option>');
    // $.each(JSON.parse(data), function(i, item) {
    //   $('#debitnote-party').append($('<option value=\"'+i+'\">'+item+'</option>'));
    //   });
    // })      
})



   if($('.customer').val()!='')
   { 
    if($('#debitnote-partytype').val()=='vendor')
    {
        
        $('.customer').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($('#debitnote-partytype').val()=='customer')
    {
       
        $('.customer').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    }
    else
    {
        $('.customer').empty();
         $('.customer').append('<option value="">--Select--</option>');
        $('.customer').select2();
    } 
    } 




// if($('#debitnote-partytype').val()){
// $.post( 'get-'+$('#debitnote-partytype').val(), function( data ) {
//      $('#debitnote-party').empty();
//     $('#debitnote-party').append('<option value="">Select Product</option>');
//     $.each(JSON.parse(data), function(i, item) {
//       $('#debitnote-party').append($('<option value=\"'+i+'\">'+item+'</option>'));
//       });
//       $('#debitnote-party').val(<?=$model->party?$model->party:''?>)
//     })   
// }
// $('#debitnote-from_date').attr('type','date');
// $('#debitnote-to_date').attr('type','date');
$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   }); 
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#search-creditnote').hide();
$('#advance-search').click(function(){
    $('#search-creditnote').toggle();
})
$('input[name="DebitNoteSearch[date]"]').attr('type','date');
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>