<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use backend\modules\users\models\CreditNoteDocument;
use backend\modules\users\models\CreditNoteProduct;
use yii\helpers\Url;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;

/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\CreditNote */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Credit Notes', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                
                                                               <div class="widget-numbers dj-text-success">View Credit Note</div> 

                                                            </div>
                                                            <div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/users/inventory-pending/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
<div class="credit-note-view">

    

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'setting_type',
            'customer_type',
            [
                'label'=>'Customer',
               'attribute' => 'customer_name',
               'value' => function ($data) {
                if($data->customer_type=='customer')
                {
                    $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                else
                {
                    $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                    return $val->business_name;
                }
                
               }
            ],
            'notes:ntext',
            'receiver_gstn',
            'sales_type',
            'supply_type',
            'supply_reverse_charge',
            'pricelist',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'prefix',
            'credit_note_no',
            'suffix',
            'credit_note_id',
            [
                'label' => 'Show To Store Keeper',
                'attribute' => 'show_to_store_keeper',
                'value' => function ($data) {
                    if($data->show_to_store_keeper==1)
                    {
                        return 'Yes';
                    }
                    else
                    {
                        return 'No';
                    }
            },
            ],
            'order_type',
            
            [
                'label' => 'Date',
                'attribute' => 'date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['date']));
                    return $newDate;
            },
            ],
            'invoice_no',
            [
                'label' => 'Invoice Date',
                'attribute' => 'invoice_date',
                'value' => function ($data) {
                    $newDate = date("d-m-Y", strtotime($data['invoice_date']));
                    return $newDate;
            },
            ],
            'sub_total_amount',
            'total_amount',
            'credit_note_terms:ntext',
            'credit_notes:ntext',
            [
                'label' => 'Created Date',
                'attribute' => 'created_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                    return $newDate;
            },
            ],
            [
                'label' => 'Updated Date',
                'attribute' => 'updated_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                    return $newDate;
            },
            ],
             [
                'label' => 'Documents',
                'format'    => 'raw',
                'value' => function ($data) {
                    $user= CreditNoteDocument::find()->select(['document_name'])->where(['credit_note_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],
        ],
    ]) ?>


<h4>Products</h4>
<table id="w0" class="table table-striped table-bordered detail-view">
    <thead>
    <tr>
        <th>Product</th>
        <th>Description</th>
        <th>Quantity</th>
        <th>Units</th>
        <th>Unit Price</th>
        <th>Price</th>
        <th>Discount</th>
        <th>Discount Type</th>
        <th>Tax</th>
        <th>Incl Tax</th>
        <th>Amount</th>
    </tr>
</thead>
<tbody>
    <?php foreach($products as $value){ ?>
        <tr>
           <td><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td> 
           <td><?=$value->description?></td>
           <td><?=$value->quantity?></td>
           <td><?=$value->units?></td>
           <td><?=$value->unit_price?></td>
           <td><?=$value->price?></td>
           <td><?=$value->discount?></td>
           <td><?=$value->discount_type?></td>
           <td><?=$value->tax?> %</td>
           <td><?=$value->tax_included?></td>
           <td><?=$value->amount?></td>
        </tr>
    <?php } ?>    
</tbody>    
</table>


</div>
</div>
