<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\PurchaseOrder */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Purchase Orders', 'url' => ['index']];
$this->params['breadcrumbs'][] = "View Purchase Order";
\yii\web\YiiAsset::register($this);
?>
<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Inventory Pendings</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/users/inventory-pending/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
    
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'setting_type',
            // 'vendor_name',
            [
                'header'=> 'Vendor Name',
                'attribute' => 'vendor_name',
                'value'=> function($data){
                    $vendor=Vendor::find()->where(['id'=>$data->vendor_name])->one();
                   return $vendor?$vendor->business_name:'';
                } 
            ],
            'sendor_gstin',
            'bill_type',
            'notes:ntext',
            'delivery_address:ntext',
            'supply_type',
            'supply_attracts',
            'currancy',
            'point_of_supply',
            'eligibity_of_itc',
            'prefix',
            'po_last',
            [
                'header'=> 'date',
                'attribute' => 'date',
                'value'=> function($data){
                    $last_date = date('d-m-y', strtotime($data->date));
                   return $last_date;
                } 
            ],
            [
                'header'=> 'Due Date',
                'attribute' => 'due_date',
                'value'=> function($data){
                    if(isset($data->due_date)){
                    $last_date = date('d-m-y', strtotime($data->due_date));
                   return $last_date;
                    }
                } 
            ],
            'terms_of_payment',
            'total_amount',
            'terms_and_condition:ntext',
            'advance_payment',
            'advance_settingtype',
            'advance_amount',
            'bank',
            'cheque_no',
            'cheque_date',
            'advance_note',
            'supplier_ref',
            'other_ref',
            'dispatch_through',
            'destination',
            'mode_of_payment',
            'delivery_date',
            'reminder',
            'reminder_for',
            'reminder_emails',
            'reminder_content',
            'reminder_repeat_on',
            [
                'header'=> 'Reminder From Date',
                'attribute' => 'reminder_from_date',
                'value'=> function($data){
                    if(isset($data->reminder_from_date)){
                    $last_date = date('d-m-y', strtotime($data->reminder_from_date));
                   return $last_date;
                    }
                } 
            ],
            [
                'header'=> 'Reminder To Date',
                'attribute' => 'reminder_to_date',
                'value'=> function($data){
                    if(isset($data->reminder_to_date)){
                    $last_date = date('d-m-y', strtotime($data->reminder_to_date));
                   return $last_date;
                    }
                } 
            ],
            'terms_of_delivery',
        ],
    ]) ?>
    <h4>Products</h4>
<table id="w0" class="table table-striped table-bordered detail-view">
    <thead>
    <tr>
        <th>Product</th>
        <th>Description</th>
        <th>Quantity</th>
        <th>Units</th>
        <th>Unit Price</th>
        <th>Price</th>
        <th>Discount</th>
        <th>Discount Type</th>
        <th>Tax</th>
        <th>Incl Tax</th>
        <th>Amount</th>
    </tr>
</thead>
<tbody>
    <?php foreach($products as $value)
    { 
        if($value->product_id!=""){
        ?>
        <tr>
           <td><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td> 
           <td><?=$value->description?></td>
           <td><?=$value->quantity?></td>
           <td><?=$value->units?></td>
           <td><?=$value->unit_price?></td>
           <td><?=$value->price?></td>
           <td><?=$value->discount?></td>
           <td><?php if($value->discount_type==1){?>
                 %
            <?php }else if($value->discount_type==2) {?>
               FLAT
            <?php } ?> </td>
           <td><?=$value->tax?> %</td>
           <td><?=$value->tax_included?></td>
           <td><?=$value->amount?></td>
        </tr>
    <?php } }?>    
</tbody>    
</table>

</div>
