<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\users\models\InvoiceDocument;
use backend\modules\master\models\Customer;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Invoice Details';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Invoice Details</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
              'settings_id',
              'prefix',
              'invoice_id',
              'suffix',
              'invoice_no',
               [   

                  'label' => 'Customer Name',
                  'contentOptions'=>[ 'style'=>'font-weight:bold'],
                  'attribute' => 'customer_name',
                  'value' => function ($data) {
                       $name = Customer::find()->where(['id'=>$data->customer_name])->one();
                       return $name->business_name;
                     
              },
              ],
              'executive',
              'receiver_gstn',
              'customer_referance',
              'sales_type',
              'notes',
              'sypply_type',
              'supply_reverse_change',
              'po_number',
              'po_date:date',
              'price_list',
              'point_of_supply',
              'income_terms',
              'tax_status',
              'date:date',
              'due_date:date',
              'terms_of_payment',
              'sub_total_price',
              'total_price',
              'payment_details',
              'receipt_setting_type',
              'receipt_total_amount',
              'receipt_bank',
              'receipt_cheque_no',
              'receipt_cheque_date:date',
              'advance_note',
              'credit_note_id',
              'receipt_id',
              'time_of_preparation:date',
              'time_o_removal:date',
              'reminder',
              'reminder_for',
              'reminder_through',
              'reminder_emails',
              'reminder_content',
              'reminder_repeat',
              'reminder_from_date:date',
              'reminder_to_date:date',
              'add_delivery_details',
              'delivery_note',
              'suppliers_ref',
              'other_reference',
              'buyer_details',
              'buyer_order',
              'buyer_order_date:date',
              'buyer',
              'dispatch_details',
              'dispatch_document_no',
              'dispatch_date:date',
              'dispatched_through',
              'destination',
              'terms_of_delivery',
              'deliver_to',
              'delivery_receiver_name',
              'deliver_to_address_1',
              'deliver_to_address_2',
              'deliver_to_city',
              'deliver_to_zipcode',
              'deliver_to_state',
              'deliver_state_code',
              'deliver_to_country',
              'recurring',
              'recurring_frequency',
              'recurring_until',
              'recurring_until_date:date',
              'packing_details',
              'net_weight',
              'gross_weight',
              'dimension_for_primary',
              'dimention_for_master',
              'dimention_for_pallet',
              'no_of_pallets',
              [

                  'label' => 'Status',
                  'value' => function ($data) {
                      if($data['status'])
                              {
                                  // return $data['status'];
                                  // if($data['status']=='Paid')
                                  if(($data->pending_amount)==0)
                                  {
                                       return 'PAID';
                                  }
                                  // else if($data['status']=='Pending')
                                  else if($data->total_price==($data->pending_amount))
                                  {
                                   return 'PENDING';
                                  }
                                  // else if ($data['status']=='Partially Paid')
                                  else if(($data->total_price-($data->pending_amount))>0)
                                   {
                                   return 'PARTIAL';
                                  }
                                  else{
                                      return $data->status;
                                  }
                              }



                              if(!($data->pending_amount-$data->tds_amount))
                              {
                               return 'PAID';
                           }
                           //    else if($total<$data->total && $total!=0)
                              else if($data->total-($data->pending_amount-$data->tds_amount))
                              {   
                               return 'PARTIAL';
                           }
                           //    else if($total==0)
                              else if($data->total=($data->pending_amount))
                              {
                               return 'PENDING';
                           }
                      
              },
               ],
              [

                  'label' => ' Shipment Status',
                  'value' => function ($data) {
                      if($data['shipment_status'])
                              {
                                  // return $data['status'];
                                  if($data['shipment_status']=='DELIVERED')
                                  {
                                       return 'DELIVERED';
                                  }
                                  else if($data['shipment_status']=='PARTIAL')
                                  {
                                   return 'PARTIAL';
                                  }
                                  else if ($data['shipment_status']=='NOT DELIVERED') {
                                   return 'PENDING';
                                  }
                                  else{
                                      return $data->shipment_status;
                                  }
                              }
                      
                  },
                ],
              'sale_order_id',
              'proforma_invoice_id',
               [
                'label' => 'Created At',
                'attribute' => 'created_at',
                'value' => function ($data) {
                    $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                    return $newDate;
                },
                ],
                [
                    'label' => 'Updated At',
                    'attribute' => 'updated_at',
                    'value' => function ($data) {
                        $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                        return $newDate;
                },
                ], 
              [
                      'label' => 'Documents',
                      'format'    => 'raw',
                      // 'attribute' => 'customer_name',
                      'value' => function ($data) {
                          $user= InvoiceDocument::find()->select(['document_name'])->where(['invoice_id' =>$data['id']])->asArray()->column();
                          $documents = implode(" <br> ", $user);
                          return $documents;

                          
                  },
                  ],
           
           
        ],
    ]); ?>


</div>
</div>
</div>
