<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\users\models\ProformaInvoiceDocument;
use backend\modules\master\models\LeadExecutive;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Proforma Details';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Proforma Details</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'setting_id',
            'customer_name',
            'notes',
            [
                'label' => 'Executive',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= LeadExecutive::find()->where(['id' =>$data['executive']])->one();
                    return $user['name'];


                    
            },
            ],
            'receiver_gstn',
            'sales_type',
            'supply_type',
            'supply_reverse_change',  
            'point_of_supply',
            'is_invoice_paid_provisional',
            'prefix',
            'proforma_invoice_no',
            'suffix',
            'proforma_invoice_id',
            'date',
            'due_date',
            'terms_of_payment',
            'sub_total_price',
            'total_price',
            'reminder',
            'reminder_for',
            'reminder_through',
            'reminder_emails',
            'reminder_content',
            'reminder_repeat_on',
            'reminder_from_date',
            'reminder_to_date',
            'add_delivery_details',
            'delivery_note',
            'suppliers_reference', 
            'other_reference',
            'converted_to',
            'terms',
            [
                'label' => 'Status',
                'headerOptions'=>['style'=>'text-align: center;'],
               
                'value' => function ($data) {                              
                    if($data['status'])
                    {
                        // return $data['status'];
                        if($data['status']=='Pending')
                        {
                             return 'DRAFT';
                        }
                        else if($data['status']=='Paid')
                        {
                            return 'PAID';
                        }
                        else if ($data['status']=='Draft') {
                            return 'DRAFT';
                        }
                    } 
              }
            ],
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= ProformaInvoiceDocument::find()->select(['document_name'])->where(['proforma_invoice_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],
            'created_at',
            'updated_at',
        ],
    ]); ?>


</div>
</div>
</div>
