<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use backend\modules\users\models\ProformaInvoiceDocument;
use backend\modules\users\models\ProformaInvoiceProduct;
use backend\modules\master\models\LeadExecutive;
use backend\modules\master\models\Product;
use backend\modules\master\models\Customer;
use backend\modules\master\models\AccountingTax;
use backend\modules\master\models\GenericTemplate;

$template = GenericTemplate::find()->where(['gt_id' => $model->setting_id])->one();
/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\ProformaInvoice */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Proforma Invoices', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<?php
function AmountInWords(float $amount)
{
   $amount_after_decimal = round($amount - ($num = floor($amount)), 2) * 100;
   // Check if there is any number after decimal
   $amt_hundred = null;
   $count_length = strlen($num);
   $x = 0;
   $string = array();
   $change_words = array(0 => '', 1 => 'One', 2 => 'Two',
     3 => 'Three', 4 => 'Four', 5 => 'Five', 6 => 'Six',
     7 => 'Seven', 8 => 'Eight', 9 => 'Nine',
     10 => 'Ten', 11 => 'Eleven', 12 => 'Twelve',
     13 => 'Thirteen', 14 => 'Fourteen', 15 => 'Fifteen',
     16 => 'Sixteen', 17 => 'Seventeen', 18 => 'Eighteen',
     19 => 'Nineteen', 20 => 'Twenty', 30 => 'Thirty',
     40 => 'Forty', 50 => 'Fifty', 60 => 'Sixty',
     70 => 'Seventy', 80 => 'Eighty', 90 => 'Ninety');
    $here_digits = array('', 'Hundred','Thousand','Lakh', 'Crore');
    while( $x < $count_length ) {
      $get_divider = ($x == 2) ? 10 : 100;
      $amount = floor($num % $get_divider);
      $num = floor($num / $get_divider);
      $x += $get_divider == 10 ? 1 : 2;
      if ($amount) {
       $add_plural = (($counter = count($string)) && $amount > 9) ? 's' : null;
       $amt_hundred = ($counter == 1 && $string[0]) ? ' and ' : null;
       $string [] = ($amount < 21) ? $change_words[$amount].' '. $here_digits[$counter]. $add_plural.' 
       '.$amt_hundred:$change_words[floor($amount / 10) * 10].' '.$change_words[$amount % 10]. ' 
       '.$here_digits[$counter].$add_plural.' '.$amt_hundred;
        }
   else $string[] = null;
   }
   $implode_to_Rupees = implode('', array_reverse($string));
   $get_paise = ($amount_after_decimal > 0) ? "And " . ($change_words[$amount_after_decimal / 10] . " 
   " . $change_words[$amount_after_decimal % 10]) . ' Paise' : '';
   return ($implode_to_Rupees ? $implode_to_Rupees . 'Rupees ' : '') . $get_paise;
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1"/>
	<title>Print Proforma Invoice</title>
	<meta name="generator" content="https://conversiontools.io" />
	<meta name="created" content="2021-04-01T17:03:36"/>
	<meta name="changed" content="2021-04-01T17:03:36"/>
	<meta name="AppVersion" content="12.0000"/>
	<meta name="DocSecurity" content="0"/>
	<meta name="HyperlinksChanged" content="false"/>
	<meta name="LinksUpToDate" content="false"/>
	<meta name="ScaleCrop" content="false"/>
	<meta name="ShareDoc" content="false"/>
	
	<style type="text/css">
		a.comment-indicator:hover + comment { background:#ffd; position:absolute; display:block; border:1px solid black; padding:0.5em;  } 
		a.comment-indicator { background:red; display:inline-block; border:1px solid black; width:0.5em; height:0.5em;  } 
		comment { display:none;  } 
		body{
			font-size:13px !important;
		}
	</style>
	<?php
$customer=Customer::find()->where(['business_name'=>$model->customer_name])->one();

?>
</head>

<body>
<?php if($model->point_of_supply!=21){?>
<table cellspacing="0" border="0" width="">
<colgroup width="35"></colgroup>
	<colgroup width="93"></colgroup>
	<colgroup width="158"></colgroup>
	<colgroup width="16"></colgroup>
	<colgroup width="18"></colgroup>
	<colgroup width="28"></colgroup>
	<colgroup width="38"></colgroup>
	<colgroup width="24"></colgroup>
	<colgroup width="58"></colgroup>
	<colgroup width="10"></colgroup>
	<colgroup width="52"></colgroup>
	<colgroup width="53"></colgroup>
	<colgroup width="34"></colgroup>
	<colgroup width="43"></colgroup>
	<colgroup width="33"></colgroup>
	<colgroup width="44"></colgroup>
	<colgroup width="21"></colgroup>
	<colgroup width="41"></colgroup>

	<tr>
		<td  style="border-top:1px solid black;border-left:1px solid black;border-bottom:1px solid black;"><img width="56" height="85" src="./theme/images/1569578921_Mohapatra_Logo.jpg"></td>
	    <td  style=" font-size:13px;padding-left:100px; border-top: 1px solid #000000; border-bottom: 1px solid #000000;  border-right: 1px solid #000000" colspan=15 height="94" align="left" valign=top><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong><br>F2G/30, INDRADHANU MARKET <br>IRC VILLAGE <br> BHUBANESWAR<br>Odisha.<br> Mobile no: 9337007255, Phone no: 06742360684<br>Fax no: 06742361907 : Trade License :-560/2017,<br>Email: mohasyn.bbsr@gmail.com<br>Company's GSTIN: <strong>21AAPCM1333E1ZX</strong> , PAN: <strong>AAUPM3341G</strong> </td>
	</tr>


	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=16 height="36" align="center" valign=top bgcolor="#CCCCCC"><b><font face="Cambria" size=5><?=$template->template_name?></font></b></td>
		</tr>
	<tr>

	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=4 height="19" align="left" valign=top><b><font face="">Proforma Invoice No:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000;padding-left:5px;" colspan=4 align="left" valign=top><font face=""><strong><?=$model->proforma_invoice_id?></strong></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=4 align="left" valign=top><b><font face="">Supplier's Ref:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=3 align="left" valign=top><font face=""><?=$model->suppliers_reference?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom><font color="#000000"><br></font></td>

	</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=4 height="19" align="left" valign=top><b><font face="">Proforma Invoice Date:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=date('F d Y', strtotime($model->date))?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=4 align="left" valign=top><b><font face="">Delivery Note:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=3 align="left" valign=top><font face=""><?=$model->delivery_note?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
  <tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=7 height="19" align="left" valign=top><b><font face="">Reverse Charge (Y/N):</font></b></td>
		<?php  if($model->supply_reverse_change=='Yes'){
				$is_reverse='Y';	
		}else{
			$is_reverse='N';
		}?>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000;border-left: 1px solid #000000" colspan=1 align="center" valign=top><font face=""><?=$is_reverse?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=4 align="left" valign=top><b><font face="">Other Reference:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=3 align="left" valign=top><font face=""><?=$model->other_reference?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
  
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="19" align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=1 align="left" valign=top sdval="27" sdnum="1033;0;0"><font face="" color="#000000"><?=$model->point_of_supply?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000;" colspan=4 align="left" valign=bottom><font color="#000000"><strong>Place of Supply:</strong> </font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=bottom><font color="#000000"></font><?=$customer->adderss_line_1?></td>
		</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="19" align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=6 align="left" valign=top bgcolor="#CCCCCC"><b><font face="">Bill to Party</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=3 align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top bgcolor="#CCCCCC"><b><font face="">Ship to Party</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="34" align="left" valign=top><b><font face="">Name:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=6 align="left" valign=top><font face=""><?=$customer->business_name?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 align="left" valign=top><b><font face="">Name:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$customer->business_name?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=middle><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="62" align="left" valign=top><b><font face="">Address:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=6 align="left" valign=top><font color="#000000"><?=$customer->adderss_line_1?>,<?=$customer->adderss_line_2?>,<?=$customer->city?>-<?=$customer->pin_code?> <br> <?=$customer->pin_code?>.<br> Mobile: <?=$customer->phone?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 align="left" valign=top><b><font face="">Address:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font color="#000000"><?=$customer->adderss_line_1?>,<?=$customer->adderss_line_2?>,<?=$customer->city?>-<?=$customer->pin_code?> <br> <?=$customer->pin_code?>.<br> Mobile: <?=$customer->phone?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="19" align="left" valign=top><b><font face="">GSTIN:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=6 align="left" valign=top><font face=""><?=$model->receiver_gstn?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 align="left" valign=top><b><font face="">GSTIN:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->receiver_gstn?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="19" align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top sdval="27" sdnum="1033;0;0"><font face="" color="#000000"><?=$model->point_of_supply?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top sdval="21" sdnum="1033;0;0"><font face="" color="#000000"><?=$model->point_of_supply?></font></td>
	</tr>

	<tr>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 height="39" align="left" valign=top><font face=""></font><strong>S.NO</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Product</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 align="left" valign=top ><font face=""></font><strong>HSN code</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>UOMs</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 align="left" valign=top ><font face=""></font><strong>Qty</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Amount</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Taxable Value</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="center" valign=top ><font face=""></font><strong>IGST</strong></td>
		<td style="width:60px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Total</strong></td>
		</tr>
    
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="center" valign=top ><font face=""></font><strong>%</strong></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan= align="center" valign=top ><font face=""></font><strong>Amt</strong></td>
		</tr>
    <?php
      $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;
      foreach($products as $key=>$value){ 
          # # FOR TOTAL # #
          $tot_quant+=$value->quantity;
          $tot_unitprice+=$value->unit_price;   
          $grandtot+=$value->amount;                         

         $amount=$value->quantity*$value->unit_price;
         if($value->discount_type=='FLAT'){
          $taxable_value=$amount-$value->discount;
          $tot_taxablevalue+=$taxable_value;
         }else if($value->discount_type=='%'){
          $taxable_value=$amount-($amount*$value->discount*0.01);
          $tot_taxablevalue+=$taxable_value;
         }else{
             $taxable_value=$amount;
             $tot_taxablevalue+=$taxable_value;
         }
          if($value->tax_included==1){
              $tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
              $tax_amount=$taxable_value*$tax_percent*0.01;
              $tot_taxamount+=$tax_amount;
          }else{
              $tax_percent=0;
              $tax_amount=0;
              $tot_taxamount+=$tax_amount;
          }
          ?>
	<tr>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" height="17" align="left" valign=top sdval="1" sdnum="1033;0;0"><font face="" color="#000000"><?=$key+1?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top><font face=""><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top sdval="6210" sdnum="1033;0;0"><font face="" color="#000000"><?=Product::find()->where(['id'=>$value->product_id])->one()->hsn_sac_code?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$value->units?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="lefts" valign=top sdval="400" sdnum="1033;0;0"><font face="" color="#000000"><?=$value->quantity?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="5" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$value->unit_price?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$taxable_value?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="5" sdnum="1033;0;0"><font face="" color="#000000"><?=(int)$tax_percent?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000"  align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tax_amount?></font></td>
		<td style="padding-top:9px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$value->amount?></font></td>
		</tr>
    <?php } ?>
	<tr>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" height="200" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000"  align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=6 height="31" align="left" valign=top><b><font face="" size=5>Total</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top sdval="400" sdnum="1033;0;0"><font face="" color="#000000"><?=$tot_quant?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="5" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tot_unitprice?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$tot_taxablevalue?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=middle><font color="#000000"><br></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000"  align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tot_taxamount?></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$grandtot?></font></td>
		</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=11 rowspan=4 height="70" align="left" valign=top><font color="#000000"> <strong>Total amount in words:</strong>  <hr style="color:black"><br><?=AmountInWords($model->total_price)?> (INR) Only</font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="right" valign=top><b><font face="">Total Amount before Tax</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$tot_taxablevalue?></font></b></td>
		</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="right" valign=top><b><font face="">OUTPUT IGST :</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><b><font face="" color="#000000"><?=$tot_taxamount?></font></b></td>
		</tr>
    <tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="right" valign=top><b><font face="">TCS:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$model->tcs_amount?></font></b></td>
		</tr>
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="right" valign=top><b><font face="">Total Amount after Tax:</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$model->total_price?></font></b></td>
		</tr>
    
	<tr>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=6 rowspan=3 height="137" align="center" valign=top><b><font face="">Terms &amp; Conditions</font></b></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4  align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000;font-size:7px;" colspan=6 rowspan=2 align="center" valign=top><b><font face=""> *Computer Generated Proforma Invoice no Sign Required</font></b></td>
		</tr>
	<!-- <tr>
		<td style="border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=6 rowspan=2 align="center" valign=top><font color="#000000">For MOHAPATRA SCIENTIFIC SUPPLY<br>SYNDICATE<br>Authorised signatory</font></td>
		</tr> -->
	<tr>
		<td style="font-size:15px; border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="center" valign=top><b><font face="">Common Seal</font></b></td>
		</tr>
</table>
<!-- ************************************************************************** -->
</body>
<?php }?>
<?php if($model->point_of_supply==21){?>

	<table cellspacing="0" border="0" >
	<colgroup width="35"></colgroup>
	<colgroup width="93"></colgroup>
	<colgroup width="158"></colgroup>
	<colgroup width="16"></colgroup>
	<colgroup width="18"></colgroup>
	<colgroup width="28"></colgroup>
	<colgroup width="38"></colgroup>
	<colgroup width="24"></colgroup>
	<colgroup width="58"></colgroup>
	<colgroup width="10"></colgroup>
	<colgroup width="52"></colgroup>
	<colgroup width="53"></colgroup>
	<colgroup width="34"></colgroup>
	<colgroup width="43"></colgroup>
	<colgroup width="33"></colgroup>
	<colgroup width="44"></colgroup>
	<colgroup width="21"></colgroup>
	<colgroup width="41"></colgroup>

	<tr>
		<td  style="border-top:1px solid black;border-left:1px solid black;border-bottom:1px solid black;"><img width="86" height="100" src="./theme/images/1569578921_Mohapatra_Logo.jpg"></td>
	    <td  style=" font-size:23px;padding-left:200px;border-top: 1px solid #000000; border-bottom: 1px solid #000000;  border-right: 1px solid #000000" colspan=18 height="94" align="left" valign=top><strong>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</strong><br>F2G/30, INDRADHANU MARKET <br>IRC VILLAGE <br> BHUBANESWAR<br>Odisha.<br> Mobile no: 9337007255, Phone no: 06742360684<br>Fax no: 06742361907 : Trade License :-560/2017,<br>Email: mohasyn.bbsr@gmail.com<br>Company's GSTIN: <strong>21AAPCM1333E1ZX</strong> , PAN: <strong>AAUPM3341G</strong></td>
	</tr>


	<tr>
		<td  style=" font-size:25px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=19 height="36" align="center" valign=top bgcolor="#CCCCCC"><b><font face="Cambria" size=10><?=$model->setting_id?></font></b></td>
		</tr>
	<tr>

	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="19" align="left" valign=top><b><font face="">Proforma Invoice No:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><strong><?=$model->proforma_invoice_id?></strong></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">Supplier's Ref:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->suppliers_reference?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left"  valign=bottom><font color="#000000"><br></font></td>

	</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="19" align="left" valign=top><b><font face="">Proforma Invoice Date:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=date('F d Y', strtotime($model->date))?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">Delivery Note:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->delivery_note?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000"   align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
  <tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=7 height="19" align="left" valign=top><b><font face="">Reverse Charge (Y/N):</font></b></td>
		<?php  if($model->supply_reverse_change=='Yes'){
				$is_reverse='Y';	
		}else{
			$is_reverse='N';
		}?>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000;border-left:1px solid balck;" colspan=2 align="center" valign=top><font face=""><?=$is_reverse?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">Other Reference:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->other_reference?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000"   align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
  
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 height="19" align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top sdval="27" sdnum="1033;0;0"><font face="" color="#000000"><?=$model->point_of_supply?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="19" align="left" valign=top><b><font face="">Place of Supply:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=5 align="left" valign=top><font face=""></font><?=$customer->adderss_line_1?></td>
		<!-- <td style="border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=8 align="left" valign=bottom><font color="#000000"><br></font></td> -->
		</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 height="19" align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=5 align="left" valign=top bgcolor="#CCCCCC"><b><font face="">Bill to Party</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=5 align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=6 align="left" valign=top bgcolor="#CCCCCC"><b><font face="">Ship to Party</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=bottom bgcolor="#CCCCCC"><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="34" align="left" valign=top><b><font face="">Name:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$customer->business_name?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">Name:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$customer->business_name?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=middle><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="62" align="left" valign=top><b><font face="">Address:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font color="#000000"><?=$customer->adderss_line_1?>,<?=$customer->adderss_line_2?>,<?=$customer->city?>-<?=$customer->pin_code?> <br> <?=$customer->pin_code?>.<br> Mobile: <?=$customer->phone?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">Address:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font color="#000000"><?=$customer->adderss_line_1?>,<?=$customer->adderss_line_2?>,<?=$customer->city?>-<?=$customer->pin_code?> <br> <?=$customer->pin_code?>.<br> Mobile: <?=$customer->phone?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" align="left"  valign=top><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 height="19" align="left" valign=top><b><font face="">GSTIN:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->receiver_gstn?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=5 align="left" valign=top><b><font face="">GSTIN:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$model->receiver_gstn?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000"  align="left" valign=bottom><font color="#000000"><br></font></td>
	</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=3 height="19" align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top sdval="27" sdnum="1033;0;0"><font face="" color="#000000"><?=$model->point_of_supply?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">State:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="left" valign=top><font face=""><?=$customer->state?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><b><font face="">Code:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2  align="left" valign=top sdval="21" sdnum="1033;0;0"><font face=""  color="#000000"><?=$model->point_of_supply?></font></td>
	</tr>

	<tr>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 height="39" align="left" valign=top ><font face=""> <strong>S.NO</strong></font></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""> <strong>Product</strong></font></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 align="left" valign=top ><font face=""></font><strong>HSN code</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>UOM</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" rowspan=2 align="left" valign=top ><font face=""></font><strong>Qty</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Amount</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Taxable Value</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="center" valign=top ><font face=""></font><strong>SGST</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=3 align="center" valign=top ><font face=""></font><strong>CGST</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 rowspan=2 align="left" valign=top ><font face=""></font><strong>Total</strong> </td>
		</tr>
    
	<tr>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top ><font face=""> <strong>%</strong></font></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top ><font face=""> <strong>Amt</strong></font></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top ><font face=""></font><strong>%</strong></td>
		<td style="width:content-fixed;font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top ><font face=""></font><strong>Amt</strong></td>
		</tr>
    <?php
      $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;
      foreach($products as $key=>$value){ 
          # # FOR TOTAL # #
          $tot_quant+=$value->quantity;
          $tot_unitprice+=$value->unit_price;   
          $grandtot+=$value->amount;                         

         $amount=$value->quantity*$value->unit_price;
         if($value->discount_type=='FLAT'){
          $taxable_value=$amount-$value->discount;
          $tot_taxablevalue+=$taxable_value;
         }else if($value->discount_type=='%'){
          $taxable_value=$amount-($amount*$value->discount*0.01);
          $tot_taxablevalue+=$taxable_value;
         }else{
             $taxable_value=$amount;
             $tot_taxablevalue+=$taxable_value;
         }
          if($value->tax_included==1){
              $tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
              $tax_amount=$taxable_value*$tax_percent*0.01;
              $tot_taxamount+=$tax_amount;
          }else{
              $tax_percent=0;
              $tax_amount=0;
              $tot_taxamount+=$tax_amount;
          }
          ?>
	<tr>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" height="17" align="left" valign=top sdval="1" sdnum="1033;0;0"><font face="" color="#000000"><?=$key+1?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top><font face=""><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top sdval="6210" sdnum="1033;0;0"><font face="" color="#000000"><?=Product::find()->where(['id'=>$value->product_id])->one()->hsn_sac_code?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font face=""><?=$value->units?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="right" valign=top sdval="400" sdnum="1033;0;0"><font face="" color="#000000"><?=$value->quantity?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="5" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$value->unit_price?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?= $taxable_value?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="right" valign=top sdval="5" sdnum="1033;0;0"><font face="" color="#000000"><?= (int)$tax_percent/2?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tax_amount/2?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" align="right" valign=top sdval="5" sdnum="1033;0;0"><font face="" color="#000000"><?=(int)$tax_percent/2?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tax_amount/2?></font></td>
		<td style="padding-top:9px;font-size:23px; border-left: 1px solid #000000;" colspan= align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$value->amount?></font></td>
		<td style="border-right:1px solid black"></td>
		</tr>
    <?php } ?>
	<tr>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" height="355" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		<td style="border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="left" valign=top><font color="#000000"><br></font></td>
		</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=6 height="31" align="left" valign=top><b><font face="">Total</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="right" valign=top sdval="400" sdnum="1033;0;0"><font face="" color="#000000"><?=$tot_quant?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="5" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tot_unitprice?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$tot_taxablevalue?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="right" valign=middle><font color="#000000"><br></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tot_taxamount/2?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" align="lerightft" valign=middle><font color="#000000"><br></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><font face="" color="#000000"><?=$tot_taxamount/2?></font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><font face="" color="#000000"><?=$grandtot?></font></td>
		</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=13 rowspan=5 height="70" align="left" valign=top><font color="#000000"><strong>Total amount in words:</strong><hr style="color:black"> <br><?=AmountInWords($model->total_price)?> (INR) Only</font></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="right" valign=top><b><font face="">Total Amount before Tax</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2000" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$tot_taxablevalue?></font></b></td>
		</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="right" valign=top><b><font face="">OUTPUT CGST :</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><b><font face="" color="#000000"><?=$tot_taxamount/2?></font></b></td>
		</tr>
		<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="right" valign=top><b><font face="">OUTPUT SGST :</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="100" sdnum="1033;0;0.00"><b><font face="" color="#000000"><?=$tot_taxamount/2?></font></b></td>
		</tr>	
    <tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="right" valign=top><b><font face="">TCS:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$model->tcs_amount?></font></b></td>
		</tr>
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=4 align="right" valign=top><b><font face="">Total Amount after Tax:</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=2 align="right" valign=top sdval="2100" sdnum="1033;0;#,##0.00"><b><font face="" color="#000000"><?=$model->total_price?></font></b></td>
		</tr>
    
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=6 rowspan=3 height="137" align="center" valign=top><b><font face="">Terms &amp; Conditions</font></b></td>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=5  align="left" valign=top><font color="#000000"><br></font></td>
		<td style="font-size:15px;border-top: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000;border-bottom:1px solid black" rowspan=2 colspan=8 align="center" valign=top><b><font face="" size=1></font>* Computer Generated Proforma Invoice no Sign Required</b></td>
		</tr>
	<!-- <tr>
		<td style="border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=8 rowspan=2 align="center" valign=top><font color="#000000"></font></td>
		</tr> -->
	<tr>
		<td style="font-size:23px;border-top: 1px solid #000000; border-bottom: 1px solid #000000; border-left: 1px solid #000000; border-right: 1px solid #000000" colspan=5 align="center" valign=top><b><font face="">Common Seal</font></b></td>
		</tr>
</table>	
<!-- ************************************************************************** -->
</body>
<?php }?>
</html>
