<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Debit Note';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Purchase Bill</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'label'=>'Bill #',
               'attribute' => 'bill_no',
               'value' => function ($data) {
                return $data->bill_no;
               }
            ],
            [
                'label'=>'Vendor / Category',
               'attribute' => 'vendor_id',
               'value' => function ($data) {
                $val=Vendor::find()->where(['id'=>$data->vendor_id])->one();
                return $val->business_name;
               }
            ],
            'date:date',
            [
                'label'=>'Amount',
               'attribute' => 'total',
               'value' => function ($data) {
                return $data->total;
               }
            ],
            'setting_type',
            'vendor_bill_no',
            'bill_date:date',
            'sender_gst_id',
            'notes',
            'bill_type',
            'supply_type',
            'supply_attracts',
            'is_ineligible_itc',
            'point_of_supply',
            'pricelist',
            'prefix',
            'suffix',
            'due_date:date',
            'bill_notes',
            'terms_of_payment',
            'product_code',
            'subtotal',
            'total',
            [
                'label'=>'Payment',
               'attribute' => 'payment',
               'value' => function ($data) {
                switch($data->payment){
                    case '1':  return "Add Payment";
                    case '2':  return "Match Payment";
                    case '3':  return "Match Debit Note";
                    case '3':  return "Match Debit Note";
        }
                return $data->payment?'YES':'NO';
               }
            ],
            [
                'label'=>'Set Reminder',
               'attribute' => 'set_reminder',
               'value' => function ($data) {
                return $data->set_reminder?'YES':'NO';
               }
            ],
            [
                'label'=>'Show to store keeper',
               'attribute' => 'show_to_store_keeper',
               'value' => function ($data) {
                return $data->show_to_store_keeper?'YES':'NO';
               }
            ],
            'order_type',
            'terms',
            'created_at:date',
            'updated_at:date',
           
           
        ],
    ]); ?>


</div>
</div>
</div>


