<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
/* @var $this yii\web\View */
use yii\widgets\ActiveForm;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\master\models\AccountingTax;
use backend\modules\users\models\PurchasePayment;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\BillsAdjustedAmounts;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\SettingTypes;
use backend\modules\master\models\GenericTemplate;

//$purchasetemplate = PurchaseTemplates::find()->where(['template_name' => $model->setting_type])->one();
$template = GenericTemplate::find()->where(['gt_id' => $model->setting_type])->one();

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();


\yii\web\YiiAsset::register($this);
$vendor = Vendor::find()->where(['id'=>$model->vendor_id])->one();

$findadjusted=BillsAdjustedAmounts::find()->where(['bill_id'=>$model->id])->Count();
$income=AccountingLedger::find()->where(['account_type_id'=>3])->all();

$liability=AccountingLedger::find()->where(['account_type_id'=>5])->all();
$asset = AccountingLedger::find()->where(['account_type_id'=>1])->all();
$expense = AccountingLedger::find()->where(['account_type_id'=>4])->all();
$bank_account = AccountingLedger::find()->where(['account_type_id'=>2])->all();
$other = AccountingLedger::find()->where(['account_type_id'=>NULL])->all();

$incomes='';
foreach($income as $value){
    $incomes.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}
$liabilitys='';
foreach($liability as $value){
    $liabilitys.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}
$assets='';
foreach($asset as $value){
    $assets.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$expenses='';
foreach($expense as $value){
    $expenses.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$bank_accounts='';
foreach($bank_account as $value){
    $bank_accounts.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$others='';
foreach($other as $value){
    $others.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}



function AmountInWords(float $amount)
{
   $amount_after_decimal = round($amount - ($num = floor($amount)), 2) * 100;
   // Check if there is any number after decimal
   $amt_hundred = null;
   $count_length = strlen($num);
   $x = 0;
   $string = array();
   $change_words = array(0 => '', 1 => 'One', 2 => 'Two',
     3 => 'Three', 4 => 'Four', 5 => 'Five', 6 => 'Six',
     7 => 'Seven', 8 => 'Eight', 9 => 'Nine',
     10 => 'Ten', 11 => 'Eleven', 12 => 'Twelve',
     13 => 'Thirteen', 14 => 'Fourteen', 15 => 'Fifteen',
     16 => 'Sixteen', 17 => 'Seventeen', 18 => 'Eighteen',
     19 => 'Nineteen', 20 => 'Twenty', 30 => 'Thirty',
     40 => 'Forty', 50 => 'Fifty', 60 => 'Sixty',
     70 => 'Seventy', 80 => 'Eighty', 90 => 'Ninety');
    $here_digits = array('', 'Hundred','Thousand','Lakh', 'Crore');
    while( $x < $count_length ) {
      $get_divider = ($x == 2) ? 10 : 100;
      $amount = floor($num % $get_divider);
      $num = floor($num / $get_divider);
      $x += $get_divider == 10 ? 1 : 2;
      if ($amount) {
       $add_plural = (($counter = count($string)) && $amount > 9) ? 's' : null;
       $amt_hundred = ($counter == 1 && $string[0]) ? ' and ' : null;
       $string [] = ($amount < 21) ? $change_words[$amount].' '. $here_digits[$counter]. $add_plural.' 
       '.$amt_hundred:$change_words[floor($amount / 10) * 10].' '.$change_words[$amount % 10]. ' 
       '.$here_digits[$counter].$add_plural.' '.$amt_hundred;
        }
   else $string[] = null;
   }
   $implode_to_Rupees = implode('', array_reverse($string));
   $get_paise = ($amount_after_decimal > 0) ? "And " . ($change_words[$amount_after_decimal / 10] . " 
   " . $change_words[$amount_after_decimal % 10]) . ' Paise' : '';
   return ($implode_to_Rupees ? $implode_to_Rupees . 'Rupees ' : '') . $get_paise;
}

?>
<style>
    td { 
        font-size:12px;
    }
table.main {
                color: #000;
                font-family: arial;
                font-size: 13px;
                border:solid 1px #666666;
            }
            table.all {
                color: #000;
                font-family: arial;
                font-size: 13px;
            }
            td.main {
                border-right: solid 1px #000;
                border-bottom: solid 1px #000;
            }
            td.right {
                border-right: solid 1px #000;
            }
            td.left {
                border-left: solid 1px #000;
                
            }
            td.bottom {
                border-right: solid 1px #000;
                border-bottom: solid 1px #000;
            }
            td.last {
                border-bottom: solid 1px #000;
                border-left: solid 1px #000;
                border-right: solid 1px #000;
                border-top: solid 1px #000;
            }
            td.dotlast {
                border-bottom: dotted 1px #000;
            }
            td.top {
                border-top: solid 1px #000;
            }
            p{
                padding:5px;
            }
            .bg1 {
                background-color:#ccc;
            }
            .text01{
                color: #000;
                font-family: arial;
                font-size: 13px;
                font-weight:bold;
            }
            .text02{
                color: #000;
                font-family: arial;
                font-size: 14px;
                font-weight:bold;
            }
            .text03{
                color: #000;
                font-family: arial;
                font-size: 15px;
                font-weight:bold;
            }
            td.tdpaddingline{ font-weight:normal; text-align:left; padding:5px; border:1px solid #000; }
            td.tdpaddingliner{ font-weight:normal; text-align:left; padding:5px; border-right:1px solid #000; }
            td.tdpaddinglinel{ font-weight:normal; text-align:left; padding:5px; border-left:1px solid #000; }
                    td.tdpaddinglinel{ font-weight:normal; text-align:left; padding:5px; border-left:1px solid #000; }
                    
            thead.theadnopad td.tdpaddingliner, thead.theadnopad p {padding:2px; margin:0px;}

            .invCancelledPrint {
    width:670px;
    display: block;
    height: 96%;
    position: absolute;
    text-align: center;
    vertical-align: middle;
}
@media print {
        .app-header.header-shadow {
    visibility: hidden;
}
.logo-src {
    visibility: hidden;
}
li.bg-transparent.list-group-item {
    visibility: hidden;
}
.app-main .app-main__inner {
    padding: 0 30px 0;
 }
.card.no-shadow.bg-transparent.no-border.rm-borders.mb-3 {
    visibility: hidden;
    margin-bottom: 0px !important;
    border: unset;
}
		.dj-print-sec{
			display:none!important ;
		}
		.widget-content-wrapper{
			display:none!important ;	
		}
		/*.table-responsive{
			overflow:hidden;
		}*/
		.app-header__menu{
			display:none!important ;
		}
        .toolbar{
            display:none!important ;

        }
        .tab-content{
            display:none!important ;
        }
        .nav {
            display:none!important ;
        }
	}
</style>
<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Purchase Bill</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/users/purchase-bill/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
<div class="main-card mb-3 card">

  <div class="toolbar col-lg-12" style="margin-top: 10px; margin-bottom: -10px">

    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/update'])->one()!=''){?>
  <a class="btn btn-primary download" href="<?=Url::base();?>/users/purchase-bill/update?id=<?= $model->id ?>"><i class="fa fa-pencil"></i> Update</a>
   <?php }else {?>

   <?php } ?>

   <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/purchasebill-template'])->one()!=''){?>

   <a href="javascript:void(0);" onclick="window.open('<?=Url::base();?>/users/purchase-bill/printall?id=<?= $model->id ?>&form=print','name','width=700,height=700')"  title="Print" data-method="post" class="btn btn-primary add newWindow">  <i class="fa fa-print"></i> Print</a>  
   <?php }else {?>

   <?php } ?>
      
                   
      <!-- <a class="btn btn-primary sendAttachmentMail" title="Print" href="#"><i class="fa fa-envelope-o"></i> Mail</a>                                                             -->
  </div>
                           <div class="card-body">




<div class="col-lg-12" style="margin:0;padding: 0; width:100%; border:1px solid #000;">

        

    <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
        <td align="center" width="100%">
                        <table width="100%" border="0" cellspacing="0" cellpadding="0" align="center" style="color:#000000;">
                        <tr>
                <td colspan="2">
   <table width="100%" border="0" cellspacing="0" cellpadding="0" align="center" style="color:#000000;">
            <tr>
                <td valign="top" width="60%" class="left" style="padding:5px;">
                    <table width="100%" border="0" cellspacing="0" cellpadding="2" class="all">
                        <tr>
                          <td   width="30%"><p><b><img width="56" height="85" src="../../theme/images/1569578921_Mohapatra_Logo.JPG" alt=""/></b></p></td>
                          <td  align="left" width="50%"><p><b style="font-size:14px; font-weight:bold"><?= $template->company_name ?></b><br /> <?= $template->address ?>,<br /> <?= $template->city ?>,<?= $template->state ?> , Code: <?= $template->pin ?>,<br /> <?= $template->country ?> - <br /> Mobile no: <?= $template->mobile ?>, Phone no: <?= $template->phone_no ?>,<br /> GSTIN : <?= $template->gst_no ?>,<br /> Fax no: <?= $template->fax_no ?> : Trade License :-<?= $template->trade_licence ?>,<br /> Email: <?= $template->email ?></td>
                          <td  width="20%"><p><b></b></p></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
            <td   class="left" valign=""   style="padding:5px;">
                <table width="100%" border="0" cellspacing="0" cellpadding="" class="all">

                                    <tr>
                        <td class="top bottom left " colspan="8" align="center" width="100%" style="background-color: #CCC;font-size: 25px;"><p><b><?=$template->template_name?></b></p></td>
                    </tr>
                                        <tr>
                        <td class="top left " width="25%"><p><b>Tax Bill No: </b></p></td>
                        <td class="tdpaddingliner top" colspan="3" width="25%"><p><b> <?= $model->full_bill_name ?> </b></p></td>
                        <td class="top" width="25%"><p><b>Reverse Charge (Y/N): </b></p></td>
                        <td class=" top  " colspan="2" width="20%"><p><b></b></p></td>
                        <td class=" top tdpaddingliner  " width="5%" style="text-align: center;"><p><b><?php if($model->supply_attracts==1)
                        {
                            echo 'N';
                        }
                        else if ($model->supply_attracts==0) {
                            echo 'Y';
                        }
                        else{
                            echo '';
                        } ?></b></p></td>
                        <!--<td class="top" width="25%"><p><b>Transport Mode: </b></p></td>
                        <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b></p></td>-->
                    </tr>
                    <tr>
                         <td class="top left" width="25%"><p><b>Tax Bill Date: </b></p></td>
                         <td class=" top " colspan="3" width="25%"><p><b></b><?= date(("\ F j  Y"), strtotime($model->date)) ?></p></td>
                        <td class="top tdpaddingliner" width="25%"><p><b>State: </b></p></td>
                        <td class=" top tdpaddingliner" width="15%"><p><b></b>Odisha</p></td>
                        <td class=" top tdpaddingliner " width="5%"><p><b>Code: </b></p></td>
                        <td class=" top tdpaddingliner " width="5%"><p><b></b>21</p></td>
                         <!--<td class="top" width="25%"><p><b>Vehicle Number: </b></p></td>
                         <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b></p></td>-->
                    </tr>
                    <!--<tr>
                        <td class="top" width="25%"><p><b>Date of Supply:</b></p></td>
                        <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b></p></td>
                    </tr>
                    <tr>
                        <td class="top" width="25%"><p><b>Place of Supply:</b></p></td>
                        <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b></p></td>
                    </tr>-->
                                        <tr>
                        <td class="top tdpaddingliner left" colspan="4" align="center" width="50%" style="background-color: #CCC;"><p><b>Bill from Party</b></p></td>
                        <td class="top tdpaddingliner" colspan="4" align="center" width="50%" style="background-color: #CCC;"><p><b>Ship to Party</b></p></td>
                    </tr>
                    <tr>
                        <td class="top left" width="25%"><p><b>Name: </b></p></td>
                        <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b> <?= $vendor->business_name ?></p></td>
                        <td class="top" width="25%"><p><b>Name: </b></p></td>
                        <td class=" top tdpaddingliner" colspan="3" width="25%"><p><b></b>MOHAPATRA SCIENTIFIC PRIVATE LIMITED</p></td>
                    </tr>
                    <tr>
                         <td class="top left" width="25%" style="min-height: 30px; vertical-align: top;"><p><b>Address: </b></p></td>
                         <td class="tdpaddingliner top" colspan="3" width="25%" style="vertical-align: top;"><p><b></b><?= $vendor->adderss_line_1.','.$vendor->adderss_line_2.','.$vendor->adderss_line_3.','.$vendor->city.','.$vendor->state.','.$vendor->country.'-'.$vendor->pin_code?></p></td>
                         <td class="top" width="25%" style="vertical-align: top;"><p><b>Address: </b></p></td>
                         <td class="tdpaddingliner top" colspan="3" width="25%" style="vertical-align: top;"><p>F2G/30, INDRADHANU MARKET,IRC VILLAGE,&nbsp;BHUBANESWAR<br>Odisha.<br /></p></td>
                         <!-- </br></br></br> -->
                    </tr>
                    <tr>
                         <td class="top left" width="25%"><p><b>GSTIN:</b> </p></td>
                         <td class="tdpaddingliner top" colspan="3" width="25%"><p><b></b><?= $model->sender_gst_id ?></p></td>
                         <td class="top" width="25%"><p><b>GSTIN: </b></p></td>
                         <td class=" top tdpaddingliner" colspan="3" width="25%"><p><b></b>21AAPCM1333E1ZX</p></td>
                    </tr>
                    <tr>
                        <td class="top left" width="25%"><p><b>State: </b></p></td>
                        <td class=" top tdpaddingliner" width="15%"><p><b></b><?= $vendor->state ?></p></td>
                        <td class=" top tdpaddingliner" width="5%"><p><b>Code: </b></p></td>
                        <td class="tdpaddingliner top" width="5%"><p><b></b><?= $model->point_of_supply ?></p></td>
                        <td class="top" width="25%"><p><b>State: </b></p></td>
                        <td class="tdpaddingliner top" width="15%"><p><b></b></p>Odisha</td>
                        <td class="tdpaddingliner top" width="5%"><p><b>Code: </b></p></td>
                        <td class=" top right" width="5%"><p><b></b>21</p></td>
                    </tr>
                    <tr style="border-bottom: 1px solid #000">
                         <td class="top left" width="25%"><p><b>Bill No:</b> </p></td>
                         <td class="tdpaddingliner top" colspan="3" width="25%"><p><?= $model->vendor_bill_no ?></p></td>
                         <td class="top" width="25%"><p><b>Bill Dated:</b></p></td>
                         <td class=" top tdpaddingliner" colspan="3" width="25%"><p><?php if($model->bill_date!='')
                                  {
                                      echo date(("\ F j Y"), strtotime($model->bill_date));
                                  }
                                  else{
                                      echo '';
                                  } ?></p></td>
                    </tr>
                </table>
            </td>
            </tr>
        
                    <tr>
                        <td> <!-- style="padding-top:10px;" -->



        <?php if($model->point_of_supply!=21)
        { ?>

                <table border="0" cellpadding="0" cellspacing="0" width="100%" style="color:#000000; font-family:Arial, Helvetica, sans-serif; font-size:12px;">
                        <tr style="">
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>S.No</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="18%" style=" font-weight:bold;"><p>Product Description</p></td>          
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>HSN Code</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>Qty</p></td>
                                <td rowspan="2" class="tdpaddingliner top bottom" align="center" width="%" style=" font-weight:bold;"><p>UOM</p></td>
                            <td rowspan="2"  class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>Rate</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="0%" style=" font-weight:bold; text-align: center;"><p>Amount</p></td>
                           
                            <td rowspan="2" class="tdpaddingliner top bottom" align="center" width="0%" style=" font-weight:bold; text-align: center;"><p>Taxable value</p></td>
                            <td colspan="4" class="tdpaddingliner top bottom" align="center" width="0%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>IGST</p></td>
                            <td rowspan="2" class="top bottom" align="center" width="0%" style=" font-weight:bold; text-align: center;"><p>Total</p></td>
                        </tr>
                        <tr>
                            <td class="tdpaddingliner bottom" colspan="2"style="text-align:center; width: 8%" align="center">Rate</td>
                            <td class="tdpaddingliner bottom" colspan="2" style="text-align:center;" align="center" >Amt</td>
                        </tr>

                        <?php  
                            $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;$total_amt =0;
                            foreach($products as $key=>$value){ 
                                # # FOR TOTAL # #
                                $product_name = Product::find()->where(['id'=>$value->product_id])->one();
                                $tot_quant+=$value->qty;
                                $tot_unitprice+=$value->price;   
                                $grandtot+=$value->amount;                         

                               $amount=$value->qty*$value->price;
                               $total_amt = $total_amt + $amount;
                               if($value->discount_type=='FLAT'){
                                $taxable_value=$amount-$value->discount;
                                $tot_taxablevalue+=$taxable_value;
                               }else if($value->discount_type=='%'){
                                $taxable_value=$amount-($amount*$value->discount*0.01);
                                $tot_taxablevalue+=$taxable_value;
                               }else{
                                   $taxable_value=$amount;
                                   $tot_taxablevalue+=$taxable_value;
                               }
                                if($value->incl_tax==1){
                                    if($value->tax!='') 
                                    $tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
                                    else
                                    $tax_percent = 0;
                                    $tax_amount=$taxable_value*$tax_percent*0.01;
                                    $tot_taxamount+=$tax_amount;
                                }else{
                                    $tax_percent=0;
                                    $tax_amount=0;
                                    $tot_taxamount+=$tax_amount;
                                }
                                ?>
                      <tr>
                        <td class="tdpaddingliner" valign="top"><?= $key+1 ?></td>      
                        <td class="tdpaddingliner" style="text-align:left" valign="top"><p><?= $product_name->product_name ?></p></td>
                        <!-- <td class="tdpaddingliner" style="text-align:center" valign="top"><?=$value->description?></td> -->
                        <td class="tdpaddingliner" style="text-align:center" valign="top"><?= $product_name->hsn_sac_code ?></td>
                        <td class="tdpaddingliner" style="text-align:center" valign="top"><?= $value->qty ?></td>
                        <td class="tdpaddingliner" style="text-align:center;" valign="top"><?= $value->unit ?></td> 
                        <td class="tdpaddingliner" style="text-align:right" valign="top"><?= $value->price?></td>       
                        <td class="tdpaddingliner" style="text-align:right;" valign="top"><?= $amount?></td>
                        
                        <td class="tdpaddingliner" style="text-align:right;" valign="top"><?= $taxable_value ?></td>
                        <td class="tdpaddingliner" colspan="2" style="text-align:right;" valign="top"><?= $tax_percent ?></td> 
                        <td class="tdpaddingliner" colspan="2"  style="text-align:right;" valign="top"><?= $tax_amount ?></td>
                        <td class="" style="text-align:right;padding-right:5px;padding-top:5px;" valign="top"><?= $value->amount ?></td>   
                      </tr>

                       <?php } ?> 
                    <tr>
                        <td class="tdpaddingliner top bottom" colspan="3"><b> Total</b></td>
                        <td class="tdpaddingliner top bottom" ><?= $tot_quant ?></td>
                        <td class="tdpaddingliner top bottom"> </td>
                        <td class="tdpaddingliner top bottom"><?= $tot_unitprice ?></td>
                        <td class="tdpaddingliner top bottom" style="text-align:right;"><?= $total_amt ?> </td>
                        
                        <td class="tdpaddingliner top bottom" style="text-align:right;" valign="top"><?= $tot_taxablevalue ?></td>
                        <td colspan="2" class="tdpaddingliner top bottom"> </td>
                        <td colspan="2" class="tdpaddingliner top bottom" style="text-align:right;"><?= $tot_taxamount ?></td>
                        <td class=" top bottom" style="text-align:right;padding-right:5px;padding-top:5px;"><?= $grandtot ?></td><!-- $totgstsubtotal+$totcgst+$totsgst+$totigst -->
                    </tr>
                    <tr>
                        <td class="tdpaddingliner" colspan="8" style="text-align: center;"><b>Total Invoice amount in words</b></td>
                        <td class="tdpaddingliner bottom" colspan="4" style="text-align: right;"><b>Total Amount before Tax</b></td>
                        <td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?= $tot_taxablevalue ?></b></td> <!-- totgstsubtotal -->
                    </tr>

                        <tr>
                        <td class="tdpaddingliner top" colspan="8" rowspan="7" style="text-align: left; vertical-align: top;"><b></b><?= AmountInWords($model->total).' '.' (INR) Only'?> 
                        </td>
                    </tr>
                    <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>INPUT IGST</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?= $tot_taxamount ?></b></td></tr>      
                    <tr>
                        <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>TCS</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?php if($model->is_tcs==1)
                    {
                        echo $model->tcs;
                    }
                    else{
                        echo "0";
                    } ?></b></td></tr>      
                    <tr>
                        <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>ROUND OFF</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?php if($model->round_off=='')
                    {
                        echo '0';
                    }
                    else{
                        echo $model->round_off;
                    } ?></b></td></tr>      
                    <tr>
                        <td class="tdpaddingliner bottom" colspan="4" style="text-align: right; padding-right:5px;padding-top:5px;"><b>Total Amount After Tax</b></td>
                        <!--<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b></b></td> -->
                        <td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$model->total) ?></b></td>
                    </tr>
                </table>





       <?php } else{?>



                        <table border="0" cellpadding="0" cellspacing="0" width="100%" style="color:#000000; font-family:Arial, Helvetica, sans-serif; font-size:12px;">
                        <tr style="">
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>S.No</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="18%" style=" font-weight:bold;"><p>Product Description</p></td>          
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>HSN Code</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>Qty</p></td>
                                <td rowspan="2" class="tdpaddingliner top bottom" align="center" width="%" style=" font-weight:bold;"><p>UOM</p></td>
                            <td rowspan="2"  class="tdpaddingliner top bottom" width="%" style=" font-weight:bold; text-align: center;"><p>Rate</p></td>
                            <td rowspan="2" class="tdpaddingliner top bottom" width="0%" style=" font-weight:bold; text-align: center;"><p>Amount</p></td>
                            
                            <td rowspan="2" class="tdpaddingliner top bottom" align="center" width="0%" style=" font-weight:bold; text-align: center;"><p>Taxable value</p></td>
                            <td colspan="3" class="tdpaddingliner top bottom" align="center" width="0%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>SGST</p></td>
                            <td colspan="3" class="tdpaddingliner top bottom" align="center" width="0%" style="padding-top:5px; text-align:center; font-weight:bold;"><p>CGST</p></td>
                            <td rowspan="2" class="top bottom" align="center" width="0%" style=" font-weight:bold; text-align: center;"><p>Total</p></td>
                        </tr>
                        <tr>
                            <td class="tdpaddingliner bottom" colspan="1" style="text-align:center;" align="center">Rate</td>
                            <td class="tdpaddingliner bottom" colspan="2" style="text-align:center;" align="center" >Amt</td>
                            <td class="tdpaddingliner bottom" colspan="1" style="text-align:center;" align="center">Rate</td>
                            <td class="tdpaddingliner bottom" colspan="2" style="text-align:center;" align="center" >Amt</td>
                        </tr>

                        <?php  
                            $tot_quant=0;$tot_unitprice=0;$tot_taxablevalue=0;$tot_taxamount=0;$grandtot=0;$total_amt =0;
                            foreach($products as $key=>$value){ 
                                # # FOR TOTAL # #
                                $product_name = Product::find()->where(['id'=>$value->product_id])->one();
                                $tot_quant+=$value->qty;
                                $tot_unitprice+=$value->price;   
                                $grandtot+=$value->amount;                         

                               $amount=$value->qty*$value->price;
                               $total_amt = $total_amt + $amount;
                               if($value->discount_type=='FLAT'){
                                $taxable_value=$amount-$value->discount;
                                $tot_taxablevalue+=$taxable_value;
                               }else if($value->discount_type=='%'){
                                $taxable_value=$amount-($amount*$value->discount*0.01);
                                $tot_taxablevalue+=$taxable_value;
                               }else{
                                   $taxable_value=$amount;
                                   $tot_taxablevalue+=$taxable_value;
                               }
                                if($value->incl_tax==1){
                                //   print_r($value->tax);
                                //     die();
                                    if($value->tax!='') 
                                    $tax_percent=AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $value->tax])->one()->tax_rate;
                                    else
                                    $tax_percent = 0;
                                    $tax_amount=$taxable_value*$tax_percent*0.01;
                                    $tot_taxamount+=$tax_amount;
                                }else{
                                    $tax_percent=0;
                                    $tax_amount=0;
                                    $tot_taxamount+=$tax_amount;
                                }
                                ?>
                      <tr>
                        <td class="tdpaddingliner" valign="top"><?= $key+1 ?></td>      
                        <td class="tdpaddingliner" style="text-align:left" valign="top"><p><?= $product_name->product_name ?></p></td>
                        <!-- <td class="tdpaddingliner" style="text-align:center" valign="top"><?=$value->description?></td> -->
                        <td class="tdpaddingliner" style="text-align:center" valign="top"><?= $product_name->hsn_sac_code ?></td>
                        <td class="tdpaddingliner" style="text-align:center" valign="top"><?= $value->qty ?></td>
                        <td class="tdpaddingliner" style="text-align:center;" valign="top"><?= $value->unit ?></td> 
                        <td class="tdpaddingliner" style="text-align:right" valign="top"><?= $value->price?></td>       
                        <td class="tdpaddingliner" style="text-align:right;" valign="top"><?= $amount?></td>
                        
                        <td class="tdpaddingliner" style="text-align:right;" valign="top"><?= $taxable_value ?></td>
                        <td class="tdpaddingliner" colspan="1" style="text-align:right;" valign="top"><?= ($tax_percent)/2 ?></td> 
                        <td class="tdpaddingliner qty" colspan="2" style="text-align:right;" valign="top"><?= ($tax_amount)/2 ?></td>
                        <td class="tdpaddingliner" colspan="1" style="text-align:right;" valign="top"><?= ($tax_percent)/2 ?></td> 
                        <td class="tdpaddingliner qty" colspan="2" style="text-align:right;" valign="top"><?= ($tax_amount)/2 ?></td>
                        <td class="" style="text-align:right;padding-right:5px;padding-top:5px;" valign="top"><?= $value->amount ?></td>   
                      </tr>

                       <?php } ?> 
                    <tr>
                        <td class="tdpaddingliner top bottom" colspan="3"><b> Total</b></td>
                        <td class="tdpaddingliner top bottom" style="text-align: center;"><?= $tot_quant ?></td>
                        <td class="tdpaddingliner top bottom"> </td>
                        <td class="tdpaddingliner top bottom" style="text-align:right;"><?= $tot_unitprice ?></td>
                        <td class="tdpaddingliner top bottom" style="text-align:right;"><?= $total_amt ?> </td>
                       
                        <td class="tdpaddingliner top bottom" style="text-align:right;" valign="top"><?= $tot_taxablevalue ?></td>
                        <td colspan="1" class="tdpaddingliner top bottom"> </td>
                        <td colspan="2" class="tdpaddingliner top bottom" style="text-align:right;"><?= ($tot_taxamount)/2 ?></td>
                        <td colspan="1" class="tdpaddingliner top bottom"> </td>
                        <td colspan="2" class="tdpaddingliner top bottom" style="text-align:right;"><?= ($tot_taxamount)/2 ?></td>
                        <td class=" top bottom" style="text-align:right;padding-right:5px;padding-top:5px;"><?= $grandtot ?></td><!-- $totgstsubtotal+$totcgst+$totsgst+$totigst -->
                    </tr>
                    <tr>
                        <td class="tdpaddingliner" colspan="10" style="text-align: center;"><b>Total Invoice amount in words</b></td>
                        <td class="tdpaddingliner bottom" colspan="4" style="text-align: right;"><b>Total Amount before Tax</b></td>
                        <td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?= $tot_taxablevalue ?></b></td> <!-- totgstsubtotal -->
                    </tr>

                        <tr>
                        <td class="tdpaddingliner top" colspan="10" rowspan="8" style="text-align:right; vertical-align: top;"><b></b><?= AmountInWords($model->total).' '.' (INR) Only'?> 
                        </td>
                    </tr>
                    <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>INPUT SGST</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?= $tot_taxamount/2 ?></b></td></tr> 
                    <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>INPUT CGST</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?= $tot_taxamount/2 ?></b></td></tr>    
                    <tr>
                        <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>TCS</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?php if($model->is_tcs==1)
                    {
                        echo $model->tcs;
                    }
                    else{
                        echo "0.00";
                    } ?></b></td></tr>      
                    <tr>
                        <tr><td style="text-align:right;" colspan="4" class="tdpaddingliner bottom"><b>ROUND OFF</b></td>
                    <td style="text-align:right;padding-right:5px;padding-top:5px;" class="bottom"><b><?php if($model->round_off=='')
                    {
                        echo '0.00';
                    }
                    else{
                        echo $model->round_off;
                    } ?></b></td></tr>      
                    <tr>
                        <td class="tdpaddingliner bottom" colspan="4" style="text-align: right; padding-right:5px;padding-top:5px;"><b>Total Amount After Tax</b></td>
                        <!--<td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b></b></td> -->
                        <td class="bottom" style="text-align:right; padding-right:5px;padding-top:5px;"><b><?= preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$model->total) ?></b></td>
                    </tr>
                </table>

     <?php }?>                  
        

                        </td>
                    </tr>
                                    <tr>
                    <td>
                        <table width="100%" class="" cellspacing="0" cellpadding="0">
                            <tr>
                              <td width="40%" height="40%" class="tdpaddingliner top" rowspan="7" style="vertical-align: top;word-wrap:break-word;"><b>Terms & Conditions</b><br><?= $template->terms_and_condition ?></td>
                              <td width="20%" class="tdpaddingliner top"></td>

                              <td width="40%" style="font-size:10px; text-align: center;" class="top"><b>Ceritified that the particulars given above are true and correct</b></td>
                            </tr>
                            <tr>
                              <td width="20%" class="tdpaddingliner"><b></b></td>
                              <td width="40%" class="top" style="text-align: center;"><b><?=$template->company_signature?></b></td>
                            </tr>
                            
                            <tr>
                              <td width="20%" class="tdpaddingliner"><b></b></td>
                              <td width="40%" class=""><b><br></b></td>
                            </tr>
                            <tr>
                              <td width="20%" class="tdpaddingliner top" style="text-align: center;"><b>Common Seal</b></td>
                              <td width="40%" class="top" style="text-align: center;"><b>Authorised signatory</b>     
                              </td>
                            </tr>
                        </table>
            
                    </td>
                </tr>   
                                </table>
                </td>
            </tr>
            </table>
        </td>
    </tr>
    </table>
        </div>
        </div>





        <br>
<ul class="nav nav-tabs" id="myTab" role="tablist" style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">
  <li class="nav-item">
    <a class="nav-link active" id="home-tab" data-toggle="tab" href="#home" role="tab" aria-controls="home" aria-selected="true">RECEIPT</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="profile-tab" data-toggle="tab" href="#profile" role="tab" aria-controls="profile" aria-selected="false">DEBIT NOTE</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="messages-tab" data-toggle="tab" href="#messages" role="tab" aria-controls="messages" aria-selected="false">ADJUSTMENT</a>
  </li>
  </ul>

<!-- Tab panes -->
<div class="tab-content">
  <div class="tab-pane active" id="home" role="tabpanel" aria-labelledby="home-tab">
    

<table class="table table-striped table-bordered">

  <tr>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Date</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Payment Mode</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Paid Amount</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Notes</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Action</th>
  </tr>
<?php
foreach ($qurey1 as $key => $value) { ?>
        <tr>
          <td><?= date(("\ F j  Y"), strtotime($value->date)); ?></td>
          <td><?= $value->payment_mode ?></td>
          <td><?= $value->amount ?></td>
          <td><?= $value->notes ?></td>
          <td style="width: 100px"><?php   $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/view?id='.$value->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/purchasepayment-template'])->one()!='')
                    {
                        $printstring = '<li class="nav-item">
                        <a class="nav-link" target=_blank href='.Url::base().'/users/purchase-payment/purchasepayment-template?id='.$value->id.' data-method=post>
                           <i class="fa fa-print"></i>
                            <span class="dj-icon-gap"> Print</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $printstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/update?id='.$value->id.' data-method=post>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/purchase-payment/delete?id='.$value->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                   


                    echo $topstring.''.$viewstring.''.$printstring.''.$editstring.''.$deletestring.''.$downstring; ?></td>
        </tr>
 <?php  } ?>

 <?php
foreach ($findadjustedbill as $key => $val) { 

    // print_r($findadjustedinvoice)

    $adjustedpayments = PurchasePayment::find()->where(['id'=> $val->payment_id])->all();

   ?><?php foreach ($adjustedpayments as $key => $value)  { ?>
        <tr>
          <td><?= date(("\ F j  Y"), strtotime($value->date)); ?></td>
          <td><?= $value->payment_mode ?></td>
          <td><?= $value->amount ?></td>
          <td><?= $value->notes ?></td>
          <td style="width: 100px"><?php  echo '<div class="d-inline-block dropdown">
            <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
            <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                <ul class="nav flex-column">
                <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/view?id='.$val->id.' data-method=post target=_blank>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/purchasepayment-template?id='.$val->id.' data-method=post target=_blank>
                           <i class="fa fa-print"></i>
                            <span class="dj-icon-gap"> Print</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/update?id='.$val->id.' data-method=post target=_blank>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/purchase-payment/delete?id='.$val->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href= >
                           <i class="fa fa-envelope"></i>
                            <span class="dj-icon-gap">  Mail Payment</span>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href= >
                           <i class="fa fa-whatsapp"></i>
                            <span class="dj-icon-gap">  Whatsapp Payment </span>
                        </a>
                    </li>
                    
                </ul>
            </div>
        </div>' ?></td>
        </tr>
 <?php  } ?>

 <?php  } ?>


<tr>
  <td style="border:none;"><a href="<?=Url::base();?>/users/purchase-payment/create?id=<?= $model->id ?>&from=from-bill" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-plus-circle "></i> Add Payment</button></a></td>

</tr>

</table>




  </div>

  <div class="tab-pane" id="profile" role="tabpanel" aria-labelledby="profile-tab">
    


    <table class="table table-striped table-bordered">

  <tr>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Debit Note #</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Amount</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Vendor Name / Financial Category</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Date</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Paid</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Pending</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Status</th>
    <th style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Action</th>
  </tr>
<?php
foreach ($finddebitnotes as $key => $debit) { ?>
        <tr>
          <td><?= $debit->po ?></td>
          <td><?= $debit->total?></td>
          <td><?php if($debit->party_type!='Vendor')
            {
                $findname = Vendor::find()->where(['id'=>$debit->party_id])->one();
                
                echo $findname->business_name;
            }
            else
            {
               $findname = Customer::find()->where(['id'=>$debit->party_id])->one();
                
                echo $findname->business_name;
            } ?></td>
          <td><?= date(("\ F j  Y"), strtotime($debit->date)); ?></td>
          <td>
            
           <?php  if($debit->bill_no!='')
          {
              $payment = PurchasePayment::find()->where(['against_bill'=>$debit->bill_no])->all();
                $total = 0;
                foreach ($payment as $key => $value) {
                      $total = $total + $value->amount;
                }
                
                echo number_format($total,2);
          }
          else{
              echo 0;
          } ?>

          </td>
          <td>
            
            <?php if($debit->bill_no!='')
            {
                $payment = PurchasePayment::find()->where(['against_bill'=>$debit->bill_no])->all();
                $total = 0;
                foreach ($payment as $key => $value) {
                      $total = $total + $value->amount;
                }
                $total = $debit->total-$total;
                echo number_format($total,2);
            }
            else
            {
                echo 0;
            } ?>

          </td>

          <td><?php 
                    // return $data['status'];
                    $payment = PurchasePayment::find()->where(['against_bill'=>$debit->bill_no])->all();
                    $total = 0;
                    foreach ($payment as $key => $value) {
                          $total = $total + $value->amount;
                    }
                   if($total>=$debit->total)
                   {
                        echo '<span class="label-paid">PAID</span>';
                   }
                   else if($total<$debit->total && $total!=0)
                   {
                        echo '<span class="label-parital">PARTIAL</span>';
                   }
                   else if($total==0)
                   {
                         echo '<span class="label-draft">PENDING</span>';
                   }
                ?></td>
           <td style="width: 100px"><?php  $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/debit-note/view?id='.$debit->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap"> View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }


                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/debit-note/update?id='.$debit->id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/debit-note/delete?id='.$debit->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                
                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/debit-note/debitnote-pdf'])->one()!='')
                    {
                        $pdfstring = '<li class="nav-item">
                                <a class="nav-link" href='.Url::base().'/users/debit-note/debitnote-pdf?id='.$debit->id.'>
                                    <i class="fa fa-file"></i>
                                    <span class="dj-icon-gap"> PDF Debit Note </span>
                                </a>
                            </li>';
                    }
                    else
                    {
                        $pdfstring = '';
                    }

                    echo $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$pdfstring.''.$downstring; ?></td>
        </tr>
 <?php  } ?>


<tr>
  <td style="border:none;"><a href="<?=Url::base();?>/users/debit-note/create" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn" ><i class="fa fa-plus-circle "></i> Add Debit Note</button></a></td>

</tr>

</table>


  </div>
  <div class="tab-pane" id="messages" role="tabpanel" aria-labelledby="messages-tab">




    <?php $form = ActiveForm::begin(); ?>

     <div class="col-md-12 form-group" id="showreceipt" style="">
                        
       <table id="VoucherTransactionsTable" class="dataTables-example table-striped  table-hover col-tab dataTable table table-bordered no-footer dtr-inline col-sm-12"><thead><tr><th class="account" style="font-size:10px; font-family:Arial, Helvetica, sans-serif; width: 800px;">Account</th><th class="amount" style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Amount</th><th class="amount" style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Notes</th><th class="amount"></th></tr></thead><tbody class="vouchertransactions">                                           
      <?php foreach($adj_amount_of_bill as $i=>$val){ 
          
          $incomesi='';
      foreach($income as $value){
          if($val->account==$value->accounting_ledger_id)
          $incomesi.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $incomesi.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }
      $liabilitysi='';
      foreach($liability as $value){
          if($val->account==$value->accounting_ledger_id)
          $liabilitysi.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $liabilitysi.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }

      $assetsi='';
      foreach($asset as $value){
          if($val->account==$value->accounting_ledger_id)
          $assetsi.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $assetsi.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }
      $expensesi='';
      foreach($expense as $value){
          if($val->account==$value->accounting_ledger_id)
          $expensesi.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $expensesi.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }

      $bank_accounti='';
      foreach($bank_account as $value){
          if($val->account==$value->accounting_ledger_id)
          $bank_accounti.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $bank_accounti.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }

      $otheri='';
      foreach($other as $value){
          if($val->account==$value->accounting_ledger_id)
          $otheri.="<option selected value=$value->accounting_ledger_id>$value->ledger_id</option>";
          else
          $otheri.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
      }

?>   
      <tr class="item transaction"><td class="account"><select class="form-control select_class required select2-offscreen income" data-errorrequired="Select Account" value=<?=$value->ledger_id?> name="Adj[<?=$i?>][accountDD]" tabindex="-1"><option value="">Select an Account</option><optgroup label="Expense"><?=$incomesi?></optgroup><optgroup label="Liability"><?=$liabilitysi?></optgroup><optgroup label="Assets"><?=$assetsi?></optgroup><optgroup label="Others"><?=$otheri?></optgroup><optgroup label="Bank Accounts"><?=$bank_accounti?></optgroup></select></td><td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" value=<?=$val->amount?> name="Adj[<?=$i?>][item_price]" min=0 type="number"></td><td class="itamount"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" name="Adj[<?=$i?>][notes]"  type="text" value=<?=$val->notes?> ></td><td class="id"><a class="add-row sm-button add" value="Add" id="btn_addimgV" name="btn_addimgV" href="javascript:void(0)"><i class="fa fa-plus"></i></a></td></tr>
      <?php } ?>


      </tbody><tfoot><tr><td colspan="2">Total:</td><td class="total" id="totaltaxTxt"></td><td class="total" id="totalTxt">0.00</td></tr></tfoot>

      </table>
      
      </div>
      <?= $form->field($modl, 'from_date')->textInput(['type'=>"date",'class'=>"form-control " ,"hidden"=>'true'])->label(false) ?>

      <div class="djsec-text-right">
      <?= Html::submitButton('<span class="fa fa-check-square-o"></span> Add', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn submit-btn','name' => 'save', 'value' => '0']) ?>


                                                 
      <a href="<?=Url::base();?>/users/purchase-bill/deleteadjust?id=<?= $model->id ?>" class="mb-2 mr-2 btn-icon btn btn-danger"><i class="fa fa-ban" aria-hidden="true"></i> Clear Adjustment</a>


      </div>
      <?php ActiveForm::end(); ?>






  </div>
</div>




</body>
</div>
<br>
<br>
<br>
<br>
<br>



    </div>
</div>


<?php ob_start();?>
<script type="text/javascript">
$(function() {
$('.select_class').select2({ width: '100%'});
totalamount();

  $('#myTab a').on('click', function (e) {
  e.preventDefault()
  $(this).tab('show')
})


 
if(!<?= $findadjusted ?>)
{
  $('#showreceipt').empty(); 
var count=$('.vouchertransactions tr').length+1;
    $('#showreceipt').append('<table id="VoucherTransactionsTable" class="dataTables-example table-striped  table-hover col-tab dataTable table table-bordered no-footer dtr-inline col-sm-12"><thead><tr><th class="account"  style="font-size:10px; font-family:Arial, Helvetica, sans-serif; width:800px;">Account</th><th class="amount" style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Amount</th><th class="amount" style="font-size:10px; font-family:Arial, Helvetica, sans-serif;">Remarks</th><th class="id">&nbsp;</th></tr style="font-size:10px; font-family:Arial, Helvetica, sans-serif;"></thead><tbody class="vouchertransactions"><tr class="item transaction"><td class="account"><select class="form-control select_class required select2-offscreen income" data-errorrequired="Select Account" name="Adj['+count+'][accountDD]" tabindex="-1"><option value="">Select an Account</option><optgroup label="Expense"><?=$incomes?></optgroup><optgroup label="Liability"><?=$liabilitys?>></optgroup><optgroup label="Assets"><?=$assets?></optgroup><optgroup label="Bank Accounts"><?=$bank_accounts?></optgroup><optgroup label="Others"><?=$others?></optgroup> </select></td><td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" name="Adj['+count+'][item_price]" min=0 type="number"></td><td class="itamount"><input class="form-control required item_note" autocomplete="off" data-errorrequired="Enter notes"  name="Adj['+count+'][notes]"  type="text"></td><td class="id"><a class="add-row sm-button add" value="Add" id="btn_addimgV" name="btn_addimgV" href="javascript:void(0)"><i class="fa fa-plus"></i></a></td></tr></tbody><tfoot><tr><td colspan="2">Total:</td><td class="total" id="totaltaxTxt"></td><td class="total" id="totalTxt">0.00</td><input id="taxVal" name="Invoice[taxVal]" type="hidden"><input name="Invoice[sumTotal]" id="Invoice_sumTotal" type="hidden"></tr></tfoot></table>')
    $('.select_class').select2({ width: '100%'});
    $('.amount_ind').hide();
    $('.tds_amount_ind').hide();
    $('.total_amount_ind').hide();
  }
  else{
        // $('#showreceipt').empty();  
        $('.amount_ind').show();
    $('.tds_amount_ind').show();
    $('.total_amount_ind').show();
    }


     $(document).on('click', '.add-row.sm-button.add', function() {
        var count=$('.vouchertransactions tr').length+1;
    $('#VoucherTransactionsTable').append('<tr class="item transaction"><td class="account"><select class="form-control select_class'+count+' required select2-offscreen income" data-errorrequired="Select Account" name="Adj['+count+'][accountDD]" tabindex="-1"><option value="">Select an Account</option><optgroup label="Expense"><?=$incomes?></optgroup><optgroup label="Liability"><?=$liabilitys?></optgroup><optgroup label="Assets"><?=$assets?></optgroup><optgroup label="Bank Accounts"><?=$bank_accounts?></optgroup><optgroup label="Others"><?=$others?></optgroup> </select></td><td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" min=0 name="Adj['+count+'][item_price]" type="number"></td><td class="itamount"><input class="form-control required item_note" autocomplete="off" data-errorrequired="Enter notes"  name="Adj['+count+'][notes]"  type="text"></td><td class="id"><a class="add-row sm-button removeRowBtnV" value="Add"  href="javascript:void(0)"><i class="fa fa-minus"></i></a></td></tr>')
    $('.select_class'+count).select2({ width: '100%'});
})

     $(document).on('click', '.removeRowBtnV', function() {
$(this).parent().parent().remove();
totalamount();
})
$(document).on('change', '.item_price', function() {
totalamount();
})



function totalamount(){
    var val=0;
    var tax=0
    $('.item_price').each(function(){
        if($(this).val() && !isNaN($(this).val()))
        val+=parseFloat($(this).val());
    })
    $('#totalTxt').text((val+tax).toFixed(2))
    
}
});
<?php if ($from == 'print') {?>
  window.print();
           return false;
    <?php }?>
$('.print_page').click(function(){
           window.print();
           return false;
});
</script>   
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?> 
