<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\DirectPayment;
use backend\modules\master\models\PurchaseTemplates;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\GenericTemplate;

$payment = GenericTemplate::find()->where(['template_for'=>'Payment'])->all();
$paymenttype=ArrayHelper::map($payment, 'gt_id', 'template_name');

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\PurchasePaymentSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Payments';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
<?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Payment</div>
                                                            </div>
															<div class="widget-content-right">
															<a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Payment</a>

                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/create'])->one()!=''){?>
                                                               <a href="<?=Url::base().'/users/purchase-payment/create'?>" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Payment</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                               
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
						   <div class="row dj-adv-search-row">
						   <div class="col-md-2">
                               <div class="position-relative form-group">
                               <?= $form->field($model, 'prefix')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Prefix"])->label(false) ?>

                                 <!-- <input name="amount" id="amount" type="text" class="form-control" placeholder="Prefix" > -->
                              </div>
                            </div>
							<div class="col-md-2">
                               <div class="position-relative form-group">
                               <?= $form->field($model, 'payment_no')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Payment #"])->label(false) ?>

                                 <!-- <input name="amount" id="amount" type="text" class="form-control" placeholder="Payment #" > -->
                              </div>
                            </div>
							<div class="col-md-2">
                               <div class="position-relative form-group">
                               <?= $form->field($model, 'suffix')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Suffix"])->label(false) ?>

                                 <!-- <input name="amount" id="amount" type="text" class="form-control" placeholder="Suffix" > -->
                              </div>
                            </div>
							<div class="col-md-2">
                            <!-- <button class="btn  btn-rounded dj-adv-search"><i class="fa fa-search"></i>Search</button> -->
                             <button  class="search_field_buttons"><i class="fa fa-search"></i> Search</button>
                                <!-- <a href="#" class="btn btn-rounded dj-adv-search"><i class="fa fa-search"></i> Search</a> -->
                            </div>
                          
                         <div class="col-md-3">
                            <a class="search_field_buttons search2" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            
                            <a  class="search_field_buttons"  href="<?=Url::base().'/users/purchase-payment/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
  
						   </div>
                           <?php ActiveForm::end(); ?>
									<!-- <form class="dj-sale-form collapse" id="search-look"> -->
                                    <?php $form = ActiveForm::begin(['method' => 'get','id' => 'search-creditnote','options' => ['enctype' => 'multipart/form-data']]); ?>

                                        <div class="form-row">
                                      
										<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'class'=>'form-control','type'=>'date'])->label(false) ?>
                                                   <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'class'=>'form-control','type'=>'date'])->label(false) ?>
                                                   <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Vendor</label>

                                                    <?php if($model->vendor!=''){?>

                                                    <?php $customer=Vendor::find()->where(['id'=>$model->vendor])->one()?>
                                                    <?=$form->field($model, 'vendor')->dropDownList([$model->vendor=>$customer->business_name], ['options' => [$model->vendor => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($model, 'vendor')->dropDownList([], ['prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>           
                                                   <?php } ?>

                                                </div>
												
                                            </div>
										
											   <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Payment Mode</label>
                                                    <?=$form->field($model, 'bank')->dropDownList($bank, ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect form-control">
														<option value="39723">CASH</option>
														<option value="39742">INDIAN OVERSEASE BANK</option>
														<option value="39728">STATE BANK OF INDIA</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Note</label>
                                                    <?= $form->field($model, 'notes')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Account Category</label>
                                                    <?=$form->field($model, 'account_category')->dropDownList([], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Cost Centre Category</label>
                                                    <?=$form->field($model, 'centre_category')->dropDownList([], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>											
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Payment Type</label>
                                                    <?=$form->field($model, 'payment_type')->dropDownList(['Payment against bill'=>'Payment against bill','Direct payment'=>'Direct payment','For advances against payment'=>'For advances against payment'], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Setting Type</label>
                                                    <?=$form->field($model, 'settingtype')->dropDownList($paymenttype, ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Cheque No.</label>
                                                    <?= $form->field($model, 'cheque_no')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount From</label>
                                                    <?=$form->field($model, 'amount_from')->dropDownList(['>'=>'>','>='=>'>='], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect form-control">
														<option value="=">=</option>
														<option value="<">&lt;</option>
														<option value="<=">&lt;=</option>
														<option value=">">&gt;</option>
														<option value=">=">&gt;=</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">with</label>
                                                    <?= $form->field($model, 'amountfrom')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount To</label>
                                                    <?=$form->field($model, 'amount_to')->dropDownList(['<'=>'<','<='=>'<='], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="=">=</option>
														<option value="<">&lt;</option>
														<option value="<=">&lt;=</option>
														<option value=">">&gt;</option>
														<option value=">=">&gt;=</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">with</label>
                                                    <?= $form->field($model, 'amountto')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											
											<div class="col-md-4 dj-btn-align">
                                            <button class="btn btn-info btn-rounded dj-search"><i class="fa fa-search"></i>Search</button>

											<!-- <a href="#" class="btn btn-primary btn-rounded dj-search"><i class="fa fa-search"></i> Search</a> -->
											</div>

                                        </div>
                                        <?php ActiveForm::end(); ?>
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">
						      <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/delete'])->one()!=''){?>
                              <button class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn" id="delete"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                               <?php }else {?>

                               <?php } ?>
								
							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">

                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/excel-export'])->one()!=''){?>
                                        	    <?php if(Yii::$app->request->getQueryParams()){?>
                                                       <a href="<?=Url::current()?>&totalexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                                                       <a href="<?=Url::current()?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                    <?php } else{ ?>
                                                       <a href="<?=Url::current()?>?totalexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                                                       <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                    <?php } ?>
                                       <?php }else {?>

                                       <?php } ?>

                                       <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/purchasepayment-template'])->one()!=''){?>
                                            <?php if(Yii::$app->request->getQueryParams()){?>
                                                <a href="<?=Url::current()?>&print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>         
                                             <?php } else{ ?>
                                                <a href="<?=Url::current()?>?print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>
                                            <?php } ?>
                                       <?php }else {?>

                                       <?php } ?>
                           
                        

                        
							
                                     </div>
							 </div>
							 </div>
                             <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            [
                'label'=>'Payment #',
               'attribute' => 'payment_no',
               'value' => function ($data) {
                return 'P '.$data->payment_no.'/'.$data->suffix;
               }
            ],
            // 'date:date',
            [
                'header'=> 'Date',
                'value'=> function($data){
                    return date(("\ F j  Y"), strtotime($data->date));
                } 
            ],
            [
                'label'=>'Amount',
                'contentOptions'=>[ 'style'=>'text-align:right'],
               'attribute' => 'amount',
               'value' => function ($data) {
                if($data->amount==NULL)
                {
                    return '0.00';
                }
                else
                {
                    $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->amount);
                    return $num;   
                }
                 
                // return number_format($data->amount,2);
               }
            ],
            [
                'label'=>'Payment Mode',
               'attribute' => 'payment_mode',
               'value' => function ($data) {
                return $data->payment_mode;
               }
            ],
            [
               'label'=>'Vendor/Category',
               'attribute' => 'vendor_id',
               'contentOptions'=>['style'=>'font-weight:bold'],
               'value' => function ($data) {
                $against_ledger =  array();
                $all_ledgers = array();
                $vendor=Vendor::find()->where(['id'=>$data->vendor_id])->one();
                if($vendor!='')
                {
                   return $vendor->business_name;
                }
                else
                {
                    $against = DirectPayment::find()->where(['payment_id'=>$data->id])->all();
                    foreach ($against as $key => $value) {
                        $against_ledger[$key] = $value->ledger_id;
                    }
                    foreach ($against_ledger as $key => $val) {
                        $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$val])->one();
                        if($ledger)
                          $all_ledgers[$key] = $ledger->ledger_id;
                    }
                    return implode(",",$all_ledgers);
                    
                }
               }
            ],
            'notes',
           
            [
                'label' => 'Action',
                'contentOptions'=>['style'=>'width:35px'],
                'headerOptions' => ['style' => 'color:#495057'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/view?id='.$data->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/purchasepayment-template'])->one()!='')
                    {
                        $printstring = '<li class="nav-item">
                        <a class="nav-link" target=_blank href='.Url::base().'/users/purchase-payment/view?id='.$data->id.'&from=print data-method=post>
                           <i class="fa fa-print"></i>
                            <span class="dj-icon-gap"> Print</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $printstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-payment/update?id='.$data->id.' data-method=post>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/purchase-payment/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/findpaymentalldetails'])->one()!='')
                    {
                        $whatsappstring = '<li class="nav-item">
                                                <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                    <i class="fa fa-whatsapp"></i>
                                                    <span class="dj-icon-gap"> Whatsapp Payment</span>
                                                </a>
                                            </li>';
                    }
                    else
                    {
                        $whatsappstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/download-attachment'])->one()!='')
                    {
                        $attachmentstring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/purchase-payment/download-attachment?id='.$data->id.'>
                                <i class="fa fa-file"></i>
                                <span class="dj-icon-gap"> Download Attachment</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $attachmentstring = '';
                    }

                    return $topstring.''.$viewstring.''.$printstring.''.$editstring.''.$deletestring.''.$whatsappstring.''.$attachmentstring.''.$downstring;


                },
            ],

        ],
    ]); ?>
                        </div>
                    </div>
                </div>

<div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-8" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                          <?= $form->field($model, 'text_send')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id",])->label(false) ?> 
                       <!-- </div> -->
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Save', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>




                <?php ob_start();?>
 <script type="text/javascript">
$(function() {


 $('.sendwhatapp').click(function()  {  
    var country_code = $('.c_code').val();
    var mobile = $('.c_mobile').val();
    var mobile_no = country_code.concat(mobile);
    var g_text = $('.send_text').val();
    var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
    window.location.href = url; 
 })

 $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     jQuery.ajaxSetup({async:false});
     $.get('findpaymentalldetails',{id:id},function(data)
     {
       var data =$.parseJSON(data);
       $('.c_code').val('91');
       $('.reason').val('');
       jQuery.ajaxSetup({async:false});
       $.get('create-url',{id:id},function(st)
       {
        var st =$.parseJSON(st);
        $('.send_text').text('We have confirmed your Payment '+'P'+(data.payment_no)+' has been raised for Rs '+data.amount+'. Thank you! For Download Click this link '+st); 
       })
     }); 
 })


$('input[name="PurchasePaymentSearch[date]"]').attr('type','date');
// $('#purchasepayment-from_date').attr('type','date');
// $('#purchasepayment-to_date').attr('type','date');
$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#search-creditnote').hide();
$('.multiselect').select2();
$('.search2').click(function(){
    $('#search-creditnote').toggle();
})

$('.findvendor').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
